// Generated by Futhark 0.22.0
// git: e8b7244 (Wed Jan 12 23:26:03 2022 +0100)

// We need to define _GNU_SOURCE before
// _any_ headers files are imported to get
// the usage statistics of a thread (i.e. have RUSAGE_THREAD) on GNU/Linux
// https://manpages.courier-mta.org/htmlman2/getrusage.2.html
#ifndef _GNU_SOURCE // Avoid possible double-definition warning.
#define _GNU_SOURCE
#endif

#ifdef __clang__
#pragma clang diagnostic ignored "-Wunused-function"
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wparentheses"
#pragma clang diagnostic ignored "-Wunused-label"
#elif __GNUC__
#pragma GCC diagnostic ignored "-Wunused-function"
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wparentheses"
#pragma GCC diagnostic ignored "-Wunused-label"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif

// Headers\n")
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdio.h>
#include <float.h>

#ifdef __cplusplus
extern "C" {
#endif

// Initialisation
struct futhark_context_config;
struct futhark_context_config *futhark_context_config_new(void);
void futhark_context_config_free(struct futhark_context_config *cfg);
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int flag);
struct futhark_context;
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg);
void futhark_context_free(struct futhark_context *ctx);
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value);
int futhark_get_tuning_param_count(void);
const char *futhark_get_tuning_param_name(int);
const char *futhark_get_tuning_param_class(int);

// Arrays
struct futhark_f64_2d;
struct futhark_f64_2d *futhark_new_f64_2d(struct futhark_context *ctx, const
                                          double *data, int64_t dim0,
                                          int64_t dim1);
struct futhark_f64_2d *futhark_new_raw_f64_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1);
int futhark_free_f64_2d(struct futhark_context *ctx,
                        struct futhark_f64_2d *arr);
int futhark_values_f64_2d(struct futhark_context *ctx,
                          struct futhark_f64_2d *arr, double *data);
unsigned char *futhark_values_raw_f64_2d(struct futhark_context *ctx,
                                         struct futhark_f64_2d *arr);
const int64_t *futhark_shape_f64_2d(struct futhark_context *ctx,
                                    struct futhark_f64_2d *arr);

// Opaque values


// Entry points
int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f64_2d **out0,
                       struct futhark_f64_2d **out1,
                       struct futhark_f64_2d **out2, const
                       struct futhark_f64_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5, const int64_t in6, const int64_t in7, const
                       int64_t in8, const int64_t in9, const int64_t in10, const
                       int64_t in11, const int64_t in12, const int64_t in13,
                       const int64_t in14);

// Miscellaneous
int futhark_context_sync(struct futhark_context *ctx);
char *futhark_context_report(struct futhark_context *ctx);
char *futhark_context_get_error(struct futhark_context *ctx);
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f);
void futhark_context_pause_profiling(struct futhark_context *ctx);
void futhark_context_unpause_profiling(struct futhark_context *ctx);
int futhark_context_clear_caches(struct futhark_context *ctx);
#define FUTHARK_BACKEND_c

#ifdef __cplusplus
}
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>
#include <stdint.h>
// If NDEBUG is set, the assert() macro will do nothing. Since Futhark
// (unfortunately) makes use of assert() for error detection (and even some
// side effects), we want to avoid that.
#undef NDEBUG
#include <assert.h>
#include <stdarg.h>
// Start of util.h.
//
// Various helper functions that are useful in all generated C code.

#include <errno.h>
#include <string.h>

static const char *fut_progname = "(embedded Futhark)";

static void futhark_panic(int eval, const char *fmt, ...) __attribute__((noreturn));
static char* msgprintf(const char *s, ...);
static void* slurp_file(const char *filename, size_t *size);
static int dump_file(const char *file, const void *buf, size_t n);
struct str_builder;
static void str_builder_init(struct str_builder *b);
static void str_builder(struct str_builder *b, const char *s, ...);

static void futhark_panic(int eval, const char *fmt, ...) {
  va_list ap;
  va_start(ap, fmt);
  fprintf(stderr, "%s: ", fut_progname);
  vfprintf(stderr, fmt, ap);
  va_end(ap);
  exit(eval);
}

// For generating arbitrary-sized error messages.  It is the callers
// responsibility to free the buffer at some point.
static char* msgprintf(const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = 1 + (size_t)vsnprintf(NULL, 0, s, vl);
  char *buffer = (char*) malloc(needed);
  va_start(vl, s); // Must re-init.
  vsnprintf(buffer, needed, s, vl);
  return buffer;
}

static inline void check_err(int errval, int sets_errno, const char *fun, int line,
                            const char *msg, ...) {
  if (errval) {
    char errnum[10];

    va_list vl;
    va_start(vl, msg);

    fprintf(stderr, "ERROR: ");
    vfprintf(stderr, msg, vl);
    fprintf(stderr, " in %s() at line %d with error code %s\n",
            fun, line,
            sets_errno ? strerror(errno) : errnum);
    exit(errval);
  }
}

#define CHECK_ERR(err, ...) check_err(err, 0, __func__, __LINE__, __VA_ARGS__)
#define CHECK_ERRNO(err, ...) check_err(err, 1, __func__, __LINE__, __VA_ARGS__)

// Read the rest of an open file into a NUL-terminated string; returns
// NULL on error.
static void* fslurp_file(FILE *f, size_t *size) {
  long start = ftell(f);
  fseek(f, 0, SEEK_END);
  long src_size = ftell(f)-start;
  fseek(f, start, SEEK_SET);
  unsigned char *s = (unsigned char*) malloc((size_t)src_size + 1);
  if (fread(s, 1, (size_t)src_size, f) != (size_t)src_size) {
    free(s);
    s = NULL;
  } else {
    s[src_size] = '\0';
  }

  if (size) {
    *size = (size_t)src_size;
  }

  return s;
}

// Read a file into a NUL-terminated string; returns NULL on error.
static void* slurp_file(const char *filename, size_t *size) {
  FILE *f = fopen(filename, "rb"); // To avoid Windows messing with linebreaks.
  if (f == NULL) return NULL;
  unsigned char *s = fslurp_file(f, size);
  fclose(f);
  return s;
}

// Dump 'n' bytes from 'buf' into the file at the designated location.
// Returns 0 on success.
static int dump_file(const char *file, const void *buf, size_t n) {
  FILE *f = fopen(file, "w");

  if (f == NULL) {
    return 1;
  }

  if (fwrite(buf, sizeof(char), n, f) != n) {
    return 1;
  }

  if (fclose(f) != 0) {
    return 1;
  }

  return 0;
}

struct str_builder {
  char *str;
  size_t capacity; // Size of buffer.
  size_t used; // Bytes used, *not* including final zero.
};

static void str_builder_init(struct str_builder *b) {
  b->capacity = 10;
  b->used = 0;
  b->str = malloc(b->capacity);
  b->str[0] = 0;
}

static void str_builder(struct str_builder *b, const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = (size_t)vsnprintf(NULL, 0, s, vl);

  while (b->capacity < b->used + needed + 1) {
    b->capacity *= 2;
    b->str = realloc(b->str, b->capacity);
  }

  va_start(vl, s); // Must re-init.
  vsnprintf(b->str+b->used, b->capacity-b->used, s, vl);
  b->used += needed;
}

// End of util.h.
// Start of half.h.

// Conversion functions are from http://half.sourceforge.net/, but
// translated to C.
//
// Copyright (c) 2012-2021 Christian Rau
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#ifndef __OPENCL_VERSION__
#define __constant
#endif

__constant static const uint16_t base_table[512] = {
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080, 0x0100,
  0x0200, 0x0400, 0x0800, 0x0C00, 0x1000, 0x1400, 0x1800, 0x1C00, 0x2000, 0x2400, 0x2800, 0x2C00, 0x3000, 0x3400, 0x3800, 0x3C00,
  0x4000, 0x4400, 0x4800, 0x4C00, 0x5000, 0x5400, 0x5800, 0x5C00, 0x6000, 0x6400, 0x6800, 0x6C00, 0x7000, 0x7400, 0x7800, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8001, 0x8002, 0x8004, 0x8008, 0x8010, 0x8020, 0x8040, 0x8080, 0x8100,
  0x8200, 0x8400, 0x8800, 0x8C00, 0x9000, 0x9400, 0x9800, 0x9C00, 0xA000, 0xA400, 0xA800, 0xAC00, 0xB000, 0xB400, 0xB800, 0xBC00,
  0xC000, 0xC400, 0xC800, 0xCC00, 0xD000, 0xD400, 0xD800, 0xDC00, 0xE000, 0xE400, 0xE800, 0xEC00, 0xF000, 0xF400, 0xF800, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00 };

__constant static const unsigned char shift_table[512] = {
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13 };

__constant static const uint32_t mantissa_table[2048] = {
  0x00000000, 0x33800000, 0x34000000, 0x34400000, 0x34800000, 0x34A00000, 0x34C00000, 0x34E00000, 0x35000000, 0x35100000, 0x35200000, 0x35300000, 0x35400000, 0x35500000, 0x35600000, 0x35700000,
  0x35800000, 0x35880000, 0x35900000, 0x35980000, 0x35A00000, 0x35A80000, 0x35B00000, 0x35B80000, 0x35C00000, 0x35C80000, 0x35D00000, 0x35D80000, 0x35E00000, 0x35E80000, 0x35F00000, 0x35F80000,
  0x36000000, 0x36040000, 0x36080000, 0x360C0000, 0x36100000, 0x36140000, 0x36180000, 0x361C0000, 0x36200000, 0x36240000, 0x36280000, 0x362C0000, 0x36300000, 0x36340000, 0x36380000, 0x363C0000,
  0x36400000, 0x36440000, 0x36480000, 0x364C0000, 0x36500000, 0x36540000, 0x36580000, 0x365C0000, 0x36600000, 0x36640000, 0x36680000, 0x366C0000, 0x36700000, 0x36740000, 0x36780000, 0x367C0000,
  0x36800000, 0x36820000, 0x36840000, 0x36860000, 0x36880000, 0x368A0000, 0x368C0000, 0x368E0000, 0x36900000, 0x36920000, 0x36940000, 0x36960000, 0x36980000, 0x369A0000, 0x369C0000, 0x369E0000,
  0x36A00000, 0x36A20000, 0x36A40000, 0x36A60000, 0x36A80000, 0x36AA0000, 0x36AC0000, 0x36AE0000, 0x36B00000, 0x36B20000, 0x36B40000, 0x36B60000, 0x36B80000, 0x36BA0000, 0x36BC0000, 0x36BE0000,
  0x36C00000, 0x36C20000, 0x36C40000, 0x36C60000, 0x36C80000, 0x36CA0000, 0x36CC0000, 0x36CE0000, 0x36D00000, 0x36D20000, 0x36D40000, 0x36D60000, 0x36D80000, 0x36DA0000, 0x36DC0000, 0x36DE0000,
  0x36E00000, 0x36E20000, 0x36E40000, 0x36E60000, 0x36E80000, 0x36EA0000, 0x36EC0000, 0x36EE0000, 0x36F00000, 0x36F20000, 0x36F40000, 0x36F60000, 0x36F80000, 0x36FA0000, 0x36FC0000, 0x36FE0000,
  0x37000000, 0x37010000, 0x37020000, 0x37030000, 0x37040000, 0x37050000, 0x37060000, 0x37070000, 0x37080000, 0x37090000, 0x370A0000, 0x370B0000, 0x370C0000, 0x370D0000, 0x370E0000, 0x370F0000,
  0x37100000, 0x37110000, 0x37120000, 0x37130000, 0x37140000, 0x37150000, 0x37160000, 0x37170000, 0x37180000, 0x37190000, 0x371A0000, 0x371B0000, 0x371C0000, 0x371D0000, 0x371E0000, 0x371F0000,
  0x37200000, 0x37210000, 0x37220000, 0x37230000, 0x37240000, 0x37250000, 0x37260000, 0x37270000, 0x37280000, 0x37290000, 0x372A0000, 0x372B0000, 0x372C0000, 0x372D0000, 0x372E0000, 0x372F0000,
  0x37300000, 0x37310000, 0x37320000, 0x37330000, 0x37340000, 0x37350000, 0x37360000, 0x37370000, 0x37380000, 0x37390000, 0x373A0000, 0x373B0000, 0x373C0000, 0x373D0000, 0x373E0000, 0x373F0000,
  0x37400000, 0x37410000, 0x37420000, 0x37430000, 0x37440000, 0x37450000, 0x37460000, 0x37470000, 0x37480000, 0x37490000, 0x374A0000, 0x374B0000, 0x374C0000, 0x374D0000, 0x374E0000, 0x374F0000,
  0x37500000, 0x37510000, 0x37520000, 0x37530000, 0x37540000, 0x37550000, 0x37560000, 0x37570000, 0x37580000, 0x37590000, 0x375A0000, 0x375B0000, 0x375C0000, 0x375D0000, 0x375E0000, 0x375F0000,
  0x37600000, 0x37610000, 0x37620000, 0x37630000, 0x37640000, 0x37650000, 0x37660000, 0x37670000, 0x37680000, 0x37690000, 0x376A0000, 0x376B0000, 0x376C0000, 0x376D0000, 0x376E0000, 0x376F0000,
  0x37700000, 0x37710000, 0x37720000, 0x37730000, 0x37740000, 0x37750000, 0x37760000, 0x37770000, 0x37780000, 0x37790000, 0x377A0000, 0x377B0000, 0x377C0000, 0x377D0000, 0x377E0000, 0x377F0000,
  0x37800000, 0x37808000, 0x37810000, 0x37818000, 0x37820000, 0x37828000, 0x37830000, 0x37838000, 0x37840000, 0x37848000, 0x37850000, 0x37858000, 0x37860000, 0x37868000, 0x37870000, 0x37878000,
  0x37880000, 0x37888000, 0x37890000, 0x37898000, 0x378A0000, 0x378A8000, 0x378B0000, 0x378B8000, 0x378C0000, 0x378C8000, 0x378D0000, 0x378D8000, 0x378E0000, 0x378E8000, 0x378F0000, 0x378F8000,
  0x37900000, 0x37908000, 0x37910000, 0x37918000, 0x37920000, 0x37928000, 0x37930000, 0x37938000, 0x37940000, 0x37948000, 0x37950000, 0x37958000, 0x37960000, 0x37968000, 0x37970000, 0x37978000,
  0x37980000, 0x37988000, 0x37990000, 0x37998000, 0x379A0000, 0x379A8000, 0x379B0000, 0x379B8000, 0x379C0000, 0x379C8000, 0x379D0000, 0x379D8000, 0x379E0000, 0x379E8000, 0x379F0000, 0x379F8000,
  0x37A00000, 0x37A08000, 0x37A10000, 0x37A18000, 0x37A20000, 0x37A28000, 0x37A30000, 0x37A38000, 0x37A40000, 0x37A48000, 0x37A50000, 0x37A58000, 0x37A60000, 0x37A68000, 0x37A70000, 0x37A78000,
  0x37A80000, 0x37A88000, 0x37A90000, 0x37A98000, 0x37AA0000, 0x37AA8000, 0x37AB0000, 0x37AB8000, 0x37AC0000, 0x37AC8000, 0x37AD0000, 0x37AD8000, 0x37AE0000, 0x37AE8000, 0x37AF0000, 0x37AF8000,
  0x37B00000, 0x37B08000, 0x37B10000, 0x37B18000, 0x37B20000, 0x37B28000, 0x37B30000, 0x37B38000, 0x37B40000, 0x37B48000, 0x37B50000, 0x37B58000, 0x37B60000, 0x37B68000, 0x37B70000, 0x37B78000,
  0x37B80000, 0x37B88000, 0x37B90000, 0x37B98000, 0x37BA0000, 0x37BA8000, 0x37BB0000, 0x37BB8000, 0x37BC0000, 0x37BC8000, 0x37BD0000, 0x37BD8000, 0x37BE0000, 0x37BE8000, 0x37BF0000, 0x37BF8000,
  0x37C00000, 0x37C08000, 0x37C10000, 0x37C18000, 0x37C20000, 0x37C28000, 0x37C30000, 0x37C38000, 0x37C40000, 0x37C48000, 0x37C50000, 0x37C58000, 0x37C60000, 0x37C68000, 0x37C70000, 0x37C78000,
  0x37C80000, 0x37C88000, 0x37C90000, 0x37C98000, 0x37CA0000, 0x37CA8000, 0x37CB0000, 0x37CB8000, 0x37CC0000, 0x37CC8000, 0x37CD0000, 0x37CD8000, 0x37CE0000, 0x37CE8000, 0x37CF0000, 0x37CF8000,
  0x37D00000, 0x37D08000, 0x37D10000, 0x37D18000, 0x37D20000, 0x37D28000, 0x37D30000, 0x37D38000, 0x37D40000, 0x37D48000, 0x37D50000, 0x37D58000, 0x37D60000, 0x37D68000, 0x37D70000, 0x37D78000,
  0x37D80000, 0x37D88000, 0x37D90000, 0x37D98000, 0x37DA0000, 0x37DA8000, 0x37DB0000, 0x37DB8000, 0x37DC0000, 0x37DC8000, 0x37DD0000, 0x37DD8000, 0x37DE0000, 0x37DE8000, 0x37DF0000, 0x37DF8000,
  0x37E00000, 0x37E08000, 0x37E10000, 0x37E18000, 0x37E20000, 0x37E28000, 0x37E30000, 0x37E38000, 0x37E40000, 0x37E48000, 0x37E50000, 0x37E58000, 0x37E60000, 0x37E68000, 0x37E70000, 0x37E78000,
  0x37E80000, 0x37E88000, 0x37E90000, 0x37E98000, 0x37EA0000, 0x37EA8000, 0x37EB0000, 0x37EB8000, 0x37EC0000, 0x37EC8000, 0x37ED0000, 0x37ED8000, 0x37EE0000, 0x37EE8000, 0x37EF0000, 0x37EF8000,
  0x37F00000, 0x37F08000, 0x37F10000, 0x37F18000, 0x37F20000, 0x37F28000, 0x37F30000, 0x37F38000, 0x37F40000, 0x37F48000, 0x37F50000, 0x37F58000, 0x37F60000, 0x37F68000, 0x37F70000, 0x37F78000,
  0x37F80000, 0x37F88000, 0x37F90000, 0x37F98000, 0x37FA0000, 0x37FA8000, 0x37FB0000, 0x37FB8000, 0x37FC0000, 0x37FC8000, 0x37FD0000, 0x37FD8000, 0x37FE0000, 0x37FE8000, 0x37FF0000, 0x37FF8000,
  0x38000000, 0x38004000, 0x38008000, 0x3800C000, 0x38010000, 0x38014000, 0x38018000, 0x3801C000, 0x38020000, 0x38024000, 0x38028000, 0x3802C000, 0x38030000, 0x38034000, 0x38038000, 0x3803C000,
  0x38040000, 0x38044000, 0x38048000, 0x3804C000, 0x38050000, 0x38054000, 0x38058000, 0x3805C000, 0x38060000, 0x38064000, 0x38068000, 0x3806C000, 0x38070000, 0x38074000, 0x38078000, 0x3807C000,
  0x38080000, 0x38084000, 0x38088000, 0x3808C000, 0x38090000, 0x38094000, 0x38098000, 0x3809C000, 0x380A0000, 0x380A4000, 0x380A8000, 0x380AC000, 0x380B0000, 0x380B4000, 0x380B8000, 0x380BC000,
  0x380C0000, 0x380C4000, 0x380C8000, 0x380CC000, 0x380D0000, 0x380D4000, 0x380D8000, 0x380DC000, 0x380E0000, 0x380E4000, 0x380E8000, 0x380EC000, 0x380F0000, 0x380F4000, 0x380F8000, 0x380FC000,
  0x38100000, 0x38104000, 0x38108000, 0x3810C000, 0x38110000, 0x38114000, 0x38118000, 0x3811C000, 0x38120000, 0x38124000, 0x38128000, 0x3812C000, 0x38130000, 0x38134000, 0x38138000, 0x3813C000,
  0x38140000, 0x38144000, 0x38148000, 0x3814C000, 0x38150000, 0x38154000, 0x38158000, 0x3815C000, 0x38160000, 0x38164000, 0x38168000, 0x3816C000, 0x38170000, 0x38174000, 0x38178000, 0x3817C000,
  0x38180000, 0x38184000, 0x38188000, 0x3818C000, 0x38190000, 0x38194000, 0x38198000, 0x3819C000, 0x381A0000, 0x381A4000, 0x381A8000, 0x381AC000, 0x381B0000, 0x381B4000, 0x381B8000, 0x381BC000,
  0x381C0000, 0x381C4000, 0x381C8000, 0x381CC000, 0x381D0000, 0x381D4000, 0x381D8000, 0x381DC000, 0x381E0000, 0x381E4000, 0x381E8000, 0x381EC000, 0x381F0000, 0x381F4000, 0x381F8000, 0x381FC000,
  0x38200000, 0x38204000, 0x38208000, 0x3820C000, 0x38210000, 0x38214000, 0x38218000, 0x3821C000, 0x38220000, 0x38224000, 0x38228000, 0x3822C000, 0x38230000, 0x38234000, 0x38238000, 0x3823C000,
  0x38240000, 0x38244000, 0x38248000, 0x3824C000, 0x38250000, 0x38254000, 0x38258000, 0x3825C000, 0x38260000, 0x38264000, 0x38268000, 0x3826C000, 0x38270000, 0x38274000, 0x38278000, 0x3827C000,
  0x38280000, 0x38284000, 0x38288000, 0x3828C000, 0x38290000, 0x38294000, 0x38298000, 0x3829C000, 0x382A0000, 0x382A4000, 0x382A8000, 0x382AC000, 0x382B0000, 0x382B4000, 0x382B8000, 0x382BC000,
  0x382C0000, 0x382C4000, 0x382C8000, 0x382CC000, 0x382D0000, 0x382D4000, 0x382D8000, 0x382DC000, 0x382E0000, 0x382E4000, 0x382E8000, 0x382EC000, 0x382F0000, 0x382F4000, 0x382F8000, 0x382FC000,
  0x38300000, 0x38304000, 0x38308000, 0x3830C000, 0x38310000, 0x38314000, 0x38318000, 0x3831C000, 0x38320000, 0x38324000, 0x38328000, 0x3832C000, 0x38330000, 0x38334000, 0x38338000, 0x3833C000,
  0x38340000, 0x38344000, 0x38348000, 0x3834C000, 0x38350000, 0x38354000, 0x38358000, 0x3835C000, 0x38360000, 0x38364000, 0x38368000, 0x3836C000, 0x38370000, 0x38374000, 0x38378000, 0x3837C000,
  0x38380000, 0x38384000, 0x38388000, 0x3838C000, 0x38390000, 0x38394000, 0x38398000, 0x3839C000, 0x383A0000, 0x383A4000, 0x383A8000, 0x383AC000, 0x383B0000, 0x383B4000, 0x383B8000, 0x383BC000,
  0x383C0000, 0x383C4000, 0x383C8000, 0x383CC000, 0x383D0000, 0x383D4000, 0x383D8000, 0x383DC000, 0x383E0000, 0x383E4000, 0x383E8000, 0x383EC000, 0x383F0000, 0x383F4000, 0x383F8000, 0x383FC000,
  0x38400000, 0x38404000, 0x38408000, 0x3840C000, 0x38410000, 0x38414000, 0x38418000, 0x3841C000, 0x38420000, 0x38424000, 0x38428000, 0x3842C000, 0x38430000, 0x38434000, 0x38438000, 0x3843C000,
  0x38440000, 0x38444000, 0x38448000, 0x3844C000, 0x38450000, 0x38454000, 0x38458000, 0x3845C000, 0x38460000, 0x38464000, 0x38468000, 0x3846C000, 0x38470000, 0x38474000, 0x38478000, 0x3847C000,
  0x38480000, 0x38484000, 0x38488000, 0x3848C000, 0x38490000, 0x38494000, 0x38498000, 0x3849C000, 0x384A0000, 0x384A4000, 0x384A8000, 0x384AC000, 0x384B0000, 0x384B4000, 0x384B8000, 0x384BC000,
  0x384C0000, 0x384C4000, 0x384C8000, 0x384CC000, 0x384D0000, 0x384D4000, 0x384D8000, 0x384DC000, 0x384E0000, 0x384E4000, 0x384E8000, 0x384EC000, 0x384F0000, 0x384F4000, 0x384F8000, 0x384FC000,
  0x38500000, 0x38504000, 0x38508000, 0x3850C000, 0x38510000, 0x38514000, 0x38518000, 0x3851C000, 0x38520000, 0x38524000, 0x38528000, 0x3852C000, 0x38530000, 0x38534000, 0x38538000, 0x3853C000,
  0x38540000, 0x38544000, 0x38548000, 0x3854C000, 0x38550000, 0x38554000, 0x38558000, 0x3855C000, 0x38560000, 0x38564000, 0x38568000, 0x3856C000, 0x38570000, 0x38574000, 0x38578000, 0x3857C000,
  0x38580000, 0x38584000, 0x38588000, 0x3858C000, 0x38590000, 0x38594000, 0x38598000, 0x3859C000, 0x385A0000, 0x385A4000, 0x385A8000, 0x385AC000, 0x385B0000, 0x385B4000, 0x385B8000, 0x385BC000,
  0x385C0000, 0x385C4000, 0x385C8000, 0x385CC000, 0x385D0000, 0x385D4000, 0x385D8000, 0x385DC000, 0x385E0000, 0x385E4000, 0x385E8000, 0x385EC000, 0x385F0000, 0x385F4000, 0x385F8000, 0x385FC000,
  0x38600000, 0x38604000, 0x38608000, 0x3860C000, 0x38610000, 0x38614000, 0x38618000, 0x3861C000, 0x38620000, 0x38624000, 0x38628000, 0x3862C000, 0x38630000, 0x38634000, 0x38638000, 0x3863C000,
  0x38640000, 0x38644000, 0x38648000, 0x3864C000, 0x38650000, 0x38654000, 0x38658000, 0x3865C000, 0x38660000, 0x38664000, 0x38668000, 0x3866C000, 0x38670000, 0x38674000, 0x38678000, 0x3867C000,
  0x38680000, 0x38684000, 0x38688000, 0x3868C000, 0x38690000, 0x38694000, 0x38698000, 0x3869C000, 0x386A0000, 0x386A4000, 0x386A8000, 0x386AC000, 0x386B0000, 0x386B4000, 0x386B8000, 0x386BC000,
  0x386C0000, 0x386C4000, 0x386C8000, 0x386CC000, 0x386D0000, 0x386D4000, 0x386D8000, 0x386DC000, 0x386E0000, 0x386E4000, 0x386E8000, 0x386EC000, 0x386F0000, 0x386F4000, 0x386F8000, 0x386FC000,
  0x38700000, 0x38704000, 0x38708000, 0x3870C000, 0x38710000, 0x38714000, 0x38718000, 0x3871C000, 0x38720000, 0x38724000, 0x38728000, 0x3872C000, 0x38730000, 0x38734000, 0x38738000, 0x3873C000,
  0x38740000, 0x38744000, 0x38748000, 0x3874C000, 0x38750000, 0x38754000, 0x38758000, 0x3875C000, 0x38760000, 0x38764000, 0x38768000, 0x3876C000, 0x38770000, 0x38774000, 0x38778000, 0x3877C000,
  0x38780000, 0x38784000, 0x38788000, 0x3878C000, 0x38790000, 0x38794000, 0x38798000, 0x3879C000, 0x387A0000, 0x387A4000, 0x387A8000, 0x387AC000, 0x387B0000, 0x387B4000, 0x387B8000, 0x387BC000,
  0x387C0000, 0x387C4000, 0x387C8000, 0x387CC000, 0x387D0000, 0x387D4000, 0x387D8000, 0x387DC000, 0x387E0000, 0x387E4000, 0x387E8000, 0x387EC000, 0x387F0000, 0x387F4000, 0x387F8000, 0x387FC000,
  0x38000000, 0x38002000, 0x38004000, 0x38006000, 0x38008000, 0x3800A000, 0x3800C000, 0x3800E000, 0x38010000, 0x38012000, 0x38014000, 0x38016000, 0x38018000, 0x3801A000, 0x3801C000, 0x3801E000,
  0x38020000, 0x38022000, 0x38024000, 0x38026000, 0x38028000, 0x3802A000, 0x3802C000, 0x3802E000, 0x38030000, 0x38032000, 0x38034000, 0x38036000, 0x38038000, 0x3803A000, 0x3803C000, 0x3803E000,
  0x38040000, 0x38042000, 0x38044000, 0x38046000, 0x38048000, 0x3804A000, 0x3804C000, 0x3804E000, 0x38050000, 0x38052000, 0x38054000, 0x38056000, 0x38058000, 0x3805A000, 0x3805C000, 0x3805E000,
  0x38060000, 0x38062000, 0x38064000, 0x38066000, 0x38068000, 0x3806A000, 0x3806C000, 0x3806E000, 0x38070000, 0x38072000, 0x38074000, 0x38076000, 0x38078000, 0x3807A000, 0x3807C000, 0x3807E000,
  0x38080000, 0x38082000, 0x38084000, 0x38086000, 0x38088000, 0x3808A000, 0x3808C000, 0x3808E000, 0x38090000, 0x38092000, 0x38094000, 0x38096000, 0x38098000, 0x3809A000, 0x3809C000, 0x3809E000,
  0x380A0000, 0x380A2000, 0x380A4000, 0x380A6000, 0x380A8000, 0x380AA000, 0x380AC000, 0x380AE000, 0x380B0000, 0x380B2000, 0x380B4000, 0x380B6000, 0x380B8000, 0x380BA000, 0x380BC000, 0x380BE000,
  0x380C0000, 0x380C2000, 0x380C4000, 0x380C6000, 0x380C8000, 0x380CA000, 0x380CC000, 0x380CE000, 0x380D0000, 0x380D2000, 0x380D4000, 0x380D6000, 0x380D8000, 0x380DA000, 0x380DC000, 0x380DE000,
  0x380E0000, 0x380E2000, 0x380E4000, 0x380E6000, 0x380E8000, 0x380EA000, 0x380EC000, 0x380EE000, 0x380F0000, 0x380F2000, 0x380F4000, 0x380F6000, 0x380F8000, 0x380FA000, 0x380FC000, 0x380FE000,
  0x38100000, 0x38102000, 0x38104000, 0x38106000, 0x38108000, 0x3810A000, 0x3810C000, 0x3810E000, 0x38110000, 0x38112000, 0x38114000, 0x38116000, 0x38118000, 0x3811A000, 0x3811C000, 0x3811E000,
  0x38120000, 0x38122000, 0x38124000, 0x38126000, 0x38128000, 0x3812A000, 0x3812C000, 0x3812E000, 0x38130000, 0x38132000, 0x38134000, 0x38136000, 0x38138000, 0x3813A000, 0x3813C000, 0x3813E000,
  0x38140000, 0x38142000, 0x38144000, 0x38146000, 0x38148000, 0x3814A000, 0x3814C000, 0x3814E000, 0x38150000, 0x38152000, 0x38154000, 0x38156000, 0x38158000, 0x3815A000, 0x3815C000, 0x3815E000,
  0x38160000, 0x38162000, 0x38164000, 0x38166000, 0x38168000, 0x3816A000, 0x3816C000, 0x3816E000, 0x38170000, 0x38172000, 0x38174000, 0x38176000, 0x38178000, 0x3817A000, 0x3817C000, 0x3817E000,
  0x38180000, 0x38182000, 0x38184000, 0x38186000, 0x38188000, 0x3818A000, 0x3818C000, 0x3818E000, 0x38190000, 0x38192000, 0x38194000, 0x38196000, 0x38198000, 0x3819A000, 0x3819C000, 0x3819E000,
  0x381A0000, 0x381A2000, 0x381A4000, 0x381A6000, 0x381A8000, 0x381AA000, 0x381AC000, 0x381AE000, 0x381B0000, 0x381B2000, 0x381B4000, 0x381B6000, 0x381B8000, 0x381BA000, 0x381BC000, 0x381BE000,
  0x381C0000, 0x381C2000, 0x381C4000, 0x381C6000, 0x381C8000, 0x381CA000, 0x381CC000, 0x381CE000, 0x381D0000, 0x381D2000, 0x381D4000, 0x381D6000, 0x381D8000, 0x381DA000, 0x381DC000, 0x381DE000,
  0x381E0000, 0x381E2000, 0x381E4000, 0x381E6000, 0x381E8000, 0x381EA000, 0x381EC000, 0x381EE000, 0x381F0000, 0x381F2000, 0x381F4000, 0x381F6000, 0x381F8000, 0x381FA000, 0x381FC000, 0x381FE000,
  0x38200000, 0x38202000, 0x38204000, 0x38206000, 0x38208000, 0x3820A000, 0x3820C000, 0x3820E000, 0x38210000, 0x38212000, 0x38214000, 0x38216000, 0x38218000, 0x3821A000, 0x3821C000, 0x3821E000,
  0x38220000, 0x38222000, 0x38224000, 0x38226000, 0x38228000, 0x3822A000, 0x3822C000, 0x3822E000, 0x38230000, 0x38232000, 0x38234000, 0x38236000, 0x38238000, 0x3823A000, 0x3823C000, 0x3823E000,
  0x38240000, 0x38242000, 0x38244000, 0x38246000, 0x38248000, 0x3824A000, 0x3824C000, 0x3824E000, 0x38250000, 0x38252000, 0x38254000, 0x38256000, 0x38258000, 0x3825A000, 0x3825C000, 0x3825E000,
  0x38260000, 0x38262000, 0x38264000, 0x38266000, 0x38268000, 0x3826A000, 0x3826C000, 0x3826E000, 0x38270000, 0x38272000, 0x38274000, 0x38276000, 0x38278000, 0x3827A000, 0x3827C000, 0x3827E000,
  0x38280000, 0x38282000, 0x38284000, 0x38286000, 0x38288000, 0x3828A000, 0x3828C000, 0x3828E000, 0x38290000, 0x38292000, 0x38294000, 0x38296000, 0x38298000, 0x3829A000, 0x3829C000, 0x3829E000,
  0x382A0000, 0x382A2000, 0x382A4000, 0x382A6000, 0x382A8000, 0x382AA000, 0x382AC000, 0x382AE000, 0x382B0000, 0x382B2000, 0x382B4000, 0x382B6000, 0x382B8000, 0x382BA000, 0x382BC000, 0x382BE000,
  0x382C0000, 0x382C2000, 0x382C4000, 0x382C6000, 0x382C8000, 0x382CA000, 0x382CC000, 0x382CE000, 0x382D0000, 0x382D2000, 0x382D4000, 0x382D6000, 0x382D8000, 0x382DA000, 0x382DC000, 0x382DE000,
  0x382E0000, 0x382E2000, 0x382E4000, 0x382E6000, 0x382E8000, 0x382EA000, 0x382EC000, 0x382EE000, 0x382F0000, 0x382F2000, 0x382F4000, 0x382F6000, 0x382F8000, 0x382FA000, 0x382FC000, 0x382FE000,
  0x38300000, 0x38302000, 0x38304000, 0x38306000, 0x38308000, 0x3830A000, 0x3830C000, 0x3830E000, 0x38310000, 0x38312000, 0x38314000, 0x38316000, 0x38318000, 0x3831A000, 0x3831C000, 0x3831E000,
  0x38320000, 0x38322000, 0x38324000, 0x38326000, 0x38328000, 0x3832A000, 0x3832C000, 0x3832E000, 0x38330000, 0x38332000, 0x38334000, 0x38336000, 0x38338000, 0x3833A000, 0x3833C000, 0x3833E000,
  0x38340000, 0x38342000, 0x38344000, 0x38346000, 0x38348000, 0x3834A000, 0x3834C000, 0x3834E000, 0x38350000, 0x38352000, 0x38354000, 0x38356000, 0x38358000, 0x3835A000, 0x3835C000, 0x3835E000,
  0x38360000, 0x38362000, 0x38364000, 0x38366000, 0x38368000, 0x3836A000, 0x3836C000, 0x3836E000, 0x38370000, 0x38372000, 0x38374000, 0x38376000, 0x38378000, 0x3837A000, 0x3837C000, 0x3837E000,
  0x38380000, 0x38382000, 0x38384000, 0x38386000, 0x38388000, 0x3838A000, 0x3838C000, 0x3838E000, 0x38390000, 0x38392000, 0x38394000, 0x38396000, 0x38398000, 0x3839A000, 0x3839C000, 0x3839E000,
  0x383A0000, 0x383A2000, 0x383A4000, 0x383A6000, 0x383A8000, 0x383AA000, 0x383AC000, 0x383AE000, 0x383B0000, 0x383B2000, 0x383B4000, 0x383B6000, 0x383B8000, 0x383BA000, 0x383BC000, 0x383BE000,
  0x383C0000, 0x383C2000, 0x383C4000, 0x383C6000, 0x383C8000, 0x383CA000, 0x383CC000, 0x383CE000, 0x383D0000, 0x383D2000, 0x383D4000, 0x383D6000, 0x383D8000, 0x383DA000, 0x383DC000, 0x383DE000,
  0x383E0000, 0x383E2000, 0x383E4000, 0x383E6000, 0x383E8000, 0x383EA000, 0x383EC000, 0x383EE000, 0x383F0000, 0x383F2000, 0x383F4000, 0x383F6000, 0x383F8000, 0x383FA000, 0x383FC000, 0x383FE000,
  0x38400000, 0x38402000, 0x38404000, 0x38406000, 0x38408000, 0x3840A000, 0x3840C000, 0x3840E000, 0x38410000, 0x38412000, 0x38414000, 0x38416000, 0x38418000, 0x3841A000, 0x3841C000, 0x3841E000,
  0x38420000, 0x38422000, 0x38424000, 0x38426000, 0x38428000, 0x3842A000, 0x3842C000, 0x3842E000, 0x38430000, 0x38432000, 0x38434000, 0x38436000, 0x38438000, 0x3843A000, 0x3843C000, 0x3843E000,
  0x38440000, 0x38442000, 0x38444000, 0x38446000, 0x38448000, 0x3844A000, 0x3844C000, 0x3844E000, 0x38450000, 0x38452000, 0x38454000, 0x38456000, 0x38458000, 0x3845A000, 0x3845C000, 0x3845E000,
  0x38460000, 0x38462000, 0x38464000, 0x38466000, 0x38468000, 0x3846A000, 0x3846C000, 0x3846E000, 0x38470000, 0x38472000, 0x38474000, 0x38476000, 0x38478000, 0x3847A000, 0x3847C000, 0x3847E000,
  0x38480000, 0x38482000, 0x38484000, 0x38486000, 0x38488000, 0x3848A000, 0x3848C000, 0x3848E000, 0x38490000, 0x38492000, 0x38494000, 0x38496000, 0x38498000, 0x3849A000, 0x3849C000, 0x3849E000,
  0x384A0000, 0x384A2000, 0x384A4000, 0x384A6000, 0x384A8000, 0x384AA000, 0x384AC000, 0x384AE000, 0x384B0000, 0x384B2000, 0x384B4000, 0x384B6000, 0x384B8000, 0x384BA000, 0x384BC000, 0x384BE000,
  0x384C0000, 0x384C2000, 0x384C4000, 0x384C6000, 0x384C8000, 0x384CA000, 0x384CC000, 0x384CE000, 0x384D0000, 0x384D2000, 0x384D4000, 0x384D6000, 0x384D8000, 0x384DA000, 0x384DC000, 0x384DE000,
  0x384E0000, 0x384E2000, 0x384E4000, 0x384E6000, 0x384E8000, 0x384EA000, 0x384EC000, 0x384EE000, 0x384F0000, 0x384F2000, 0x384F4000, 0x384F6000, 0x384F8000, 0x384FA000, 0x384FC000, 0x384FE000,
  0x38500000, 0x38502000, 0x38504000, 0x38506000, 0x38508000, 0x3850A000, 0x3850C000, 0x3850E000, 0x38510000, 0x38512000, 0x38514000, 0x38516000, 0x38518000, 0x3851A000, 0x3851C000, 0x3851E000,
  0x38520000, 0x38522000, 0x38524000, 0x38526000, 0x38528000, 0x3852A000, 0x3852C000, 0x3852E000, 0x38530000, 0x38532000, 0x38534000, 0x38536000, 0x38538000, 0x3853A000, 0x3853C000, 0x3853E000,
  0x38540000, 0x38542000, 0x38544000, 0x38546000, 0x38548000, 0x3854A000, 0x3854C000, 0x3854E000, 0x38550000, 0x38552000, 0x38554000, 0x38556000, 0x38558000, 0x3855A000, 0x3855C000, 0x3855E000,
  0x38560000, 0x38562000, 0x38564000, 0x38566000, 0x38568000, 0x3856A000, 0x3856C000, 0x3856E000, 0x38570000, 0x38572000, 0x38574000, 0x38576000, 0x38578000, 0x3857A000, 0x3857C000, 0x3857E000,
  0x38580000, 0x38582000, 0x38584000, 0x38586000, 0x38588000, 0x3858A000, 0x3858C000, 0x3858E000, 0x38590000, 0x38592000, 0x38594000, 0x38596000, 0x38598000, 0x3859A000, 0x3859C000, 0x3859E000,
  0x385A0000, 0x385A2000, 0x385A4000, 0x385A6000, 0x385A8000, 0x385AA000, 0x385AC000, 0x385AE000, 0x385B0000, 0x385B2000, 0x385B4000, 0x385B6000, 0x385B8000, 0x385BA000, 0x385BC000, 0x385BE000,
  0x385C0000, 0x385C2000, 0x385C4000, 0x385C6000, 0x385C8000, 0x385CA000, 0x385CC000, 0x385CE000, 0x385D0000, 0x385D2000, 0x385D4000, 0x385D6000, 0x385D8000, 0x385DA000, 0x385DC000, 0x385DE000,
  0x385E0000, 0x385E2000, 0x385E4000, 0x385E6000, 0x385E8000, 0x385EA000, 0x385EC000, 0x385EE000, 0x385F0000, 0x385F2000, 0x385F4000, 0x385F6000, 0x385F8000, 0x385FA000, 0x385FC000, 0x385FE000,
  0x38600000, 0x38602000, 0x38604000, 0x38606000, 0x38608000, 0x3860A000, 0x3860C000, 0x3860E000, 0x38610000, 0x38612000, 0x38614000, 0x38616000, 0x38618000, 0x3861A000, 0x3861C000, 0x3861E000,
  0x38620000, 0x38622000, 0x38624000, 0x38626000, 0x38628000, 0x3862A000, 0x3862C000, 0x3862E000, 0x38630000, 0x38632000, 0x38634000, 0x38636000, 0x38638000, 0x3863A000, 0x3863C000, 0x3863E000,
  0x38640000, 0x38642000, 0x38644000, 0x38646000, 0x38648000, 0x3864A000, 0x3864C000, 0x3864E000, 0x38650000, 0x38652000, 0x38654000, 0x38656000, 0x38658000, 0x3865A000, 0x3865C000, 0x3865E000,
  0x38660000, 0x38662000, 0x38664000, 0x38666000, 0x38668000, 0x3866A000, 0x3866C000, 0x3866E000, 0x38670000, 0x38672000, 0x38674000, 0x38676000, 0x38678000, 0x3867A000, 0x3867C000, 0x3867E000,
  0x38680000, 0x38682000, 0x38684000, 0x38686000, 0x38688000, 0x3868A000, 0x3868C000, 0x3868E000, 0x38690000, 0x38692000, 0x38694000, 0x38696000, 0x38698000, 0x3869A000, 0x3869C000, 0x3869E000,
  0x386A0000, 0x386A2000, 0x386A4000, 0x386A6000, 0x386A8000, 0x386AA000, 0x386AC000, 0x386AE000, 0x386B0000, 0x386B2000, 0x386B4000, 0x386B6000, 0x386B8000, 0x386BA000, 0x386BC000, 0x386BE000,
  0x386C0000, 0x386C2000, 0x386C4000, 0x386C6000, 0x386C8000, 0x386CA000, 0x386CC000, 0x386CE000, 0x386D0000, 0x386D2000, 0x386D4000, 0x386D6000, 0x386D8000, 0x386DA000, 0x386DC000, 0x386DE000,
  0x386E0000, 0x386E2000, 0x386E4000, 0x386E6000, 0x386E8000, 0x386EA000, 0x386EC000, 0x386EE000, 0x386F0000, 0x386F2000, 0x386F4000, 0x386F6000, 0x386F8000, 0x386FA000, 0x386FC000, 0x386FE000,
  0x38700000, 0x38702000, 0x38704000, 0x38706000, 0x38708000, 0x3870A000, 0x3870C000, 0x3870E000, 0x38710000, 0x38712000, 0x38714000, 0x38716000, 0x38718000, 0x3871A000, 0x3871C000, 0x3871E000,
  0x38720000, 0x38722000, 0x38724000, 0x38726000, 0x38728000, 0x3872A000, 0x3872C000, 0x3872E000, 0x38730000, 0x38732000, 0x38734000, 0x38736000, 0x38738000, 0x3873A000, 0x3873C000, 0x3873E000,
  0x38740000, 0x38742000, 0x38744000, 0x38746000, 0x38748000, 0x3874A000, 0x3874C000, 0x3874E000, 0x38750000, 0x38752000, 0x38754000, 0x38756000, 0x38758000, 0x3875A000, 0x3875C000, 0x3875E000,
  0x38760000, 0x38762000, 0x38764000, 0x38766000, 0x38768000, 0x3876A000, 0x3876C000, 0x3876E000, 0x38770000, 0x38772000, 0x38774000, 0x38776000, 0x38778000, 0x3877A000, 0x3877C000, 0x3877E000,
  0x38780000, 0x38782000, 0x38784000, 0x38786000, 0x38788000, 0x3878A000, 0x3878C000, 0x3878E000, 0x38790000, 0x38792000, 0x38794000, 0x38796000, 0x38798000, 0x3879A000, 0x3879C000, 0x3879E000,
  0x387A0000, 0x387A2000, 0x387A4000, 0x387A6000, 0x387A8000, 0x387AA000, 0x387AC000, 0x387AE000, 0x387B0000, 0x387B2000, 0x387B4000, 0x387B6000, 0x387B8000, 0x387BA000, 0x387BC000, 0x387BE000,
  0x387C0000, 0x387C2000, 0x387C4000, 0x387C6000, 0x387C8000, 0x387CA000, 0x387CC000, 0x387CE000, 0x387D0000, 0x387D2000, 0x387D4000, 0x387D6000, 0x387D8000, 0x387DA000, 0x387DC000, 0x387DE000,
  0x387E0000, 0x387E2000, 0x387E4000, 0x387E6000, 0x387E8000, 0x387EA000, 0x387EC000, 0x387EE000, 0x387F0000, 0x387F2000, 0x387F4000, 0x387F6000, 0x387F8000, 0x387FA000, 0x387FC000, 0x387FE000 };
__constant static const uint32_t exponent_table[64] = {
  0x00000000, 0x00800000, 0x01000000, 0x01800000, 0x02000000, 0x02800000, 0x03000000, 0x03800000, 0x04000000, 0x04800000, 0x05000000, 0x05800000, 0x06000000, 0x06800000, 0x07000000, 0x07800000,
  0x08000000, 0x08800000, 0x09000000, 0x09800000, 0x0A000000, 0x0A800000, 0x0B000000, 0x0B800000, 0x0C000000, 0x0C800000, 0x0D000000, 0x0D800000, 0x0E000000, 0x0E800000, 0x0F000000, 0x47800000,
  0x80000000, 0x80800000, 0x81000000, 0x81800000, 0x82000000, 0x82800000, 0x83000000, 0x83800000, 0x84000000, 0x84800000, 0x85000000, 0x85800000, 0x86000000, 0x86800000, 0x87000000, 0x87800000,
  0x88000000, 0x88800000, 0x89000000, 0x89800000, 0x8A000000, 0x8A800000, 0x8B000000, 0x8B800000, 0x8C000000, 0x8C800000, 0x8D000000, 0x8D800000, 0x8E000000, 0x8E800000, 0x8F000000, 0xC7800000 };
__constant static const unsigned short offset_table[64] = {
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024 };

static uint16_t float2halfbits(float value) {
  union { float x; uint32_t y; } u;
  u.x = value;
  uint32_t bits = u.y;

  uint16_t hbits = base_table[bits>>23] + (uint16_t)((bits&0x7FFFFF)>>shift_table[bits>>23]);;

  return hbits;
}

static float halfbits2float(uint16_t value) {
  uint32_t bits = mantissa_table[offset_table[value>>10]+(value&0x3FF)] + exponent_table[value>>10];

  union { uint32_t x; float y; } u;
  u.x = bits;
  return u.y;
}

// End of half.h.
// Start of timing.h.

// The function get_wall_time() returns the wall time in microseconds
// (with an unspecified offset).

#ifdef _WIN32

#include <windows.h>

static int64_t get_wall_time(void) {
  LARGE_INTEGER time,freq;
  assert(QueryPerformanceFrequency(&freq));
  assert(QueryPerformanceCounter(&time));
  return ((double)time.QuadPart / freq.QuadPart) * 1000000;
}

#else
// Assuming POSIX

#include <time.h>
#include <sys/time.h>

static int64_t get_wall_time(void) {
  struct timeval time;
  assert(gettimeofday(&time,NULL) == 0);
  return time.tv_sec * 1000000 + time.tv_usec;
}

static int64_t get_wall_time_ns(void) {
  struct timespec time;
  assert(clock_gettime(CLOCK_REALTIME, &time) == 0);
  return time.tv_sec * 1000000000 + time.tv_nsec;
}

#endif

// End of timing.h.

#ifdef _MSC_VER
#define inline __inline
#endif
#include <string.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <ctype.h>



// Start of lock.h.

// A very simple cross-platform implementation of locks.  Uses
// pthreads on Unix and some Windows thing there.  Futhark's
// host-level code is not multithreaded, but user code may be, so we
// need some mechanism for ensuring atomic access to API functions.
// This is that mechanism.  It is not exposed to user code at all, so
// we do not have to worry about name collisions.

#ifdef _WIN32

typedef HANDLE lock_t;

static void create_lock(lock_t *lock) {
  *lock = CreateMutex(NULL,  // Default security attributes.
                      FALSE, // Initially unlocked.
                      NULL); // Unnamed.
}

static void lock_lock(lock_t *lock) {
  assert(WaitForSingleObject(*lock, INFINITE) == WAIT_OBJECT_0);
}

static void lock_unlock(lock_t *lock) {
  assert(ReleaseMutex(*lock));
}

static void free_lock(lock_t *lock) {
  CloseHandle(*lock);
}

#else
// Assuming POSIX

#include <pthread.h>

typedef pthread_mutex_t lock_t;

static void create_lock(lock_t *lock) {
  int r = pthread_mutex_init(lock, NULL);
  assert(r == 0);
}

static void lock_lock(lock_t *lock) {
  int r = pthread_mutex_lock(lock);
  assert(r == 0);
}

static void lock_unlock(lock_t *lock) {
  int r = pthread_mutex_unlock(lock);
  assert(r == 0);
}

static void free_lock(lock_t *lock) {
  // Nothing to do for pthreads.
  (void)lock;
}

#endif

// End of lock.h.

#define FUTHARK_F64_ENABLED

// Start of scalar.h.

// Implementation of the primitive scalar operations.  Very
// repetitive.  This code is inserted directly into both CUDA and
// OpenCL programs, as well as the CPU code, so it has some #ifdefs to
// work everywhere.  Some operations are defined as macros because
// this allows us to use them as constant expressions in things like
// array sizes and static initialisers.

// Some of the #ifdefs are because OpenCL uses type-generic functions
// for some operations (e.g. sqrt), while C and CUDA sensibly use
// distinct functions for different precisions (e.g. sqrtf() and
// sqrt()).  This is quite annoying.  Due to C's unfortunate casting
// rules, it is also really easy to accidentally implement
// floating-point functions in the wrong precision, so be careful.

// Double-precision definitions are only included if the preprocessor
// macro FUTHARK_F64_ENABLED is set.

static inline uint8_t add8(uint8_t x, uint8_t y) {
  return x + y;
}

static inline uint16_t add16(uint16_t x, uint16_t y) {
  return x + y;
}

static inline uint32_t add32(uint32_t x, uint32_t y) {
  return x + y;
}

static inline uint64_t add64(uint64_t x, uint64_t y) {
  return x + y;
}

static inline uint8_t sub8(uint8_t x, uint8_t y) {
  return x - y;
}

static inline uint16_t sub16(uint16_t x, uint16_t y) {
  return x - y;
}

static inline uint32_t sub32(uint32_t x, uint32_t y) {
  return x - y;
}

static inline uint64_t sub64(uint64_t x, uint64_t y) {
  return x - y;
}

static inline uint8_t mul8(uint8_t x, uint8_t y) {
  return x * y;
}

static inline uint16_t mul16(uint16_t x, uint16_t y) {
  return x * y;
}

static inline uint32_t mul32(uint32_t x, uint32_t y) {
  return x * y;
}

static inline uint64_t mul64(uint64_t x, uint64_t y) {
  return x * y;
}

static inline uint8_t udiv8(uint8_t x, uint8_t y) {
  return x / y;
}

static inline uint16_t udiv16(uint16_t x, uint16_t y) {
  return x / y;
}

static inline uint32_t udiv32(uint32_t x, uint32_t y) {
  return x / y;
}

static inline uint64_t udiv64(uint64_t x, uint64_t y) {
  return x / y;
}

static inline uint8_t udiv_up8(uint8_t x, uint8_t y) {
  return (x + y - 1) / y;
}

static inline uint16_t udiv_up16(uint16_t x, uint16_t y) {
  return (x + y - 1) / y;
}

static inline uint32_t udiv_up32(uint32_t x, uint32_t y) {
  return (x + y - 1) / y;
}

static inline uint64_t udiv_up64(uint64_t x, uint64_t y) {
  return (x + y - 1) / y;
}

static inline uint8_t umod8(uint8_t x, uint8_t y) {
  return x % y;
}

static inline uint16_t umod16(uint16_t x, uint16_t y) {
  return x % y;
}

static inline uint32_t umod32(uint32_t x, uint32_t y) {
  return x % y;
}

static inline uint64_t umod64(uint64_t x, uint64_t y) {
  return x % y;
}

static inline uint8_t udiv_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint16_t udiv_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint32_t udiv_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint64_t udiv_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint8_t udiv_up_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint16_t udiv_up_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint32_t udiv_up_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint64_t udiv_up_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint8_t umod_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint16_t umod_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint32_t umod_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint64_t umod_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t sdiv8(int8_t x, int8_t y) {
  int8_t q = x / y;
  int8_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int16_t sdiv16(int16_t x, int16_t y) {
  int16_t q = x / y;
  int16_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int32_t sdiv32(int32_t x, int32_t y) {
  int32_t q = x / y;
  int32_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int64_t sdiv64(int64_t x, int64_t y) {
  int64_t q = x / y;
  int64_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int8_t sdiv_up8(int8_t x, int8_t y) {
  return sdiv8(x + y - 1, y);
}

static inline int16_t sdiv_up16(int16_t x, int16_t y) {
  return sdiv16(x + y - 1, y);
}

static inline int32_t sdiv_up32(int32_t x, int32_t y) {
  return sdiv32(x + y - 1, y);
}

static inline int64_t sdiv_up64(int64_t x, int64_t y) {
  return sdiv64(x + y - 1, y);
}

static inline int8_t smod8(int8_t x, int8_t y) {
  int8_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int16_t smod16(int16_t x, int16_t y) {
  int16_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int32_t smod32(int32_t x, int32_t y) {
  int32_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int64_t smod64(int64_t x, int64_t y) {
  int64_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int8_t sdiv_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : sdiv8(x, y);
}

static inline int16_t sdiv_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : sdiv16(x, y);
}

static inline int32_t sdiv_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : sdiv32(x, y);
}

static inline int64_t sdiv_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : sdiv64(x, y);
}

static inline int8_t sdiv_up_safe8(int8_t x, int8_t y) {
  return sdiv_safe8(x + y - 1, y);
}

static inline int16_t sdiv_up_safe16(int16_t x, int16_t y) {
  return sdiv_safe16(x + y - 1, y);
}

static inline int32_t sdiv_up_safe32(int32_t x, int32_t y) {
  return sdiv_safe32(x + y - 1, y);
}

static inline int64_t sdiv_up_safe64(int64_t x, int64_t y) {
  return sdiv_safe64(x + y - 1, y);
}

static inline int8_t smod_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : smod8(x, y);
}

static inline int16_t smod_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : smod16(x, y);
}

static inline int32_t smod_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : smod32(x, y);
}

static inline int64_t smod_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : smod64(x, y);
}

static inline int8_t squot8(int8_t x, int8_t y) {
  return x / y;
}

static inline int16_t squot16(int16_t x, int16_t y) {
  return x / y;
}

static inline int32_t squot32(int32_t x, int32_t y) {
  return x / y;
}

static inline int64_t squot64(int64_t x, int64_t y) {
  return x / y;
}

static inline int8_t srem8(int8_t x, int8_t y) {
  return x % y;
}

static inline int16_t srem16(int16_t x, int16_t y) {
  return x % y;
}

static inline int32_t srem32(int32_t x, int32_t y) {
  return x % y;
}

static inline int64_t srem64(int64_t x, int64_t y) {
  return x % y;
}

static inline int8_t squot_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int16_t squot_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int32_t squot_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int64_t squot_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int8_t srem_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int16_t srem_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int32_t srem_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int64_t srem_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t smin8(int8_t x, int8_t y) {
  return x < y ? x : y;
}

static inline int16_t smin16(int16_t x, int16_t y) {
  return x < y ? x : y;
}

static inline int32_t smin32(int32_t x, int32_t y) {
  return x < y ? x : y;
}

static inline int64_t smin64(int64_t x, int64_t y) {
  return x < y ? x : y;
}

static inline uint8_t umin8(uint8_t x, uint8_t y) {
  return x < y ? x : y;
}

static inline uint16_t umin16(uint16_t x, uint16_t y) {
  return x < y ? x : y;
}

static inline uint32_t umin32(uint32_t x, uint32_t y) {
  return x < y ? x : y;
}

static inline uint64_t umin64(uint64_t x, uint64_t y) {
  return x < y ? x : y;
}

static inline int8_t smax8(int8_t x, int8_t y) {
  return x < y ? y : x;
}

static inline int16_t smax16(int16_t x, int16_t y) {
  return x < y ? y : x;
}

static inline int32_t smax32(int32_t x, int32_t y) {
  return x < y ? y : x;
}

static inline int64_t smax64(int64_t x, int64_t y) {
  return x < y ? y : x;
}

static inline uint8_t umax8(uint8_t x, uint8_t y) {
  return x < y ? y : x;
}

static inline uint16_t umax16(uint16_t x, uint16_t y) {
  return x < y ? y : x;
}

static inline uint32_t umax32(uint32_t x, uint32_t y) {
  return x < y ? y : x;
}

static inline uint64_t umax64(uint64_t x, uint64_t y) {
  return x < y ? y : x;
}

static inline uint8_t shl8(uint8_t x, uint8_t y) {
  return (uint8_t)(x << y);
}

static inline uint16_t shl16(uint16_t x, uint16_t y) {
  return (uint16_t)(x << y);
}

static inline uint32_t shl32(uint32_t x, uint32_t y) {
  return x << y;
}

static inline uint64_t shl64(uint64_t x, uint64_t y) {
  return x << y;
}

static inline uint8_t lshr8(uint8_t x, uint8_t y) {
  return x >> y;
}

static inline uint16_t lshr16(uint16_t x, uint16_t y) {
  return x >> y;
}

static inline uint32_t lshr32(uint32_t x, uint32_t y) {
  return x >> y;
}

static inline uint64_t lshr64(uint64_t x, uint64_t y) {
  return x >> y;
}

static inline int8_t ashr8(int8_t x, int8_t y) {
  return x >> y;
}

static inline int16_t ashr16(int16_t x, int16_t y) {
  return x >> y;
}

static inline int32_t ashr32(int32_t x, int32_t y) {
  return x >> y;
}

static inline int64_t ashr64(int64_t x, int64_t y) {
  return x >> y;
}

static inline uint8_t and8(uint8_t x, uint8_t y) {
  return x & y;
}

static inline uint16_t and16(uint16_t x, uint16_t y) {
  return x & y;
}

static inline uint32_t and32(uint32_t x, uint32_t y) {
  return x & y;
}

static inline uint64_t and64(uint64_t x, uint64_t y) {
  return x & y;
}

static inline uint8_t or8(uint8_t x, uint8_t y) {
  return x | y;
}

static inline uint16_t or16(uint16_t x, uint16_t y) {
  return x | y;
}

static inline uint32_t or32(uint32_t x, uint32_t y) {
  return x | y;
}

static inline uint64_t or64(uint64_t x, uint64_t y) {
  return x | y;
}

static inline uint8_t xor8(uint8_t x, uint8_t y) {
  return x ^ y;
}

static inline uint16_t xor16(uint16_t x, uint16_t y) {
  return x ^ y;
}

static inline uint32_t xor32(uint32_t x, uint32_t y) {
  return x ^ y;
}

static inline uint64_t xor64(uint64_t x, uint64_t y) {
  return x ^ y;
}

static inline bool ult8(uint8_t x, uint8_t y) {
  return x < y;
}

static inline bool ult16(uint16_t x, uint16_t y) {
  return x < y;
}

static inline bool ult32(uint32_t x, uint32_t y) {
  return x < y;
}

static inline bool ult64(uint64_t x, uint64_t y) {
  return x < y;
}

static inline bool ule8(uint8_t x, uint8_t y) {
  return x <= y;
}

static inline bool ule16(uint16_t x, uint16_t y) {
  return x <= y;
}

static inline bool ule32(uint32_t x, uint32_t y) {
  return x <= y;
}

static inline bool ule64(uint64_t x, uint64_t y) {
  return x <= y;
}

static inline bool slt8(int8_t x, int8_t y) {
  return x < y;
}

static inline bool slt16(int16_t x, int16_t y) {
  return x < y;
}

static inline bool slt32(int32_t x, int32_t y) {
  return x < y;
}

static inline bool slt64(int64_t x, int64_t y) {
  return x < y;
}

static inline bool sle8(int8_t x, int8_t y) {
  return x <= y;
}

static inline bool sle16(int16_t x, int16_t y) {
  return x <= y;
}

static inline bool sle32(int32_t x, int32_t y) {
  return x <= y;
}

static inline bool sle64(int64_t x, int64_t y) {
  return x <= y;
}

static inline uint8_t pow8(uint8_t x, uint8_t y) {
  uint8_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint16_t pow16(uint16_t x, uint16_t y) {
  uint16_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint32_t pow32(uint32_t x, uint32_t y) {
  uint32_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint64_t pow64(uint64_t x, uint64_t y) {
  uint64_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline bool itob_i8_bool(int8_t x) {
  return x;
}

static inline bool itob_i16_bool(int16_t x) {
  return x;
}

static inline bool itob_i32_bool(int32_t x) {
  return x;
}

static inline bool itob_i64_bool(int64_t x) {
  return x;
}

static inline int8_t btoi_bool_i8(bool x) {
  return x;
}

static inline int16_t btoi_bool_i16(bool x) {
  return x;
}

static inline int32_t btoi_bool_i32(bool x) {
  return x;
}

static inline int64_t btoi_bool_i64(bool x) {
  return x;
}

#define sext_i8_i8(x) ((int8_t) (int8_t) (x))
#define sext_i8_i16(x) ((int16_t) (int8_t) (x))
#define sext_i8_i32(x) ((int32_t) (int8_t) (x))
#define sext_i8_i64(x) ((int64_t) (int8_t) (x))
#define sext_i16_i8(x) ((int8_t) (int16_t) (x))
#define sext_i16_i16(x) ((int16_t) (int16_t) (x))
#define sext_i16_i32(x) ((int32_t) (int16_t) (x))
#define sext_i16_i64(x) ((int64_t) (int16_t) (x))
#define sext_i32_i8(x) ((int8_t) (int32_t) (x))
#define sext_i32_i16(x) ((int16_t) (int32_t) (x))
#define sext_i32_i32(x) ((int32_t) (int32_t) (x))
#define sext_i32_i64(x) ((int64_t) (int32_t) (x))
#define sext_i64_i8(x) ((int8_t) (int64_t) (x))
#define sext_i64_i16(x) ((int16_t) (int64_t) (x))
#define sext_i64_i32(x) ((int32_t) (int64_t) (x))
#define sext_i64_i64(x) ((int64_t) (int64_t) (x))
#define zext_i8_i8(x) ((int8_t) (uint8_t) (x))
#define zext_i8_i16(x) ((int16_t) (uint8_t) (x))
#define zext_i8_i32(x) ((int32_t) (uint8_t) (x))
#define zext_i8_i64(x) ((int64_t) (uint8_t) (x))
#define zext_i16_i8(x) ((int8_t) (uint16_t) (x))
#define zext_i16_i16(x) ((int16_t) (uint16_t) (x))
#define zext_i16_i32(x) ((int32_t) (uint16_t) (x))
#define zext_i16_i64(x) ((int64_t) (uint16_t) (x))
#define zext_i32_i8(x) ((int8_t) (uint32_t) (x))
#define zext_i32_i16(x) ((int16_t) (uint32_t) (x))
#define zext_i32_i32(x) ((int32_t) (uint32_t) (x))
#define zext_i32_i64(x) ((int64_t) (uint32_t) (x))
#define zext_i64_i8(x) ((int8_t) (uint64_t) (x))
#define zext_i64_i16(x) ((int16_t) (uint64_t) (x))
#define zext_i64_i32(x) ((int32_t) (uint64_t) (x))
#define zext_i64_i64(x) ((int64_t) (uint64_t) (x))

static int8_t abs8(int8_t x) {
  return (int8_t)abs(x);
}

static int16_t abs16(int16_t x) {
  return (int16_t)abs(x);
}

static int32_t abs32(int32_t x) {
  return abs(x);
}

static int64_t abs64(int64_t x) {
#if defined(__OPENCL_VERSION__)
  return abs(x);
#else
  return llabs(x);
#endif
}

#if defined(__OPENCL_VERSION__)
static int32_t futrts_popc8(int8_t x) {
  return popcount(x);
}

static int32_t futrts_popc16(int16_t x) {
  return popcount(x);
}

static int32_t futrts_popc32(int32_t x) {
  return popcount(x);
}

static int32_t futrts_popc64(int64_t x) {
  return popcount(x);
}
#elif defined(__CUDA_ARCH__)

static int32_t futrts_popc8(int8_t x) {
  return __popc(zext_i8_i32(x));
}

static int32_t futrts_popc16(int16_t x) {
  return __popc(zext_i16_i32(x));
}

static int32_t futrts_popc32(int32_t x) {
  return __popc(x);
}

static int32_t futrts_popc64(int64_t x) {
  return __popcll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_popc8(uint8_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc16(uint16_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc32(uint32_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc64(uint64_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  return mul_hi(a, b);
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  return mul_hi(a, b);
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mul_hi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul_hi(a, b);
}

#elif defined(__CUDA_ARCH__)

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mulhi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul64hi(a, b);
}

#else // Not OpenCL or CUDA, but plain C.

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  uint64_t aa = a;
  uint64_t bb = b;

  return aa * bb >> 32;
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  __uint128_t aa = a;
  __uint128_t bb = b;

  return aa * bb >> 64;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return mad_hi(a, b, c);
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return mad_hi(a, b, c);
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return mad_hi(a, b, c);
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return mad_hi(a, b, c);
}

#else // Not OpenCL

static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return futrts_mul_hi8(a, b) + c;
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return futrts_mul_hi16(a, b) + c;
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return futrts_mul_hi32(a, b) + c;
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return futrts_mul_hi64(a, b) + c;
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_clzz8(int8_t x) {
  return clz(x);
}

static int32_t futrts_clzz16(int16_t x) {
  return clz(x);
}

static int32_t futrts_clzz32(int32_t x) {
  return clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return clz(x);
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_clzz8(int8_t x) {
  return __clz(zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return __clz(zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return __clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return __clzll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_clzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_clz((uint32_t)zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_clz((uint32_t)zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_clz((uint32_t)x);
}

static int32_t futrts_clzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_clzll((uint64_t)x);
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_ctzz8(int8_t x) {
  int i = 0;
  for (; i < 8 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz16(int16_t x) {
  int i = 0;
  for (; i < 16 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz32(int32_t x) {
  int i = 0;
  for (; i < 32 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz64(int64_t x) {
  int i = 0;
  for (; i < 64 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_ctzz8(int8_t x) {
  int y = __ffs(x);
  return y == 0 ? 8 : y - 1;
}

static int32_t futrts_ctzz16(int16_t x) {
  int y = __ffs(x);
  return y == 0 ? 16 : y - 1;
}

static int32_t futrts_ctzz32(int32_t x) {
  int y = __ffs(x);
  return y == 0 ? 32 : y - 1;
}

static int32_t futrts_ctzz64(int64_t x) {
  int y = __ffsll(x);
  return y == 0 ? 64 : y - 1;
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_ctzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_ctzll((uint64_t)x);
}
#endif

static inline float fdiv32(float x, float y) {
  return x / y;
}

static inline float fadd32(float x, float y) {
  return x + y;
}

static inline float fsub32(float x, float y) {
  return x - y;
}

static inline float fmul32(float x, float y) {
  return x * y;
}

static inline bool cmplt32(float x, float y) {
  return x < y;
}

static inline bool cmple32(float x, float y) {
  return x <= y;
}

static inline float sitofp_i8_f32(int8_t x) {
  return (float) x;
}

static inline float sitofp_i16_f32(int16_t x) {
  return (float) x;
}

static inline float sitofp_i32_f32(int32_t x) {
  return (float) x;
}

static inline float sitofp_i64_f32(int64_t x) {
  return (float) x;
}

static inline float uitofp_i8_f32(uint8_t x) {
  return (float) x;
}

static inline float uitofp_i16_f32(uint16_t x) {
  return (float) x;
}

static inline float uitofp_i32_f32(uint32_t x) {
  return (float) x;
}

static inline float uitofp_i64_f32(uint64_t x) {
  return (float) x;
}

static inline int8_t fptosi_f32_i8(float x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f32_i16(float x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f32_i32(float x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f32_i64(float x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f32_i8(float x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f32_i16(float x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f32_i32(float x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f32_i64(float x) {
  return (uint64_t) x;
}

#ifdef __OPENCL_VERSION__
static inline float fabs32(float x) {
  return fabs(x);
}

static inline float fmax32(float x, float y) {
  return fmax(x, y);
}

static inline float fmin32(float x, float y) {
  return fmin(x, y);
}

static inline float fpow32(float x, float y) {
  return pow(x, y);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float fabs32(float x) {
  return fabsf(x);
}

static inline float fmax32(float x, float y) {
  return fmaxf(x, y);
}

static inline float fmin32(float x, float y) {
  return fminf(x, y);
}

static inline float fpow32(float x, float y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan32(float x) {
  return isnan(x);
}

static inline bool futrts_isinf32(float x) {
  return isinf(x);
}

#ifdef __OPENCL_VERSION__
static inline float futrts_log32(float x) {
  return log(x);
}

static inline float futrts_log2_32(float x) {
  return log2(x);
}

static inline float futrts_log10_32(float x) {
  return log10(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrt(x);
}

static inline float futrts_exp32(float x) {
  return exp(x);
}

static inline float futrts_cos32(float x) {
  return cos(x);
}

static inline float futrts_sin32(float x) {
  return sin(x);
}

static inline float futrts_tan32(float x) {
  return tan(x);
}

static inline float futrts_acos32(float x) {
  return acos(x);
}

static inline float futrts_asin32(float x) {
  return asin(x);
}

static inline float futrts_atan32(float x) {
  return atan(x);
}

static inline float futrts_cosh32(float x) {
  return cosh(x);
}

static inline float futrts_sinh32(float x) {
  return sinh(x);
}

static inline float futrts_tanh32(float x) {
  return tanh(x);
}

static inline float futrts_acosh32(float x) {
  return acosh(x);
}

static inline float futrts_asinh32(float x) {
  return asinh(x);
}

static inline float futrts_atanh32(float x) {
  return atanh(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypot(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgamma(x);
}

static inline float futrts_lgamma32(float x) {
  return lgamma(x);
}

static inline float fmod32(float x, float y) {
  return fmod(x, y);
}

static inline float futrts_round32(float x) {
  return rint(x);
}

static inline float futrts_floor32(float x) {
  return floor(x);
}

static inline float futrts_ceil32(float x) {
  return ceil(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return mix(v0, v1, t);
}

static inline float futrts_mad32(float a, float b, float c) {
  return mad(a, b, c);
}

static inline float futrts_fma32(float a, float b, float c) {
  return fma(a, b, c);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float futrts_log32(float x) {
  return logf(x);
}

static inline float futrts_log2_32(float x) {
  return log2f(x);
}

static inline float futrts_log10_32(float x) {
  return log10f(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrtf(x);
}

static inline float futrts_exp32(float x) {
  return expf(x);
}

static inline float futrts_cos32(float x) {
  return cosf(x);
}

static inline float futrts_sin32(float x) {
  return sinf(x);
}

static inline float futrts_tan32(float x) {
  return tanf(x);
}

static inline float futrts_acos32(float x) {
  return acosf(x);
}

static inline float futrts_asin32(float x) {
  return asinf(x);
}

static inline float futrts_atan32(float x) {
  return atanf(x);
}

static inline float futrts_cosh32(float x) {
  return coshf(x);
}

static inline float futrts_sinh32(float x) {
  return sinhf(x);
}

static inline float futrts_tanh32(float x) {
  return tanhf(x);
}

static inline float futrts_acosh32(float x) {
  return acoshf(x);
}

static inline float futrts_asinh32(float x) {
  return asinhf(x);
}

static inline float futrts_atanh32(float x) {
  return atanhf(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2f(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypotf(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgammaf(x);
}

static inline float futrts_lgamma32(float x) {
  return lgammaf(x);
}

static inline float fmod32(float x, float y) {
  return fmodf(x, y);
}

static inline float futrts_round32(float x) {
  return rintf(x);
}

static inline float futrts_floor32(float x) {
  return floorf(x);
}

static inline float futrts_ceil32(float x) {
  return ceilf(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return v0 + (v1 - v0) * t;
}

static inline float futrts_mad32(float a, float b, float c) {
  return a * b + c;
}

static inline float futrts_fma32(float a, float b, float c) {
  return fmaf(a, b, c);
}
#endif

static inline int32_t futrts_to_bits32(float x) {
  union {
    float f;
    int32_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline float futrts_from_bits32(int32_t x) {
  union {
    int32_t f;
    float t;
  } p;

  p.f = x;
  return p.t;
}

static inline float fsignum32(float x) {
  return futrts_isnan32(x) ? x : (x > 0) - (x < 0);
}

#ifdef FUTHARK_F64_ENABLED

static inline double fdiv64(double x, double y) {
  return x / y;
}

static inline double fadd64(double x, double y) {
  return x + y;
}

static inline double fsub64(double x, double y) {
  return x - y;
}

static inline double fmul64(double x, double y) {
  return x * y;
}

static inline bool cmplt64(double x, double y) {
  return x < y;
}

static inline bool cmple64(double x, double y) {
  return x <= y;
}

static inline double sitofp_i8_f64(int8_t x) {
  return (double) x;
}

static inline double sitofp_i16_f64(int16_t x) {
  return (double) x;
}

static inline double sitofp_i32_f64(int32_t x) {
  return (double) x;
}

static inline double sitofp_i64_f64(int64_t x) {
  return (double) x;
}

static inline double uitofp_i8_f64(uint8_t x) {
  return (double) x;
}

static inline double uitofp_i16_f64(uint16_t x) {
  return (double) x;
}

static inline double uitofp_i32_f64(uint32_t x) {
  return (double) x;
}

static inline double uitofp_i64_f64(uint64_t x) {
  return (double) x;
}

static inline int8_t fptosi_f64_i8(double x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f64_i16(double x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f64_i32(double x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f64_i64(double x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f64_i8(double x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f64_i16(double x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f64_i32(double x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f64_i64(double x) {
  return (uint64_t) x;
}

static inline double fabs64(double x) {
  return fabs(x);
}

static inline double fmax64(double x, double y) {
  return fmax(x, y);
}

static inline double fmin64(double x, double y) {
  return fmin(x, y);
}

static inline double fpow64(double x, double y) {
  return pow(x, y);
}

static inline double futrts_log64(double x) {
  return log(x);
}

static inline double futrts_log2_64(double x) {
  return log2(x);
}

static inline double futrts_log10_64(double x) {
  return log10(x);
}

static inline double futrts_sqrt64(double x) {
  return sqrt(x);
}

static inline double futrts_exp64(double x) {
  return exp(x);
}

static inline double futrts_cos64(double x) {
  return cos(x);
}

static inline double futrts_sin64(double x) {
  return sin(x);
}

static inline double futrts_tan64(double x) {
  return tan(x);
}

static inline double futrts_acos64(double x) {
  return acos(x);
}

static inline double futrts_asin64(double x) {
  return asin(x);
}

static inline double futrts_atan64(double x) {
  return atan(x);
}

static inline double futrts_cosh64(double x) {
  return cosh(x);
}

static inline double futrts_sinh64(double x) {
  return sinh(x);
}

static inline double futrts_tanh64(double x) {
  return tanh(x);
}

static inline double futrts_acosh64(double x) {
  return acosh(x);
}

static inline double futrts_asinh64(double x) {
  return asinh(x);
}

static inline double futrts_atanh64(double x) {
  return atanh(x);
}

static inline double futrts_atan2_64(double x, double y) {
  return atan2(x, y);
}

static inline double futrts_hypot64(double x, double y) {
  return hypot(x, y);
}

static inline double futrts_gamma64(double x) {
  return tgamma(x);
}

static inline double futrts_lgamma64(double x) {
  return lgamma(x);
}

static inline double futrts_fma64(double a, double b, double c) {
  return fma(a, b, c);
}

static inline double futrts_round64(double x) {
  return rint(x);
}

static inline double futrts_ceil64(double x) {
  return ceil(x);
}

static inline double futrts_floor64(double x) {
  return floor(x);
}

static inline bool futrts_isnan64(double x) {
  return isnan(x);
}

static inline bool futrts_isinf64(double x) {
  return isinf(x);
}

static inline int64_t futrts_to_bits64(double x) {
  union {
    double f;
    int64_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline double futrts_from_bits64(int64_t x) {
  union {
    int64_t f;
    double t;
  } p;

  p.f = x;
  return p.t;
}

static inline double fmod64(double x, double y) {
  return fmod(x, y);
}

static inline double fsignum64(double x) {
  return futrts_isnan64(x) ? x : (x > 0) - (x < 0);
}

static inline double futrts_lerp64(double v0, double v1, double t) {
#ifdef __OPENCL_VERSION__
  return mix(v0, v1, t);
#else
  return v0 + (v1 - v0) * t;
#endif
}

static inline double futrts_mad64(double a, double b, double c) {
#ifdef __OPENCL_VERSION__
  return mad(a, b, c);
#else
  return a * b + c;
#endif
}

static inline float fpconv_f32_f32(float x) {
  return (float) x;
}

static inline double fpconv_f32_f64(float x) {
  return (double) x;
}

static inline float fpconv_f64_f32(double x) {
  return (float) x;
}

static inline double fpconv_f64_f64(double x) {
  return (double) x;
}

#endif

// End of scalar.h.
// Start of scalar_f16.h.

// Half-precision is emulated if needed (e.g. in straight C) with the
// native type used if possible.  The emulation works by typedef'ing
// 'float' to 'f16', and then implementing all operations on single
// precision.  To cut down on duplication, we use the same code for
// those Futhark functions that require just operators or casts.  The
// in-memory representation for arrays will still be 16 bits even
// under emulation, so the compiler will have to be careful when
// generating reads or writes.

#if !defined(cl_khr_fp16) && !(defined(__CUDA_ARCH__) && __CUDA_ARCH__ >= 600)
#define EMULATE_F16
#endif

#if !defined(EMULATE_F16) && defined(__OPENCL_VERSION__)
#pragma OPENCL EXTENSION cl_khr_fp16 : enable
#endif

#ifdef EMULATE_F16

// Note that the half-precision storage format is still 16 bits - the
// compiler will have to be real careful!
typedef float f16;

#else

#ifdef __CUDA_ARCH__
#include <cuda_fp16.h>
#endif

typedef half f16;

#endif

// Some of these functions convert to single precision because half
// precision versions are not available.

static inline f16 fadd16(f16 x, f16 y) {
  return x + y;
}

static inline f16 fsub16(f16 x, f16 y) {
  return x - y;
}

static inline f16 fmul16(f16 x, f16 y) {
  return x * y;
}

static inline bool cmplt16(f16 x, f16 y) {
  return x < y;
}

static inline bool cmple16(f16 x, f16 y) {
  return x <= y;
}

static inline f16 sitofp_i8_f16(int8_t x) {
  return (f16) x;
}

static inline f16 sitofp_i16_f16(int16_t x) {
  return (f16) x;
}

static inline f16 sitofp_i32_f16(int32_t x) {
  return (f16) x;
}

static inline f16 sitofp_i64_f16(int64_t x) {
  return (f16) x;
}

static inline f16 uitofp_i8_f16(uint8_t x) {
  return (f16) x;
}

static inline f16 uitofp_i16_f16(uint16_t x) {
  return (f16) x;
}

static inline f16 uitofp_i32_f16(uint32_t x) {
  return (f16) x;
}

static inline f16 uitofp_i64_f16(uint64_t x) {
  return (f16) x;
}

static inline int8_t fptosi_f16_i8(f16 x) {
  return (int8_t) (float) x;
}

static inline int16_t fptosi_f16_i16(f16 x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f16_i32(f16 x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f16_i64(f16 x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f16_i8(f16 x) {
  return (uint8_t) (float) x;
}

static inline uint16_t fptoui_f16_i16(f16 x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f16_i32(f16 x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f16_i64(f16 x) {
  return (uint64_t) x;
}

#ifndef EMULATE_F16

#ifdef __OPENCL_VERSION__
static inline f16 fabs16(f16 x) {
  return fabs(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return pow(x, y);
}

#else // Assuming CUDA.

static inline f16 fabs16(f16 x) {
  return fabsf(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmaxf(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fminf(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan16(f16 x) {
  return isnan((float)x);
}

static inline bool futrts_isinf16(f16 x) {
  return isinf((float)x);
}

#ifdef __OPENCL_VERSION__
static inline f16 futrts_log16(f16 x) {
  return log(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return log2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return log10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return sqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return exp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return cos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return sin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tan(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acos(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asin(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atan(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return cosh(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinh(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanh(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acosh(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinh(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanh(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypot(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgamma(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgamma(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rint(x);
}

static inline f16 futrts_floor16(f16 x) {
  return floor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return ceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return mix(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return mad(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fma(a, b, c);
}

#else // Assume CUDA.

static inline f16 futrts_log16(f16 x) {
  return hlog(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return hlog2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return hlog10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return hsqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return hexp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return hcos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return hsin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tanf(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acosf(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asinf(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atanf(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return coshf(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinhf(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanhf(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acoshf(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinhf(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanhf(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2f(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypotf(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgammaf(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgammaf(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmodf(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rintf(x);
}

static inline f16 futrts_floor16(f16 x) {
  return hfloor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return hceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return v0 + (v1 - v0) * t;
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return a * b + c;
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fmaf(a, b, c);
}

#endif

// The CUDA __half type cannot be put in unions for some reason, so we
// use bespoke conversion functions instead.
#ifdef __CUDA_ARCH__
static inline int16_t futrts_to_bits16(f16 x) {
  return __half_as_ushort(x);
}
static inline f16 futrts_from_bits16(int16_t x) {
  return __ushort_as_half(x);
}
#else
static inline int16_t futrts_to_bits16(f16 x) {
  union {
    f16 f;
    int16_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline f16 futrts_from_bits16(int16_t x) {
  union {
    int16_t f;
    f16 t;
  } p;

  p.f = x;
  return p.t;
}
#endif

#else // No native f16 - emulate.

static inline f16 fabs16(f16 x) {
  return fabs32(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax32(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin32(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return fpow32(x, y);
}

static inline bool futrts_isnan16(f16 x) {
  return futrts_isnan32(x);
}

static inline bool futrts_isinf16(f16 x) {
  return futrts_isinf32(x);
}

static inline f16 futrts_log16(f16 x) {
  return futrts_log32(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return futrts_log2_32(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return futrts_log10_32(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return futrts_sqrt32(x);
}

static inline f16 futrts_exp16(f16 x) {
  return futrts_exp32(x);
}

static inline f16 futrts_cos16(f16 x) {
  return futrts_cos32(x);
}

static inline f16 futrts_sin16(f16 x) {
  return futrts_sin32(x);
}

static inline f16 futrts_tan16(f16 x) {
  return futrts_tan32(x);
}

static inline f16 futrts_acos16(f16 x) {
  return futrts_acos32(x);
}

static inline f16 futrts_asin16(f16 x) {
  return futrts_asin32(x);
}

static inline f16 futrts_atan16(f16 x) {
  return futrts_atan32(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return futrts_cosh32(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return futrts_sinh32(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return futrts_tanh32(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return futrts_acosh32(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return futrts_asinh32(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return futrts_atanh32(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return futrts_atan2_32(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return futrts_hypot32(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return futrts_gamma32(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return futrts_lgamma32(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod32(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return futrts_round32(x);
}

static inline f16 futrts_floor16(f16 x) {
  return futrts_floor32(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return futrts_ceil32(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return futrts_lerp32(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return futrts_mad32(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return futrts_fma32(a, b, c);
}

// Even when we are using an OpenCL that does not support cl_khr_fp16,
// it must still support vload_half for actually creating a
// half-precision number, which can then be efficiently converted to a
// float.  Similarly for vstore_half.
#ifdef __OPENCL_VERSION__

static inline int16_t futrts_to_bits16(f16 x) {
  int16_t y;
  // Violating strict aliasing here.
  vstore_half((float)x, 0, (half*)&y);
  return y;
}

static inline f16 futrts_from_bits16(int16_t x) {
  return (f16)vload_half(0, (half*)&x);
}

#else

static inline int16_t futrts_to_bits16(f16 x) {
  return (int16_t)float2halfbits(x);
}

static inline f16 futrts_from_bits16(int16_t x) {
  return halfbits2float((uint16_t)x);
}

static inline f16 fsignum16(f16 x) {
  return futrts_isnan16(x) ? x : (x > 0) - (x < 0);
}

#endif

#endif

static inline float fpconv_f16_f16(f16 x) {
  return x;
}

static inline float fpconv_f16_f32(f16 x) {
  return x;
}

static inline f16 fpconv_f32_f16(float x) {
  return x;
}

#ifdef FUTHARK_F64_ENABLED

static inline double fpconv_f16_f64(f16 x) {
  return (double) x;
}

static inline f16 fpconv_f64_f16(double x) {
  return (f16) x;
}

#endif


// End of scalar_f16.h.

static int init_constants(struct futhark_context *);
static int free_constants(struct futhark_context *);
struct memblock {
    int *references;
    unsigned char *mem;
    int64_t size;
    const char *desc;
};
struct futhark_context_config {
    int debugging;
    int in_use;
};
struct futhark_context_config *futhark_context_config_new(void)
{
    struct futhark_context_config *cfg =
                                  (struct futhark_context_config *) malloc(sizeof(struct futhark_context_config));
    
    if (cfg == NULL)
        return NULL;
    cfg->in_use = 0;
    cfg->debugging = 0;
    return cfg;
}
void futhark_context_config_free(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    free(cfg);
}
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int detail)
{
    cfg->debugging = detail;
}
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag)
{
    (void) cfg;
    (void) flag;
}
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int detail)
{
    // Does nothing for this backend.
    (void) cfg;
    (void) detail;
}
struct futhark_context {
    struct futhark_context_config *cfg;
    int detail_memory;
    int debugging;
    int profiling;
    int logging;
    lock_t lock;
    char *error;
    FILE *log;
    int profiling_paused;
    int64_t peak_mem_usage_default;
    int64_t cur_mem_usage_default;
    struct {
        int dummy;
    } constants;
};
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    
    struct futhark_context *ctx =
                           (struct futhark_context *) malloc(sizeof(struct futhark_context));
    
    if (ctx == NULL)
        return NULL;
    ctx->cfg = cfg;
    ctx->cfg->in_use = 1;
    ctx->detail_memory = cfg->debugging;
    ctx->debugging = cfg->debugging;
    ctx->profiling = cfg->debugging;
    ctx->logging = cfg->debugging;
    ctx->error = NULL;
    ctx->log = stderr;
    create_lock(&ctx->lock);
    ctx->peak_mem_usage_default = 0;
    ctx->cur_mem_usage_default = 0;
    init_constants(ctx);
    return ctx;
}
void futhark_context_free(struct futhark_context *ctx)
{
    free_constants(ctx);
    free_lock(&ctx->lock);
    ctx->cfg->in_use = 0;
    free(ctx);
}
int futhark_context_sync(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
static const char *tuning_param_names[0];
static const char *tuning_param_vars[0];
static const char *tuning_param_classes[0];
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value)
{
    (void) cfg;
    (void) param_name;
    (void) param_value;
    return 1;
}
static int memblock_unref(struct futhark_context *ctx, struct memblock *block,
                          const char *desc)
{
    if (block->references != NULL) {
        *block->references -= 1;
        if (ctx->detail_memory)
            fprintf(ctx->log,
                    "Unreferencing block %s (allocated as %s) in %s: %d references remaining.\n",
                    desc, block->desc, "default space", *block->references);
        if (*block->references == 0) {
            ctx->cur_mem_usage_default -= block->size;
            free(block->mem);
            free(block->references);
            if (ctx->detail_memory)
                fprintf(ctx->log,
                        "%lld bytes freed (now allocated: %lld bytes)\n",
                        (long long) block->size,
                        (long long) ctx->cur_mem_usage_default);
        }
        block->references = NULL;
    }
    return 0;
}
static int memblock_alloc(struct futhark_context *ctx, struct memblock *block,
                          int64_t size, const char *desc)
{
    if (size < 0)
        futhark_panic(1,
                      "Negative allocation of %lld bytes attempted for %s in %s.\n",
                      (long long) size, desc, "default space",
                      ctx->cur_mem_usage_default);
    
    int ret = memblock_unref(ctx, block, desc);
    
    ctx->cur_mem_usage_default += size;
    if (ctx->detail_memory)
        fprintf(ctx->log,
                "Allocating %lld bytes for %s in %s (then allocated: %lld bytes)",
                (long long) size, desc, "default space",
                (long long) ctx->cur_mem_usage_default);
    if (ctx->cur_mem_usage_default > ctx->peak_mem_usage_default) {
        ctx->peak_mem_usage_default = ctx->cur_mem_usage_default;
        if (ctx->detail_memory)
            fprintf(ctx->log, " (new peak).\n");
    } else if (ctx->detail_memory)
        fprintf(ctx->log, ".\n");
    block->mem = (unsigned char *) malloc((size_t) size);
    block->references = (int *) malloc(sizeof(int));
    *block->references = 1;
    block->size = size;
    block->desc = desc;
    return ret;
}
static int memblock_set(struct futhark_context *ctx, struct memblock *lhs,
                        struct memblock *rhs, const char *lhs_desc)
{
    int ret = memblock_unref(ctx, lhs, lhs_desc);
    
    if (rhs->references != NULL)
        (*rhs->references)++;
    *lhs = *rhs;
    return ret;
}
int futhark_get_tuning_param_count(void)
{
    return sizeof(tuning_param_names) / sizeof(tuning_param_names[0]);
}
const char *futhark_get_tuning_param_name(int i)
{
    return tuning_param_names[i];
}
const char *futhark_get_tuning_param_class(int i)
{
    return tuning_param_classes[i];
}
char *futhark_context_report(struct futhark_context *ctx)
{
    if (futhark_context_sync(ctx) != 0)
        return NULL;
    
    struct str_builder builder;
    
    str_builder_init(&builder);
    if (ctx->detail_memory || ctx->profiling || ctx->logging) {
        { }
    }
    if (ctx->profiling) { }
    return builder.str;
}
char *futhark_context_get_error(struct futhark_context *ctx)
{
    char *error = ctx->error;
    
    ctx->error = NULL;
    return error;
}
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f)
{
    ctx->log = f;
}
void futhark_context_pause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 1;
}
void futhark_context_unpause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 0;
}
int futhark_context_clear_caches(struct futhark_context *ctx)
{
    lock_lock(&ctx->lock);
    ctx->peak_mem_usage_default = 0;
    lock_unlock(&ctx->lock);
    return ctx->error != NULL;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_213841,
                             struct memblock *mem_out_p_213842,
                             struct memblock *mem_out_p_213843,
                             struct memblock Y_mem_208412, int64_t m_203571,
                             int64_t n_203572, int64_t n_p_203574,
                             int64_t q_s_203575, int64_t q_t_203576,
                             int64_t q_l_203577, int64_t d_s_203578,
                             int64_t d_t_203579, int64_t d_l_203580,
                             int64_t jump_s_203581, int64_t jump_t_203582,
                             int64_t jump_l_203583, int64_t n_inner_203584,
                             int64_t n_outer_203585,
                             int64_t jump_threshold_203586,
                             int64_t q_threshold_203587);

static int init_constants(struct futhark_context *ctx)
{
    (void) ctx;
    
    int err = 0;
    
    
  cleanup:
    return err;
}
static int free_constants(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
struct futhark_f64_2d {
    struct memblock mem;
    int64_t shape[2];
};
struct futhark_f64_2d *futhark_new_f64_2d(struct futhark_context *ctx, const
                                          double *data, int64_t dim0,
                                          int64_t dim1)
{
    struct futhark_f64_2d *bad = NULL;
    struct futhark_f64_2d *arr =
                          (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 8, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 8 > 0)
        memmove(arr->mem.mem + 0, data + 0, (size_t) (dim0 * dim1) * 8);
    lock_unlock(&ctx->lock);
    return arr;
}
struct futhark_f64_2d *futhark_new_raw_f64_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1)
{
    struct futhark_f64_2d *bad = NULL;
    struct futhark_f64_2d *arr =
                          (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 8, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 8 > 0)
        memmove(arr->mem.mem + 0, data + offset, (size_t) (dim0 * dim1) * 8);
    lock_unlock(&ctx->lock);
    return arr;
}
int futhark_free_f64_2d(struct futhark_context *ctx, struct futhark_f64_2d *arr)
{
    lock_lock(&ctx->lock);
    if (memblock_unref(ctx, &arr->mem, "arr->mem") != 0)
        return 1;
    lock_unlock(&ctx->lock);
    free(arr);
    return 0;
}
int futhark_values_f64_2d(struct futhark_context *ctx,
                          struct futhark_f64_2d *arr, double *data)
{
    lock_lock(&ctx->lock);
    if ((size_t) (arr->shape[0] * arr->shape[1]) * 8 > 0)
        memmove(data + 0, arr->mem.mem + 0, (size_t) (arr->shape[0] *
                                                      arr->shape[1]) * 8);
    lock_unlock(&ctx->lock);
    return 0;
}
unsigned char *futhark_values_raw_f64_2d(struct futhark_context *ctx,
                                         struct futhark_f64_2d *arr)
{
    (void) ctx;
    return arr->mem.mem;
}
const int64_t *futhark_shape_f64_2d(struct futhark_context *ctx,
                                    struct futhark_f64_2d *arr)
{
    (void) ctx;
    return arr->shape;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_213841,
                             struct memblock *mem_out_p_213842,
                             struct memblock *mem_out_p_213843,
                             struct memblock Y_mem_208412, int64_t m_203571,
                             int64_t n_203572, int64_t n_p_203574,
                             int64_t q_s_203575, int64_t q_t_203576,
                             int64_t q_l_203577, int64_t d_s_203578,
                             int64_t d_t_203579, int64_t d_l_203580,
                             int64_t jump_s_203581, int64_t jump_t_203582,
                             int64_t jump_l_203583, int64_t n_inner_203584,
                             int64_t n_outer_203585,
                             int64_t jump_threshold_203586,
                             int64_t q_threshold_203587)
{
    (void) ctx;
    
    int err = 0;
    size_t mem_208415_cached_sizze_213844 = 0;
    unsigned char *mem_208415 = NULL;
    size_t mem_208418_cached_sizze_213845 = 0;
    unsigned char *mem_208418 = NULL;
    size_t mem_208434_cached_sizze_213846 = 0;
    unsigned char *mem_208434 = NULL;
    size_t mem_208460_cached_sizze_213847 = 0;
    unsigned char *mem_208460 = NULL;
    size_t mem_208463_cached_sizze_213848 = 0;
    unsigned char *mem_208463 = NULL;
    size_t mem_208483_cached_sizze_213849 = 0;
    unsigned char *mem_208483 = NULL;
    size_t mem_208500_cached_sizze_213850 = 0;
    unsigned char *mem_208500 = NULL;
    size_t mem_208503_cached_sizze_213851 = 0;
    unsigned char *mem_208503 = NULL;
    size_t mem_208523_cached_sizze_213852 = 0;
    unsigned char *mem_208523 = NULL;
    size_t mem_208538_cached_sizze_213853 = 0;
    unsigned char *mem_208538 = NULL;
    size_t mem_208575_cached_sizze_213854 = 0;
    unsigned char *mem_208575 = NULL;
    size_t mem_208667_cached_sizze_213855 = 0;
    unsigned char *mem_208667 = NULL;
    size_t mem_208671_cached_sizze_213856 = 0;
    unsigned char *mem_208671 = NULL;
    size_t mem_208724_cached_sizze_213857 = 0;
    unsigned char *mem_208724 = NULL;
    size_t mem_208739_cached_sizze_213858 = 0;
    unsigned char *mem_208739 = NULL;
    size_t mem_208818_cached_sizze_213859 = 0;
    unsigned char *mem_208818 = NULL;
    size_t mem_208823_cached_sizze_213860 = 0;
    unsigned char *mem_208823 = NULL;
    size_t mem_208884_cached_sizze_213861 = 0;
    unsigned char *mem_208884 = NULL;
    size_t mem_209016_cached_sizze_213862 = 0;
    unsigned char *mem_209016 = NULL;
    size_t mem_209020_cached_sizze_213863 = 0;
    unsigned char *mem_209020 = NULL;
    size_t mem_209043_cached_sizze_213864 = 0;
    unsigned char *mem_209043 = NULL;
    size_t mem_209119_cached_sizze_213865 = 0;
    unsigned char *mem_209119 = NULL;
    size_t mem_209123_cached_sizze_213866 = 0;
    unsigned char *mem_209123 = NULL;
    size_t mem_209146_cached_sizze_213867 = 0;
    unsigned char *mem_209146 = NULL;
    size_t mem_209276_cached_sizze_213868 = 0;
    unsigned char *mem_209276 = NULL;
    size_t mem_209321_cached_sizze_213869 = 0;
    unsigned char *mem_209321 = NULL;
    size_t mem_209326_cached_sizze_213870 = 0;
    unsigned char *mem_209326 = NULL;
    size_t mem_210070_cached_sizze_213871 = 0;
    unsigned char *mem_210070 = NULL;
    size_t mem_210229_cached_sizze_213872 = 0;
    unsigned char *mem_210229 = NULL;
    size_t mem_210232_cached_sizze_213873 = 0;
    unsigned char *mem_210232 = NULL;
    size_t mem_210443_cached_sizze_213874 = 0;
    unsigned char *mem_210443 = NULL;
    size_t mem_210446_cached_sizze_213875 = 0;
    unsigned char *mem_210446 = NULL;
    size_t mem_210473_cached_sizze_213876 = 0;
    unsigned char *mem_210473 = NULL;
    size_t mem_210476_cached_sizze_213877 = 0;
    unsigned char *mem_210476 = NULL;
    size_t mem_210751_cached_sizze_213878 = 0;
    unsigned char *mem_210751 = NULL;
    size_t mem_210794_cached_sizze_213879 = 0;
    unsigned char *mem_210794 = NULL;
    size_t mem_210810_cached_sizze_213880 = 0;
    unsigned char *mem_210810 = NULL;
    size_t mem_210823_cached_sizze_213881 = 0;
    unsigned char *mem_210823 = NULL;
    size_t mem_210846_cached_sizze_213882 = 0;
    unsigned char *mem_210846 = NULL;
    size_t mem_210862_cached_sizze_213883 = 0;
    unsigned char *mem_210862 = NULL;
    size_t mem_210875_cached_sizze_213884 = 0;
    unsigned char *mem_210875 = NULL;
    size_t mem_210898_cached_sizze_213885 = 0;
    unsigned char *mem_210898 = NULL;
    size_t mem_210914_cached_sizze_213886 = 0;
    unsigned char *mem_210914 = NULL;
    size_t mem_210927_cached_sizze_213887 = 0;
    unsigned char *mem_210927 = NULL;
    size_t mem_211235_cached_sizze_213888 = 0;
    unsigned char *mem_211235 = NULL;
    size_t mem_211319_cached_sizze_213889 = 0;
    unsigned char *mem_211319 = NULL;
    size_t mem_211322_cached_sizze_213890 = 0;
    unsigned char *mem_211322 = NULL;
    size_t mem_211437_cached_sizze_213891 = 0;
    unsigned char *mem_211437 = NULL;
    size_t mem_211440_cached_sizze_213892 = 0;
    unsigned char *mem_211440 = NULL;
    size_t mem_211467_cached_sizze_213893 = 0;
    unsigned char *mem_211467 = NULL;
    size_t mem_211470_cached_sizze_213894 = 0;
    unsigned char *mem_211470 = NULL;
    size_t mem_211697_cached_sizze_213895 = 0;
    unsigned char *mem_211697 = NULL;
    size_t mem_211712_cached_sizze_213896 = 0;
    unsigned char *mem_211712 = NULL;
    size_t mem_211715_cached_sizze_213897 = 0;
    unsigned char *mem_211715 = NULL;
    size_t mem_211800_cached_sizze_213898 = 0;
    unsigned char *mem_211800 = NULL;
    size_t mem_211815_cached_sizze_213899 = 0;
    unsigned char *mem_211815 = NULL;
    size_t mem_211818_cached_sizze_213900 = 0;
    unsigned char *mem_211818 = NULL;
    size_t mem_211933_cached_sizze_213901 = 0;
    unsigned char *mem_211933 = NULL;
    size_t mem_211948_cached_sizze_213902 = 0;
    unsigned char *mem_211948 = NULL;
    size_t mem_211951_cached_sizze_213903 = 0;
    unsigned char *mem_211951 = NULL;
    size_t mem_212088_cached_sizze_213904 = 0;
    unsigned char *mem_212088 = NULL;
    size_t mem_212103_cached_sizze_213905 = 0;
    unsigned char *mem_212103 = NULL;
    size_t mem_212106_cached_sizze_213906 = 0;
    unsigned char *mem_212106 = NULL;
    size_t mem_212144_cached_sizze_213907 = 0;
    unsigned char *mem_212144 = NULL;
    size_t mem_212206_cached_sizze_213908 = 0;
    unsigned char *mem_212206 = NULL;
    size_t mem_212221_cached_sizze_213909 = 0;
    unsigned char *mem_212221 = NULL;
    size_t mem_212224_cached_sizze_213910 = 0;
    unsigned char *mem_212224 = NULL;
    size_t mem_212273_cached_sizze_213911 = 0;
    unsigned char *mem_212273 = NULL;
    size_t mem_212276_cached_sizze_213912 = 0;
    unsigned char *mem_212276 = NULL;
    size_t mem_212369_cached_sizze_213913 = 0;
    unsigned char *mem_212369 = NULL;
    size_t mem_212384_cached_sizze_213914 = 0;
    unsigned char *mem_212384 = NULL;
    size_t mem_212387_cached_sizze_213915 = 0;
    unsigned char *mem_212387 = NULL;
    size_t mem_212436_cached_sizze_213916 = 0;
    unsigned char *mem_212436 = NULL;
    size_t mem_212439_cached_sizze_213917 = 0;
    unsigned char *mem_212439 = NULL;
    size_t mem_212466_cached_sizze_213918 = 0;
    unsigned char *mem_212466 = NULL;
    size_t mem_212469_cached_sizze_213919 = 0;
    unsigned char *mem_212469 = NULL;
    size_t mem_212651_cached_sizze_213920 = 0;
    unsigned char *mem_212651 = NULL;
    size_t mem_212655_cached_sizze_213921 = 0;
    unsigned char *mem_212655 = NULL;
    size_t mem_212739_cached_sizze_213922 = 0;
    unsigned char *mem_212739 = NULL;
    size_t mem_212760_cached_sizze_213923 = 0;
    unsigned char *mem_212760 = NULL;
    size_t mem_212763_cached_sizze_213924 = 0;
    unsigned char *mem_212763 = NULL;
    size_t mem_212766_cached_sizze_213925 = 0;
    unsigned char *mem_212766 = NULL;
    size_t mem_212769_cached_sizze_213926 = 0;
    unsigned char *mem_212769 = NULL;
    size_t mem_212772_cached_sizze_213927 = 0;
    unsigned char *mem_212772 = NULL;
    size_t mem_212835_cached_sizze_213928 = 0;
    unsigned char *mem_212835 = NULL;
    size_t mem_212866_cached_sizze_213929 = 0;
    unsigned char *mem_212866 = NULL;
    size_t mem_212869_cached_sizze_213930 = 0;
    unsigned char *mem_212869 = NULL;
    size_t mem_212872_cached_sizze_213931 = 0;
    unsigned char *mem_212872 = NULL;
    size_t mem_212988_cached_sizze_213932 = 0;
    unsigned char *mem_212988 = NULL;
    size_t mem_212992_cached_sizze_213933 = 0;
    unsigned char *mem_212992 = NULL;
    size_t mem_212996_cached_sizze_213934 = 0;
    unsigned char *mem_212996 = NULL;
    size_t mem_213029_cached_sizze_213935 = 0;
    unsigned char *mem_213029 = NULL;
    size_t mem_213032_cached_sizze_213936 = 0;
    unsigned char *mem_213032 = NULL;
    size_t mem_213035_cached_sizze_213937 = 0;
    unsigned char *mem_213035 = NULL;
    struct memblock mem_out_213475;
    
    mem_out_213475.references = NULL;
    
    struct memblock mem_out_213476;
    
    mem_out_213476.references = NULL;
    
    struct memblock mem_out_213477;
    
    mem_out_213477.references = NULL;
    
    double i64_res_203588 = sitofp_i64_f64(n_203572);
    double i64_res_203589 = sitofp_i64_f64(n_p_203574);
    double ceil_arg_203590 = i64_res_203588 / i64_res_203589;
    double ceil_res_203591;
    
    ceil_res_203591 = futrts_ceil64(ceil_arg_203590);
    
    int64_t defunc_0_f_res_203592 = fptosi_f64_i64(ceil_res_203591);
    bool bounds_invalid_upwards_203593 = slt64(n_p_203574, (int64_t) 0);
    bool valid_203594 = !bounds_invalid_upwards_203593;
    bool range_valid_c_203595;
    
    if (!valid_203594) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) n_p_203574, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:403:29-408:37\n   #4  stl.fut:402:22-409:28\n   #5  stl.fut:455:3-469:34\n   #6  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_203597 = slt64(defunc_0_f_res_203592,
                                               (int64_t) 0);
    bool valid_203598 = !bounds_invalid_upwards_203597;
    bool range_valid_c_203599;
    
    if (!valid_203598) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) defunc_0_f_res_203592,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:404:36-407:52\n   #4  /prelude/soacs.fut:59:3-10\n   #5  /prelude/array.fut:195:3-17\n   #6  utils.fut:6:3-16\n   #7  stl.fut:403:29-408:37\n   #8  stl.fut:402:22-409:28\n   #9  stl.fut:455:3-469:34\n   #10 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_y_208413 = (int64_t) 8 * m_203571;
    int64_t bytes_208414 = smax64((int64_t) 0, binop_y_208413);
    
    if (mem_208415_cached_sizze_213844 < (size_t) bytes_208414) {
        mem_208415 = realloc(mem_208415, bytes_208414);
        mem_208415_cached_sizze_213844 = bytes_208414;
    }
    if (mem_208418_cached_sizze_213845 < (size_t) bytes_208414) {
        mem_208418 = realloc(mem_208418, bytes_208414);
        mem_208418_cached_sizze_213845 = bytes_208414;
    }
    
    int64_t bytes_208433 = smax64((int64_t) 0, defunc_0_f_res_203592);
    
    if (mem_208434_cached_sizze_213846 < (size_t) bytes_208433) {
        mem_208434 = realloc(mem_208434, bytes_208433);
        mem_208434_cached_sizze_213846 = bytes_208433;
    }
    
    int64_t discard_206969;
    int64_t scanacc_206961 = (int64_t) 0;
    
    for (int64_t i_206965 = 0; i_206965 < m_203571; i_206965++) {
        bool defunc_2_reduce_res_203634;
        bool redout_206956 = 0;
        
        for (int64_t i_206957 = 0; i_206957 < n_p_203574; i_206957++) {
            for (int64_t i_206952 = 0; i_206952 < defunc_0_f_res_203592;
                 i_206952++) {
                int64_t x_203641 = mul64(n_p_203574, i_206952);
                int64_t idx_203642 = add64(x_203641, i_206957);
                bool cond_203643 = sle64(n_203572, idx_203642);
                bool defunc_0_f_res_203644;
                
                if (cond_203643) {
                    defunc_0_f_res_203644 = 1;
                } else {
                    bool x_203645 = sle64((int64_t) 0, idx_203642);
                    bool y_203646 = slt64(idx_203642, n_203572);
                    bool bounds_check_203647 = x_203645 && y_203646;
                    bool index_certs_203648;
                    
                    if (!bounds_check_203647) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) idx_203642,
                                      "] out of bounds for array of shape [",
                                      (long long) n_203572, "].",
                                      "-> #0  stl.fut:406:66-71\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:404:36-407:52\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:403:29-408:37\n   #9  stl.fut:402:22-409:28\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &mem_out_213477,
                                           "mem_out_213477") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213476,
                                           "mem_out_213476") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213475,
                                           "mem_out_213475") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    double isnan_arg_203649;
                    
                    isnan_arg_203649 = ((double *) Y_mem_208412.mem)[i_206965 *
                                                                     n_203572 +
                                                                     idx_203642];
                    
                    bool isnan_res_203650;
                    
                    isnan_res_203650 = futrts_isnan64(isnan_arg_203649);
                    defunc_0_f_res_203644 = isnan_res_203650;
                }
                ((bool *) mem_208434)[i_206952] = defunc_0_f_res_203644;
            }
            // Trace: trace
            {
                fprintf(ctx->log, "%s", "trace: ");
                for (int64_t nest_i_213483 = 0; nest_i_213483 <
                     defunc_0_f_res_203592; nest_i_213483++) {
                    bool arr_elem_213484;
                    
                    arr_elem_213484 = ((bool *) mem_208434)[nest_i_213483];
                    fprintf(ctx->log, "%s%s",
                            arr_elem_213484 ? "true" : "false", " ");
                }
                fprintf(ctx->log, "%s", "\n");
            }
            
            bool defunc_2_reduce_res_203652;
            bool redout_206954 = 1;
            
            for (int64_t i_206955 = 0; i_206955 < defunc_0_f_res_203592;
                 i_206955++) {
                bool x_203656;
                
                x_203656 = ((bool *) mem_208434)[i_206955];
                
                bool x_203655 = x_203656 && redout_206954;
                bool redout_tmp_213485 = x_203655;
                
                redout_206954 = redout_tmp_213485;
            }
            defunc_2_reduce_res_203652 = redout_206954;
            
            bool defunc_1_op_res_203637 = defunc_2_reduce_res_203652 ||
                 redout_206956;
            bool redout_tmp_213481 = defunc_1_op_res_203637;
            
            redout_206956 = redout_tmp_213481;
        }
        defunc_2_reduce_res_203634 = redout_206956;
        
        int64_t defunc_2_lifted_lambda_res_203657 =
                btoi_bool_i64(defunc_2_reduce_res_203634);
        bool is_i_203658 = defunc_2_lifted_lambda_res_203657 == (int64_t) 0;
        bool cond_neg_203659 = !is_i_203658;
        int64_t part_res_203660 = btoi_bool_i64(cond_neg_203659);
        int64_t part_res_203661 = btoi_bool_i64(is_i_203658);
        int64_t zz_203632 = part_res_203661 + scanacc_206961;
        
        ((int64_t *) mem_208415)[i_206965] = zz_203632;
        ((int64_t *) mem_208418)[i_206965] = part_res_203660;
        
        int64_t scanacc_tmp_213478 = zz_203632;
        
        scanacc_206961 = scanacc_tmp_213478;
    }
    discard_206969 = scanacc_206961;
    
    int64_t last_index_203665 = m_203571 - (int64_t) 1;
    bool is_empty_203666 = m_203571 == (int64_t) 0;
    int64_t partition_sizze_203667;
    
    if (is_empty_203666) {
        partition_sizze_203667 = (int64_t) 0;
    } else {
        int64_t last_offset_203668;
        
        last_offset_203668 = ((int64_t *) mem_208415)[last_index_203665];
        partition_sizze_203667 = last_offset_203668;
    }
    
    int64_t binop_x_208457 = m_203571 * n_203572;
    int64_t binop_y_208458 = (int64_t) 8 * binop_x_208457;
    int64_t bytes_208459 = smax64((int64_t) 0, binop_y_208458);
    
    if (mem_208460_cached_sizze_213847 < (size_t) bytes_208459) {
        mem_208460 = realloc(mem_208460, bytes_208459);
        mem_208460_cached_sizze_213847 = bytes_208459;
    }
    if (mem_208463_cached_sizze_213848 < (size_t) bytes_208414) {
        mem_208463 = realloc(mem_208463, bytes_208414);
        mem_208463_cached_sizze_213848 = bytes_208414;
    }
    
    int64_t binop_y_208481 = (int64_t) 8 * n_203572;
    int64_t bytes_208482 = smax64((int64_t) 0, binop_y_208481);
    
    if (mem_208483_cached_sizze_213849 < (size_t) bytes_208482) {
        mem_208483 = realloc(mem_208483, bytes_208482);
        mem_208483_cached_sizze_213849 = bytes_208482;
    }
    for (int64_t write_iter_206970 = 0; write_iter_206970 < m_203571;
         write_iter_206970++) {
        int64_t write_iv_206973;
        
        write_iv_206973 = ((int64_t *) mem_208418)[write_iter_206970];
        
        int64_t write_iv_206974;
        
        write_iv_206974 = ((int64_t *) mem_208415)[write_iter_206970];
        if (n_203572 * (int64_t) 8 > 0)
            memmove(mem_208483 + (int64_t) 0, Y_mem_208412.mem +
                    write_iter_206970 * n_203572 * (int64_t) 8, n_203572 *
                    (int64_t) 8);
        
        bool is_this_one_203678 = write_iv_206973 == (int64_t) 0;
        int64_t this_offset_203679 = (int64_t) -1 + write_iv_206974;
        int64_t total_res_203680;
        
        if (is_this_one_203678) {
            total_res_203680 = this_offset_203679;
        } else {
            total_res_203680 = (int64_t) -1;
        }
        if ((sle64((int64_t) 0, total_res_203680) && slt64(total_res_203680,
                                                           m_203571)) &&
            (sle64((int64_t) 0, (int64_t) 0) && slt64(n_203572 - (int64_t) 1,
                                                      n_203572))) {
            if (n_203572 * (int64_t) 8 > 0)
                memmove(mem_208460 + total_res_203680 * n_203572 * (int64_t) 8,
                        mem_208483 + (int64_t) 0, n_203572 * (int64_t) 8);
        }
        if (sle64((int64_t) 0, total_res_203680) && slt64(total_res_203680,
                                                          m_203571)) {
            ((int64_t *) mem_208463)[total_res_203680] = write_iter_206970;
        }
    }
    
    bool empty_slice_203681 = partition_sizze_203667 == (int64_t) 0;
    int64_t m_203682 = sub64(partition_sizze_203667, (int64_t) 1);
    bool zzero_leq_i_p_m_t_s_203683 = sle64((int64_t) 0, m_203682);
    bool i_p_m_t_s_leq_w_203684 = slt64(m_203682, m_203571);
    bool i_lte_j_203685 = sle64((int64_t) 0, partition_sizze_203667);
    bool y_203686 = zzero_leq_i_p_m_t_s_203683 && i_p_m_t_s_leq_w_203684;
    bool y_203687 = i_lte_j_203685 && y_203686;
    bool ok_or_empty_203688 = empty_slice_203681 || y_203687;
    bool index_certs_203689;
    
    if (!ok_or_empty_203688) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) partition_sizze_203667,
                               "] out of bounds for array of shape [",
                               (long long) m_203571, "].",
                               "-> #0  /prelude/soacs.fut:163:6-16\n   #1  stl.fut:412:7-66\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203692 = sle64((int64_t) 4, n_p_203574);
    bool assert_c_203693;
    
    if (!assert_cond_203692) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (n_p >= 4)",
                               "-> #0  stl.fut:69:13-33\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t x_203694 = smod64(q_t_203576, (int64_t) 2);
    bool assert_cond_203695 = x_203694 == (int64_t) 1;
    bool assert_c_203696;
    
    if (!assert_cond_203695) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x % 2 == 1)",
                               "-> #0  utils.fut:20:3-23\n   #1  /prelude/functional.fut:39:62-64\n   #2  stl.fut:71:13-25\n   #3  stl.fut:415:61-429:75\n   #4  stl.fut:455:3-469:34\n   #5  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203697 = slt64((int64_t) 0, q_t_203576);
    bool assert_c_203698;
    
    if (!assert_cond_203697) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  /prelude/functional.fut:39:59-65\n   #2  stl.fut:71:13-25\n   #3  stl.fut:415:61-429:75\n   #4  stl.fut:455:3-469:34\n   #5  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t x_203699 = smod64(q_l_203577, (int64_t) 2);
    bool assert_cond_203700 = x_203699 == (int64_t) 1;
    bool assert_c_203701;
    
    if (!assert_cond_203700) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x % 2 == 1)",
                               "-> #0  utils.fut:20:3-23\n   #1  /prelude/functional.fut:39:62-64\n   #2  stl.fut:72:13-25\n   #3  stl.fut:415:61-429:75\n   #4  stl.fut:455:3-469:34\n   #5  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203702 = slt64((int64_t) 0, q_l_203577);
    bool assert_c_203703;
    
    if (!assert_cond_203702) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  /prelude/functional.fut:39:59-65\n   #2  stl.fut:72:13-25\n   #3  stl.fut:415:61-429:75\n   #4  stl.fut:455:3-469:34\n   #5  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203712 = slt64((int64_t) 0, jump_t_203582);
    bool assert_c_203713;
    
    if (!assert_cond_203712) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:77:16-31\n   #2  stl.fut:415:61-429:75\n   #3  stl.fut:455:3-469:34\n   #4  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203714 = slt64((int64_t) 0, jump_l_203583);
    bool assert_c_203715;
    
    if (!assert_cond_203714) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:78:16-31\n   #2  stl.fut:415:61-429:75\n   #3  stl.fut:455:3-469:34\n   #4  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203716 = slt64((int64_t) 0, n_inner_203584);
    bool assert_c_203717;
    
    if (!assert_cond_203716) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:80:17-33\n   #2  stl.fut:415:61-429:75\n   #3  stl.fut:455:3-469:34\n   #4  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool assert_cond_203718 = slt64((int64_t) 0, n_outer_203585);
    bool assert_c_203719;
    
    if (!assert_cond_203718) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:81:17-33\n   #2  stl.fut:415:61-429:75\n   #3  stl.fut:455:3-469:34\n   #4  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    double ceil_res_203720;
    
    ceil_res_203720 = futrts_ceil64(ceil_arg_203590);
    
    int64_t defunc_0_f_res_203721 = fptosi_f64_i64(ceil_res_203720);
    int64_t pad_css_len_203722 = add64((int64_t) 2, defunc_0_f_res_203721);
    int64_t y_203723 = mul64((int64_t) 2, n_p_203574);
    int64_t C_len_203724 = add64(n_203572, y_203723);
    bool cond_203725 = jump_s_203581 == (int64_t) 1;
    int64_t s_n_m_203726;
    
    if (cond_203725) {
        s_n_m_203726 = pad_css_len_203722;
    } else {
        bool zzero_203727 = jump_s_203581 == (int64_t) 0;
        bool nonzzero_203728 = !zzero_203727;
        bool nonzzero_cert_203729;
        
        if (!nonzzero_203728) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:88:52-71\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
            if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t x_203730 = sdiv64(defunc_0_f_res_203721, jump_s_203581);
        int64_t s_n_m_f_res_203731 = add64((int64_t) 3, x_203730);
        
        s_n_m_203726 = s_n_m_f_res_203731;
    }
    
    bool cond_203732 = jump_l_203583 == (int64_t) 1;
    int64_t l_n_m_203733;
    
    if (cond_203732) {
        l_n_m_203733 = n_203572;
    } else {
        bool zzero_203734 = jump_l_203583 == (int64_t) 0;
        bool nonzzero_203735 = !zzero_203734;
        bool nonzzero_cert_203736;
        
        if (!nonzzero_203735) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:94:42-51\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
            if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t x_203737 = sdiv64(n_203572, jump_l_203583);
        int64_t l_n_m_f_res_203738 = add64((int64_t) 1, x_203737);
        
        l_n_m_203733 = l_n_m_f_res_203738;
    }
    
    bool cond_203739 = jump_t_203582 == (int64_t) 1;
    int64_t t_n_m_203740;
    
    if (cond_203739) {
        t_n_m_203740 = n_203572;
    } else {
        bool zzero_203741 = jump_t_203582 == (int64_t) 0;
        bool nonzzero_203742 = !zzero_203741;
        bool nonzzero_cert_203743;
        
        if (!nonzzero_203742) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:98:42-51\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
            if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
                return 1;
            err = 1;
            goto cleanup;
        }
        
        int64_t x_203744 = sdiv64(n_203572, jump_t_203582);
        int64_t t_n_m_f_res_203745 = add64((int64_t) 1, x_203744);
        
        t_n_m_203740 = t_n_m_f_res_203745;
    }
    
    double x_203746 = i64_res_203588 / 2.0;
    double floor_arg_203747 = 1.0 + x_203746;
    double floor_res_203748;
    
    floor_res_203748 = futrts_floor64(floor_arg_203747);
    
    int64_t defunc_0_f_res_203749 = fptosi_f64_i64(floor_res_203748);
    int64_t x_203750 = sub64(n_203572, defunc_0_f_res_203749);
    int64_t mid2_203751 = add64((int64_t) 1, x_203750);
    bool cond_203752 = defunc_0_f_res_203749 == mid2_203751;
    int64_t stl_res_t_res_203753 = sub64(defunc_0_f_res_203749, (int64_t) 1);
    int64_t stl_res_203754;
    int64_t stl_res_203755;
    
    if (cond_203752) {
        stl_res_203754 = stl_res_t_res_203753;
        stl_res_203755 = defunc_0_f_res_203749;
    } else {
        int64_t min_res_203756 = smin64(defunc_0_f_res_203749, mid2_203751);
        int64_t stl_res_f_res_203757 = sub64(min_res_203756, (int64_t) 1);
        int64_t max_res_203758 = smax64(defunc_0_f_res_203749, mid2_203751);
        
        stl_res_203754 = stl_res_f_res_203757;
        stl_res_203755 = max_res_203758;
    }
    
    int64_t i_203760 = sub64(n_203572, (int64_t) 1);
    bool x_203761 = sle64((int64_t) 0, i_203760);
    bool y_203762 = slt64(i_203760, n_203572);
    bool bounds_check_203763 = x_203761 && y_203762;
    bool index_certs_203764;
    
    if (!bounds_check_203763) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_203760,
                               "] out of bounds for array of shape [",
                               (long long) n_203572, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  stl.fut:112:31-49\n   #3  stl.fut:415:61-429:75\n   #4  stl.fut:455:3-469:34\n   #5  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_x_208497 = n_203572 * partition_sizze_203667;
    int64_t binop_y_208498 = (int64_t) 8 * binop_x_208497;
    int64_t bytes_208499 = smax64((int64_t) 0, binop_y_208498);
    
    if (mem_208500_cached_sizze_213850 < (size_t) bytes_208499) {
        mem_208500 = realloc(mem_208500, bytes_208499);
        mem_208500_cached_sizze_213850 = bytes_208499;
    }
    
    int64_t binop_y_208501 = (int64_t) 8 * partition_sizze_203667;
    int64_t bytes_208502 = smax64((int64_t) 0, binop_y_208501);
    
    if (mem_208503_cached_sizze_213851 < (size_t) bytes_208502) {
        mem_208503 = realloc(mem_208503, bytes_208502);
        mem_208503_cached_sizze_213851 = bytes_208502;
    }
    
    int64_t binop_y_208521 = (int64_t) 8 * n_203572;
    int64_t bytes_208522 = smax64((int64_t) 0, binop_y_208521);
    
    if (mem_208523_cached_sizze_213852 < (size_t) bytes_208522) {
        mem_208523 = realloc(mem_208523, bytes_208522);
        mem_208523_cached_sizze_213852 = bytes_208522;
    }
    if (mem_208538_cached_sizze_213853 < (size_t) bytes_208522) {
        mem_208538 = realloc(mem_208538, bytes_208522);
        mem_208538_cached_sizze_213853 = bytes_208522;
    }
    for (int64_t i_213488 = 0; i_213488 < n_203572; i_213488++) {
        ((int64_t *) mem_208538)[i_213488] = (int64_t) -1;
    }
    for (int64_t i_206996 = 0; i_206996 < partition_sizze_203667; i_206996++) {
        int64_t discard_206985;
        int64_t scanacc_206981 = (int64_t) 0;
        
        for (int64_t i_206983 = 0; i_206983 < n_203572; i_206983++) {
            double x_203772;
            
            x_203772 = ((double *) mem_208460)[i_206996 * n_203572 + i_206983];
            
            bool isnan_res_203773;
            
            isnan_res_203773 = futrts_isnan64(x_203772);
            
            bool defunc_0_p_res_203774 = !isnan_res_203773;
            int64_t defunc_0_f_res_203775 =
                    btoi_bool_i64(defunc_0_p_res_203774);
            int64_t defunc_1_op_res_203771 = add64(defunc_0_f_res_203775,
                                                   scanacc_206981);
            
            ((int64_t *) mem_208523)[i_206983] = defunc_1_op_res_203771;
            
            int64_t scanacc_tmp_213491 = defunc_1_op_res_203771;
            
            scanacc_206981 = scanacc_tmp_213491;
        }
        discard_206985 = scanacc_206981;
        if (n_203572 * (int64_t) 8 > 0)
            memmove(mem_208500 + i_206996 * n_203572 * (int64_t) 8, mem_208538 +
                    (int64_t) 0, n_203572 * (int64_t) 8);
        for (int64_t write_iter_206986 = 0; write_iter_206986 < n_203572;
             write_iter_206986++) {
            double write_iv_206988;
            
            write_iv_206988 = ((double *) mem_208460)[i_206996 * n_203572 +
                                                      write_iter_206986];
            
            int64_t write_iv_206989;
            
            write_iv_206989 = ((int64_t *) mem_208523)[write_iter_206986];
            
            bool isnan_res_203782;
            
            isnan_res_203782 = futrts_isnan64(write_iv_206988);
            
            bool defunc_0_p_res_203783 = !isnan_res_203782;
            int64_t defunc_1_f_res_203784;
            
            if (defunc_0_p_res_203783) {
                int64_t defunc_1_f_res_t_res_203785 = sub64(write_iv_206989,
                                                            (int64_t) 1);
                
                defunc_1_f_res_203784 = defunc_1_f_res_t_res_203785;
            } else {
                defunc_1_f_res_203784 = (int64_t) -1;
            }
            if ((sle64((int64_t) 0, i_206996) && slt64(i_206996,
                                                       partition_sizze_203667)) &&
                (sle64((int64_t) 0, defunc_1_f_res_203784) &&
                 slt64(defunc_1_f_res_203784, n_203572))) {
                ((int64_t *) mem_208500)[i_206996 * n_203572 +
                                         defunc_1_f_res_203784] =
                    write_iter_206986;
            }
        }
        if ((int64_t) 8 > 0)
            memmove(mem_208503 + i_206996 * (int64_t) 8, mem_208523 +
                    ((int64_t) 0 + (int64_t) 1 * i_203760) * (int64_t) 8,
                    (int64_t) 8);
    }
    
    bool bounds_invalid_upwards_203788 = slt64(defunc_0_f_res_203721,
                                               (int64_t) 0);
    bool valid_203789 = !bounds_invalid_upwards_203788;
    bool range_valid_c_203790;
    
    if (!valid_203789) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) defunc_0_f_res_203721,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:119:20-125:36\n   #4  /prelude/soacs.fut:59:3-10\n   #5  /prelude/array.fut:195:3-17\n   #6  utils.fut:6:3-16\n   #7  stl.fut:117:12-126:20\n   #8  stl.fut:116:5-127:11\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t binop_x_208571 = n_p_203574 * partition_sizze_203667;
    int64_t binop_x_208572 = defunc_0_f_res_203721 * binop_x_208571;
    int64_t binop_y_208573 = (int64_t) 8 * binop_x_208572;
    int64_t bytes_208574 = smax64((int64_t) 0, binop_y_208573);
    
    if (mem_208575_cached_sizze_213854 < (size_t) bytes_208574) {
        mem_208575 = realloc(mem_208575, bytes_208574);
        mem_208575_cached_sizze_213854 = bytes_208574;
    }
    
    int64_t ctx_val_208588 = n_p_203574 * defunc_0_f_res_203721;
    
    for (int64_t i_207009 = 0; i_207009 < partition_sizze_203667; i_207009++) {
        for (int64_t i_207005 = 0; i_207005 < n_p_203574; i_207005++) {
            for (int64_t i_207001 = 0; i_207001 < defunc_0_f_res_203721;
                 i_207001++) {
                int64_t y_203798 = mul64(n_p_203574, i_207001);
                int64_t new_i_203799 = add64(y_203798, i_207005);
                bool cond_203800 = slt64(i_203760, new_i_203799);
                double defunc_0_f_res_203801;
                
                if (cond_203800) {
                    defunc_0_f_res_203801 = NAN;
                } else {
                    bool x_203802 = sle64((int64_t) 0, new_i_203799);
                    bool y_203803 = slt64(new_i_203799, n_203572);
                    bool bounds_check_203804 = x_203802 && y_203803;
                    bool index_certs_203805;
                    
                    if (!bounds_check_203804) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) new_i_203799,
                                      "] out of bounds for array of shape [",
                                      (long long) n_203572, "].",
                                      "-> #0  stl.fut:124:33-40\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:119:20-125:36\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:117:12-126:20\n   #9  stl.fut:116:5-127:11\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &mem_out_213477,
                                           "mem_out_213477") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213476,
                                           "mem_out_213476") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213475,
                                           "mem_out_213475") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    double defunc_0_f_res_f_res_203806;
                    
                    defunc_0_f_res_f_res_203806 =
                        ((double *) mem_208460)[i_207009 * n_203572 +
                                                new_i_203799];
                    defunc_0_f_res_203801 = defunc_0_f_res_f_res_203806;
                }
                ((double *) mem_208575)[i_207009 * ctx_val_208588 + i_207005 *
                                        defunc_0_f_res_203721 + i_207001] =
                    defunc_0_f_res_203801;
            }
        }
    }
    
    int64_t i_203808 = sub64(defunc_0_f_res_203721, (int64_t) 1);
    bool x_203809 = sle64((int64_t) 0, i_203808);
    bool y_203810 = slt64(i_203808, defunc_0_f_res_203721);
    bool bounds_check_203811 = x_203809 && y_203810;
    bool index_certs_203812;
    
    if (!bounds_check_203811) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_203808,
                               "] out of bounds for array of shape [",
                               (long long) defunc_0_f_res_203721, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  stl.fut:133:51-67\n   #3  stl.fut:132:12-135:21\n   #4  stl.fut:131:5-136:16\n   #5  stl.fut:415:61-429:75\n   #6  stl.fut:455:3-469:34\n   #7  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    if (mem_208667_cached_sizze_213855 < (size_t) bytes_208574) {
        mem_208667 = realloc(mem_208667, bytes_208574);
        mem_208667_cached_sizze_213855 = bytes_208574;
    }
    
    int64_t binop_y_208669 = (int64_t) 8 * binop_x_208571;
    int64_t bytes_208670 = smax64((int64_t) 0, binop_y_208669);
    
    if (mem_208671_cached_sizze_213856 < (size_t) bytes_208670) {
        mem_208671 = realloc(mem_208671, bytes_208670);
        mem_208671_cached_sizze_213856 = bytes_208670;
    }
    
    int64_t binop_y_208722 = (int64_t) 8 * defunc_0_f_res_203721;
    int64_t bytes_208723 = smax64((int64_t) 0, binop_y_208722);
    
    if (mem_208724_cached_sizze_213857 < (size_t) bytes_208723) {
        mem_208724 = realloc(mem_208724, bytes_208723);
        mem_208724_cached_sizze_213857 = bytes_208723;
    }
    if (mem_208739_cached_sizze_213858 < (size_t) bytes_208723) {
        mem_208739 = realloc(mem_208739, bytes_208723);
        mem_208739_cached_sizze_213858 = bytes_208723;
    }
    for (int64_t i_213497 = 0; i_213497 < defunc_0_f_res_203721; i_213497++) {
        ((int64_t *) mem_208739)[i_213497] = (int64_t) -1;
    }
    for (int64_t i_207034 = 0; i_207034 < partition_sizze_203667; i_207034++) {
        for (int64_t i_207027 = 0; i_207027 < n_p_203574; i_207027++) {
            int64_t discard_207016;
            int64_t scanacc_207012 = (int64_t) 0;
            
            for (int64_t i_207014 = 0; i_207014 < defunc_0_f_res_203721;
                 i_207014++) {
                double x_203823;
                
                x_203823 = ((double *) mem_208575)[i_207034 * ctx_val_208588 +
                                                   i_207027 *
                                                   defunc_0_f_res_203721 +
                                                   i_207014];
                
                bool isnan_res_203824;
                
                isnan_res_203824 = futrts_isnan64(x_203823);
                
                bool defunc_0_p_res_203825 = !isnan_res_203824;
                int64_t defunc_0_f_res_203826 =
                        btoi_bool_i64(defunc_0_p_res_203825);
                int64_t defunc_1_op_res_203822 = add64(defunc_0_f_res_203826,
                                                       scanacc_207012);
                
                ((int64_t *) mem_208724)[i_207014] = defunc_1_op_res_203822;
                
                int64_t scanacc_tmp_213502 = defunc_1_op_res_203822;
                
                scanacc_207012 = scanacc_tmp_213502;
            }
            discard_207016 = scanacc_207012;
            if (defunc_0_f_res_203721 * (int64_t) 8 > 0)
                memmove(mem_208667 + (i_207034 * ctx_val_208588 + i_207027 *
                                      defunc_0_f_res_203721) * (int64_t) 8,
                        mem_208739 + (int64_t) 0, defunc_0_f_res_203721 *
                        (int64_t) 8);
            for (int64_t write_iter_207017 = 0; write_iter_207017 <
                 defunc_0_f_res_203721; write_iter_207017++) {
                double write_iv_207019;
                
                write_iv_207019 = ((double *) mem_208575)[i_207034 *
                                                          ctx_val_208588 +
                                                          i_207027 *
                                                          defunc_0_f_res_203721 +
                                                          write_iter_207017];
                
                int64_t write_iv_207020;
                
                write_iv_207020 = ((int64_t *) mem_208724)[write_iter_207017];
                
                bool isnan_res_203833;
                
                isnan_res_203833 = futrts_isnan64(write_iv_207019);
                
                bool defunc_0_p_res_203834 = !isnan_res_203833;
                int64_t defunc_1_f_res_203835;
                
                if (defunc_0_p_res_203834) {
                    int64_t defunc_1_f_res_t_res_203836 = sub64(write_iv_207020,
                                                                (int64_t) 1);
                    
                    defunc_1_f_res_203835 = defunc_1_f_res_t_res_203836;
                } else {
                    defunc_1_f_res_203835 = (int64_t) -1;
                }
                if (((sle64((int64_t) 0, i_207034) && slt64(i_207034,
                                                            partition_sizze_203667)) &&
                     (sle64((int64_t) 0, i_207027) && slt64(i_207027,
                                                            n_p_203574))) &&
                    (sle64((int64_t) 0, defunc_1_f_res_203835) &&
                     slt64(defunc_1_f_res_203835, defunc_0_f_res_203721))) {
                    ((int64_t *) mem_208667)[i_207034 * ctx_val_208588 +
                                             i_207027 * defunc_0_f_res_203721 +
                                             defunc_1_f_res_203835] =
                        write_iter_207017;
                }
            }
            if ((int64_t) 8 > 0)
                memmove(mem_208671 + (i_207034 * n_p_203574 + i_207027) *
                        (int64_t) 8, mem_208724 + ((int64_t) 0 + (int64_t) 1 *
                                                   i_203808) * (int64_t) 8,
                        (int64_t) 8);
        }
    }
    
    int64_t min_res_203839 = smin64(q_s_203575, defunc_0_f_res_203721);
    bool bounds_invalid_upwards_203840 = slt64(s_n_m_203726, (int64_t) 0);
    bool valid_203841 = !bounds_invalid_upwards_203840;
    bool range_valid_c_203842;
    
    if (!valid_203841) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) s_n_m_203726, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:443:3-470:10\n   #4  loess.fut:517:15-50\n   #5  stl.fut:142:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:141:12-143:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:140:5-144:36\n   #12 stl.fut:415:61-429:75\n   #13 stl.fut:455:3-469:34\n   #14 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool loop_cond_203844 = slt64((int64_t) 1, min_res_203839);
    double i64_res_203845 = sitofp_i64_f64(q_s_203575);
    int64_t binop_x_208815 = s_n_m_203726 * binop_x_208571;
    int64_t binop_y_208816 = (int64_t) 8 * binop_x_208815;
    int64_t bytes_208817 = smax64((int64_t) 0, binop_y_208816);
    
    if (mem_208818_cached_sizze_213859 < (size_t) bytes_208817) {
        mem_208818 = realloc(mem_208818, bytes_208817);
        mem_208818_cached_sizze_213859 = bytes_208817;
    }
    if (mem_208823_cached_sizze_213860 < (size_t) bytes_208817) {
        mem_208823 = realloc(mem_208823, bytes_208817);
        mem_208823_cached_sizze_213860 = bytes_208817;
    }
    
    int64_t ctx_val_208847 = n_p_203574 * s_n_m_203726;
    int64_t binop_y_208882 = (int64_t) 8 * defunc_0_f_res_203721;
    int64_t bytes_208883 = smax64((int64_t) 0, binop_y_208882);
    
    if (mem_208884_cached_sizze_213861 < (size_t) bytes_208883) {
        mem_208884 = realloc(mem_208884, bytes_208883);
        mem_208884_cached_sizze_213861 = bytes_208883;
    }
    for (int64_t i_207059 = 0; i_207059 < partition_sizze_203667; i_207059++) {
        for (int64_t i_207052 = 0; i_207052 < n_p_203574; i_207052++) {
            int64_t x_203853;
            
            x_203853 = ((int64_t *) mem_208671)[i_207059 * n_p_203574 +
                                                i_207052];
            for (int64_t i_207039 = 0; i_207039 < defunc_0_f_res_203721;
                 i_207039++) {
                int64_t x_203855;
                
                x_203855 = ((int64_t *) mem_208667)[i_207059 * ctx_val_208588 +
                                                    i_207052 *
                                                    defunc_0_f_res_203721 +
                                                    i_207039];
                
                int64_t defunc_0_f_res_203856 = add64((int64_t) 1, x_203855);
                
                ((int64_t *) mem_208884)[i_207039] = defunc_0_f_res_203856;
            }
            
            int64_t min_arg_203857 = sub64(x_203853, (int64_t) 1);
            int64_t min_arg_203858 = sub64(x_203853, min_res_203839);
            int64_t min_res_203859 = smin64(q_s_203575, x_203853);
            double i64_res_203860 = sitofp_i64_f64(x_203853);
            double x_203861 = i64_res_203845 - i64_res_203860;
            double max_arg_203862 = x_203861 / 2.0;
            double max_res_203863 = fmax64(0.0, max_arg_203862);
            
            for (int64_t i_207045 = 0; i_207045 < s_n_m_203726; i_207045++) {
                bool cond_203867 = i_207045 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_203868;
                
                if (cond_203867) {
                    defunc_0_m_fun_res_203868 = (int64_t) 0;
                } else {
                    int64_t y_203869 = sub64(s_n_m_203726, (int64_t) 1);
                    bool cond_203870 = i_207045 == y_203869;
                    int64_t defunc_0_m_fun_res_f_res_203871;
                    
                    if (cond_203870) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_203872 =
                                sub64(pad_css_len_203722, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_203871 =
                            defunc_0_m_fun_res_f_res_t_res_203872;
                    } else {
                        int64_t x_203873 = sub64(i_207045, (int64_t) 1);
                        int64_t x_203874 = mul64(jump_s_203581, x_203873);
                        int64_t min_arg_203875 = add64((int64_t) 1, x_203874);
                        int64_t min_res_203876 = smin64(defunc_0_f_res_203721,
                                                        min_arg_203875);
                        
                        defunc_0_m_fun_res_f_res_203871 = min_res_203876;
                    }
                    defunc_0_m_fun_res_203868 = defunc_0_m_fun_res_f_res_203871;
                }
                
                bool init_idx_203877;
                int64_t init_idx_203878;
                int64_t init_idx_203879;
                bool loop_while_203880;
                int64_t low_203881;
                int64_t high_203882;
                
                loop_while_203880 = x_203809;
                low_203881 = (int64_t) 0;
                high_203882 = i_203808;
                while (loop_while_203880) {
                    int64_t x_203883 = add64(low_203881, high_203882);
                    int64_t mid_203884 = sdiv64(x_203883, (int64_t) 2);
                    bool x_203885 = sle64((int64_t) 0, mid_203884);
                    bool y_203886 = slt64(mid_203884, defunc_0_f_res_203721);
                    bool bounds_check_203887 = x_203885 && y_203886;
                    bool index_certs_203888;
                    
                    if (!bounds_check_203887) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) mid_203884,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_203721, "].",
                                      "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:517:15-50\n   #6  stl.fut:142:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:141:12-143:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:140:5-144:36\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &mem_out_213477,
                                           "mem_out_213477") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213476,
                                           "mem_out_213476") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213475,
                                           "mem_out_213475") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t mid_id_203889;
                    
                    mid_id_203889 = ((int64_t *) mem_208884)[mid_203884];
                    
                    bool cond_203890 = slt64(mid_id_203889, (int64_t) 0);
                    int64_t mid_idx_203891;
                    
                    if (cond_203890) {
                        mid_idx_203891 = (int64_t) 9223372036854775807;
                    } else {
                        mid_idx_203891 = mid_id_203889;
                    }
                    
                    bool cond_203892 = sle64(defunc_0_m_fun_res_203868,
                                             mid_idx_203891);
                    int64_t loopres_203893;
                    int64_t loopres_203894;
                    
                    if (cond_203892) {
                        int64_t loopres_t_res_203895 = sub64(mid_203884,
                                                             (int64_t) 1);
                        
                        loopres_203893 = low_203881;
                        loopres_203894 = loopres_t_res_203895;
                    } else {
                        int64_t loopres_f_res_203896 = add64((int64_t) 1,
                                                             mid_203884);
                        
                        loopres_203893 = loopres_f_res_203896;
                        loopres_203894 = high_203882;
                    }
                    
                    bool loop_cond_203897 = sle64(loopres_203893,
                                                  loopres_203894);
                    bool loop_while_tmp_213512 = loop_cond_203897;
                    int64_t low_tmp_213513 = loopres_203893;
                    int64_t high_tmp_213514 = loopres_203894;
                    
                    loop_while_203880 = loop_while_tmp_213512;
                    low_203881 = low_tmp_213513;
                    high_203882 = high_tmp_213514;
                }
                init_idx_203877 = loop_while_203880;
                init_idx_203878 = low_203881;
                init_idx_203879 = high_203882;
                
                bool idx_203898;
                int64_t idx_203899;
                int64_t idx_203900;
                int64_t idx_203901;
                bool loop_while_203902;
                int64_t l_idx_203903;
                int64_t r_idx_203904;
                int64_t span_203905;
                
                loop_while_203902 = loop_cond_203844;
                l_idx_203903 = init_idx_203878;
                r_idx_203904 = init_idx_203878;
                span_203905 = (int64_t) 1;
                while (loop_while_203902) {
                    int64_t max_arg_203906 = sub64(l_idx_203903, (int64_t) 1);
                    int64_t max_res_203907 = smax64((int64_t) 0,
                                                    max_arg_203906);
                    int64_t min_arg_203908 = add64((int64_t) 1, r_idx_203904);
                    int64_t min_res_203909 = smin64(min_arg_203857,
                                                    min_arg_203908);
                    bool x_203910 = sle64((int64_t) 0, max_res_203907);
                    bool y_203911 = slt64(max_res_203907,
                                          defunc_0_f_res_203721);
                    bool bounds_check_203912 = x_203910 && y_203911;
                    bool index_certs_203913;
                    
                    if (!bounds_check_203912) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) max_res_203907,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_203721, "].",
                                      "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:517:15-50\n   #6  stl.fut:142:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:141:12-143:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:140:5-144:36\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &mem_out_213477,
                                           "mem_out_213477") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213476,
                                           "mem_out_213476") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213475,
                                           "mem_out_213475") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_203914;
                    
                    x_203914 = ((int64_t *) mem_208884)[max_res_203907];
                    
                    int64_t abs_arg_203915 = sub64(x_203914,
                                                   defunc_0_m_fun_res_203868);
                    int64_t abs_res_203916 = abs64(abs_arg_203915);
                    bool x_203917 = sle64((int64_t) 0, min_res_203909);
                    bool y_203918 = slt64(min_res_203909,
                                          defunc_0_f_res_203721);
                    bool bounds_check_203919 = x_203917 && y_203918;
                    bool index_certs_203920;
                    
                    if (!bounds_check_203919) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) min_res_203909,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_203721, "].",
                                      "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:517:15-50\n   #6  stl.fut:142:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:141:12-143:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:140:5-144:36\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &mem_out_213477,
                                           "mem_out_213477") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213476,
                                           "mem_out_213476") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213475,
                                           "mem_out_213475") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t x_203921;
                    
                    x_203921 = ((int64_t *) mem_208884)[min_res_203909];
                    
                    int64_t abs_arg_203922 = sub64(x_203921,
                                                   defunc_0_m_fun_res_203868);
                    int64_t abs_res_203923 = abs64(abs_arg_203922);
                    bool cond_203924 = max_res_203907 == l_idx_203903;
                    int64_t loopres_203925;
                    int64_t loopres_203926;
                    int64_t loopres_203927;
                    
                    if (cond_203924) {
                        loopres_203925 = l_idx_203903;
                        loopres_203926 = r_idx_203904;
                        loopres_203927 = min_res_203839;
                    } else {
                        bool cond_203928 = slt64(abs_res_203916,
                                                 abs_res_203923);
                        bool cond_f_res_203929 = min_res_203909 == r_idx_203904;
                        bool x_203930 = !cond_203928;
                        bool y_203931 = cond_f_res_203929 && x_203930;
                        bool cond_203932 = cond_203928 || y_203931;
                        int64_t loopres_f_res_203933;
                        
                        if (cond_203932) {
                            loopres_f_res_203933 = max_res_203907;
                        } else {
                            loopres_f_res_203933 = l_idx_203903;
                        }
                        
                        int64_t loopres_f_res_203934;
                        
                        if (cond_203932) {
                            loopres_f_res_203934 = r_idx_203904;
                        } else {
                            loopres_f_res_203934 = min_res_203909;
                        }
                        
                        int64_t loopres_f_res_203935;
                        
                        if (cond_203932) {
                            int64_t loopres_f_res_t_res_203936 =
                                    add64((int64_t) 1, span_203905);
                            
                            loopres_f_res_203935 = loopres_f_res_t_res_203936;
                        } else {
                            int64_t loopres_f_res_f_res_203937 =
                                    add64((int64_t) 1, span_203905);
                            
                            loopres_f_res_203935 = loopres_f_res_f_res_203937;
                        }
                        loopres_203925 = loopres_f_res_203933;
                        loopres_203926 = loopres_f_res_203934;
                        loopres_203927 = loopres_f_res_203935;
                    }
                    
                    bool loop_cond_203938 = slt64(loopres_203927,
                                                  min_res_203839);
                    bool loop_while_tmp_213515 = loop_cond_203938;
                    int64_t l_idx_tmp_213516 = loopres_203925;
                    int64_t r_idx_tmp_213517 = loopres_203926;
                    int64_t span_tmp_213518 = loopres_203927;
                    
                    loop_while_203902 = loop_while_tmp_213515;
                    l_idx_203903 = l_idx_tmp_213516;
                    r_idx_203904 = r_idx_tmp_213517;
                    span_203905 = span_tmp_213518;
                }
                idx_203898 = loop_while_203902;
                idx_203899 = l_idx_203903;
                idx_203900 = r_idx_203904;
                idx_203901 = span_203905;
                
                int64_t min_res_203939 = smin64(min_arg_203858, idx_203899);
                int64_t max_res_203940 = smax64((int64_t) 0, min_res_203939);
                int64_t defunc_0_m_fun_res_203941;
                
                if (cond_203867) {
                    defunc_0_m_fun_res_203941 = (int64_t) 0;
                } else {
                    int64_t y_203942 = sub64(s_n_m_203726, (int64_t) 1);
                    bool cond_203943 = i_207045 == y_203942;
                    int64_t defunc_0_m_fun_res_f_res_203944;
                    
                    if (cond_203943) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_203945 =
                                sub64(pad_css_len_203722, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_203944 =
                            defunc_0_m_fun_res_f_res_t_res_203945;
                    } else {
                        int64_t x_203946 = sub64(i_207045, (int64_t) 1);
                        int64_t x_203947 = mul64(jump_s_203581, x_203946);
                        int64_t min_arg_203948 = add64((int64_t) 1, x_203947);
                        int64_t min_res_203949 = smin64(defunc_0_f_res_203721,
                                                        min_arg_203948);
                        
                        defunc_0_m_fun_res_f_res_203944 = min_res_203949;
                    }
                    defunc_0_m_fun_res_203941 = defunc_0_m_fun_res_f_res_203944;
                }
                
                int64_t x_203950 = add64(min_res_203859, max_res_203940);
                int64_t r_203951 = sub64(x_203950, (int64_t) 1);
                bool x_203952 = sle64((int64_t) 0, r_203951);
                bool y_203953 = slt64(r_203951, defunc_0_f_res_203721);
                bool bounds_check_203954 = x_203952 && y_203953;
                bool index_certs_203955;
                
                if (!bounds_check_203954) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) r_203951,
                                  "] out of bounds for array of shape [",
                                  (long long) defunc_0_f_res_203721, "].",
                                  "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:518:16-54\n   #5  stl.fut:142:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:141:12-143:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:140:5-144:36\n   #12 stl.fut:415:61-429:75\n   #13 stl.fut:455:3-469:34\n   #14 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_203956;
                
                x_203956 = ((int64_t *) mem_208884)[r_203951];
                
                int64_t abs_arg_203957 = sub64(x_203956,
                                               defunc_0_m_fun_res_203941);
                int64_t abs_res_203958 = abs64(abs_arg_203957);
                bool x_203959 = sle64((int64_t) 0, max_res_203940);
                bool y_203960 = slt64(max_res_203940, defunc_0_f_res_203721);
                bool bounds_check_203961 = x_203959 && y_203960;
                bool index_certs_203962;
                
                if (!bounds_check_203961) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_203940,
                                  "] out of bounds for array of shape [",
                                  (long long) defunc_0_f_res_203721, "].",
                                  "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:518:16-54\n   #5  stl.fut:142:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:141:12-143:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:140:5-144:36\n   #12 stl.fut:415:61-429:75\n   #13 stl.fut:455:3-469:34\n   #14 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_203963;
                
                x_203963 = ((int64_t *) mem_208884)[max_res_203940];
                
                int64_t abs_arg_203964 = sub64(x_203963,
                                               defunc_0_m_fun_res_203941);
                int64_t abs_res_203965 = abs64(abs_arg_203964);
                int64_t max_res_203966 = smax64(abs_res_203958, abs_res_203965);
                double defunc_0_f_res_203967 = sitofp_i64_f64(max_res_203966);
                double defunc_1_f_res_203968 = max_res_203863 +
                       defunc_0_f_res_203967;
                
                ((double *) mem_208823)[i_207059 * ctx_val_208847 + i_207052 *
                                        s_n_m_203726 + i_207045] =
                    defunc_1_f_res_203968;
                ((int64_t *) mem_208818)[i_207059 * ctx_val_208847 + i_207052 *
                                         s_n_m_203726 + i_207045] =
                    max_res_203940;
            }
        }
    }
    
    int64_t min_res_203971 = smin64(n_203572, q_l_203577);
    bool bounds_invalid_upwards_203972 = slt64(l_n_m_203733, (int64_t) 0);
    bool valid_203973 = !bounds_invalid_upwards_203972;
    bool range_valid_c_203974;
    
    if (!valid_203973) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) l_n_m_203733, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:443:3-470:10\n   #4  loess.fut:503:15-61\n   #5  stl.fut:150:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:148:5-151:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool loop_cond_203976 = slt64((int64_t) 1, min_res_203971);
    double i64_res_203977 = sitofp_i64_f64(q_l_203577);
    int64_t binop_x_209013 = partition_sizze_203667 * l_n_m_203733;
    int64_t binop_y_209014 = (int64_t) 8 * binop_x_209013;
    int64_t bytes_209015 = smax64((int64_t) 0, binop_y_209014);
    
    if (mem_209016_cached_sizze_213862 < (size_t) bytes_209015) {
        mem_209016 = realloc(mem_209016, bytes_209015);
        mem_209016_cached_sizze_213862 = bytes_209015;
    }
    if (mem_209020_cached_sizze_213863 < (size_t) bytes_209015) {
        mem_209020 = realloc(mem_209020, bytes_209015);
        mem_209020_cached_sizze_213863 = bytes_209015;
    }
    
    int64_t binop_y_209041 = (int64_t) 8 * n_203572;
    int64_t bytes_209042 = smax64((int64_t) 0, binop_y_209041);
    
    if (mem_209043_cached_sizze_213864 < (size_t) bytes_209042) {
        mem_209043 = realloc(mem_209043, bytes_209042);
        mem_209043_cached_sizze_213864 = bytes_209042;
    }
    for (int64_t i_207077 = 0; i_207077 < partition_sizze_203667; i_207077++) {
        int64_t x_203981;
        
        x_203981 = ((int64_t *) mem_208503)[i_207077];
        for (int64_t i_207064 = 0; i_207064 < n_203572; i_207064++) {
            int64_t x_203983;
            
            x_203983 = ((int64_t *) mem_208500)[i_207077 * n_203572 + i_207064];
            
            int64_t defunc_0_f_res_203984 = add64((int64_t) 1, x_203983);
            
            ((int64_t *) mem_209043)[i_207064] = defunc_0_f_res_203984;
        }
        
        int64_t min_arg_203985 = sub64(x_203981, (int64_t) 1);
        int64_t min_arg_203986 = sub64(x_203981, min_res_203971);
        int64_t min_res_203987 = smin64(q_l_203577, x_203981);
        double i64_res_203988 = sitofp_i64_f64(x_203981);
        double x_203989 = i64_res_203977 - i64_res_203988;
        double max_arg_203990 = x_203989 / 2.0;
        double max_res_203991 = fmax64(0.0, max_arg_203990);
        
        for (int64_t i_207070 = 0; i_207070 < l_n_m_203733; i_207070++) {
            int64_t min_arg_203995 = mul64(jump_l_203583, i_207070);
            int64_t min_res_203996 = smin64(i_203760, min_arg_203995);
            int64_t defunc_0_g_res_203997 = add64((int64_t) 1, min_res_203996);
            bool init_idx_203998;
            int64_t init_idx_203999;
            int64_t init_idx_204000;
            bool loop_while_204001;
            int64_t low_204002;
            int64_t high_204003;
            
            loop_while_204001 = x_203761;
            low_204002 = (int64_t) 0;
            high_204003 = i_203760;
            while (loop_while_204001) {
                int64_t x_204004 = add64(low_204002, high_204003);
                int64_t mid_204005 = sdiv64(x_204004, (int64_t) 2);
                bool x_204006 = sle64((int64_t) 0, mid_204005);
                bool y_204007 = slt64(mid_204005, n_203572);
                bool bounds_check_204008 = x_204006 && y_204007;
                bool index_certs_204009;
                
                if (!bounds_check_204008) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) mid_204005,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203572, "].",
                                  "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:150:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:148:5-151:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t mid_id_204010;
                
                mid_id_204010 = ((int64_t *) mem_209043)[mid_204005];
                
                bool cond_204011 = slt64(mid_id_204010, (int64_t) 0);
                int64_t mid_idx_204012;
                
                if (cond_204011) {
                    mid_idx_204012 = (int64_t) 9223372036854775807;
                } else {
                    mid_idx_204012 = mid_id_204010;
                }
                
                bool cond_204013 = sle64(defunc_0_g_res_203997, mid_idx_204012);
                int64_t loopres_204014;
                int64_t loopres_204015;
                
                if (cond_204013) {
                    int64_t loopres_t_res_204016 = sub64(mid_204005,
                                                         (int64_t) 1);
                    
                    loopres_204014 = low_204002;
                    loopres_204015 = loopres_t_res_204016;
                } else {
                    int64_t loopres_f_res_204017 = add64((int64_t) 1,
                                                         mid_204005);
                    
                    loopres_204014 = loopres_f_res_204017;
                    loopres_204015 = high_204003;
                }
                
                bool loop_cond_204018 = sle64(loopres_204014, loopres_204015);
                bool loop_while_tmp_213524 = loop_cond_204018;
                int64_t low_tmp_213525 = loopres_204014;
                int64_t high_tmp_213526 = loopres_204015;
                
                loop_while_204001 = loop_while_tmp_213524;
                low_204002 = low_tmp_213525;
                high_204003 = high_tmp_213526;
            }
            init_idx_203998 = loop_while_204001;
            init_idx_203999 = low_204002;
            init_idx_204000 = high_204003;
            
            bool idx_204019;
            int64_t idx_204020;
            int64_t idx_204021;
            int64_t idx_204022;
            bool loop_while_204023;
            int64_t l_idx_204024;
            int64_t r_idx_204025;
            int64_t span_204026;
            
            loop_while_204023 = loop_cond_203976;
            l_idx_204024 = init_idx_203999;
            r_idx_204025 = init_idx_203999;
            span_204026 = (int64_t) 1;
            while (loop_while_204023) {
                int64_t max_arg_204027 = sub64(l_idx_204024, (int64_t) 1);
                int64_t max_res_204028 = smax64((int64_t) 0, max_arg_204027);
                int64_t min_arg_204029 = add64((int64_t) 1, r_idx_204025);
                int64_t min_res_204030 = smin64(min_arg_203985, min_arg_204029);
                bool x_204031 = sle64((int64_t) 0, max_res_204028);
                bool y_204032 = slt64(max_res_204028, n_203572);
                bool bounds_check_204033 = x_204031 && y_204032;
                bool index_certs_204034;
                
                if (!bounds_check_204033) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_204028,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203572, "].",
                                  "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:150:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:148:5-151:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_204035;
                
                x_204035 = ((int64_t *) mem_209043)[max_res_204028];
                
                int64_t abs_arg_204036 = sub64(x_204035, defunc_0_g_res_203997);
                int64_t abs_res_204037 = abs64(abs_arg_204036);
                bool x_204038 = sle64((int64_t) 0, min_res_204030);
                bool y_204039 = slt64(min_res_204030, n_203572);
                bool bounds_check_204040 = x_204038 && y_204039;
                bool index_certs_204041;
                
                if (!bounds_check_204040) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) min_res_204030,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203572, "].",
                                  "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:150:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:148:5-151:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_204042;
                
                x_204042 = ((int64_t *) mem_209043)[min_res_204030];
                
                int64_t abs_arg_204043 = sub64(x_204042, defunc_0_g_res_203997);
                int64_t abs_res_204044 = abs64(abs_arg_204043);
                bool cond_204045 = max_res_204028 == l_idx_204024;
                int64_t loopres_204046;
                int64_t loopres_204047;
                int64_t loopres_204048;
                
                if (cond_204045) {
                    loopres_204046 = l_idx_204024;
                    loopres_204047 = r_idx_204025;
                    loopres_204048 = min_res_203971;
                } else {
                    bool cond_204049 = slt64(abs_res_204037, abs_res_204044);
                    bool cond_f_res_204050 = min_res_204030 == r_idx_204025;
                    bool x_204051 = !cond_204049;
                    bool y_204052 = cond_f_res_204050 && x_204051;
                    bool cond_204053 = cond_204049 || y_204052;
                    int64_t loopres_f_res_204054;
                    
                    if (cond_204053) {
                        loopres_f_res_204054 = max_res_204028;
                    } else {
                        loopres_f_res_204054 = l_idx_204024;
                    }
                    
                    int64_t loopres_f_res_204055;
                    
                    if (cond_204053) {
                        loopres_f_res_204055 = r_idx_204025;
                    } else {
                        loopres_f_res_204055 = min_res_204030;
                    }
                    
                    int64_t loopres_f_res_204056;
                    
                    if (cond_204053) {
                        int64_t loopres_f_res_t_res_204057 = add64((int64_t) 1,
                                                                   span_204026);
                        
                        loopres_f_res_204056 = loopres_f_res_t_res_204057;
                    } else {
                        int64_t loopres_f_res_f_res_204058 = add64((int64_t) 1,
                                                                   span_204026);
                        
                        loopres_f_res_204056 = loopres_f_res_f_res_204058;
                    }
                    loopres_204046 = loopres_f_res_204054;
                    loopres_204047 = loopres_f_res_204055;
                    loopres_204048 = loopres_f_res_204056;
                }
                
                bool loop_cond_204059 = slt64(loopres_204048, min_res_203971);
                bool loop_while_tmp_213527 = loop_cond_204059;
                int64_t l_idx_tmp_213528 = loopres_204046;
                int64_t r_idx_tmp_213529 = loopres_204047;
                int64_t span_tmp_213530 = loopres_204048;
                
                loop_while_204023 = loop_while_tmp_213527;
                l_idx_204024 = l_idx_tmp_213528;
                r_idx_204025 = r_idx_tmp_213529;
                span_204026 = span_tmp_213530;
            }
            idx_204019 = loop_while_204023;
            idx_204020 = l_idx_204024;
            idx_204021 = r_idx_204025;
            idx_204022 = span_204026;
            
            int64_t min_res_204060 = smin64(min_arg_203986, idx_204020);
            int64_t max_res_204061 = smax64((int64_t) 0, min_res_204060);
            int64_t x_204062 = add64(min_res_203987, max_res_204061);
            int64_t r_204063 = sub64(x_204062, (int64_t) 1);
            bool x_204064 = sle64((int64_t) 0, r_204063);
            bool y_204065 = slt64(r_204063, n_203572);
            bool bounds_check_204066 = x_204064 && y_204065;
            bool index_certs_204067;
            
            if (!bounds_check_204066) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) r_204063,
                              "] out of bounds for array of shape [",
                              (long long) n_203572, "].",
                              "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  stl.fut:150:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:148:5-151:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_204068;
            
            x_204068 = ((int64_t *) mem_208500)[i_207077 * n_203572 + r_204063];
            
            int64_t abs_arg_204069 = sub64(x_204068, min_res_203996);
            int64_t abs_res_204070 = abs64(abs_arg_204069);
            bool x_204071 = sle64((int64_t) 0, max_res_204061);
            bool y_204072 = slt64(max_res_204061, n_203572);
            bool bounds_check_204073 = x_204071 && y_204072;
            bool index_certs_204074;
            
            if (!bounds_check_204073) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_204061,
                              "] out of bounds for array of shape [",
                              (long long) n_203572, "].",
                              "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  stl.fut:150:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:148:5-151:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_204075;
            
            x_204075 = ((int64_t *) mem_208500)[i_207077 * n_203572 +
                                                max_res_204061];
            
            int64_t abs_arg_204076 = sub64(x_204075, min_res_203996);
            int64_t abs_res_204077 = abs64(abs_arg_204076);
            int64_t max_res_204078 = smax64(abs_res_204070, abs_res_204077);
            double defunc_0_f_res_204079 = sitofp_i64_f64(max_res_204078);
            double defunc_1_f_res_204080 = max_res_203991 +
                   defunc_0_f_res_204079;
            
            ((double *) mem_209020)[i_207077 * l_n_m_203733 + i_207070] =
                defunc_1_f_res_204080;
            ((int64_t *) mem_209016)[i_207077 * l_n_m_203733 + i_207070] =
                max_res_204061;
        }
    }
    
    int64_t min_res_204083 = smin64(n_203572, q_t_203576);
    bool bounds_invalid_upwards_204084 = slt64(t_n_m_203740, (int64_t) 0);
    bool valid_204085 = !bounds_invalid_upwards_204084;
    bool range_valid_c_204086;
    
    if (!valid_204085) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) t_n_m_203740, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:443:3-470:10\n   #4  loess.fut:503:15-61\n   #5  stl.fut:157:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:155:5-158:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool loop_cond_204088 = slt64((int64_t) 1, min_res_204083);
    double i64_res_204089 = sitofp_i64_f64(q_t_203576);
    int64_t binop_x_209116 = partition_sizze_203667 * t_n_m_203740;
    int64_t binop_y_209117 = (int64_t) 8 * binop_x_209116;
    int64_t bytes_209118 = smax64((int64_t) 0, binop_y_209117);
    
    if (mem_209119_cached_sizze_213865 < (size_t) bytes_209118) {
        mem_209119 = realloc(mem_209119, bytes_209118);
        mem_209119_cached_sizze_213865 = bytes_209118;
    }
    if (mem_209123_cached_sizze_213866 < (size_t) bytes_209118) {
        mem_209123 = realloc(mem_209123, bytes_209118);
        mem_209123_cached_sizze_213866 = bytes_209118;
    }
    
    int64_t binop_y_209144 = (int64_t) 8 * n_203572;
    int64_t bytes_209145 = smax64((int64_t) 0, binop_y_209144);
    
    if (mem_209146_cached_sizze_213867 < (size_t) bytes_209145) {
        mem_209146 = realloc(mem_209146, bytes_209145);
        mem_209146_cached_sizze_213867 = bytes_209145;
    }
    for (int64_t i_207095 = 0; i_207095 < partition_sizze_203667; i_207095++) {
        int64_t x_204093;
        
        x_204093 = ((int64_t *) mem_208503)[i_207095];
        for (int64_t i_207082 = 0; i_207082 < n_203572; i_207082++) {
            int64_t x_204095;
            
            x_204095 = ((int64_t *) mem_208500)[i_207095 * n_203572 + i_207082];
            
            int64_t defunc_0_f_res_204096 = add64((int64_t) 1, x_204095);
            
            ((int64_t *) mem_209146)[i_207082] = defunc_0_f_res_204096;
        }
        
        int64_t min_arg_204097 = sub64(x_204093, (int64_t) 1);
        int64_t min_arg_204098 = sub64(x_204093, min_res_204083);
        int64_t min_res_204099 = smin64(q_t_203576, x_204093);
        double i64_res_204100 = sitofp_i64_f64(x_204093);
        double x_204101 = i64_res_204089 - i64_res_204100;
        double max_arg_204102 = x_204101 / 2.0;
        double max_res_204103 = fmax64(0.0, max_arg_204102);
        
        for (int64_t i_207088 = 0; i_207088 < t_n_m_203740; i_207088++) {
            int64_t min_arg_204107 = mul64(jump_t_203582, i_207088);
            int64_t min_res_204108 = smin64(i_203760, min_arg_204107);
            int64_t defunc_0_g_res_204109 = add64((int64_t) 1, min_res_204108);
            bool init_idx_204110;
            int64_t init_idx_204111;
            int64_t init_idx_204112;
            bool loop_while_204113;
            int64_t low_204114;
            int64_t high_204115;
            
            loop_while_204113 = x_203761;
            low_204114 = (int64_t) 0;
            high_204115 = i_203760;
            while (loop_while_204113) {
                int64_t x_204116 = add64(low_204114, high_204115);
                int64_t mid_204117 = sdiv64(x_204116, (int64_t) 2);
                bool x_204118 = sle64((int64_t) 0, mid_204117);
                bool y_204119 = slt64(mid_204117, n_203572);
                bool bounds_check_204120 = x_204118 && y_204119;
                bool index_certs_204121;
                
                if (!bounds_check_204120) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) mid_204117,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203572, "].",
                                  "-> #0  loess.fut:450:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:157:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:155:5-158:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t mid_id_204122;
                
                mid_id_204122 = ((int64_t *) mem_209146)[mid_204117];
                
                bool cond_204123 = slt64(mid_id_204122, (int64_t) 0);
                int64_t mid_idx_204124;
                
                if (cond_204123) {
                    mid_idx_204124 = (int64_t) 9223372036854775807;
                } else {
                    mid_idx_204124 = mid_id_204122;
                }
                
                bool cond_204125 = sle64(defunc_0_g_res_204109, mid_idx_204124);
                int64_t loopres_204126;
                int64_t loopres_204127;
                
                if (cond_204125) {
                    int64_t loopres_t_res_204128 = sub64(mid_204117,
                                                         (int64_t) 1);
                    
                    loopres_204126 = low_204114;
                    loopres_204127 = loopres_t_res_204128;
                } else {
                    int64_t loopres_f_res_204129 = add64((int64_t) 1,
                                                         mid_204117);
                    
                    loopres_204126 = loopres_f_res_204129;
                    loopres_204127 = high_204115;
                }
                
                bool loop_cond_204130 = sle64(loopres_204126, loopres_204127);
                bool loop_while_tmp_213536 = loop_cond_204130;
                int64_t low_tmp_213537 = loopres_204126;
                int64_t high_tmp_213538 = loopres_204127;
                
                loop_while_204113 = loop_while_tmp_213536;
                low_204114 = low_tmp_213537;
                high_204115 = high_tmp_213538;
            }
            init_idx_204110 = loop_while_204113;
            init_idx_204111 = low_204114;
            init_idx_204112 = high_204115;
            
            bool idx_204131;
            int64_t idx_204132;
            int64_t idx_204133;
            int64_t idx_204134;
            bool loop_while_204135;
            int64_t l_idx_204136;
            int64_t r_idx_204137;
            int64_t span_204138;
            
            loop_while_204135 = loop_cond_204088;
            l_idx_204136 = init_idx_204111;
            r_idx_204137 = init_idx_204111;
            span_204138 = (int64_t) 1;
            while (loop_while_204135) {
                int64_t max_arg_204139 = sub64(l_idx_204136, (int64_t) 1);
                int64_t max_res_204140 = smax64((int64_t) 0, max_arg_204139);
                int64_t min_arg_204141 = add64((int64_t) 1, r_idx_204137);
                int64_t min_res_204142 = smin64(min_arg_204097, min_arg_204141);
                bool x_204143 = sle64((int64_t) 0, max_res_204140);
                bool y_204144 = slt64(max_res_204140, n_203572);
                bool bounds_check_204145 = x_204143 && y_204144;
                bool index_certs_204146;
                
                if (!bounds_check_204145) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_204140,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203572, "].",
                                  "-> #0  loess.fut:460:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:157:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:155:5-158:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_204147;
                
                x_204147 = ((int64_t *) mem_209146)[max_res_204140];
                
                int64_t abs_arg_204148 = sub64(x_204147, defunc_0_g_res_204109);
                int64_t abs_res_204149 = abs64(abs_arg_204148);
                bool x_204150 = sle64((int64_t) 0, min_res_204142);
                bool y_204151 = slt64(min_res_204142, n_203572);
                bool bounds_check_204152 = x_204150 && y_204151;
                bool index_certs_204153;
                
                if (!bounds_check_204152) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) min_res_204142,
                                  "] out of bounds for array of shape [",
                                  (long long) n_203572, "].",
                                  "-> #0  loess.fut:461:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:443:3-470:10\n   #5  loess.fut:503:15-61\n   #6  stl.fut:157:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:155:5-158:26\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t x_204154;
                
                x_204154 = ((int64_t *) mem_209146)[min_res_204142];
                
                int64_t abs_arg_204155 = sub64(x_204154, defunc_0_g_res_204109);
                int64_t abs_res_204156 = abs64(abs_arg_204155);
                bool cond_204157 = max_res_204140 == l_idx_204136;
                int64_t loopres_204158;
                int64_t loopres_204159;
                int64_t loopres_204160;
                
                if (cond_204157) {
                    loopres_204158 = l_idx_204136;
                    loopres_204159 = r_idx_204137;
                    loopres_204160 = min_res_204083;
                } else {
                    bool cond_204161 = slt64(abs_res_204149, abs_res_204156);
                    bool cond_f_res_204162 = min_res_204142 == r_idx_204137;
                    bool x_204163 = !cond_204161;
                    bool y_204164 = cond_f_res_204162 && x_204163;
                    bool cond_204165 = cond_204161 || y_204164;
                    int64_t loopres_f_res_204166;
                    
                    if (cond_204165) {
                        loopres_f_res_204166 = max_res_204140;
                    } else {
                        loopres_f_res_204166 = l_idx_204136;
                    }
                    
                    int64_t loopres_f_res_204167;
                    
                    if (cond_204165) {
                        loopres_f_res_204167 = r_idx_204137;
                    } else {
                        loopres_f_res_204167 = min_res_204142;
                    }
                    
                    int64_t loopres_f_res_204168;
                    
                    if (cond_204165) {
                        int64_t loopres_f_res_t_res_204169 = add64((int64_t) 1,
                                                                   span_204138);
                        
                        loopres_f_res_204168 = loopres_f_res_t_res_204169;
                    } else {
                        int64_t loopres_f_res_f_res_204170 = add64((int64_t) 1,
                                                                   span_204138);
                        
                        loopres_f_res_204168 = loopres_f_res_f_res_204170;
                    }
                    loopres_204158 = loopres_f_res_204166;
                    loopres_204159 = loopres_f_res_204167;
                    loopres_204160 = loopres_f_res_204168;
                }
                
                bool loop_cond_204171 = slt64(loopres_204160, min_res_204083);
                bool loop_while_tmp_213539 = loop_cond_204171;
                int64_t l_idx_tmp_213540 = loopres_204158;
                int64_t r_idx_tmp_213541 = loopres_204159;
                int64_t span_tmp_213542 = loopres_204160;
                
                loop_while_204135 = loop_while_tmp_213539;
                l_idx_204136 = l_idx_tmp_213540;
                r_idx_204137 = r_idx_tmp_213541;
                span_204138 = span_tmp_213542;
            }
            idx_204131 = loop_while_204135;
            idx_204132 = l_idx_204136;
            idx_204133 = r_idx_204137;
            idx_204134 = span_204138;
            
            int64_t min_res_204172 = smin64(min_arg_204098, idx_204132);
            int64_t max_res_204173 = smax64((int64_t) 0, min_res_204172);
            int64_t x_204174 = add64(min_res_204099, max_res_204173);
            int64_t r_204175 = sub64(x_204174, (int64_t) 1);
            bool x_204176 = sle64((int64_t) 0, r_204175);
            bool y_204177 = slt64(r_204175, n_203572);
            bool bounds_check_204178 = x_204176 && y_204177;
            bool index_certs_204179;
            
            if (!bounds_check_204178) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) r_204175,
                              "] out of bounds for array of shape [",
                              (long long) n_203572, "].",
                              "-> #0  loess.fut:485:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  stl.fut:157:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:155:5-158:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_204180;
            
            x_204180 = ((int64_t *) mem_208500)[i_207095 * n_203572 + r_204175];
            
            int64_t abs_arg_204181 = sub64(x_204180, min_res_204108);
            int64_t abs_res_204182 = abs64(abs_arg_204181);
            bool x_204183 = sle64((int64_t) 0, max_res_204173);
            bool y_204184 = slt64(max_res_204173, n_203572);
            bool bounds_check_204185 = x_204183 && y_204184;
            bool index_certs_204186;
            
            if (!bounds_check_204185) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_204173,
                              "] out of bounds for array of shape [",
                              (long long) n_203572, "].",
                              "-> #0  loess.fut:484:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:480:3-488:25\n   #4  loess.fut:504:16-51\n   #5  stl.fut:157:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:155:5-158:26\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            
            int64_t x_204187;
            
            x_204187 = ((int64_t *) mem_208500)[i_207095 * n_203572 +
                                                max_res_204173];
            
            int64_t abs_arg_204188 = sub64(x_204187, min_res_204108);
            int64_t abs_res_204189 = abs64(abs_arg_204188);
            int64_t max_res_204190 = smax64(abs_res_204182, abs_res_204189);
            double defunc_0_f_res_204191 = sitofp_i64_f64(max_res_204190);
            double defunc_1_f_res_204192 = max_res_204103 +
                   defunc_0_f_res_204191;
            
            ((double *) mem_209123)[i_207095 * t_n_m_203740 + i_207088] =
                defunc_1_f_res_204192;
            ((int64_t *) mem_209119)[i_207095 * t_n_m_203740 + i_207088] =
                max_res_204173;
        }
    }
    
    struct memblock mem_209222;
    
    mem_209222.references = NULL;
    if (memblock_alloc(ctx, &mem_209222, bytes_208499, "mem_209222")) {
        err = 1;
        goto cleanup;
    }
    for (int64_t i_213543 = 0; i_213543 < partition_sizze_203667; i_213543++) {
        for (int64_t i_213544 = 0; i_213544 < n_203572; i_213544++) {
            ((double *) mem_209222.mem)[i_213543 * n_203572 + i_213544] = 0.0;
        }
    }
    
    struct memblock mem_209226;
    
    mem_209226.references = NULL;
    if (memblock_alloc(ctx, &mem_209226, bytes_208499, "mem_209226")) {
        err = 1;
        goto cleanup;
    }
    for (int64_t i_213545 = 0; i_213545 < partition_sizze_203667; i_213545++) {
        for (int64_t i_213546 = 0; i_213546 < n_203572; i_213546++) {
            ((double *) mem_209226.mem)[i_213545 * n_203572 + i_213546] = 1.0;
        }
    }
    
    bool cond_204197 = slt64((int64_t) 1, jump_l_203583);
    bool cond_204198 = slt64((int64_t) 1, jump_t_203582);
    int64_t y_204199 = sub64(n_outer_203585, (int64_t) 1);
    int64_t css_results_l_204200;
    
    if (cond_203725) {
        css_results_l_204200 = s_n_m_203726;
    } else {
        css_results_l_204200 = pad_css_len_203722;
    }
    
    bool zzero_204201 = n_p_203574 == (int64_t) 0;
    bool nonzzero_204202 = !zzero_204201;
    bool loop_not_taken_204203 = !assert_cond_203716;
    bool protect_assert_disj_204204 = nonzzero_204202 || loop_not_taken_204203;
    bool loop_not_taken_204205 = !assert_cond_203718;
    bool protect_assert_disj_204206 = protect_assert_disj_204204 ||
         loop_not_taken_204205;
    bool nonzzero_cert_204207;
    
    if (!protect_assert_disj_204206) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "division by zero",
                               "-> #0  stl.fut:226:51-57\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:226:28-74\n   #5  stl.fut:225:21-227:39\n   #6  stl.fut:415:61-429:75\n   #7  stl.fut:455:3-469:34\n   #8  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t j_204208 = add64(n_203572, n_p_203574);
    bool empty_slice_204209 = n_203572 == (int64_t) 0;
    int64_t i_p_m_t_s_204210 = add64(n_p_203574, i_203760);
    bool zzero_leq_i_p_m_t_s_204211 = sle64((int64_t) 0, i_p_m_t_s_204210);
    bool i_p_m_t_s_leq_w_204212 = slt64(i_p_m_t_s_204210, C_len_203724);
    bool zzero_lte_i_204213 = sle64((int64_t) 0, n_p_203574);
    bool i_lte_j_204214 = sle64(n_p_203574, j_204208);
    bool y_204215 = i_p_m_t_s_leq_w_204212 && zzero_lte_i_204213;
    bool y_204216 = zzero_leq_i_p_m_t_s_204211 && y_204215;
    bool y_204217 = i_lte_j_204214 && y_204216;
    bool forwards_ok_204218 = zzero_lte_i_204213 && y_204217;
    bool ok_or_empty_204219 = empty_slice_204209 || forwards_ok_204218;
    bool protect_assert_disj_204220 = loop_not_taken_204203 ||
         ok_or_empty_204219;
    bool protect_assert_disj_204221 = loop_not_taken_204205 ||
         protect_assert_disj_204220;
    bool index_certs_204222;
    
    if (!protect_assert_disj_204221) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) n_p_203574, ":",
                               (long long) j_204208,
                               "] out of bounds for array of shape [",
                               (long long) C_len_203724, "].",
                               "-> #0  stl.fut:262:35-50\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  stl.fut:260:13-265:26\n   #4  stl.fut:415:61-429:75\n   #5  stl.fut:455:3-469:34\n   #6  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t j_m_i_204223 = sub64(stl_res_203755, stl_res_203754);
    int64_t lifted_single_ma_l_arg_204224 = add64((int64_t) 1, j_204208);
    int64_t m_204225 = sub64(n_p_203574, (int64_t) 1);
    bool zzero_leq_i_p_m_t_s_204226 = sle64((int64_t) 0, m_204225);
    bool i_p_m_t_s_leq_w_204227 = slt64(m_204225, C_len_203724);
    bool y_204228 = zzero_leq_i_p_m_t_s_204226 && i_p_m_t_s_leq_w_204227;
    bool y_204229 = zzero_lte_i_204213 && y_204228;
    bool ok_or_empty_204230 = zzero_204201 || y_204229;
    bool protect_assert_disj_204231 = loop_not_taken_204203 ||
         ok_or_empty_204230;
    bool protect_assert_disj_204232 = loop_not_taken_204205 ||
         protect_assert_disj_204231;
    bool index_certs_204233;
    
    if (!protect_assert_disj_204232) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) n_p_203574,
                               "] out of bounds for array of shape [",
                               (long long) C_len_203724, "].",
                               "-> #0  stl.fut:24:37-43\n   #1  stl.fut:24:20-48\n   #2  stl.fut:38:3-36\n   #3  stl.fut:231:23-47\n   #4  stl.fut:415:61-429:75\n   #5  stl.fut:455:3-469:34\n   #6  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    int64_t dyn_lifted_single_ma_l_arg_204234 = add64((int64_t) 2, n_203572);
    bool i_p_m_t_s_leq_w_204235 = slt64(m_204225,
                                        lifted_single_ma_l_arg_204224);
    bool y_204236 = zzero_leq_i_p_m_t_s_204226 && i_p_m_t_s_leq_w_204235;
    bool y_204237 = zzero_lte_i_204213 && y_204236;
    bool ok_or_empty_204238 = zzero_204201 || y_204237;
    bool protect_assert_disj_204239 = loop_not_taken_204203 ||
         ok_or_empty_204238;
    bool protect_assert_disj_204240 = loop_not_taken_204205 ||
         protect_assert_disj_204239;
    bool index_certs_204241;
    
    if (!protect_assert_disj_204240) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) n_p_203574,
                               "] out of bounds for array of shape [",
                               (long long) lifted_single_ma_l_arg_204224, "].",
                               "-> #0  stl.fut:24:37-43\n   #1  stl.fut:24:20-48\n   #2  /prelude/functional.fut:9:42-44\n   #3  stl.fut:38:3-64\n   #4  stl.fut:231:23-47\n   #5  stl.fut:415:61-429:75\n   #6  stl.fut:455:3-469:34\n   #7  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool i_p_m_t_s_leq_w_204242 = slt64((int64_t) 2,
                                        dyn_lifted_single_ma_l_arg_204234);
    bool protect_assert_disj_204243 = loop_not_taken_204203 ||
         i_p_m_t_s_leq_w_204242;
    bool protect_assert_disj_204244 = loop_not_taken_204205 ||
         protect_assert_disj_204243;
    bool index_certs_204245;
    
    if (!protect_assert_disj_204244) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) (int64_t) 3,
                               "] out of bounds for array of shape [",
                               (long long) dyn_lifted_single_ma_l_arg_204234,
                               "].",
                               "-> #0  stl.fut:24:37-43\n   #1  stl.fut:24:20-48\n   #2  /prelude/functional.fut:9:42-44\n   #3  stl.fut:38:3-84\n   #4  stl.fut:231:23-47\n   #5  stl.fut:415:61-429:75\n   #6  stl.fut:455:3-469:34\n   #7  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool cond_204246 = slt64(jump_l_203583, jump_threshold_203586);
    bool cond_f_res_204247 = slt64(q_threshold_203587, q_l_203577);
    bool x_204248 = !cond_204246;
    bool y_204249 = cond_f_res_204247 && x_204248;
    bool cond_204250 = cond_204246 || y_204249;
    bool cond_204251 = slt64(jump_t_203582, jump_threshold_203586);
    bool cond_f_res_204252 = slt64(q_threshold_203587, q_t_203576);
    bool x_204253 = !cond_204251;
    bool y_204254 = cond_f_res_204252 && x_204253;
    bool cond_204255 = cond_204251 || y_204254;
    bool cond_204256 = slt64(jump_s_203581, jump_threshold_203586);
    bool cond_f_res_204257 = slt64(q_threshold_203587, q_s_203575);
    bool x_204258 = !cond_204256;
    bool y_204259 = cond_f_res_204257 && x_204258;
    bool cond_204260 = cond_204256 || y_204259;
    bool bounds_invalid_upwards_204261 = slt64(C_len_203724, (int64_t) 0);
    bool valid_204262 = !bounds_invalid_upwards_204261;
    bool protect_assert_disj_204263 = loop_not_taken_204203 || valid_204262;
    bool protect_assert_disj_204264 = loop_not_taken_204205 ||
         protect_assert_disj_204263;
    bool range_valid_c_204265;
    
    if (!protect_assert_disj_204264) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) C_len_203724, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:226:28-74\n   #4  stl.fut:225:21-227:39\n   #5  stl.fut:415:61-429:75\n   #6  stl.fut:455:3-469:34\n   #7  stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_204267 = slt64(lifted_single_ma_l_arg_204224,
                                               (int64_t) 0);
    bool valid_204268 = !bounds_invalid_upwards_204267;
    bool protect_assert_disj_204269 = loop_not_taken_204203 || valid_204268;
    bool protect_assert_disj_204270 = loop_not_taken_204205 ||
         protect_assert_disj_204269;
    bool range_valid_c_204271;
    
    if (!protect_assert_disj_204270) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) lifted_single_ma_l_arg_204224,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:27:13-33:19\n   #4  /prelude/soacs.fut:67:19-23\n   #5  /prelude/soacs.fut:67:3-37\n   #6  stl.fut:26:5-34:23\n   #7  stl.fut:38:3-36\n   #8  stl.fut:231:23-47\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_204273 =
         slt64(dyn_lifted_single_ma_l_arg_204234, (int64_t) 0);
    bool valid_204274 = !bounds_invalid_upwards_204273;
    bool protect_assert_disj_204275 = loop_not_taken_204203 || valid_204274;
    bool protect_assert_disj_204276 = loop_not_taken_204205 ||
         protect_assert_disj_204275;
    bool range_valid_c_204277;
    
    if (!protect_assert_disj_204276) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) dyn_lifted_single_ma_l_arg_204234,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:27:13-33:19\n   #4  /prelude/soacs.fut:67:19-23\n   #5  /prelude/soacs.fut:67:3-37\n   #6  stl.fut:26:5-34:23\n   #7  /prelude/functional.fut:9:42-44\n   #8  stl.fut:38:3-64\n   #9  stl.fut:231:23-47\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
        if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
            return 1;
        err = 1;
        goto cleanup;
    }
    if (mem_209276_cached_sizze_213868 < (size_t) bytes_208499) {
        mem_209276 = realloc(mem_209276, bytes_208499);
        mem_209276_cached_sizze_213868 = bytes_208499;
    }
    if (mem_209321_cached_sizze_213869 < (size_t) bytes_208574) {
        mem_209321 = realloc(mem_209321, bytes_208574);
        mem_209321_cached_sizze_213869 = bytes_208574;
    }
    if (mem_209326_cached_sizze_213870 < (size_t) bytes_208574) {
        mem_209326 = realloc(mem_209326, bytes_208574);
        mem_209326_cached_sizze_213870 = bytes_208574;
    }
    
    int64_t binop_x_210649 = pad_css_len_203722 * binop_x_208571;
    int64_t binop_y_210650 = (int64_t) 8 * binop_x_210649;
    int64_t bytes_210651 = smax64((int64_t) 0, binop_y_210650);
    int64_t binop_x_210748 = partition_sizze_203667 * C_len_203724;
    int64_t binop_y_210749 = (int64_t) 8 * binop_x_210748;
    int64_t bytes_210750 = smax64((int64_t) 0, binop_y_210749);
    
    if (mem_210751_cached_sizze_213878 < (size_t) bytes_210750) {
        mem_210751 = realloc(mem_210751, bytes_210750);
        mem_210751_cached_sizze_213878 = bytes_210750;
    }
    if (mem_210794_cached_sizze_213879 < (size_t) bytes_208502) {
        mem_210794 = realloc(mem_210794, bytes_208502);
        mem_210794_cached_sizze_213879 = bytes_208502;
    }
    
    int64_t binop_x_210807 = partition_sizze_203667 *
            lifted_single_ma_l_arg_204224;
    int64_t binop_y_210808 = (int64_t) 8 * binop_x_210807;
    int64_t bytes_210809 = smax64((int64_t) 0, binop_y_210808);
    
    if (mem_210810_cached_sizze_213880 < (size_t) bytes_210809) {
        mem_210810 = realloc(mem_210810, bytes_210809);
        mem_210810_cached_sizze_213880 = bytes_210809;
    }
    
    int64_t binop_y_210821 = (int64_t) 8 * lifted_single_ma_l_arg_204224;
    int64_t bytes_210822 = smax64((int64_t) 0, binop_y_210821);
    
    if (mem_210823_cached_sizze_213881 < (size_t) bytes_210822) {
        mem_210823 = realloc(mem_210823, bytes_210822);
        mem_210823_cached_sizze_213881 = bytes_210822;
    }
    if (mem_210846_cached_sizze_213882 < (size_t) bytes_208502) {
        mem_210846 = realloc(mem_210846, bytes_208502);
        mem_210846_cached_sizze_213882 = bytes_208502;
    }
    
    int64_t binop_x_210859 = partition_sizze_203667 *
            dyn_lifted_single_ma_l_arg_204234;
    int64_t binop_y_210860 = (int64_t) 8 * binop_x_210859;
    int64_t bytes_210861 = smax64((int64_t) 0, binop_y_210860);
    
    if (mem_210862_cached_sizze_213883 < (size_t) bytes_210861) {
        mem_210862 = realloc(mem_210862, bytes_210861);
        mem_210862_cached_sizze_213883 = bytes_210861;
    }
    
    int64_t binop_y_210873 = (int64_t) 8 * dyn_lifted_single_ma_l_arg_204234;
    int64_t bytes_210874 = smax64((int64_t) 0, binop_y_210873);
    
    if (mem_210875_cached_sizze_213884 < (size_t) bytes_210874) {
        mem_210875 = realloc(mem_210875, bytes_210874);
        mem_210875_cached_sizze_213884 = bytes_210874;
    }
    if (mem_210898_cached_sizze_213885 < (size_t) bytes_208502) {
        mem_210898 = realloc(mem_210898, bytes_208502);
        mem_210898_cached_sizze_213885 = bytes_208502;
    }
    if (mem_210914_cached_sizze_213886 < (size_t) bytes_208499) {
        mem_210914 = realloc(mem_210914, bytes_208499);
        mem_210914_cached_sizze_213886 = bytes_208499;
    }
    
    int64_t binop_y_210925 = (int64_t) 8 * n_203572;
    int64_t bytes_210926 = smax64((int64_t) 0, binop_y_210925);
    
    if (mem_210927_cached_sizze_213887 < (size_t) bytes_210926) {
        mem_210927 = realloc(mem_210927, bytes_210926);
        mem_210927_cached_sizze_213887 = bytes_210926;
    }
    
    int32_t iters_206755;
    
    if (empty_slice_204209) {
        iters_206755 = 0;
    } else {
        iters_206755 = 32;
    }
    
    int64_t binop_y_212758 = (int64_t) 8 * n_203572;
    int64_t bytes_212759 = smax64((int64_t) 0, binop_y_212758);
    int64_t binop_y_212770 = (int64_t) 4 * n_203572;
    int64_t bytes_212771 = smax64((int64_t) 0, binop_y_212770);
    int64_t ext_211629;
    
    if (cond_204197) {
        ext_211629 = n_203572;
    } else {
        ext_211629 = l_n_m_203733;
    }
    
    int64_t ext_211628;
    
    if (cond_204197) {
        ext_211628 = n_203572;
    } else {
        ext_211628 = l_n_m_203733;
    }
    
    int64_t ext_212628;
    
    if (cond_204198) {
        ext_212628 = n_203572;
    } else {
        ext_212628 = t_n_m_203740;
    }
    
    int64_t ext_212627;
    
    if (cond_204198) {
        ext_212627 = n_203572;
    } else {
        ext_212627 = t_n_m_203740;
    }
    
    int64_t ext_210745;
    
    if (cond_203725) {
        ext_210745 = s_n_m_203726;
    } else {
        ext_210745 = pad_css_len_203722;
    }
    
    int64_t ext_210743;
    
    if (cond_203725) {
        ext_210743 = s_n_m_203726;
    } else {
        ext_210743 = pad_css_len_203722;
    }
    
    int64_t ext_212976;
    int64_t ext_212974;
    int64_t ext_212970;
    int64_t ext_212969;
    int64_t ext_212968;
    int64_t ext_212967;
    int64_t ext_212966;
    int64_t ext_212965;
    int64_t ext_212964;
    struct memblock ext_mem_212963;
    
    ext_mem_212963.references = NULL;
    
    struct memblock ext_mem_212962;
    
    ext_mem_212962.references = NULL;
    
    struct memblock ext_mem_212961;
    
    ext_mem_212961.references = NULL;
    
    struct memblock mem_param_209234;
    
    mem_param_209234.references = NULL;
    
    int64_t ctx_param_ext_209236;
    int64_t ctx_param_ext_209238;
    struct memblock mem_param_209242;
    
    mem_param_209242.references = NULL;
    
    int64_t ctx_param_ext_209243;
    int64_t ctx_param_ext_209244;
    int64_t ctx_param_ext_209245;
    int64_t ctx_param_ext_209246;
    int64_t ctx_param_ext_209247;
    int64_t ctx_param_ext_209248;
    int64_t ctx_param_ext_209249;
    struct memblock mem_param_209250;
    
    mem_param_209250.references = NULL;
    ctx_param_ext_209236 = n_203572;
    ctx_param_ext_209238 = n_203572;
    ctx_param_ext_209243 = partition_sizze_203667;
    ctx_param_ext_209244 = n_203572;
    ctx_param_ext_209245 = (int64_t) 0;
    ctx_param_ext_209246 = n_203572;
    ctx_param_ext_209247 = partition_sizze_203667;
    ctx_param_ext_209248 = (int64_t) 1;
    ctx_param_ext_209249 = n_203572;
    if (memblock_set(ctx, &mem_param_209234, &mem_209222, "mem_209222") != 0)
        return 1;
    if (memblock_set(ctx, &mem_param_209242, &mem_209222, "mem_209222") != 0)
        return 1;
    if (memblock_set(ctx, &mem_param_209250, &mem_209226, "mem_209226") != 0)
        return 1;
    for (int64_t i_outer_204282 = 0; i_outer_204282 < n_outer_203585;
         i_outer_204282++) {
        int64_t ext_212639;
        int64_t ext_212637;
        struct memblock ext_mem_212633;
        
        ext_mem_212633.references = NULL;
        
        struct memblock ext_mem_212632;
        
        ext_mem_212632.references = NULL;
        
        struct memblock mem_param_209264;
        
        mem_param_209264.references = NULL;
        
        int64_t ctx_param_ext_209266;
        int64_t ctx_param_ext_209268;
        struct memblock mem_param_209272;
        
        mem_param_209272.references = NULL;
        ctx_param_ext_209266 = ctx_param_ext_209236;
        ctx_param_ext_209268 = ctx_param_ext_209238;
        if (memblock_set(ctx, &mem_param_209264, &mem_param_209234,
                         "mem_param_209234") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_209272, &mem_param_209242,
                         "mem_param_209242") != 0)
            return 1;
        for (int64_t _i_inner_204288 = 0; _i_inner_204288 < n_inner_203584;
             _i_inner_204288++) {
            for (int64_t i_207104 = 0; i_207104 < partition_sizze_203667;
                 i_207104++) {
                for (int64_t i_207100 = 0; i_207100 < n_203572; i_207100++) {
                    double x_204295;
                    
                    x_204295 = ((double *) mem_208460)[i_207104 * n_203572 +
                                                       i_207100];
                    
                    double x_204296;
                    
                    x_204296 = ((double *) mem_param_209272.mem)[i_207104 *
                                                                 ctx_param_ext_209268 +
                                                                 i_207100];
                    
                    double defunc_1_f_res_204297 = x_204295 - x_204296;
                    
                    ((double *) mem_209276)[i_207104 * n_203572 + i_207100] =
                        defunc_1_f_res_204297;
                }
            }
            for (int64_t i_207124 = 0; i_207124 < partition_sizze_203667;
                 i_207124++) {
                for (int64_t i_207117 = 0; i_207117 < n_p_203574; i_207117++) {
                    for (int64_t i_207110 = 0; i_207110 < defunc_0_f_res_203721;
                         i_207110++) {
                        int64_t x_204310;
                        
                        x_204310 = ((int64_t *) mem_208667)[i_207124 *
                                                            ctx_val_208588 +
                                                            i_207117 *
                                                            defunc_0_f_res_203721 +
                                                            i_207110];
                        
                        int64_t x_204311 = mul64(n_p_203574, x_204310);
                        int64_t idx_204312 = add64(x_204311, i_207117);
                        bool cond_204313 = slt64(i_203760, idx_204312);
                        bool cond_f_res_204314 = slt64(x_204310, (int64_t) 0);
                        bool x_204315 = !cond_204313;
                        bool y_204316 = cond_f_res_204314 && x_204315;
                        bool cond_204317 = cond_204313 || y_204316;
                        double defunc_0_f_res_204318;
                        double defunc_0_f_res_204319;
                        
                        if (cond_204317) {
                            defunc_0_f_res_204318 = 0.0;
                            defunc_0_f_res_204319 = 0.0;
                        } else {
                            bool x_204320 = sle64((int64_t) 0, idx_204312);
                            bool y_204321 = slt64(idx_204312, n_203572);
                            bool bounds_check_204322 = x_204320 && y_204321;
                            bool index_certs_204323;
                            
                            if (!bounds_check_204322) {
                                ctx->error =
                                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                              "Index [", (long long) idx_204312,
                                              "] out of bounds for array of shape [",
                                              (long long) n_203572, "].",
                                              "-> #0  stl.fut:193:42-57\n   #1  stl.fut:188:28-194:44\n   #2  /prelude/soacs.fut:67:19-23\n   #3  /prelude/soacs.fut:67:3-37\n   #4  stl.fut:186:21-195:50\n   #5  /prelude/soacs.fut:75:22-28\n   #6  /prelude/soacs.fut:75:3-45\n   #7  stl.fut:184:13-196:57\n   #8  stl.fut:415:61-429:75\n   #9  stl.fut:455:3-469:34\n   #10 stl.fut:439:1-469:34\n");
                                if (memblock_unref(ctx, &mem_param_209272,
                                                   "mem_param_209272") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_209264,
                                                   "mem_param_209264") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_212632,
                                                   "ext_mem_212632") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_212633,
                                                   "ext_mem_212633") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_209250,
                                                   "mem_param_209250") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_209242,
                                                   "mem_param_209242") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_209234,
                                                   "mem_param_209234") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_212961,
                                                   "ext_mem_212961") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_212962,
                                                   "ext_mem_212962") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_212963,
                                                   "ext_mem_212963") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_209226,
                                                   "mem_209226") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_209222,
                                                   "mem_209222") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_213477,
                                                   "mem_out_213477") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_213476,
                                                   "mem_out_213476") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_213475,
                                                   "mem_out_213475") != 0)
                                    return 1;
                                err = 1;
                                goto cleanup;
                            }
                            
                            double defunc_0_f_res_f_res_204324;
                            
                            defunc_0_f_res_f_res_204324 =
                                ((double *) mem_209276)[i_207124 * n_203572 +
                                                        idx_204312];
                            
                            double defunc_0_f_res_f_res_204325;
                            
                            defunc_0_f_res_f_res_204325 =
                                ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                  (i_207124 *
                                                                   ctx_param_ext_209246 +
                                                                   idx_204312 *
                                                                   ctx_param_ext_209248)];
                            defunc_0_f_res_204318 = defunc_0_f_res_f_res_204324;
                            defunc_0_f_res_204319 = defunc_0_f_res_f_res_204325;
                        }
                        ((double *) mem_209321)[i_207124 * ctx_val_208588 +
                                                i_207117 *
                                                defunc_0_f_res_203721 +
                                                i_207110] =
                            defunc_0_f_res_204318;
                        ((double *) mem_209326)[i_207124 * ctx_val_208588 +
                                                i_207117 *
                                                defunc_0_f_res_203721 +
                                                i_207110] =
                            defunc_0_f_res_204319;
                    }
                }
            }
            
            struct memblock ext_mem_210637;
            
            ext_mem_210637.references = NULL;
            
            struct memblock ext_mem_210626;
            
            ext_mem_210626.references = NULL;
            if (cond_204260) {
                bool match_lit_204330 = (int64_t) 0 == d_s_203578;
                struct memblock ext_mem_210000;
                
                ext_mem_210000.references = NULL;
                
                struct memblock ext_mem_209989;
                
                ext_mem_209989.references = NULL;
                if (match_lit_204330) {
                    struct memblock mem_209505;
                    
                    mem_209505.references = NULL;
                    if (memblock_alloc(ctx, &mem_209505, bytes_208817,
                                       "mem_209505")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213576 = 0; i_213576 <
                         partition_sizze_203667; i_213576++) {
                        for (int64_t i_213577 = 0; i_213577 < n_p_203574;
                             i_213577++) {
                            for (int64_t i_213578 = 0; i_213578 < s_n_m_203726;
                                 i_213578++) {
                                ((double *) mem_209505.mem)[i_213576 *
                                                            (s_n_m_203726 *
                                                             n_p_203574) +
                                                            i_213577 *
                                                            s_n_m_203726 +
                                                            i_213578] = 0.0;
                            }
                        }
                    }
                    
                    struct memblock mem_209510;
                    
                    mem_209510.references = NULL;
                    if (memblock_alloc(ctx, &mem_209510, bytes_208817,
                                       "mem_209510")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_207141 = 0; i_207141 <
                         partition_sizze_203667; i_207141++) {
                        for (int64_t i_207137 = 0; i_207137 < n_p_203574;
                             i_207137++) {
                            int64_t x_204346;
                            
                            x_204346 = ((int64_t *) mem_208671)[i_207141 *
                                                                n_p_203574 +
                                                                i_207137];
                            for (int64_t i_207133 = 0; i_207133 < s_n_m_203726;
                                 i_207133++) {
                                int64_t x_204351;
                                
                                x_204351 = ((int64_t *) mem_208818)[i_207141 *
                                                                    ctx_val_208847 +
                                                                    i_207137 *
                                                                    s_n_m_203726 +
                                                                    i_207133];
                                
                                double x_204352;
                                
                                x_204352 = ((double *) mem_208823)[i_207141 *
                                                                   ctx_val_208847 +
                                                                   i_207137 *
                                                                   s_n_m_203726 +
                                                                   i_207133];
                                
                                bool cond_204353 = i_207133 == (int64_t) 0;
                                int64_t defunc_0_m_fun_res_204354;
                                
                                if (cond_204353) {
                                    defunc_0_m_fun_res_204354 = (int64_t) 0;
                                } else {
                                    int64_t y_204355 = sub64(s_n_m_203726,
                                                             (int64_t) 1);
                                    bool cond_204356 = i_207133 == y_204355;
                                    int64_t defunc_0_m_fun_res_f_res_204357;
                                    
                                    if (cond_204356) {
                                        int64_t
                                        defunc_0_m_fun_res_f_res_t_res_204358 =
                                        sub64(pad_css_len_203722, (int64_t) 1);
                                        
                                        defunc_0_m_fun_res_f_res_204357 =
                                            defunc_0_m_fun_res_f_res_t_res_204358;
                                    } else {
                                        int64_t x_204359 = sub64(i_207133,
                                                                 (int64_t) 1);
                                        int64_t x_204360 = mul64(jump_s_203581,
                                                                 x_204359);
                                        int64_t min_arg_204361 =
                                                add64((int64_t) 1, x_204360);
                                        int64_t min_res_204362 =
                                                smin64(defunc_0_f_res_203721,
                                                       min_arg_204361);
                                        
                                        defunc_0_m_fun_res_f_res_204357 =
                                            min_res_204362;
                                    }
                                    defunc_0_m_fun_res_204354 =
                                        defunc_0_m_fun_res_f_res_204357;
                                }
                                
                                double defunc_2_reduce_res_204363;
                                double redout_207127 = 0.0;
                                
                                for (int64_t i_207128 = 0; i_207128 <
                                     q_s_203575; i_207128++) {
                                    bool cond_204368 = sle64(x_204346,
                                                             i_207128);
                                    int64_t defunc_0_f_res_204369;
                                    
                                    if (cond_204368) {
                                        defunc_0_f_res_204369 = (int64_t) 0;
                                    } else {
                                        int64_t i_204370 = add64(x_204351,
                                                                 i_207128);
                                        int64_t defunc_0_add_arg_204371;
                                        
                                        defunc_0_add_arg_204371 =
                                            ((int64_t *) mem_208667)[i_207141 *
                                                                     ctx_val_208588 +
                                                                     i_207137 *
                                                                     defunc_0_f_res_203721 +
                                                                     i_204370];
                                        
                                        int64_t defunc_1_add_res_204372 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_204371);
                                        
                                        defunc_0_f_res_204369 =
                                            defunc_1_add_res_204372;
                                    }
                                    
                                    double defunc_0_f_res_204373;
                                    
                                    if (cond_204368) {
                                        defunc_0_f_res_204373 = 0.0;
                                    } else {
                                        int64_t i_204374 = add64(x_204351,
                                                                 i_207128);
                                        double defunc_0_add_arg_204375;
                                        
                                        defunc_0_add_arg_204375 =
                                            ((double *) mem_209326)[i_207141 *
                                                                    ctx_val_208588 +
                                                                    i_207137 *
                                                                    defunc_0_f_res_203721 +
                                                                    i_204374];
                                        defunc_0_f_res_204373 =
                                            defunc_0_add_arg_204375;
                                    }
                                    
                                    int64_t binop_p_204376 =
                                            sub64(defunc_0_f_res_204369,
                                                  defunc_0_m_fun_res_204354);
                                    double defunc_0_f_res_204377 =
                                           sitofp_i64_f64(binop_p_204376);
                                    double abs_res_204378 =
                                           fabs(defunc_0_f_res_204377);
                                    double tmp1_204379 = abs_res_204378 /
                                           x_204352;
                                    double x_204380 = tmp1_204379 * tmp1_204379;
                                    double y_204381 = tmp1_204379 * x_204380;
                                    double tmp2_204382 = 1.0 - y_204381;
                                    double x_204383 = tmp2_204382 * tmp2_204382;
                                    double tmp3_204384 = tmp2_204382 * x_204383;
                                    double w_j_204385 = defunc_0_f_res_204373 *
                                           tmp3_204384;
                                    double defunc_1_op_res_204366 = w_j_204385 +
                                           redout_207127;
                                    double redout_tmp_213582 =
                                           defunc_1_op_res_204366;
                                    
                                    redout_207127 = redout_tmp_213582;
                                }
                                defunc_2_reduce_res_204363 = redout_207127;
                                
                                double a0_204386 = 1.0 /
                                       defunc_2_reduce_res_204363;
                                int64_t defunc_0_m_fun_res_204387;
                                
                                if (cond_204353) {
                                    defunc_0_m_fun_res_204387 = (int64_t) 0;
                                } else {
                                    int64_t y_204388 = sub64(s_n_m_203726,
                                                             (int64_t) 1);
                                    bool cond_204389 = i_207133 == y_204388;
                                    int64_t defunc_0_m_fun_res_f_res_204390;
                                    
                                    if (cond_204389) {
                                        int64_t
                                        defunc_0_m_fun_res_f_res_t_res_204391 =
                                        sub64(pad_css_len_203722, (int64_t) 1);
                                        
                                        defunc_0_m_fun_res_f_res_204390 =
                                            defunc_0_m_fun_res_f_res_t_res_204391;
                                    } else {
                                        int64_t x_204392 = sub64(i_207133,
                                                                 (int64_t) 1);
                                        int64_t x_204393 = mul64(jump_s_203581,
                                                                 x_204392);
                                        int64_t min_arg_204394 =
                                                add64((int64_t) 1, x_204393);
                                        int64_t min_res_204395 =
                                                smin64(defunc_0_f_res_203721,
                                                       min_arg_204394);
                                        
                                        defunc_0_m_fun_res_f_res_204390 =
                                            min_res_204395;
                                    }
                                    defunc_0_m_fun_res_204387 =
                                        defunc_0_m_fun_res_f_res_204390;
                                }
                                
                                double defunc_2_reduce_res_204396;
                                double redout_207129 = 0.0;
                                
                                for (int64_t i_207130 = 0; i_207130 <
                                     q_s_203575; i_207130++) {
                                    bool cond_204401 = sle64(x_204346,
                                                             i_207130);
                                    int64_t defunc_0_f_res_204402;
                                    
                                    if (cond_204401) {
                                        defunc_0_f_res_204402 = (int64_t) 0;
                                    } else {
                                        int64_t i_204403 = add64(x_204351,
                                                                 i_207130);
                                        int64_t defunc_0_add_arg_204404;
                                        
                                        defunc_0_add_arg_204404 =
                                            ((int64_t *) mem_208667)[i_207141 *
                                                                     ctx_val_208588 +
                                                                     i_207137 *
                                                                     defunc_0_f_res_203721 +
                                                                     i_204403];
                                        
                                        int64_t defunc_1_add_res_204405 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_204404);
                                        
                                        defunc_0_f_res_204402 =
                                            defunc_1_add_res_204405;
                                    }
                                    
                                    double defunc_0_f_res_204406;
                                    
                                    if (cond_204401) {
                                        defunc_0_f_res_204406 = 0.0;
                                    } else {
                                        int64_t i_204407 = add64(x_204351,
                                                                 i_207130);
                                        double defunc_0_add_arg_204408;
                                        
                                        defunc_0_add_arg_204408 =
                                            ((double *) mem_209326)[i_207141 *
                                                                    ctx_val_208588 +
                                                                    i_207137 *
                                                                    defunc_0_f_res_203721 +
                                                                    i_204407];
                                        defunc_0_f_res_204406 =
                                            defunc_0_add_arg_204408;
                                    }
                                    
                                    int64_t binop_p_204409 =
                                            sub64(defunc_0_f_res_204402,
                                                  defunc_0_m_fun_res_204387);
                                    double defunc_0_f_res_204410 =
                                           sitofp_i64_f64(binop_p_204409);
                                    double abs_res_204411 =
                                           fabs(defunc_0_f_res_204410);
                                    double tmp1_204412 = abs_res_204411 /
                                           x_204352;
                                    double x_204413 = tmp1_204412 * tmp1_204412;
                                    double y_204414 = tmp1_204412 * x_204413;
                                    double tmp2_204415 = 1.0 - y_204414;
                                    double x_204416 = tmp2_204415 * tmp2_204415;
                                    double tmp3_204417 = tmp2_204415 * x_204416;
                                    double tmp4_204418 = defunc_0_f_res_204406 *
                                           tmp3_204417;
                                    double defunc_0_f_res_204419;
                                    
                                    if (cond_204401) {
                                        defunc_0_f_res_204419 = 0.0;
                                    } else {
                                        int64_t i_204420 = add64(x_204351,
                                                                 i_207130);
                                        double defunc_0_add_arg_204421;
                                        
                                        defunc_0_add_arg_204421 =
                                            ((double *) mem_209321)[i_207141 *
                                                                    ctx_val_208588 +
                                                                    i_207137 *
                                                                    defunc_0_f_res_203721 +
                                                                    i_204420];
                                        defunc_0_f_res_204419 =
                                            defunc_0_add_arg_204421;
                                    }
                                    
                                    double x_204422 = a0_204386 * tmp4_204418;
                                    double defunc_9_fit_fun_res_204423 =
                                           defunc_0_f_res_204419 * x_204422;
                                    double defunc_1_op_res_204399 =
                                           defunc_9_fit_fun_res_204423 +
                                           redout_207129;
                                    double redout_tmp_213583 =
                                           defunc_1_op_res_204399;
                                    
                                    redout_207129 = redout_tmp_213583;
                                }
                                defunc_2_reduce_res_204396 = redout_207129;
                                ((double *) mem_209510.mem)[i_207141 *
                                                            ctx_val_208847 +
                                                            i_207137 *
                                                            s_n_m_203726 +
                                                            i_207133] =
                                    defunc_2_reduce_res_204396;
                            }
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_210000, &mem_209510,
                                     "mem_209510") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_209989, &mem_209505,
                                     "mem_209505") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209510, "mem_209510") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209505, "mem_209505") != 0)
                        return 1;
                } else {
                    bool match_lit_204426 = (int64_t) 1 == d_s_203578;
                    struct memblock ext_mem_209977;
                    
                    ext_mem_209977.references = NULL;
                    
                    struct memblock ext_mem_209966;
                    
                    ext_mem_209966.references = NULL;
                    if (match_lit_204426) {
                        struct memblock mem_209602;
                        
                        mem_209602.references = NULL;
                        if (memblock_alloc(ctx, &mem_209602, bytes_208817,
                                           "mem_209602")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_209607;
                        
                        mem_209607.references = NULL;
                        if (memblock_alloc(ctx, &mem_209607, bytes_208817,
                                           "mem_209607")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_207168 = 0; i_207168 <
                             partition_sizze_203667; i_207168++) {
                            for (int64_t i_207161 = 0; i_207161 < n_p_203574;
                                 i_207161++) {
                                int64_t x_204443;
                                
                                x_204443 = ((int64_t *) mem_208671)[i_207168 *
                                                                    n_p_203574 +
                                                                    i_207161];
                                for (int64_t i_207154 = 0; i_207154 <
                                     s_n_m_203726; i_207154++) {
                                    int64_t x_204449;
                                    
                                    x_204449 =
                                        ((int64_t *) mem_208818)[i_207168 *
                                                                 ctx_val_208847 +
                                                                 i_207161 *
                                                                 s_n_m_203726 +
                                                                 i_207154];
                                    
                                    double x_204450;
                                    
                                    x_204450 =
                                        ((double *) mem_208823)[i_207168 *
                                                                ctx_val_208847 +
                                                                i_207161 *
                                                                s_n_m_203726 +
                                                                i_207154];
                                    
                                    bool cond_204451 = i_207154 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_204452;
                                    
                                    if (cond_204451) {
                                        defunc_0_m_fun_res_204452 = (int64_t) 0;
                                    } else {
                                        int64_t y_204453 = sub64(s_n_m_203726,
                                                                 (int64_t) 1);
                                        bool cond_204454 = i_207154 == y_204453;
                                        int64_t defunc_0_m_fun_res_f_res_204455;
                                        
                                        if (cond_204454) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204456
                                            = sub64(pad_css_len_203722,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204455 =
                                                defunc_0_m_fun_res_f_res_t_res_204456;
                                        } else {
                                            int64_t x_204457 = sub64(i_207154,
                                                                     (int64_t) 1);
                                            int64_t x_204458 =
                                                    mul64(jump_s_203581,
                                                          x_204457);
                                            int64_t min_arg_204459 =
                                                    add64((int64_t) 1,
                                                          x_204458);
                                            int64_t min_res_204460 =
                                                    smin64(defunc_0_f_res_203721,
                                                           min_arg_204459);
                                            
                                            defunc_0_m_fun_res_f_res_204455 =
                                                min_res_204460;
                                        }
                                        defunc_0_m_fun_res_204452 =
                                            defunc_0_m_fun_res_f_res_204455;
                                    }
                                    
                                    double defunc_2_reduce_res_204461;
                                    double defunc_2_reduce_res_204462;
                                    double defunc_2_reduce_res_204463;
                                    double redout_207143;
                                    double redout_207144;
                                    double redout_207145;
                                    
                                    redout_207143 = 0.0;
                                    redout_207144 = 0.0;
                                    redout_207145 = 0.0;
                                    for (int64_t i_207146 = 0; i_207146 <
                                         q_s_203575; i_207146++) {
                                        bool cond_204474 = sle64(x_204443,
                                                                 i_207146);
                                        int64_t defunc_0_f_res_204475;
                                        
                                        if (cond_204474) {
                                            defunc_0_f_res_204475 = (int64_t) 0;
                                        } else {
                                            int64_t i_204476 = add64(x_204449,
                                                                     i_207146);
                                            int64_t defunc_0_add_arg_204477;
                                            
                                            defunc_0_add_arg_204477 =
                                                ((int64_t *) mem_208667)[i_207168 *
                                                                         ctx_val_208588 +
                                                                         i_207161 *
                                                                         defunc_0_f_res_203721 +
                                                                         i_204476];
                                            
                                            int64_t defunc_1_add_res_204478 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204477);
                                            
                                            defunc_0_f_res_204475 =
                                                defunc_1_add_res_204478;
                                        }
                                        
                                        double defunc_0_f_res_204479;
                                        
                                        if (cond_204474) {
                                            defunc_0_f_res_204479 = 0.0;
                                        } else {
                                            int64_t i_204480 = add64(x_204449,
                                                                     i_207146);
                                            double defunc_0_add_arg_204481;
                                            
                                            defunc_0_add_arg_204481 =
                                                ((double *) mem_209326)[i_207168 *
                                                                        ctx_val_208588 +
                                                                        i_207161 *
                                                                        defunc_0_f_res_203721 +
                                                                        i_204480];
                                            defunc_0_f_res_204479 =
                                                defunc_0_add_arg_204481;
                                        }
                                        
                                        int64_t binop_p_204482 =
                                                sub64(defunc_0_f_res_204475,
                                                      defunc_0_m_fun_res_204452);
                                        double defunc_0_f_res_204483 =
                                               sitofp_i64_f64(binop_p_204482);
                                        double abs_res_204484 =
                                               fabs(defunc_0_f_res_204483);
                                        double tmp1_204485 = abs_res_204484 /
                                               x_204450;
                                        double x_204486 = tmp1_204485 *
                                               tmp1_204485;
                                        double y_204487 = tmp1_204485 *
                                               x_204486;
                                        double tmp2_204488 = 1.0 - y_204487;
                                        double x_204489 = tmp2_204488 *
                                               tmp2_204488;
                                        double tmp3_204490 = tmp2_204488 *
                                               x_204489;
                                        double w_j_204491 =
                                               defunc_0_f_res_204479 *
                                               tmp3_204490;
                                        double xw_j_204492 =
                                               defunc_0_f_res_204483 *
                                               w_j_204491;
                                        double x2w_j_204493 =
                                               defunc_0_f_res_204483 *
                                               xw_j_204492;
                                        double defunc_1_op_res_204466 =
                                               w_j_204491 + redout_207143;
                                        double defunc_1_op_res_204469 =
                                               xw_j_204492 + redout_207144;
                                        double defunc_1_op_res_204472 =
                                               x2w_j_204493 + redout_207145;
                                        double redout_tmp_213590 =
                                               defunc_1_op_res_204466;
                                        double redout_tmp_213591 =
                                               defunc_1_op_res_204469;
                                        double redout_tmp_213592 =
                                               defunc_1_op_res_204472;
                                        
                                        redout_207143 = redout_tmp_213590;
                                        redout_207144 = redout_tmp_213591;
                                        redout_207145 = redout_tmp_213592;
                                    }
                                    defunc_2_reduce_res_204461 = redout_207143;
                                    defunc_2_reduce_res_204462 = redout_207144;
                                    defunc_2_reduce_res_204463 = redout_207145;
                                    
                                    double x_204494 =
                                           defunc_2_reduce_res_204461 *
                                           defunc_2_reduce_res_204463;
                                    double y_204495 =
                                           defunc_2_reduce_res_204462 *
                                           defunc_2_reduce_res_204462;
                                    double y_204496 = x_204494 - y_204495;
                                    double det1_204497 = 1.0 / y_204496;
                                    double a11_204498 =
                                           defunc_2_reduce_res_204463 *
                                           det1_204497;
                                    double x_204499 = 0.0 -
                                           defunc_2_reduce_res_204462;
                                    double b11_204500 = det1_204497 * x_204499;
                                    double c11_204501 =
                                           defunc_2_reduce_res_204461 *
                                           det1_204497;
                                    int64_t defunc_0_m_fun_res_204502;
                                    
                                    if (cond_204451) {
                                        defunc_0_m_fun_res_204502 = (int64_t) 0;
                                    } else {
                                        int64_t y_204503 = sub64(s_n_m_203726,
                                                                 (int64_t) 1);
                                        bool cond_204504 = i_207154 == y_204503;
                                        int64_t defunc_0_m_fun_res_f_res_204505;
                                        
                                        if (cond_204504) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204506
                                            = sub64(pad_css_len_203722,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204505 =
                                                defunc_0_m_fun_res_f_res_t_res_204506;
                                        } else {
                                            int64_t x_204507 = sub64(i_207154,
                                                                     (int64_t) 1);
                                            int64_t x_204508 =
                                                    mul64(jump_s_203581,
                                                          x_204507);
                                            int64_t min_arg_204509 =
                                                    add64((int64_t) 1,
                                                          x_204508);
                                            int64_t min_res_204510 =
                                                    smin64(defunc_0_f_res_203721,
                                                           min_arg_204509);
                                            
                                            defunc_0_m_fun_res_f_res_204505 =
                                                min_res_204510;
                                        }
                                        defunc_0_m_fun_res_204502 =
                                            defunc_0_m_fun_res_f_res_204505;
                                    }
                                    
                                    double defunc_2_reduce_res_204511;
                                    double defunc_2_reduce_res_204512;
                                    double redout_207147;
                                    double redout_207148;
                                    
                                    redout_207147 = 0.0;
                                    redout_207148 = 0.0;
                                    for (int64_t i_207149 = 0; i_207149 <
                                         q_s_203575; i_207149++) {
                                        bool cond_204520 = sle64(x_204443,
                                                                 i_207149);
                                        int64_t defunc_0_f_res_204521;
                                        
                                        if (cond_204520) {
                                            defunc_0_f_res_204521 = (int64_t) 0;
                                        } else {
                                            int64_t i_204522 = add64(x_204449,
                                                                     i_207149);
                                            int64_t defunc_0_add_arg_204523;
                                            
                                            defunc_0_add_arg_204523 =
                                                ((int64_t *) mem_208667)[i_207168 *
                                                                         ctx_val_208588 +
                                                                         i_207161 *
                                                                         defunc_0_f_res_203721 +
                                                                         i_204522];
                                            
                                            int64_t defunc_1_add_res_204524 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204523);
                                            
                                            defunc_0_f_res_204521 =
                                                defunc_1_add_res_204524;
                                        }
                                        
                                        double defunc_0_f_res_204525;
                                        
                                        if (cond_204520) {
                                            defunc_0_f_res_204525 = 0.0;
                                        } else {
                                            int64_t i_204526 = add64(x_204449,
                                                                     i_207149);
                                            double defunc_0_add_arg_204527;
                                            
                                            defunc_0_add_arg_204527 =
                                                ((double *) mem_209326)[i_207168 *
                                                                        ctx_val_208588 +
                                                                        i_207161 *
                                                                        defunc_0_f_res_203721 +
                                                                        i_204526];
                                            defunc_0_f_res_204525 =
                                                defunc_0_add_arg_204527;
                                        }
                                        
                                        int64_t binop_p_204528 =
                                                sub64(defunc_0_f_res_204521,
                                                      defunc_0_m_fun_res_204502);
                                        double defunc_0_f_res_204529 =
                                               sitofp_i64_f64(binop_p_204528);
                                        double abs_res_204530 =
                                               fabs(defunc_0_f_res_204529);
                                        double tmp1_204531 = abs_res_204530 /
                                               x_204450;
                                        double x_204532 = tmp1_204531 *
                                               tmp1_204531;
                                        double y_204533 = tmp1_204531 *
                                               x_204532;
                                        double tmp2_204534 = 1.0 - y_204533;
                                        double x_204535 = tmp2_204534 *
                                               tmp2_204534;
                                        double tmp3_204536 = tmp2_204534 *
                                               x_204535;
                                        double tmp4_204537 =
                                               defunc_0_f_res_204525 *
                                               tmp3_204536;
                                        double defunc_1_f_res_204538 =
                                               defunc_0_f_res_204529 *
                                               tmp4_204537;
                                        double defunc_0_f_res_204539;
                                        
                                        if (cond_204520) {
                                            defunc_0_f_res_204539 = 0.0;
                                        } else {
                                            int64_t i_204540 = add64(x_204449,
                                                                     i_207149);
                                            double defunc_0_add_arg_204541;
                                            
                                            defunc_0_add_arg_204541 =
                                                ((double *) mem_209321)[i_207168 *
                                                                        ctx_val_208588 +
                                                                        i_207161 *
                                                                        defunc_0_f_res_203721 +
                                                                        i_204540];
                                            defunc_0_f_res_204539 =
                                                defunc_0_add_arg_204541;
                                        }
                                        
                                        double x_204542 = a11_204498 *
                                               tmp4_204537;
                                        double y_204543 = b11_204500 *
                                               defunc_1_f_res_204538;
                                        double x_204544 = x_204542 + y_204543;
                                        double defunc_9_fit_fun_res_204545 =
                                               defunc_0_f_res_204539 * x_204544;
                                        double x_204546 = b11_204500 *
                                               tmp4_204537;
                                        double y_204547 = c11_204501 *
                                               defunc_1_f_res_204538;
                                        double x_204548 = x_204546 + y_204547;
                                        double defunc_9_slope_fun_res_204549 =
                                               defunc_0_f_res_204539 * x_204548;
                                        double defunc_1_op_res_204515 =
                                               defunc_9_fit_fun_res_204545 +
                                               redout_207147;
                                        double defunc_1_op_res_204518 =
                                               defunc_9_slope_fun_res_204549 +
                                               redout_207148;
                                        double redout_tmp_213593 =
                                               defunc_1_op_res_204515;
                                        double redout_tmp_213594 =
                                               defunc_1_op_res_204518;
                                        
                                        redout_207147 = redout_tmp_213593;
                                        redout_207148 = redout_tmp_213594;
                                    }
                                    defunc_2_reduce_res_204511 = redout_207147;
                                    defunc_2_reduce_res_204512 = redout_207148;
                                    ((double *) mem_209602.mem)[i_207168 *
                                                                ctx_val_208847 +
                                                                i_207161 *
                                                                s_n_m_203726 +
                                                                i_207154] =
                                        defunc_2_reduce_res_204511;
                                    ((double *) mem_209607.mem)[i_207168 *
                                                                ctx_val_208847 +
                                                                i_207161 *
                                                                s_n_m_203726 +
                                                                i_207154] =
                                        defunc_2_reduce_res_204512;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_209977, &mem_209602,
                                         "mem_209602") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_209966, &mem_209607,
                                         "mem_209607") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209607, "mem_209607") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209602, "mem_209602") != 0)
                            return 1;
                    } else {
                        struct memblock mem_209786;
                        
                        mem_209786.references = NULL;
                        if (memblock_alloc(ctx, &mem_209786, bytes_208817,
                                           "mem_209786")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_209791;
                        
                        mem_209791.references = NULL;
                        if (memblock_alloc(ctx, &mem_209791, bytes_208817,
                                           "mem_209791")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_207198 = 0; i_207198 <
                             partition_sizze_203667; i_207198++) {
                            for (int64_t i_207191 = 0; i_207191 < n_p_203574;
                                 i_207191++) {
                                int64_t x_204566;
                                
                                x_204566 = ((int64_t *) mem_208671)[i_207198 *
                                                                    n_p_203574 +
                                                                    i_207191];
                                for (int64_t i_207184 = 0; i_207184 <
                                     s_n_m_203726; i_207184++) {
                                    int64_t x_204572;
                                    
                                    x_204572 =
                                        ((int64_t *) mem_208818)[i_207198 *
                                                                 ctx_val_208847 +
                                                                 i_207191 *
                                                                 s_n_m_203726 +
                                                                 i_207184];
                                    
                                    double x_204573;
                                    
                                    x_204573 =
                                        ((double *) mem_208823)[i_207198 *
                                                                ctx_val_208847 +
                                                                i_207191 *
                                                                s_n_m_203726 +
                                                                i_207184];
                                    
                                    bool cond_204574 = i_207184 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_204575;
                                    
                                    if (cond_204574) {
                                        defunc_0_m_fun_res_204575 = (int64_t) 0;
                                    } else {
                                        int64_t y_204576 = sub64(s_n_m_203726,
                                                                 (int64_t) 1);
                                        bool cond_204577 = i_207184 == y_204576;
                                        int64_t defunc_0_m_fun_res_f_res_204578;
                                        
                                        if (cond_204577) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204579
                                            = sub64(pad_css_len_203722,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204578 =
                                                defunc_0_m_fun_res_f_res_t_res_204579;
                                        } else {
                                            int64_t x_204580 = sub64(i_207184,
                                                                     (int64_t) 1);
                                            int64_t x_204581 =
                                                    mul64(jump_s_203581,
                                                          x_204580);
                                            int64_t min_arg_204582 =
                                                    add64((int64_t) 1,
                                                          x_204581);
                                            int64_t min_res_204583 =
                                                    smin64(defunc_0_f_res_203721,
                                                           min_arg_204582);
                                            
                                            defunc_0_m_fun_res_f_res_204578 =
                                                min_res_204583;
                                        }
                                        defunc_0_m_fun_res_204575 =
                                            defunc_0_m_fun_res_f_res_204578;
                                    }
                                    
                                    double defunc_2_reduce_res_204584;
                                    double defunc_2_reduce_res_204585;
                                    double defunc_2_reduce_res_204586;
                                    double defunc_2_reduce_res_204587;
                                    double defunc_2_reduce_res_204588;
                                    double redout_207171;
                                    double redout_207172;
                                    double redout_207173;
                                    double redout_207174;
                                    double redout_207175;
                                    
                                    redout_207171 = 0.0;
                                    redout_207172 = 0.0;
                                    redout_207173 = 0.0;
                                    redout_207174 = 0.0;
                                    redout_207175 = 0.0;
                                    for (int64_t i_207176 = 0; i_207176 <
                                         q_s_203575; i_207176++) {
                                        bool cond_204605 = sle64(x_204566,
                                                                 i_207176);
                                        int64_t defunc_0_f_res_204606;
                                        
                                        if (cond_204605) {
                                            defunc_0_f_res_204606 = (int64_t) 0;
                                        } else {
                                            int64_t i_204607 = add64(x_204572,
                                                                     i_207176);
                                            int64_t defunc_0_add_arg_204608;
                                            
                                            defunc_0_add_arg_204608 =
                                                ((int64_t *) mem_208667)[i_207198 *
                                                                         ctx_val_208588 +
                                                                         i_207191 *
                                                                         defunc_0_f_res_203721 +
                                                                         i_204607];
                                            
                                            int64_t defunc_1_add_res_204609 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204608);
                                            
                                            defunc_0_f_res_204606 =
                                                defunc_1_add_res_204609;
                                        }
                                        
                                        double defunc_0_f_res_204610;
                                        
                                        if (cond_204605) {
                                            defunc_0_f_res_204610 = 0.0;
                                        } else {
                                            int64_t i_204611 = add64(x_204572,
                                                                     i_207176);
                                            double defunc_0_add_arg_204612;
                                            
                                            defunc_0_add_arg_204612 =
                                                ((double *) mem_209326)[i_207198 *
                                                                        ctx_val_208588 +
                                                                        i_207191 *
                                                                        defunc_0_f_res_203721 +
                                                                        i_204611];
                                            defunc_0_f_res_204610 =
                                                defunc_0_add_arg_204612;
                                        }
                                        
                                        int64_t binop_p_204613 =
                                                sub64(defunc_0_f_res_204606,
                                                      defunc_0_m_fun_res_204575);
                                        double defunc_0_f_res_204614 =
                                               sitofp_i64_f64(binop_p_204613);
                                        double abs_res_204615 =
                                               fabs(defunc_0_f_res_204614);
                                        double tmp1_204616 = abs_res_204615 /
                                               x_204573;
                                        double x_204617 = tmp1_204616 *
                                               tmp1_204616;
                                        double y_204618 = tmp1_204616 *
                                               x_204617;
                                        double tmp2_204619 = 1.0 - y_204618;
                                        double x_204620 = tmp2_204619 *
                                               tmp2_204619;
                                        double tmp3_204621 = tmp2_204619 *
                                               x_204620;
                                        double w_j_204622 =
                                               defunc_0_f_res_204610 *
                                               tmp3_204621;
                                        double xw_j_204623 =
                                               defunc_0_f_res_204614 *
                                               w_j_204622;
                                        double x2w_j_204624 =
                                               defunc_0_f_res_204614 *
                                               xw_j_204623;
                                        double x3w_j_204625 =
                                               defunc_0_f_res_204614 *
                                               x2w_j_204624;
                                        double x4w_j_204626 =
                                               defunc_0_f_res_204614 *
                                               x3w_j_204625;
                                        double defunc_1_op_res_204591 =
                                               w_j_204622 + redout_207171;
                                        double defunc_1_op_res_204594 =
                                               xw_j_204623 + redout_207172;
                                        double defunc_1_op_res_204597 =
                                               x2w_j_204624 + redout_207173;
                                        double defunc_1_op_res_204600 =
                                               x3w_j_204625 + redout_207174;
                                        double defunc_1_op_res_204603 =
                                               x4w_j_204626 + redout_207175;
                                        double redout_tmp_213601 =
                                               defunc_1_op_res_204591;
                                        double redout_tmp_213602 =
                                               defunc_1_op_res_204594;
                                        double redout_tmp_213603 =
                                               defunc_1_op_res_204597;
                                        double redout_tmp_213604 =
                                               defunc_1_op_res_204600;
                                        double redout_tmp_213605 =
                                               defunc_1_op_res_204603;
                                        
                                        redout_207171 = redout_tmp_213601;
                                        redout_207172 = redout_tmp_213602;
                                        redout_207173 = redout_tmp_213603;
                                        redout_207174 = redout_tmp_213604;
                                        redout_207175 = redout_tmp_213605;
                                    }
                                    defunc_2_reduce_res_204584 = redout_207171;
                                    defunc_2_reduce_res_204585 = redout_207172;
                                    defunc_2_reduce_res_204586 = redout_207173;
                                    defunc_2_reduce_res_204587 = redout_207174;
                                    defunc_2_reduce_res_204588 = redout_207175;
                                    
                                    double x_204627 =
                                           defunc_2_reduce_res_204586 *
                                           defunc_2_reduce_res_204588;
                                    double y_204628 =
                                           defunc_2_reduce_res_204587 *
                                           defunc_2_reduce_res_204587;
                                    double a12_204629 = x_204627 - y_204628;
                                    double x_204630 =
                                           defunc_2_reduce_res_204586 *
                                           defunc_2_reduce_res_204587;
                                    double y_204631 =
                                           defunc_2_reduce_res_204585 *
                                           defunc_2_reduce_res_204588;
                                    double b12_204632 = x_204630 - y_204631;
                                    double x_204633 =
                                           defunc_2_reduce_res_204585 *
                                           defunc_2_reduce_res_204587;
                                    double y_204634 =
                                           defunc_2_reduce_res_204586 *
                                           defunc_2_reduce_res_204586;
                                    double c12_204635 = x_204633 - y_204634;
                                    double x_204636 =
                                           defunc_2_reduce_res_204584 *
                                           defunc_2_reduce_res_204588;
                                    double b2_204637 = x_204636 - y_204634;
                                    double x_204638 =
                                           defunc_2_reduce_res_204585 *
                                           defunc_2_reduce_res_204586;
                                    double y_204639 =
                                           defunc_2_reduce_res_204584 *
                                           defunc_2_reduce_res_204587;
                                    double c2_204640 = x_204638 - y_204639;
                                    double x_204641 =
                                           defunc_2_reduce_res_204584 *
                                           a12_204629;
                                    double y_204642 =
                                           defunc_2_reduce_res_204585 *
                                           b12_204632;
                                    double x_204643 = x_204641 + y_204642;
                                    double y_204644 =
                                           defunc_2_reduce_res_204586 *
                                           c12_204635;
                                    double y_204645 = x_204643 + y_204644;
                                    double det_204646 = 1.0 / y_204645;
                                    double a12_204647 = a12_204629 * det_204646;
                                    double b12_204648 = b12_204632 * det_204646;
                                    double c12_204649 = c12_204635 * det_204646;
                                    double b2_204650 = b2_204637 * det_204646;
                                    double c2_204651 = c2_204640 * det_204646;
                                    int64_t defunc_0_m_fun_res_204652;
                                    
                                    if (cond_204574) {
                                        defunc_0_m_fun_res_204652 = (int64_t) 0;
                                    } else {
                                        int64_t y_204653 = sub64(s_n_m_203726,
                                                                 (int64_t) 1);
                                        bool cond_204654 = i_207184 == y_204653;
                                        int64_t defunc_0_m_fun_res_f_res_204655;
                                        
                                        if (cond_204654) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204656
                                            = sub64(pad_css_len_203722,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204655 =
                                                defunc_0_m_fun_res_f_res_t_res_204656;
                                        } else {
                                            int64_t x_204657 = sub64(i_207184,
                                                                     (int64_t) 1);
                                            int64_t x_204658 =
                                                    mul64(jump_s_203581,
                                                          x_204657);
                                            int64_t min_arg_204659 =
                                                    add64((int64_t) 1,
                                                          x_204658);
                                            int64_t min_res_204660 =
                                                    smin64(defunc_0_f_res_203721,
                                                           min_arg_204659);
                                            
                                            defunc_0_m_fun_res_f_res_204655 =
                                                min_res_204660;
                                        }
                                        defunc_0_m_fun_res_204652 =
                                            defunc_0_m_fun_res_f_res_204655;
                                    }
                                    
                                    double defunc_2_reduce_res_204661;
                                    double defunc_2_reduce_res_204662;
                                    double redout_207177;
                                    double redout_207178;
                                    
                                    redout_207177 = 0.0;
                                    redout_207178 = 0.0;
                                    for (int64_t i_207179 = 0; i_207179 <
                                         q_s_203575; i_207179++) {
                                        bool cond_204670 = sle64(x_204566,
                                                                 i_207179);
                                        int64_t defunc_0_f_res_204671;
                                        
                                        if (cond_204670) {
                                            defunc_0_f_res_204671 = (int64_t) 0;
                                        } else {
                                            int64_t i_204672 = add64(x_204572,
                                                                     i_207179);
                                            int64_t defunc_0_add_arg_204673;
                                            
                                            defunc_0_add_arg_204673 =
                                                ((int64_t *) mem_208667)[i_207198 *
                                                                         ctx_val_208588 +
                                                                         i_207191 *
                                                                         defunc_0_f_res_203721 +
                                                                         i_204672];
                                            
                                            int64_t defunc_1_add_res_204674 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204673);
                                            
                                            defunc_0_f_res_204671 =
                                                defunc_1_add_res_204674;
                                        }
                                        
                                        double defunc_0_f_res_204675;
                                        
                                        if (cond_204670) {
                                            defunc_0_f_res_204675 = 0.0;
                                        } else {
                                            int64_t i_204676 = add64(x_204572,
                                                                     i_207179);
                                            double defunc_0_add_arg_204677;
                                            
                                            defunc_0_add_arg_204677 =
                                                ((double *) mem_209326)[i_207198 *
                                                                        ctx_val_208588 +
                                                                        i_207191 *
                                                                        defunc_0_f_res_203721 +
                                                                        i_204676];
                                            defunc_0_f_res_204675 =
                                                defunc_0_add_arg_204677;
                                        }
                                        
                                        int64_t binop_p_204678 =
                                                sub64(defunc_0_f_res_204671,
                                                      defunc_0_m_fun_res_204652);
                                        double defunc_0_f_res_204679 =
                                               sitofp_i64_f64(binop_p_204678);
                                        double abs_res_204680 =
                                               fabs(defunc_0_f_res_204679);
                                        double tmp1_204681 = abs_res_204680 /
                                               x_204573;
                                        double x_204682 = tmp1_204681 *
                                               tmp1_204681;
                                        double y_204683 = tmp1_204681 *
                                               x_204682;
                                        double tmp2_204684 = 1.0 - y_204683;
                                        double x_204685 = tmp2_204684 *
                                               tmp2_204684;
                                        double tmp3_204686 = tmp2_204684 *
                                               x_204685;
                                        double tmp4_204687 =
                                               defunc_0_f_res_204675 *
                                               tmp3_204686;
                                        double defunc_1_f_res_204688 =
                                               defunc_0_f_res_204679 *
                                               tmp4_204687;
                                        double defunc_1_f_res_204689 =
                                               defunc_0_f_res_204679 *
                                               defunc_1_f_res_204688;
                                        double defunc_0_f_res_204690;
                                        
                                        if (cond_204670) {
                                            defunc_0_f_res_204690 = 0.0;
                                        } else {
                                            int64_t i_204691 = add64(x_204572,
                                                                     i_207179);
                                            double defunc_0_add_arg_204692;
                                            
                                            defunc_0_add_arg_204692 =
                                                ((double *) mem_209321)[i_207198 *
                                                                        ctx_val_208588 +
                                                                        i_207191 *
                                                                        defunc_0_f_res_203721 +
                                                                        i_204691];
                                            defunc_0_f_res_204690 =
                                                defunc_0_add_arg_204692;
                                        }
                                        
                                        double x_204693 = a12_204647 *
                                               tmp4_204687;
                                        double y_204694 = b12_204648 *
                                               defunc_1_f_res_204688;
                                        double x_204695 = x_204693 + y_204694;
                                        double y_204696 = c12_204649 *
                                               defunc_1_f_res_204689;
                                        double x_204697 = x_204695 + y_204696;
                                        double defunc_9_fit_fun_res_204698 =
                                               defunc_0_f_res_204690 * x_204697;
                                        double x_204699 = b12_204648 *
                                               tmp4_204687;
                                        double y_204700 = b2_204650 *
                                               defunc_1_f_res_204688;
                                        double x_204701 = x_204699 + y_204700;
                                        double y_204702 = c2_204651 *
                                               defunc_1_f_res_204689;
                                        double x_204703 = x_204701 + y_204702;
                                        double defunc_9_slope_fun_res_204704 =
                                               defunc_0_f_res_204690 * x_204703;
                                        double defunc_1_op_res_204665 =
                                               defunc_9_fit_fun_res_204698 +
                                               redout_207177;
                                        double defunc_1_op_res_204668 =
                                               defunc_9_slope_fun_res_204704 +
                                               redout_207178;
                                        double redout_tmp_213606 =
                                               defunc_1_op_res_204665;
                                        double redout_tmp_213607 =
                                               defunc_1_op_res_204668;
                                        
                                        redout_207177 = redout_tmp_213606;
                                        redout_207178 = redout_tmp_213607;
                                    }
                                    defunc_2_reduce_res_204661 = redout_207177;
                                    defunc_2_reduce_res_204662 = redout_207178;
                                    ((double *) mem_209786.mem)[i_207198 *
                                                                ctx_val_208847 +
                                                                i_207191 *
                                                                s_n_m_203726 +
                                                                i_207184] =
                                        defunc_2_reduce_res_204661;
                                    ((double *) mem_209791.mem)[i_207198 *
                                                                ctx_val_208847 +
                                                                i_207191 *
                                                                s_n_m_203726 +
                                                                i_207184] =
                                        defunc_2_reduce_res_204662;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_209977, &mem_209786,
                                         "mem_209786") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_209966, &mem_209791,
                                         "mem_209791") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209791, "mem_209791") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209786, "mem_209786") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_210000, &ext_mem_209977,
                                     "ext_mem_209977") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_209989, &ext_mem_209966,
                                     "ext_mem_209966") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_209966,
                                       "ext_mem_209966") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_209977,
                                       "ext_mem_209977") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_210637, &ext_mem_210000,
                                 "ext_mem_210000") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_210626, &ext_mem_209989,
                                 "ext_mem_209989") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_209989, "ext_mem_209989") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_210000, "ext_mem_210000") != 0)
                    return 1;
            } else {
                bool match_lit_204707 = (int64_t) 0 == d_s_203578;
                int64_t binop_y_210068 = (int64_t) 8 * q_s_203575;
                int64_t bytes_210069 = smax64((int64_t) 0, binop_y_210068);
                struct memblock ext_mem_210615;
                
                ext_mem_210615.references = NULL;
                
                struct memblock ext_mem_210604;
                
                ext_mem_210604.references = NULL;
                if (match_lit_204707) {
                    struct memblock mem_210015;
                    
                    mem_210015.references = NULL;
                    if (memblock_alloc(ctx, &mem_210015, bytes_208817,
                                       "mem_210015")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213608 = 0; i_213608 <
                         partition_sizze_203667; i_213608++) {
                        for (int64_t i_213609 = 0; i_213609 < n_p_203574;
                             i_213609++) {
                            for (int64_t i_213610 = 0; i_213610 < s_n_m_203726;
                                 i_213610++) {
                                ((double *) mem_210015.mem)[i_213608 *
                                                            (s_n_m_203726 *
                                                             n_p_203574) +
                                                            i_213609 *
                                                            s_n_m_203726 +
                                                            i_213610] = 0.0;
                            }
                        }
                    }
                    
                    struct memblock mem_210020;
                    
                    mem_210020.references = NULL;
                    if (memblock_alloc(ctx, &mem_210020, bytes_208817,
                                       "mem_210020")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_210070_cached_sizze_213871 <
                        (size_t) bytes_210069) {
                        mem_210070 = realloc(mem_210070, bytes_210069);
                        mem_210070_cached_sizze_213871 = bytes_210069;
                    }
                    for (int64_t i_207218 = 0; i_207218 <
                         partition_sizze_203667; i_207218++) {
                        for (int64_t i_207214 = 0; i_207214 < n_p_203574;
                             i_207214++) {
                            int64_t x_204723;
                            
                            x_204723 = ((int64_t *) mem_208671)[i_207218 *
                                                                n_p_203574 +
                                                                i_207214];
                            for (int64_t i_207210 = 0; i_207210 < s_n_m_203726;
                                 i_207210++) {
                                int64_t x_204728;
                                
                                x_204728 = ((int64_t *) mem_208818)[i_207218 *
                                                                    ctx_val_208847 +
                                                                    i_207214 *
                                                                    s_n_m_203726 +
                                                                    i_207210];
                                
                                double x_204729;
                                
                                x_204729 = ((double *) mem_208823)[i_207218 *
                                                                   ctx_val_208847 +
                                                                   i_207214 *
                                                                   s_n_m_203726 +
                                                                   i_207210];
                                
                                bool cond_204730 = i_207210 == (int64_t) 0;
                                int64_t defunc_0_m_fun_res_204731;
                                
                                if (cond_204730) {
                                    defunc_0_m_fun_res_204731 = (int64_t) 0;
                                } else {
                                    int64_t y_204732 = sub64(s_n_m_203726,
                                                             (int64_t) 1);
                                    bool cond_204733 = i_207210 == y_204732;
                                    int64_t defunc_0_m_fun_res_f_res_204734;
                                    
                                    if (cond_204733) {
                                        int64_t
                                        defunc_0_m_fun_res_f_res_t_res_204735 =
                                        sub64(pad_css_len_203722, (int64_t) 1);
                                        
                                        defunc_0_m_fun_res_f_res_204734 =
                                            defunc_0_m_fun_res_f_res_t_res_204735;
                                    } else {
                                        int64_t x_204736 = sub64(i_207210,
                                                                 (int64_t) 1);
                                        int64_t x_204737 = mul64(jump_s_203581,
                                                                 x_204736);
                                        int64_t min_arg_204738 =
                                                add64((int64_t) 1, x_204737);
                                        int64_t min_res_204739 =
                                                smin64(defunc_0_f_res_203721,
                                                       min_arg_204738);
                                        
                                        defunc_0_m_fun_res_f_res_204734 =
                                            min_res_204739;
                                    }
                                    defunc_0_m_fun_res_204731 =
                                        defunc_0_m_fun_res_f_res_204734;
                                }
                                
                                double defunc_2_reduce_res_204740;
                                double redout_207202 = 0.0;
                                
                                for (int64_t i_207204 = 0; i_207204 <
                                     q_s_203575; i_207204++) {
                                    bool cond_204746 = sle64(x_204723,
                                                             i_207204);
                                    int64_t defunc_0_f_res_204747;
                                    
                                    if (cond_204746) {
                                        defunc_0_f_res_204747 = (int64_t) 0;
                                    } else {
                                        int64_t i_204748 = add64(x_204728,
                                                                 i_207204);
                                        int64_t defunc_0_add_arg_204749;
                                        
                                        defunc_0_add_arg_204749 =
                                            ((int64_t *) mem_208667)[i_207218 *
                                                                     ctx_val_208588 +
                                                                     i_207214 *
                                                                     defunc_0_f_res_203721 +
                                                                     i_204748];
                                        
                                        int64_t defunc_1_add_res_204750 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_204749);
                                        
                                        defunc_0_f_res_204747 =
                                            defunc_1_add_res_204750;
                                    }
                                    
                                    double defunc_0_f_res_204751;
                                    
                                    if (cond_204746) {
                                        defunc_0_f_res_204751 = 0.0;
                                    } else {
                                        int64_t i_204752 = add64(x_204728,
                                                                 i_207204);
                                        double defunc_0_add_arg_204753;
                                        
                                        defunc_0_add_arg_204753 =
                                            ((double *) mem_209326)[i_207218 *
                                                                    ctx_val_208588 +
                                                                    i_207214 *
                                                                    defunc_0_f_res_203721 +
                                                                    i_204752];
                                        defunc_0_f_res_204751 =
                                            defunc_0_add_arg_204753;
                                    }
                                    
                                    int64_t binop_p_204754 =
                                            sub64(defunc_0_f_res_204747,
                                                  defunc_0_m_fun_res_204731);
                                    double defunc_0_f_res_204755 =
                                           sitofp_i64_f64(binop_p_204754);
                                    double abs_res_204756 =
                                           fabs(defunc_0_f_res_204755);
                                    double tmp1_204757 = abs_res_204756 /
                                           x_204729;
                                    double x_204758 = tmp1_204757 * tmp1_204757;
                                    double y_204759 = tmp1_204757 * x_204758;
                                    double tmp2_204760 = 1.0 - y_204759;
                                    double x_204761 = tmp2_204760 * tmp2_204760;
                                    double tmp3_204762 = tmp2_204760 * x_204761;
                                    double tmp4_204763 = defunc_0_f_res_204751 *
                                           tmp3_204762;
                                    double defunc_1_op_res_204744 =
                                           tmp4_204763 + redout_207202;
                                    
                                    ((double *) mem_210070)[i_207204] =
                                        tmp4_204763;
                                    
                                    double redout_tmp_213614 =
                                           defunc_1_op_res_204744;
                                    
                                    redout_207202 = redout_tmp_213614;
                                }
                                defunc_2_reduce_res_204740 = redout_207202;
                                
                                double a0_204764 = 1.0 /
                                       defunc_2_reduce_res_204740;
                                double defunc_2_reduce_res_204765;
                                double redout_207206 = 0.0;
                                
                                for (int64_t i_207207 = 0; i_207207 <
                                     q_s_203575; i_207207++) {
                                    double x_204770;
                                    
                                    x_204770 =
                                        ((double *) mem_210070)[i_207207];
                                    
                                    bool cond_204771 = sle64(x_204723,
                                                             i_207207);
                                    double defunc_0_f_res_204772;
                                    
                                    if (cond_204771) {
                                        defunc_0_f_res_204772 = 0.0;
                                    } else {
                                        int64_t i_204773 = add64(x_204728,
                                                                 i_207207);
                                        double defunc_0_add_arg_204774;
                                        
                                        defunc_0_add_arg_204774 =
                                            ((double *) mem_209321)[i_207218 *
                                                                    ctx_val_208588 +
                                                                    i_207214 *
                                                                    defunc_0_f_res_203721 +
                                                                    i_204773];
                                        defunc_0_f_res_204772 =
                                            defunc_0_add_arg_204774;
                                    }
                                    
                                    double x_204775 = a0_204764 * x_204770;
                                    double defunc_9_fit_fun_res_204776 =
                                           defunc_0_f_res_204772 * x_204775;
                                    double defunc_1_op_res_204768 =
                                           defunc_9_fit_fun_res_204776 +
                                           redout_207206;
                                    double redout_tmp_213616 =
                                           defunc_1_op_res_204768;
                                    
                                    redout_207206 = redout_tmp_213616;
                                }
                                defunc_2_reduce_res_204765 = redout_207206;
                                ((double *) mem_210020.mem)[i_207218 *
                                                            ctx_val_208847 +
                                                            i_207214 *
                                                            s_n_m_203726 +
                                                            i_207210] =
                                    defunc_2_reduce_res_204765;
                            }
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_210615, &mem_210020,
                                     "mem_210020") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_210604, &mem_210015,
                                     "mem_210015") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_210020, "mem_210020") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_210015, "mem_210015") != 0)
                        return 1;
                } else {
                    bool match_lit_204779 = (int64_t) 1 == d_s_203578;
                    int64_t binop_y_210227 = (int64_t) 8 * q_s_203575;
                    int64_t bytes_210228 = smax64((int64_t) 0, binop_y_210227);
                    int64_t binop_y_210441 = (int64_t) 8 * q_s_203575;
                    int64_t bytes_210442 = smax64((int64_t) 0, binop_y_210441);
                    struct memblock ext_mem_210592;
                    
                    ext_mem_210592.references = NULL;
                    
                    struct memblock ext_mem_210581;
                    
                    ext_mem_210581.references = NULL;
                    if (match_lit_204779) {
                        struct memblock mem_210127;
                        
                        mem_210127.references = NULL;
                        if (memblock_alloc(ctx, &mem_210127, bytes_208817,
                                           "mem_210127")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_210132;
                        
                        mem_210132.references = NULL;
                        if (memblock_alloc(ctx, &mem_210132, bytes_208817,
                                           "mem_210132")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_210229_cached_sizze_213872 <
                            (size_t) bytes_210228) {
                            mem_210229 = realloc(mem_210229, bytes_210228);
                            mem_210229_cached_sizze_213872 = bytes_210228;
                        }
                        if (mem_210232_cached_sizze_213873 <
                            (size_t) bytes_210228) {
                            mem_210232 = realloc(mem_210232, bytes_210228);
                            mem_210232_cached_sizze_213873 = bytes_210228;
                        }
                        for (int64_t i_207251 = 0; i_207251 <
                             partition_sizze_203667; i_207251++) {
                            for (int64_t i_207244 = 0; i_207244 < n_p_203574;
                                 i_207244++) {
                                int64_t x_204796;
                                
                                x_204796 = ((int64_t *) mem_208671)[i_207251 *
                                                                    n_p_203574 +
                                                                    i_207244];
                                for (int64_t i_207237 = 0; i_207237 <
                                     s_n_m_203726; i_207237++) {
                                    int64_t x_204802;
                                    
                                    x_204802 =
                                        ((int64_t *) mem_208818)[i_207251 *
                                                                 ctx_val_208847 +
                                                                 i_207244 *
                                                                 s_n_m_203726 +
                                                                 i_207237];
                                    
                                    double x_204803;
                                    
                                    x_204803 =
                                        ((double *) mem_208823)[i_207251 *
                                                                ctx_val_208847 +
                                                                i_207244 *
                                                                s_n_m_203726 +
                                                                i_207237];
                                    
                                    bool cond_204804 = i_207237 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_204805;
                                    
                                    if (cond_204804) {
                                        defunc_0_m_fun_res_204805 = (int64_t) 0;
                                    } else {
                                        int64_t y_204806 = sub64(s_n_m_203726,
                                                                 (int64_t) 1);
                                        bool cond_204807 = i_207237 == y_204806;
                                        int64_t defunc_0_m_fun_res_f_res_204808;
                                        
                                        if (cond_204807) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204809
                                            = sub64(pad_css_len_203722,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204808 =
                                                defunc_0_m_fun_res_f_res_t_res_204809;
                                        } else {
                                            int64_t x_204810 = sub64(i_207237,
                                                                     (int64_t) 1);
                                            int64_t x_204811 =
                                                    mul64(jump_s_203581,
                                                          x_204810);
                                            int64_t min_arg_204812 =
                                                    add64((int64_t) 1,
                                                          x_204811);
                                            int64_t min_res_204813 =
                                                    smin64(defunc_0_f_res_203721,
                                                           min_arg_204812);
                                            
                                            defunc_0_m_fun_res_f_res_204808 =
                                                min_res_204813;
                                        }
                                        defunc_0_m_fun_res_204805 =
                                            defunc_0_m_fun_res_f_res_204808;
                                    }
                                    
                                    double defunc_2_reduce_res_204837;
                                    double defunc_2_reduce_res_204838;
                                    double defunc_2_reduce_res_204839;
                                    double redout_207222;
                                    double redout_207223;
                                    double redout_207224;
                                    
                                    redout_207222 = 0.0;
                                    redout_207223 = 0.0;
                                    redout_207224 = 0.0;
                                    for (int64_t i_207227 = 0; i_207227 <
                                         q_s_203575; i_207227++) {
                                        bool cond_204852 = sle64(x_204796,
                                                                 i_207227);
                                        int64_t defunc_0_f_res_204853;
                                        
                                        if (cond_204852) {
                                            defunc_0_f_res_204853 = (int64_t) 0;
                                        } else {
                                            int64_t i_204854 = add64(x_204802,
                                                                     i_207227);
                                            int64_t defunc_0_add_arg_204855;
                                            
                                            defunc_0_add_arg_204855 =
                                                ((int64_t *) mem_208667)[i_207251 *
                                                                         ctx_val_208588 +
                                                                         i_207244 *
                                                                         defunc_0_f_res_203721 +
                                                                         i_204854];
                                            
                                            int64_t defunc_1_add_res_204856 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204855);
                                            
                                            defunc_0_f_res_204853 =
                                                defunc_1_add_res_204856;
                                        }
                                        
                                        double defunc_0_f_res_204857;
                                        
                                        if (cond_204852) {
                                            defunc_0_f_res_204857 = 0.0;
                                        } else {
                                            int64_t i_204858 = add64(x_204802,
                                                                     i_207227);
                                            double defunc_0_add_arg_204859;
                                            
                                            defunc_0_add_arg_204859 =
                                                ((double *) mem_209326)[i_207251 *
                                                                        ctx_val_208588 +
                                                                        i_207244 *
                                                                        defunc_0_f_res_203721 +
                                                                        i_204858];
                                            defunc_0_f_res_204857 =
                                                defunc_0_add_arg_204859;
                                        }
                                        
                                        int64_t binop_p_204860 =
                                                sub64(defunc_0_f_res_204853,
                                                      defunc_0_m_fun_res_204805);
                                        double defunc_0_f_res_204861 =
                                               sitofp_i64_f64(binop_p_204860);
                                        double abs_res_204862 =
                                               fabs(defunc_0_f_res_204861);
                                        double tmp1_204863 = abs_res_204862 /
                                               x_204803;
                                        double x_204864 = tmp1_204863 *
                                               tmp1_204863;
                                        double y_204865 = tmp1_204863 *
                                               x_204864;
                                        double tmp2_204866 = 1.0 - y_204865;
                                        double x_204867 = tmp2_204866 *
                                               tmp2_204866;
                                        double tmp3_204868 = tmp2_204866 *
                                               x_204867;
                                        double tmp4_204869 =
                                               defunc_0_f_res_204857 *
                                               tmp3_204868;
                                        double defunc_1_f_res_204870 =
                                               defunc_0_f_res_204861 *
                                               tmp4_204869;
                                        double defunc_1_f_res_204871 =
                                               defunc_0_f_res_204861 *
                                               defunc_1_f_res_204870;
                                        double defunc_1_op_res_204844 =
                                               tmp4_204869 + redout_207222;
                                        double defunc_1_op_res_204847 =
                                               defunc_1_f_res_204870 +
                                               redout_207223;
                                        double defunc_1_op_res_204850 =
                                               defunc_1_f_res_204871 +
                                               redout_207224;
                                        
                                        ((double *) mem_210229)[i_207227] =
                                            defunc_1_f_res_204870;
                                        ((double *) mem_210232)[i_207227] =
                                            tmp4_204869;
                                        
                                        double redout_tmp_213623 =
                                               defunc_1_op_res_204844;
                                        double redout_tmp_213624 =
                                               defunc_1_op_res_204847;
                                        double redout_tmp_213625 =
                                               defunc_1_op_res_204850;
                                        
                                        redout_207222 = redout_tmp_213623;
                                        redout_207223 = redout_tmp_213624;
                                        redout_207224 = redout_tmp_213625;
                                    }
                                    defunc_2_reduce_res_204837 = redout_207222;
                                    defunc_2_reduce_res_204838 = redout_207223;
                                    defunc_2_reduce_res_204839 = redout_207224;
                                    
                                    double x_204877 =
                                           defunc_2_reduce_res_204837 *
                                           defunc_2_reduce_res_204839;
                                    double y_204878 =
                                           defunc_2_reduce_res_204838 *
                                           defunc_2_reduce_res_204838;
                                    double y_204879 = x_204877 - y_204878;
                                    double det1_204880 = 1.0 / y_204879;
                                    double a11_204881 =
                                           defunc_2_reduce_res_204839 *
                                           det1_204880;
                                    double x_204882 = 0.0 -
                                           defunc_2_reduce_res_204838;
                                    double b11_204883 = det1_204880 * x_204882;
                                    double c11_204884 =
                                           defunc_2_reduce_res_204837 *
                                           det1_204880;
                                    double defunc_2_reduce_res_204885;
                                    double defunc_2_reduce_res_204886;
                                    double redout_207230;
                                    double redout_207231;
                                    
                                    redout_207230 = 0.0;
                                    redout_207231 = 0.0;
                                    for (int64_t i_207232 = 0; i_207232 <
                                         q_s_203575; i_207232++) {
                                        double x_204894;
                                        
                                        x_204894 =
                                            ((double *) mem_210232)[i_207232];
                                        
                                        double x_204895;
                                        
                                        x_204895 =
                                            ((double *) mem_210229)[i_207232];
                                        
                                        bool cond_204896 = sle64(x_204796,
                                                                 i_207232);
                                        double defunc_0_f_res_204897;
                                        
                                        if (cond_204896) {
                                            defunc_0_f_res_204897 = 0.0;
                                        } else {
                                            int64_t i_204898 = add64(x_204802,
                                                                     i_207232);
                                            double defunc_0_add_arg_204899;
                                            
                                            defunc_0_add_arg_204899 =
                                                ((double *) mem_209321)[i_207251 *
                                                                        ctx_val_208588 +
                                                                        i_207244 *
                                                                        defunc_0_f_res_203721 +
                                                                        i_204898];
                                            defunc_0_f_res_204897 =
                                                defunc_0_add_arg_204899;
                                        }
                                        
                                        double x_204900 = a11_204881 * x_204894;
                                        double y_204901 = b11_204883 * x_204895;
                                        double x_204902 = x_204900 + y_204901;
                                        double defunc_9_fit_fun_res_204903 =
                                               defunc_0_f_res_204897 * x_204902;
                                        double x_204904 = b11_204883 * x_204894;
                                        double y_204905 = c11_204884 * x_204895;
                                        double x_204906 = x_204904 + y_204905;
                                        double defunc_9_slope_fun_res_204907 =
                                               defunc_0_f_res_204897 * x_204906;
                                        double defunc_1_op_res_204889 =
                                               defunc_9_fit_fun_res_204903 +
                                               redout_207230;
                                        double defunc_1_op_res_204892 =
                                               defunc_9_slope_fun_res_204907 +
                                               redout_207231;
                                        double redout_tmp_213628 =
                                               defunc_1_op_res_204889;
                                        double redout_tmp_213629 =
                                               defunc_1_op_res_204892;
                                        
                                        redout_207230 = redout_tmp_213628;
                                        redout_207231 = redout_tmp_213629;
                                    }
                                    defunc_2_reduce_res_204885 = redout_207230;
                                    defunc_2_reduce_res_204886 = redout_207231;
                                    ((double *) mem_210127.mem)[i_207251 *
                                                                ctx_val_208847 +
                                                                i_207244 *
                                                                s_n_m_203726 +
                                                                i_207237] =
                                        defunc_2_reduce_res_204885;
                                    ((double *) mem_210132.mem)[i_207251 *
                                                                ctx_val_208847 +
                                                                i_207244 *
                                                                s_n_m_203726 +
                                                                i_207237] =
                                        defunc_2_reduce_res_204886;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_210592, &mem_210127,
                                         "mem_210127") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_210581, &mem_210132,
                                         "mem_210132") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210132, "mem_210132") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210127, "mem_210127") != 0)
                            return 1;
                    } else {
                        struct memblock mem_210341;
                        
                        mem_210341.references = NULL;
                        if (memblock_alloc(ctx, &mem_210341, bytes_208817,
                                           "mem_210341")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_210346;
                        
                        mem_210346.references = NULL;
                        if (memblock_alloc(ctx, &mem_210346, bytes_208817,
                                           "mem_210346")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_210443_cached_sizze_213874 <
                            (size_t) bytes_210442) {
                            mem_210443 = realloc(mem_210443, bytes_210442);
                            mem_210443_cached_sizze_213874 = bytes_210442;
                        }
                        if (mem_210446_cached_sizze_213875 <
                            (size_t) bytes_210442) {
                            mem_210446 = realloc(mem_210446, bytes_210442);
                            mem_210446_cached_sizze_213875 = bytes_210442;
                        }
                        if (mem_210473_cached_sizze_213876 <
                            (size_t) bytes_210442) {
                            mem_210473 = realloc(mem_210473, bytes_210442);
                            mem_210473_cached_sizze_213876 = bytes_210442;
                        }
                        if (mem_210476_cached_sizze_213877 <
                            (size_t) bytes_210442) {
                            mem_210476 = realloc(mem_210476, bytes_210442);
                            mem_210476_cached_sizze_213877 = bytes_210442;
                        }
                        for (int64_t i_207294 = 0; i_207294 <
                             partition_sizze_203667; i_207294++) {
                            for (int64_t i_207287 = 0; i_207287 < n_p_203574;
                                 i_207287++) {
                                int64_t x_204924;
                                
                                x_204924 = ((int64_t *) mem_208671)[i_207294 *
                                                                    n_p_203574 +
                                                                    i_207287];
                                for (int64_t i_207280 = 0; i_207280 <
                                     s_n_m_203726; i_207280++) {
                                    int64_t x_204930;
                                    
                                    x_204930 =
                                        ((int64_t *) mem_208818)[i_207294 *
                                                                 ctx_val_208847 +
                                                                 i_207287 *
                                                                 s_n_m_203726 +
                                                                 i_207280];
                                    
                                    double x_204931;
                                    
                                    x_204931 =
                                        ((double *) mem_208823)[i_207294 *
                                                                ctx_val_208847 +
                                                                i_207287 *
                                                                s_n_m_203726 +
                                                                i_207280];
                                    
                                    bool cond_204932 = i_207280 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_204933;
                                    
                                    if (cond_204932) {
                                        defunc_0_m_fun_res_204933 = (int64_t) 0;
                                    } else {
                                        int64_t y_204934 = sub64(s_n_m_203726,
                                                                 (int64_t) 1);
                                        bool cond_204935 = i_207280 == y_204934;
                                        int64_t defunc_0_m_fun_res_f_res_204936;
                                        
                                        if (cond_204935) {
                                            int64_t
                                            defunc_0_m_fun_res_f_res_t_res_204937
                                            = sub64(pad_css_len_203722,
                                                    (int64_t) 1);
                                            
                                            defunc_0_m_fun_res_f_res_204936 =
                                                defunc_0_m_fun_res_f_res_t_res_204937;
                                        } else {
                                            int64_t x_204938 = sub64(i_207280,
                                                                     (int64_t) 1);
                                            int64_t x_204939 =
                                                    mul64(jump_s_203581,
                                                          x_204938);
                                            int64_t min_arg_204940 =
                                                    add64((int64_t) 1,
                                                          x_204939);
                                            int64_t min_res_204941 =
                                                    smin64(defunc_0_f_res_203721,
                                                           min_arg_204940);
                                            
                                            defunc_0_m_fun_res_f_res_204936 =
                                                min_res_204941;
                                        }
                                        defunc_0_m_fun_res_204933 =
                                            defunc_0_m_fun_res_f_res_204936;
                                    }
                                    for (int64_t i_207258 = 0; i_207258 <
                                         q_s_203575; i_207258++) {
                                        bool cond_204945 = sle64(x_204924,
                                                                 i_207258);
                                        int64_t defunc_0_f_res_204946;
                                        
                                        if (cond_204945) {
                                            defunc_0_f_res_204946 = (int64_t) 0;
                                        } else {
                                            int64_t i_204947 = add64(x_204930,
                                                                     i_207258);
                                            int64_t defunc_0_add_arg_204948;
                                            
                                            defunc_0_add_arg_204948 =
                                                ((int64_t *) mem_208667)[i_207294 *
                                                                         ctx_val_208588 +
                                                                         i_207287 *
                                                                         defunc_0_f_res_203721 +
                                                                         i_204947];
                                            
                                            int64_t defunc_1_add_res_204949 =
                                                    add64((int64_t) 1,
                                                          defunc_0_add_arg_204948);
                                            
                                            defunc_0_f_res_204946 =
                                                defunc_1_add_res_204949;
                                        }
                                        
                                        double defunc_0_f_res_204950;
                                        
                                        if (cond_204945) {
                                            defunc_0_f_res_204950 = 0.0;
                                        } else {
                                            int64_t i_204951 = add64(x_204930,
                                                                     i_207258);
                                            double defunc_0_add_arg_204952;
                                            
                                            defunc_0_add_arg_204952 =
                                                ((double *) mem_209326)[i_207294 *
                                                                        ctx_val_208588 +
                                                                        i_207287 *
                                                                        defunc_0_f_res_203721 +
                                                                        i_204951];
                                            defunc_0_f_res_204950 =
                                                defunc_0_add_arg_204952;
                                        }
                                        
                                        int64_t binop_p_204953 =
                                                sub64(defunc_0_f_res_204946,
                                                      defunc_0_m_fun_res_204933);
                                        double defunc_0_f_res_204954 =
                                               sitofp_i64_f64(binop_p_204953);
                                        double abs_res_204955 =
                                               fabs(defunc_0_f_res_204954);
                                        double tmp1_204956 = abs_res_204955 /
                                               x_204931;
                                        double x_204957 = tmp1_204956 *
                                               tmp1_204956;
                                        double y_204958 = tmp1_204956 *
                                               x_204957;
                                        double tmp2_204959 = 1.0 - y_204958;
                                        double x_204960 = tmp2_204959 *
                                               tmp2_204959;
                                        double tmp3_204961 = tmp2_204959 *
                                               x_204960;
                                        double tmp4_204962 =
                                               defunc_0_f_res_204950 *
                                               tmp3_204961;
                                        
                                        ((double *) mem_210443)[i_207258] =
                                            defunc_0_f_res_204954;
                                        ((double *) mem_210446)[i_207258] =
                                            tmp4_204962;
                                    }
                                    
                                    double defunc_2_reduce_res_204969;
                                    double defunc_2_reduce_res_204970;
                                    double defunc_2_reduce_res_204971;
                                    double defunc_2_reduce_res_204972;
                                    double defunc_2_reduce_res_204973;
                                    double redout_207263;
                                    double redout_207264;
                                    double redout_207265;
                                    double redout_207266;
                                    double redout_207267;
                                    
                                    redout_207263 = 0.0;
                                    redout_207264 = 0.0;
                                    redout_207265 = 0.0;
                                    redout_207266 = 0.0;
                                    redout_207267 = 0.0;
                                    for (int64_t i_207270 = 0; i_207270 <
                                         q_s_203575; i_207270++) {
                                        double x_204991;
                                        
                                        x_204991 =
                                            ((double *) mem_210443)[i_207270];
                                        
                                        double x_204992;
                                        
                                        x_204992 =
                                            ((double *) mem_210446)[i_207270];
                                        
                                        double defunc_1_f_res_204993 =
                                               x_204991 * x_204992;
                                        double defunc_1_f_res_204994 =
                                               x_204991 * defunc_1_f_res_204993;
                                        double defunc_1_f_res_204995 =
                                               x_204991 * defunc_1_f_res_204994;
                                        double defunc_1_f_res_204996 =
                                               x_204991 * defunc_1_f_res_204995;
                                        double defunc_1_op_res_204978 =
                                               x_204992 + redout_207263;
                                        double defunc_1_op_res_204981 =
                                               defunc_1_f_res_204993 +
                                               redout_207264;
                                        double defunc_1_op_res_204984 =
                                               defunc_1_f_res_204994 +
                                               redout_207265;
                                        double defunc_1_op_res_204987 =
                                               defunc_1_f_res_204995 +
                                               redout_207266;
                                        double defunc_1_op_res_204990 =
                                               defunc_1_f_res_204996 +
                                               redout_207267;
                                        
                                        ((double *) mem_210473)[i_207270] =
                                            defunc_1_f_res_204994;
                                        ((double *) mem_210476)[i_207270] =
                                            defunc_1_f_res_204993;
                                        
                                        double redout_tmp_213638 =
                                               defunc_1_op_res_204978;
                                        double redout_tmp_213639 =
                                               defunc_1_op_res_204981;
                                        double redout_tmp_213640 =
                                               defunc_1_op_res_204984;
                                        double redout_tmp_213641 =
                                               defunc_1_op_res_204987;
                                        double redout_tmp_213642 =
                                               defunc_1_op_res_204990;
                                        
                                        redout_207263 = redout_tmp_213638;
                                        redout_207264 = redout_tmp_213639;
                                        redout_207265 = redout_tmp_213640;
                                        redout_207266 = redout_tmp_213641;
                                        redout_207267 = redout_tmp_213642;
                                    }
                                    defunc_2_reduce_res_204969 = redout_207263;
                                    defunc_2_reduce_res_204970 = redout_207264;
                                    defunc_2_reduce_res_204971 = redout_207265;
                                    defunc_2_reduce_res_204972 = redout_207266;
                                    defunc_2_reduce_res_204973 = redout_207267;
                                    
                                    double x_205004 =
                                           defunc_2_reduce_res_204971 *
                                           defunc_2_reduce_res_204973;
                                    double y_205005 =
                                           defunc_2_reduce_res_204972 *
                                           defunc_2_reduce_res_204972;
                                    double a12_205006 = x_205004 - y_205005;
                                    double x_205007 =
                                           defunc_2_reduce_res_204971 *
                                           defunc_2_reduce_res_204972;
                                    double y_205008 =
                                           defunc_2_reduce_res_204970 *
                                           defunc_2_reduce_res_204973;
                                    double b12_205009 = x_205007 - y_205008;
                                    double x_205010 =
                                           defunc_2_reduce_res_204970 *
                                           defunc_2_reduce_res_204972;
                                    double y_205011 =
                                           defunc_2_reduce_res_204971 *
                                           defunc_2_reduce_res_204971;
                                    double c12_205012 = x_205010 - y_205011;
                                    double x_205013 =
                                           defunc_2_reduce_res_204969 *
                                           defunc_2_reduce_res_204973;
                                    double b2_205014 = x_205013 - y_205011;
                                    double x_205015 =
                                           defunc_2_reduce_res_204970 *
                                           defunc_2_reduce_res_204971;
                                    double y_205016 =
                                           defunc_2_reduce_res_204969 *
                                           defunc_2_reduce_res_204972;
                                    double c2_205017 = x_205015 - y_205016;
                                    double x_205018 =
                                           defunc_2_reduce_res_204969 *
                                           a12_205006;
                                    double y_205019 =
                                           defunc_2_reduce_res_204970 *
                                           b12_205009;
                                    double x_205020 = x_205018 + y_205019;
                                    double y_205021 =
                                           defunc_2_reduce_res_204971 *
                                           c12_205012;
                                    double y_205022 = x_205020 + y_205021;
                                    double det_205023 = 1.0 / y_205022;
                                    double a12_205024 = a12_205006 * det_205023;
                                    double b12_205025 = b12_205009 * det_205023;
                                    double c12_205026 = c12_205012 * det_205023;
                                    double b2_205027 = b2_205014 * det_205023;
                                    double c2_205028 = c2_205017 * det_205023;
                                    double defunc_2_reduce_res_205029;
                                    double defunc_2_reduce_res_205030;
                                    double redout_207273;
                                    double redout_207274;
                                    
                                    redout_207273 = 0.0;
                                    redout_207274 = 0.0;
                                    for (int64_t i_207275 = 0; i_207275 <
                                         q_s_203575; i_207275++) {
                                        double x_205038;
                                        
                                        x_205038 =
                                            ((double *) mem_210446)[i_207275];
                                        
                                        double x_205039;
                                        
                                        x_205039 =
                                            ((double *) mem_210476)[i_207275];
                                        
                                        double x_205040;
                                        
                                        x_205040 =
                                            ((double *) mem_210473)[i_207275];
                                        
                                        bool cond_205041 = sle64(x_204924,
                                                                 i_207275);
                                        double defunc_0_f_res_205042;
                                        
                                        if (cond_205041) {
                                            defunc_0_f_res_205042 = 0.0;
                                        } else {
                                            int64_t i_205043 = add64(x_204930,
                                                                     i_207275);
                                            double defunc_0_add_arg_205044;
                                            
                                            defunc_0_add_arg_205044 =
                                                ((double *) mem_209321)[i_207294 *
                                                                        ctx_val_208588 +
                                                                        i_207287 *
                                                                        defunc_0_f_res_203721 +
                                                                        i_205043];
                                            defunc_0_f_res_205042 =
                                                defunc_0_add_arg_205044;
                                        }
                                        
                                        double x_205045 = a12_205024 * x_205038;
                                        double y_205046 = b12_205025 * x_205039;
                                        double x_205047 = x_205045 + y_205046;
                                        double y_205048 = c12_205026 * x_205040;
                                        double x_205049 = x_205047 + y_205048;
                                        double defunc_9_fit_fun_res_205050 =
                                               defunc_0_f_res_205042 * x_205049;
                                        double x_205051 = b12_205025 * x_205038;
                                        double y_205052 = b2_205027 * x_205039;
                                        double x_205053 = x_205051 + y_205052;
                                        double y_205054 = c2_205028 * x_205040;
                                        double x_205055 = x_205053 + y_205054;
                                        double defunc_9_slope_fun_res_205056 =
                                               defunc_0_f_res_205042 * x_205055;
                                        double defunc_1_op_res_205033 =
                                               defunc_9_fit_fun_res_205050 +
                                               redout_207273;
                                        double defunc_1_op_res_205036 =
                                               defunc_9_slope_fun_res_205056 +
                                               redout_207274;
                                        double redout_tmp_213645 =
                                               defunc_1_op_res_205033;
                                        double redout_tmp_213646 =
                                               defunc_1_op_res_205036;
                                        
                                        redout_207273 = redout_tmp_213645;
                                        redout_207274 = redout_tmp_213646;
                                    }
                                    defunc_2_reduce_res_205029 = redout_207273;
                                    defunc_2_reduce_res_205030 = redout_207274;
                                    ((double *) mem_210341.mem)[i_207294 *
                                                                ctx_val_208847 +
                                                                i_207287 *
                                                                s_n_m_203726 +
                                                                i_207280] =
                                        defunc_2_reduce_res_205029;
                                    ((double *) mem_210346.mem)[i_207294 *
                                                                ctx_val_208847 +
                                                                i_207287 *
                                                                s_n_m_203726 +
                                                                i_207280] =
                                        defunc_2_reduce_res_205030;
                                }
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_210592, &mem_210341,
                                         "mem_210341") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_210581, &mem_210346,
                                         "mem_210346") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210346, "mem_210346") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210341, "mem_210341") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_210615, &ext_mem_210592,
                                     "ext_mem_210592") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_210604, &ext_mem_210581,
                                     "ext_mem_210581") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210581,
                                       "ext_mem_210581") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210592,
                                       "ext_mem_210592") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_210637, &ext_mem_210615,
                                 "ext_mem_210615") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_210626, &ext_mem_210604,
                                 "ext_mem_210604") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_210604, "ext_mem_210604") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_210615, "ext_mem_210615") != 0)
                    return 1;
            }
            
            int64_t ext_210744;
            struct memblock ext_mem_210740;
            
            ext_mem_210740.references = NULL;
            if (cond_203725) {
                ext_210744 = ctx_val_208847;
                if (memblock_set(ctx, &ext_mem_210740, &ext_mem_210637,
                                 "ext_mem_210637") != 0)
                    return 1;
            } else {
                bool bounds_invalid_upwards_205061 = slt64(pad_css_len_203722,
                                                           (int64_t) 0);
                bool valid_205062 = !bounds_invalid_upwards_205061;
                bool range_valid_c_205063;
                
                if (!valid_205062) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Range ", (long long) (int64_t) 0, "..",
                                  (long long) (int64_t) 1, "..<",
                                  (long long) pad_css_len_203722,
                                  " is invalid.",
                                  "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:557:3-566:9\n   #4  stl.fut:220:31-96\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:219:23-221:48\n   #8  /prelude/soacs.fut:67:19-23\n   #9  /prelude/soacs.fut:67:3-37\n   #10 stl.fut:218:15-222:44\n   #11 stl.fut:415:61-429:75\n   #12 stl.fut:455:3-469:34\n   #13 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &ext_mem_210740,
                                       "ext_mem_210740") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210626,
                                       "ext_mem_210626") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210637,
                                       "ext_mem_210637") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209272,
                                       "mem_param_209272") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209264,
                                       "mem_param_209264") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212632,
                                       "ext_mem_212632") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212633,
                                       "ext_mem_212633") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209250,
                                       "mem_param_209250") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209242,
                                       "mem_param_209242") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209234,
                                       "mem_param_209234") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212961,
                                       "ext_mem_212961") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212962,
                                       "ext_mem_212962") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212963,
                                       "ext_mem_212963") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                struct memblock mem_210652;
                
                mem_210652.references = NULL;
                if (memblock_alloc(ctx, &mem_210652, bytes_210651,
                                   "mem_210652")) {
                    err = 1;
                    goto cleanup;
                }
                
                int64_t ctx_val_210665 = n_p_203574 * pad_css_len_203722;
                
                for (int64_t i_207307 = 0; i_207307 < partition_sizze_203667;
                     i_207307++) {
                    for (int64_t i_207303 = 0; i_207303 < n_p_203574;
                         i_207303++) {
                        for (int64_t i_207299 = 0; i_207299 <
                             pad_css_len_203722; i_207299++) {
                            bool cond_205073 = i_207299 == (int64_t) 0;
                            double defunc_0_f_res_205074;
                            
                            if (cond_205073) {
                                bool y_205075 = slt64((int64_t) 0,
                                                      s_n_m_203726);
                                bool index_certs_205076;
                                
                                if (!y_205075) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) (int64_t) 0,
                                                  "] out of bounds for array of shape [",
                                                  (long long) s_n_m_203726,
                                                  "].",
                                                  "-> #0  /prelude/array.fut:21:29-32\n   #1  loess.fut:559:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:557:3-566:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                                    if (memblock_unref(ctx, &mem_210652,
                                                       "mem_210652") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210740,
                                                       "ext_mem_210740") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210626,
                                                       "ext_mem_210626") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210637,
                                                       "ext_mem_210637") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209272,
                                                       "mem_param_209272") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209264,
                                                       "mem_param_209264") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212632,
                                                       "ext_mem_212632") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212633,
                                                       "ext_mem_212633") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209250,
                                                       "mem_param_209250") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209242,
                                                       "mem_param_209242") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209234,
                                                       "mem_param_209234") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212961,
                                                       "ext_mem_212961") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212962,
                                                       "ext_mem_212962") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212963,
                                                       "ext_mem_212963") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209226,
                                                       "mem_209226") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209222,
                                                       "mem_209222") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213477,
                                                       "mem_out_213477") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213476,
                                                       "mem_out_213476") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213475,
                                                       "mem_out_213475") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                double head_res_205077;
                                
                                head_res_205077 =
                                    ((double *) ext_mem_210637.mem)[i_207307 *
                                                                    ctx_val_208847 +
                                                                    i_207303 *
                                                                    s_n_m_203726];
                                defunc_0_f_res_205074 = head_res_205077;
                            } else {
                                int64_t y_205078 = sub64(pad_css_len_203722,
                                                         (int64_t) 1);
                                bool cond_205079 = i_207299 == y_205078;
                                double defunc_0_f_res_f_res_205080;
                                
                                if (cond_205079) {
                                    int64_t i_205081 = sub64(s_n_m_203726,
                                                             (int64_t) 1);
                                    bool x_205082 = sle64((int64_t) 0,
                                                          i_205081);
                                    bool y_205083 = slt64(i_205081,
                                                          s_n_m_203726);
                                    bool bounds_check_205084 = x_205082 &&
                                         y_205083;
                                    bool index_certs_205085;
                                    
                                    if (!bounds_check_205084) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) i_205081,
                                                      "] out of bounds for array of shape [",
                                                      (long long) s_n_m_203726,
                                                      "].",
                                                      "-> #0  /prelude/array.fut:26:29-34\n   #1  loess.fut:561:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:557:3-566:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_210652,
                                                           "mem_210652") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double last_res_205086;
                                    
                                    last_res_205086 =
                                        ((double *) ext_mem_210637.mem)[i_207307 *
                                                                        ctx_val_208847 +
                                                                        i_207303 *
                                                                        s_n_m_203726 +
                                                                        i_205081];
                                    defunc_0_f_res_f_res_205080 =
                                        last_res_205086;
                                } else {
                                    int64_t x_205087 = sub64(i_207299,
                                                             (int64_t) 1);
                                    bool zzero_205088 = jump_s_203581 ==
                                         (int64_t) 0;
                                    bool nonzzero_205089 = !zzero_205088;
                                    bool nonzzero_cert_205090;
                                    
                                    if (!nonzzero_205089) {
                                        ctx->error =
                                            msgprintf("Error: %s\n\nBacktrace:\n%s",
                                                      "division by zero",
                                                      "-> #0  loess.fut:563:22-35\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:557:3-566:9\n   #5  stl.fut:220:31-96\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:219:23-221:48\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:218:15-222:44\n   #12 stl.fut:415:61-429:75\n   #13 stl.fut:455:3-469:34\n   #14 stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_210652,
                                                           "mem_210652") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    int64_t x_205091 = sdiv64(x_205087,
                                                              jump_s_203581);
                                    int64_t m_v_205092 = add64((int64_t) 1,
                                                               x_205091);
                                    int64_t j_205093;
                                    
                                    if (cond_205073) {
                                        j_205093 = (int64_t) 0;
                                    } else {
                                        int64_t y_205094 = sub64(s_n_m_203726,
                                                                 (int64_t) 1);
                                        bool cond_205095 = m_v_205092 ==
                                             y_205094;
                                        int64_t j_f_res_205096;
                                        
                                        if (cond_205095) {
                                            j_f_res_205096 = x_205091;
                                        } else {
                                            j_f_res_205096 = m_v_205092;
                                        }
                                        j_205093 = j_f_res_205096;
                                    }
                                    
                                    bool cond_205097 = j_205093 == (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_205098;
                                    
                                    if (cond_205097) {
                                        defunc_0_m_fun_res_205098 = (int64_t) 0;
                                    } else {
                                        int64_t y_205099 = sub64(s_n_m_203726,
                                                                 (int64_t) 1);
                                        bool cond_205100 = j_205093 == y_205099;
                                        int64_t defunc_0_m_fun_res_f_res_205101;
                                        
                                        if (cond_205100) {
                                            defunc_0_m_fun_res_f_res_205101 =
                                                y_205078;
                                        } else {
                                            int64_t x_205102 = sub64(j_205093,
                                                                     (int64_t) 1);
                                            int64_t x_205103 =
                                                    mul64(jump_s_203581,
                                                          x_205102);
                                            int64_t min_arg_205104 =
                                                    add64((int64_t) 1,
                                                          x_205103);
                                            int64_t min_res_205105 =
                                                    smin64(defunc_0_f_res_203721,
                                                           min_arg_205104);
                                            
                                            defunc_0_m_fun_res_f_res_205101 =
                                                min_res_205105;
                                        }
                                        defunc_0_m_fun_res_205098 =
                                            defunc_0_m_fun_res_f_res_205101;
                                    }
                                    
                                    int64_t defunc_0_m_fun_arg_205106 =
                                            add64((int64_t) 1, j_205093);
                                    bool cond_205107 =
                                         defunc_0_m_fun_arg_205106 ==
                                         (int64_t) 0;
                                    int64_t defunc_0_m_fun_res_205108;
                                    
                                    if (cond_205107) {
                                        defunc_0_m_fun_res_205108 = (int64_t) 0;
                                    } else {
                                        int64_t y_205109 = sub64(s_n_m_203726,
                                                                 (int64_t) 1);
                                        bool cond_205110 =
                                             defunc_0_m_fun_arg_205106 ==
                                             y_205109;
                                        int64_t defunc_0_m_fun_res_f_res_205111;
                                        
                                        if (cond_205110) {
                                            defunc_0_m_fun_res_f_res_205111 =
                                                y_205078;
                                        } else {
                                            int64_t x_205112 =
                                                    mul64(jump_s_203581,
                                                          j_205093);
                                            int64_t min_arg_205113 =
                                                    add64((int64_t) 1,
                                                          x_205112);
                                            int64_t min_res_205114 =
                                                    smin64(defunc_0_f_res_203721,
                                                           min_arg_205113);
                                            
                                            defunc_0_m_fun_res_f_res_205111 =
                                                min_res_205114;
                                        }
                                        defunc_0_m_fun_res_205108 =
                                            defunc_0_m_fun_res_f_res_205111;
                                    }
                                    
                                    int64_t i64_arg_205115 =
                                            sub64(defunc_0_m_fun_res_205108,
                                                  defunc_0_m_fun_res_205098);
                                    double i64_res_205116 =
                                           sitofp_i64_f64(i64_arg_205115);
                                    int64_t i64_arg_205117 = sub64(i_207299,
                                                                   defunc_0_m_fun_res_205098);
                                    double i64_res_205118 =
                                           sitofp_i64_f64(i64_arg_205117);
                                    double u_205119 = i64_res_205118 /
                                           i64_res_205116;
                                    double u2_205120 = u_205119 * u_205119;
                                    double u3_205121 = u_205119 * u2_205120;
                                    double x_205122 = 2.0 * u3_205121;
                                    double y_205123 = 3.0 * u2_205120;
                                    double x_205124 = x_205122 - y_205123;
                                    double x_205125 = 1.0 + x_205124;
                                    bool x_205126 = sle64((int64_t) 0,
                                                          j_205093);
                                    bool y_205127 = slt64(j_205093,
                                                          s_n_m_203726);
                                    bool bounds_check_205128 = x_205126 &&
                                         y_205127;
                                    bool index_certs_205129;
                                    
                                    if (!bounds_check_205128) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) j_205093,
                                                      "] out of bounds for array of shape [",
                                                      (long long) s_n_m_203726,
                                                      "].",
                                                      "-> #0  loess.fut:536:27-33\n   #1  loess.fut:565:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:557:3-566:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_210652,
                                                           "mem_210652") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double y_205130;
                                    
                                    y_205130 =
                                        ((double *) ext_mem_210637.mem)[i_207307 *
                                                                        ctx_val_208847 +
                                                                        i_207303 *
                                                                        s_n_m_203726 +
                                                                        j_205093];
                                    
                                    double x_205131 = x_205125 * y_205130;
                                    double x_205132 = y_205123 - x_205122;
                                    bool x_205133 = sle64((int64_t) 0,
                                                          defunc_0_m_fun_arg_205106);
                                    bool y_205134 =
                                         slt64(defunc_0_m_fun_arg_205106,
                                               s_n_m_203726);
                                    bool bounds_check_205135 = x_205133 &&
                                         y_205134;
                                    bool index_certs_205136;
                                    
                                    if (!bounds_check_205135) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) defunc_0_m_fun_arg_205106,
                                                      "] out of bounds for array of shape [",
                                                      (long long) s_n_m_203726,
                                                      "].",
                                                      "-> #0  loess.fut:537:27-37\n   #1  loess.fut:565:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:557:3-566:9\n   #6  stl.fut:220:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:219:23-221:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:218:15-222:44\n   #13 stl.fut:415:61-429:75\n   #14 stl.fut:455:3-469:34\n   #15 stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_210652,
                                                           "mem_210652") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double y_205137;
                                    
                                    y_205137 =
                                        ((double *) ext_mem_210637.mem)[i_207307 *
                                                                        ctx_val_208847 +
                                                                        i_207303 *
                                                                        s_n_m_203726 +
                                                                        defunc_0_m_fun_arg_205106];
                                    
                                    double y_205138 = x_205132 * y_205137;
                                    double x_205139 = x_205131 + y_205138;
                                    double y_205140 = 2.0 * u2_205120;
                                    double x_205141 = u3_205121 - y_205140;
                                    double x_205142 = u_205119 + x_205141;
                                    double y_205143;
                                    
                                    y_205143 =
                                        ((double *) ext_mem_210626.mem)[i_207307 *
                                                                        ctx_val_208847 +
                                                                        i_207303 *
                                                                        s_n_m_203726 +
                                                                        j_205093];
                                    
                                    double x_205144 = x_205142 * y_205143;
                                    double y_205145 = i64_res_205116 * x_205144;
                                    double x_205146 = x_205139 + y_205145;
                                    double x_205147 = u3_205121 - u2_205120;
                                    double y_205148;
                                    
                                    y_205148 =
                                        ((double *) ext_mem_210626.mem)[i_207307 *
                                                                        ctx_val_208847 +
                                                                        i_207303 *
                                                                        s_n_m_203726 +
                                                                        defunc_0_m_fun_arg_205106];
                                    
                                    double x_205149 = x_205147 * y_205148;
                                    double y_205150 = i64_res_205116 * x_205149;
                                    double defunc_4_interpolate_proc_res_205151
                                           = x_205146 + y_205150;
                                    
                                    defunc_0_f_res_f_res_205080 =
                                        defunc_4_interpolate_proc_res_205151;
                                }
                                defunc_0_f_res_205074 =
                                    defunc_0_f_res_f_res_205080;
                            }
                            ((double *) mem_210652.mem)[i_207307 *
                                                        ctx_val_210665 +
                                                        i_207303 *
                                                        pad_css_len_203722 +
                                                        i_207299] =
                                defunc_0_f_res_205074;
                        }
                    }
                }
                ext_210744 = ctx_val_210665;
                if (memblock_set(ctx, &ext_mem_210740, &mem_210652,
                                 "mem_210652") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_210652, "mem_210652") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_210626, "ext_mem_210626") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_210637, "ext_mem_210637") != 0)
                return 1;
            for (int64_t i_207315 = 0; i_207315 < partition_sizze_203667;
                 i_207315++) {
                for (int64_t i_207311 = 0; i_207311 < C_len_203724;
                     i_207311++) {
                    int64_t i_205158 = smod64(i_207311, n_p_203574);
                    bool x_205159 = sle64((int64_t) 0, i_205158);
                    bool y_205160 = slt64(i_205158, n_p_203574);
                    bool bounds_check_205161 = x_205159 && y_205160;
                    int64_t i_205162 = sdiv64(i_207311, n_p_203574);
                    bool x_205163 = sle64((int64_t) 0, i_205162);
                    bool y_205164 = slt64(i_205162, css_results_l_204200);
                    bool bounds_check_205165 = x_205163 && y_205164;
                    bool index_ok_205166 = bounds_check_205161 &&
                         bounds_check_205165;
                    bool index_certs_205167;
                    
                    if (!index_ok_205166) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) i_205158, ", ",
                                      (long long) i_205162,
                                      "] out of bounds for array of shape [",
                                      (long long) n_p_203574, "][",
                                      (long long) css_results_l_204200, "].",
                                      "-> #0  stl.fut:226:39-67\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:226:28-74\n   #5  stl.fut:225:21-227:39\n   #6  stl.fut:415:61-429:75\n   #7  stl.fut:455:3-469:34\n   #8  stl.fut:439:1-469:34\n");
                        if (memblock_unref(ctx, &ext_mem_210740,
                                           "ext_mem_210740") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_210626,
                                           "ext_mem_210626") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_210637,
                                           "ext_mem_210637") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_209272,
                                           "mem_param_209272") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_209264,
                                           "mem_param_209264") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_212632,
                                           "ext_mem_212632") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_212633,
                                           "ext_mem_212633") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_209250,
                                           "mem_param_209250") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_209242,
                                           "mem_param_209242") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_209234,
                                           "mem_param_209234") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_212961,
                                           "ext_mem_212961") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_212962,
                                           "ext_mem_212962") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_212963,
                                           "ext_mem_212963") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213477,
                                           "mem_out_213477") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213476,
                                           "mem_out_213476") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_213475,
                                           "mem_out_213475") != 0)
                            return 1;
                        err = 1;
                        goto cleanup;
                    }
                    if ((int64_t) 8 > 0)
                        memmove(mem_210751 + (i_207315 * C_len_203724 +
                                              i_207311) * (int64_t) 8,
                                ext_mem_210740.mem + ((int64_t) 0 + i_207315 *
                                                      ext_210744 + i_205158 *
                                                      ext_210743 + (int64_t) 1 *
                                                      i_205162) * (int64_t) 8,
                                (int64_t) 8);
                }
            }
            if (memblock_unref(ctx, &ext_mem_210740, "ext_mem_210740") != 0)
                return 1;
            for (int64_t i_207321 = 0; i_207321 < partition_sizze_203667;
                 i_207321++) {
                double defunc_2_reduce_res_205173;
                double redout_207317 = 0.0;
                
                for (int64_t i_207318 = 0; i_207318 < n_p_203574; i_207318++) {
                    double x_205177;
                    
                    x_205177 = ((double *) mem_210751)[i_207321 * C_len_203724 +
                                                       i_207318];
                    
                    double defunc_1_op_res_205176 = x_205177 + redout_207317;
                    double redout_tmp_213653 = defunc_1_op_res_205176;
                    
                    redout_207317 = redout_tmp_213653;
                }
                defunc_2_reduce_res_205173 = redout_207317;
                ((double *) mem_210794)[i_207321] = defunc_2_reduce_res_205173;
            }
            for (int64_t i_207331 = 0; i_207331 < partition_sizze_203667;
                 i_207331++) {
                double x_205181;
                
                x_205181 = ((double *) mem_210794)[i_207331];
                
                double discard_207328;
                double scanacc_207324 = 0.0;
                
                for (int64_t i_207326 = 0; i_207326 <
                     lifted_single_ma_l_arg_204224; i_207326++) {
                    bool cond_205187 = i_207326 == (int64_t) 0;
                    double defunc_0_f_res_205188;
                    
                    if (cond_205187) {
                        double defunc_0_f_res_t_res_205189 = x_205181 /
                               i64_res_203589;
                        
                        defunc_0_f_res_205188 = defunc_0_f_res_t_res_205189;
                    } else {
                        int64_t x_205190 = add64(n_p_203574, i_207326);
                        int64_t i_205191 = sub64(x_205190, (int64_t) 1);
                        bool x_205192 = sle64((int64_t) 0, i_205191);
                        bool y_205193 = slt64(i_205191, C_len_203724);
                        bool bounds_check_205194 = x_205192 && y_205193;
                        bool index_certs_205195;
                        
                        if (!bounds_check_205194) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205191,
                                          "] out of bounds for array of shape [",
                                          (long long) C_len_203724, "].",
                                          "-> #0  stl.fut:32:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  stl.fut:38:3-36\n   #9  stl.fut:231:23-47\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210740,
                                               "ext_mem_210740") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210626,
                                               "ext_mem_210626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210637,
                                               "ext_mem_210637") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209272,
                                               "mem_param_209272") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209264,
                                               "mem_param_209264") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212632,
                                               "ext_mem_212632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212633,
                                               "ext_mem_212633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209250,
                                               "mem_param_209250") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209242,
                                               "mem_param_209242") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209234,
                                               "mem_param_209234") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212961,
                                               "ext_mem_212961") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212962,
                                               "ext_mem_212962") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212963,
                                               "ext_mem_212963") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209226,
                                               "mem_209226") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209222,
                                               "mem_209222") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213477,
                                               "mem_out_213477") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213476,
                                               "mem_out_213476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213475,
                                               "mem_out_213475") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double x_205196;
                        
                        x_205196 = ((double *) mem_210751)[i_207331 *
                                                           C_len_203724 +
                                                           i_205191];
                        
                        int64_t i_205197 = sub64(i_207326, (int64_t) 1);
                        bool x_205198 = sle64((int64_t) 0, i_205197);
                        bool y_205199 = slt64(i_205197, C_len_203724);
                        bool bounds_check_205200 = x_205198 && y_205199;
                        bool index_certs_205201;
                        
                        if (!bounds_check_205200) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205197,
                                          "] out of bounds for array of shape [",
                                          (long long) C_len_203724, "].",
                                          "-> #0  stl.fut:32:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  stl.fut:38:3-36\n   #9  stl.fut:231:23-47\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210740,
                                               "ext_mem_210740") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210626,
                                               "ext_mem_210626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210637,
                                               "ext_mem_210637") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209272,
                                               "mem_param_209272") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209264,
                                               "mem_param_209264") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212632,
                                               "ext_mem_212632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212633,
                                               "ext_mem_212633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209250,
                                               "mem_param_209250") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209242,
                                               "mem_param_209242") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209234,
                                               "mem_param_209234") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212961,
                                               "ext_mem_212961") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212962,
                                               "ext_mem_212962") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212963,
                                               "ext_mem_212963") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209226,
                                               "mem_209226") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209222,
                                               "mem_209222") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213477,
                                               "mem_out_213477") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213476,
                                               "mem_out_213476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213475,
                                               "mem_out_213475") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_205202;
                        
                        y_205202 = ((double *) mem_210751)[i_207331 *
                                                           C_len_203724 +
                                                           i_205197];
                        
                        double x_205203 = x_205196 - y_205202;
                        double defunc_0_f_res_f_res_205204 = x_205203 /
                               i64_res_203589;
                        
                        defunc_0_f_res_205188 = defunc_0_f_res_f_res_205204;
                    }
                    
                    double defunc_1_op_res_205185 = defunc_0_f_res_205188 +
                           scanacc_207324;
                    
                    ((double *) mem_210823)[i_207326] = defunc_1_op_res_205185;
                    
                    double scanacc_tmp_213655 = defunc_1_op_res_205185;
                    
                    scanacc_207324 = scanacc_tmp_213655;
                }
                discard_207328 = scanacc_207324;
                if (lifted_single_ma_l_arg_204224 * (int64_t) 8 > 0)
                    memmove(mem_210810 + i_207331 *
                            lifted_single_ma_l_arg_204224 * (int64_t) 8,
                            mem_210823 + (int64_t) 0,
                            lifted_single_ma_l_arg_204224 * (int64_t) 8);
            }
            for (int64_t i_207337 = 0; i_207337 < partition_sizze_203667;
                 i_207337++) {
                double defunc_2_reduce_res_205209;
                double redout_207333 = 0.0;
                
                for (int64_t i_207334 = 0; i_207334 < n_p_203574; i_207334++) {
                    double x_205213;
                    
                    x_205213 = ((double *) mem_210810)[i_207337 *
                                                       lifted_single_ma_l_arg_204224 +
                                                       i_207334];
                    
                    double defunc_1_op_res_205212 = x_205213 + redout_207333;
                    double redout_tmp_213658 = defunc_1_op_res_205212;
                    
                    redout_207333 = redout_tmp_213658;
                }
                defunc_2_reduce_res_205209 = redout_207333;
                ((double *) mem_210846)[i_207337] = defunc_2_reduce_res_205209;
            }
            for (int64_t i_207347 = 0; i_207347 < partition_sizze_203667;
                 i_207347++) {
                double x_205217;
                
                x_205217 = ((double *) mem_210846)[i_207347];
                
                double discard_207344;
                double scanacc_207340 = 0.0;
                
                for (int64_t i_207342 = 0; i_207342 <
                     dyn_lifted_single_ma_l_arg_204234; i_207342++) {
                    bool cond_205223 = i_207342 == (int64_t) 0;
                    double defunc_0_f_res_205224;
                    
                    if (cond_205223) {
                        double defunc_0_f_res_t_res_205225 = x_205217 /
                               i64_res_203589;
                        
                        defunc_0_f_res_205224 = defunc_0_f_res_t_res_205225;
                    } else {
                        int64_t x_205226 = add64(n_p_203574, i_207342);
                        int64_t i_205227 = sub64(x_205226, (int64_t) 1);
                        bool x_205228 = sle64((int64_t) 0, i_205227);
                        bool y_205229 = slt64(i_205227,
                                              lifted_single_ma_l_arg_204224);
                        bool bounds_check_205230 = x_205228 && y_205229;
                        bool index_certs_205231;
                        
                        if (!bounds_check_205230) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205227,
                                          "] out of bounds for array of shape [",
                                          (long long) lifted_single_ma_l_arg_204224,
                                          "].",
                                          "-> #0  stl.fut:32:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-64\n   #10 stl.fut:231:23-47\n   #11 stl.fut:415:61-429:75\n   #12 stl.fut:455:3-469:34\n   #13 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210740,
                                               "ext_mem_210740") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210626,
                                               "ext_mem_210626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210637,
                                               "ext_mem_210637") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209272,
                                               "mem_param_209272") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209264,
                                               "mem_param_209264") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212632,
                                               "ext_mem_212632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212633,
                                               "ext_mem_212633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209250,
                                               "mem_param_209250") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209242,
                                               "mem_param_209242") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209234,
                                               "mem_param_209234") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212961,
                                               "ext_mem_212961") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212962,
                                               "ext_mem_212962") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212963,
                                               "ext_mem_212963") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209226,
                                               "mem_209226") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209222,
                                               "mem_209222") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213477,
                                               "mem_out_213477") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213476,
                                               "mem_out_213476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213475,
                                               "mem_out_213475") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double x_205232;
                        
                        x_205232 = ((double *) mem_210810)[i_207347 *
                                                           lifted_single_ma_l_arg_204224 +
                                                           i_205227];
                        
                        int64_t i_205233 = sub64(i_207342, (int64_t) 1);
                        bool x_205234 = sle64((int64_t) 0, i_205233);
                        bool y_205235 = slt64(i_205233,
                                              lifted_single_ma_l_arg_204224);
                        bool bounds_check_205236 = x_205234 && y_205235;
                        bool index_certs_205237;
                        
                        if (!bounds_check_205236) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205233,
                                          "] out of bounds for array of shape [",
                                          (long long) lifted_single_ma_l_arg_204224,
                                          "].",
                                          "-> #0  stl.fut:32:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-64\n   #10 stl.fut:231:23-47\n   #11 stl.fut:415:61-429:75\n   #12 stl.fut:455:3-469:34\n   #13 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210740,
                                               "ext_mem_210740") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210626,
                                               "ext_mem_210626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210637,
                                               "ext_mem_210637") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209272,
                                               "mem_param_209272") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209264,
                                               "mem_param_209264") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212632,
                                               "ext_mem_212632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212633,
                                               "ext_mem_212633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209250,
                                               "mem_param_209250") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209242,
                                               "mem_param_209242") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209234,
                                               "mem_param_209234") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212961,
                                               "ext_mem_212961") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212962,
                                               "ext_mem_212962") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212963,
                                               "ext_mem_212963") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209226,
                                               "mem_209226") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209222,
                                               "mem_209222") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213477,
                                               "mem_out_213477") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213476,
                                               "mem_out_213476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213475,
                                               "mem_out_213475") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_205238;
                        
                        y_205238 = ((double *) mem_210810)[i_207347 *
                                                           lifted_single_ma_l_arg_204224 +
                                                           i_205233];
                        
                        double x_205239 = x_205232 - y_205238;
                        double defunc_0_f_res_f_res_205240 = x_205239 /
                               i64_res_203589;
                        
                        defunc_0_f_res_205224 = defunc_0_f_res_f_res_205240;
                    }
                    
                    double defunc_1_op_res_205221 = defunc_0_f_res_205224 +
                           scanacc_207340;
                    
                    ((double *) mem_210875)[i_207342] = defunc_1_op_res_205221;
                    
                    double scanacc_tmp_213660 = defunc_1_op_res_205221;
                    
                    scanacc_207340 = scanacc_tmp_213660;
                }
                discard_207344 = scanacc_207340;
                if (dyn_lifted_single_ma_l_arg_204234 * (int64_t) 8 > 0)
                    memmove(mem_210862 + i_207347 *
                            dyn_lifted_single_ma_l_arg_204234 * (int64_t) 8,
                            mem_210875 + (int64_t) 0,
                            dyn_lifted_single_ma_l_arg_204234 * (int64_t) 8);
            }
            for (int64_t i_207353 = 0; i_207353 < partition_sizze_203667;
                 i_207353++) {
                double defunc_2_reduce_res_205245;
                double redout_207349 = 0.0;
                
                for (int32_t i_207891 = 0; i_207891 < 3; i_207891++) {
                    int64_t i_207350 = sext_i32_i64(i_207891);
                    double x_205249;
                    
                    x_205249 = ((double *) mem_210862)[i_207353 *
                                                       dyn_lifted_single_ma_l_arg_204234 +
                                                       i_207350];
                    
                    double defunc_1_op_res_205248 = x_205249 + redout_207349;
                    double redout_tmp_213663 = defunc_1_op_res_205248;
                    
                    redout_207349 = redout_tmp_213663;
                }
                defunc_2_reduce_res_205245 = redout_207349;
                ((double *) mem_210898)[i_207353] = defunc_2_reduce_res_205245;
            }
            for (int64_t i_207363 = 0; i_207363 < partition_sizze_203667;
                 i_207363++) {
                double x_205253;
                
                x_205253 = ((double *) mem_210898)[i_207363];
                
                double discard_207360;
                double scanacc_207356 = 0.0;
                
                for (int64_t i_207358 = 0; i_207358 < n_203572; i_207358++) {
                    bool cond_205259 = i_207358 == (int64_t) 0;
                    double defunc_0_f_res_205260;
                    
                    if (cond_205259) {
                        double defunc_0_f_res_t_res_205261 = x_205253 / 3.0;
                        
                        defunc_0_f_res_205260 = defunc_0_f_res_t_res_205261;
                    } else {
                        int64_t x_205262 = add64((int64_t) 3, i_207358);
                        int64_t i_205263 = sub64(x_205262, (int64_t) 1);
                        bool x_205264 = sle64((int64_t) 0, i_205263);
                        bool y_205265 = slt64(i_205263,
                                              dyn_lifted_single_ma_l_arg_204234);
                        bool bounds_check_205266 = x_205264 && y_205265;
                        bool index_certs_205267;
                        
                        if (!bounds_check_205266) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205263,
                                          "] out of bounds for array of shape [",
                                          (long long) dyn_lifted_single_ma_l_arg_204234,
                                          "].",
                                          "-> #0  stl.fut:32:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-84\n   #10 stl.fut:231:23-47\n   #11 stl.fut:415:61-429:75\n   #12 stl.fut:455:3-469:34\n   #13 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210740,
                                               "ext_mem_210740") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210626,
                                               "ext_mem_210626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210637,
                                               "ext_mem_210637") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209272,
                                               "mem_param_209272") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209264,
                                               "mem_param_209264") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212632,
                                               "ext_mem_212632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212633,
                                               "ext_mem_212633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209250,
                                               "mem_param_209250") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209242,
                                               "mem_param_209242") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209234,
                                               "mem_param_209234") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212961,
                                               "ext_mem_212961") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212962,
                                               "ext_mem_212962") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212963,
                                               "ext_mem_212963") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209226,
                                               "mem_209226") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209222,
                                               "mem_209222") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213477,
                                               "mem_out_213477") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213476,
                                               "mem_out_213476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213475,
                                               "mem_out_213475") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double x_205268;
                        
                        x_205268 = ((double *) mem_210862)[i_207363 *
                                                           dyn_lifted_single_ma_l_arg_204234 +
                                                           i_205263];
                        
                        int64_t i_205269 = sub64(i_207358, (int64_t) 1);
                        bool x_205270 = sle64((int64_t) 0, i_205269);
                        bool y_205271 = slt64(i_205269,
                                              dyn_lifted_single_ma_l_arg_204234);
                        bool bounds_check_205272 = x_205270 && y_205271;
                        bool index_certs_205273;
                        
                        if (!bounds_check_205272) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_205269,
                                          "] out of bounds for array of shape [",
                                          (long long) dyn_lifted_single_ma_l_arg_204234,
                                          "].",
                                          "-> #0  stl.fut:32:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:27:13-33:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:26:5-34:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:38:3-84\n   #10 stl.fut:231:23-47\n   #11 stl.fut:415:61-429:75\n   #12 stl.fut:455:3-469:34\n   #13 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_210740,
                                               "ext_mem_210740") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210626,
                                               "ext_mem_210626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210637,
                                               "ext_mem_210637") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209272,
                                               "mem_param_209272") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209264,
                                               "mem_param_209264") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212632,
                                               "ext_mem_212632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212633,
                                               "ext_mem_212633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209250,
                                               "mem_param_209250") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209242,
                                               "mem_param_209242") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209234,
                                               "mem_param_209234") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212961,
                                               "ext_mem_212961") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212962,
                                               "ext_mem_212962") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212963,
                                               "ext_mem_212963") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209226,
                                               "mem_209226") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209222,
                                               "mem_209222") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213477,
                                               "mem_out_213477") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213476,
                                               "mem_out_213476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213475,
                                               "mem_out_213475") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_205274;
                        
                        y_205274 = ((double *) mem_210862)[i_207363 *
                                                           dyn_lifted_single_ma_l_arg_204234 +
                                                           i_205269];
                        
                        double x_205275 = x_205268 - y_205274;
                        double defunc_0_f_res_f_res_205276 = x_205275 / 3.0;
                        
                        defunc_0_f_res_205260 = defunc_0_f_res_f_res_205276;
                    }
                    
                    double defunc_1_op_res_205257 = defunc_0_f_res_205260 +
                           scanacc_207356;
                    
                    ((double *) mem_210927)[i_207358] = defunc_1_op_res_205257;
                    
                    double scanacc_tmp_213665 = defunc_1_op_res_205257;
                    
                    scanacc_207356 = scanacc_tmp_213665;
                }
                discard_207360 = scanacc_207356;
                if (n_203572 * (int64_t) 8 > 0)
                    memmove(mem_210914 + i_207363 * n_203572 * (int64_t) 8,
                            mem_210927 + (int64_t) 0, n_203572 * (int64_t) 8);
            }
            
            struct memblock ext_mem_211573;
            
            ext_mem_211573.references = NULL;
            
            struct memblock ext_mem_211565;
            
            ext_mem_211565.references = NULL;
            if (cond_204250) {
                bool match_lit_205280 = (int64_t) 0 == d_l_203580;
                struct memblock ext_mem_211196;
                
                ext_mem_211196.references = NULL;
                
                struct memblock ext_mem_211188;
                
                ext_mem_211188.references = NULL;
                if (match_lit_205280) {
                    struct memblock mem_210951;
                    
                    mem_210951.references = NULL;
                    if (memblock_alloc(ctx, &mem_210951, bytes_209015,
                                       "mem_210951")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213667 = 0; i_213667 <
                         partition_sizze_203667; i_213667++) {
                        for (int64_t i_213668 = 0; i_213668 < l_n_m_203733;
                             i_213668++) {
                            ((double *) mem_210951.mem)[i_213667 *
                                                        l_n_m_203733 +
                                                        i_213668] = 0.0;
                        }
                    }
                    
                    struct memblock mem_210955;
                    
                    mem_210955.references = NULL;
                    if (memblock_alloc(ctx, &mem_210955, bytes_209015,
                                       "mem_210955")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_207375 = 0; i_207375 <
                         partition_sizze_203667; i_207375++) {
                        for (int64_t i_207371 = 0; i_207371 < l_n_m_203733;
                             i_207371++) {
                            int64_t x_205292;
                            
                            x_205292 = ((int64_t *) mem_209016)[i_207375 *
                                                                l_n_m_203733 +
                                                                i_207371];
                            
                            double x_205293;
                            
                            x_205293 = ((double *) mem_209020)[i_207375 *
                                                               l_n_m_203733 +
                                                               i_207371];
                            
                            int64_t min_arg_205294 = mul64(jump_t_203582,
                                                           i_207371);
                            int64_t min_res_205295 = smin64(i_203760,
                                                            min_arg_205294);
                            int64_t defunc_0_g_res_205296 = add64((int64_t) 1,
                                                                  min_res_205295);
                            double defunc_2_reduce_res_205297;
                            double redout_207365 = 0.0;
                            
                            for (int64_t i_207366 = 0; i_207366 < q_l_203577;
                                 i_207366++) {
                                bool cond_205302 = sle64(n_203572, i_207366);
                                int64_t defunc_0_f_res_205303;
                                
                                if (cond_205302) {
                                    defunc_0_f_res_205303 = (int64_t) 0;
                                } else {
                                    int64_t i_205304 = add64(x_205292,
                                                             i_207366);
                                    int64_t defunc_1_add_res_205305 =
                                            add64((int64_t) 1, i_205304);
                                    
                                    defunc_0_f_res_205303 =
                                        defunc_1_add_res_205305;
                                }
                                
                                double defunc_0_f_res_205306;
                                
                                if (cond_205302) {
                                    defunc_0_f_res_205306 = 0.0;
                                } else {
                                    int64_t i_205307 = add64(x_205292,
                                                             i_207366);
                                    double defunc_0_add_arg_205308;
                                    
                                    defunc_0_add_arg_205308 =
                                        ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                          (i_207375 *
                                                                           ctx_param_ext_209246 +
                                                                           i_205307 *
                                                                           ctx_param_ext_209248)];
                                    defunc_0_f_res_205306 =
                                        defunc_0_add_arg_205308;
                                }
                                
                                int64_t binop_p_205309 =
                                        sub64(defunc_0_f_res_205303,
                                              defunc_0_g_res_205296);
                                double defunc_0_f_res_205310 =
                                       sitofp_i64_f64(binop_p_205309);
                                double abs_res_205311 =
                                       fabs(defunc_0_f_res_205310);
                                double tmp1_205312 = abs_res_205311 / x_205293;
                                double x_205313 = tmp1_205312 * tmp1_205312;
                                double y_205314 = tmp1_205312 * x_205313;
                                double tmp2_205315 = 1.0 - y_205314;
                                double x_205316 = tmp2_205315 * tmp2_205315;
                                double tmp3_205317 = tmp2_205315 * x_205316;
                                double w_j_205318 = defunc_0_f_res_205306 *
                                       tmp3_205317;
                                double defunc_1_op_res_205300 = w_j_205318 +
                                       redout_207365;
                                double redout_tmp_213671 =
                                       defunc_1_op_res_205300;
                                
                                redout_207365 = redout_tmp_213671;
                            }
                            defunc_2_reduce_res_205297 = redout_207365;
                            
                            double a0_205319 = 1.0 / defunc_2_reduce_res_205297;
                            double defunc_2_reduce_res_205320;
                            double redout_207367 = 0.0;
                            
                            for (int64_t i_207368 = 0; i_207368 < q_l_203577;
                                 i_207368++) {
                                bool cond_205325 = sle64(n_203572, i_207368);
                                int64_t defunc_0_f_res_205326;
                                
                                if (cond_205325) {
                                    defunc_0_f_res_205326 = (int64_t) 0;
                                } else {
                                    int64_t i_205327 = add64(x_205292,
                                                             i_207368);
                                    int64_t defunc_1_add_res_205328 =
                                            add64((int64_t) 1, i_205327);
                                    
                                    defunc_0_f_res_205326 =
                                        defunc_1_add_res_205328;
                                }
                                
                                double defunc_0_f_res_205329;
                                
                                if (cond_205325) {
                                    defunc_0_f_res_205329 = 0.0;
                                } else {
                                    int64_t i_205330 = add64(x_205292,
                                                             i_207368);
                                    double defunc_0_add_arg_205331;
                                    
                                    defunc_0_add_arg_205331 =
                                        ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                          (i_207375 *
                                                                           ctx_param_ext_209246 +
                                                                           i_205330 *
                                                                           ctx_param_ext_209248)];
                                    defunc_0_f_res_205329 =
                                        defunc_0_add_arg_205331;
                                }
                                
                                int64_t binop_p_205332 =
                                        sub64(defunc_0_f_res_205326,
                                              defunc_0_g_res_205296);
                                double defunc_0_f_res_205333 =
                                       sitofp_i64_f64(binop_p_205332);
                                double abs_res_205334 =
                                       fabs(defunc_0_f_res_205333);
                                double tmp1_205335 = abs_res_205334 / x_205293;
                                double x_205336 = tmp1_205335 * tmp1_205335;
                                double y_205337 = tmp1_205335 * x_205336;
                                double tmp2_205338 = 1.0 - y_205337;
                                double x_205339 = tmp2_205338 * tmp2_205338;
                                double tmp3_205340 = tmp2_205338 * x_205339;
                                double tmp4_205341 = defunc_0_f_res_205329 *
                                       tmp3_205340;
                                double defunc_0_f_res_205342;
                                
                                if (cond_205325) {
                                    defunc_0_f_res_205342 = 0.0;
                                } else {
                                    int64_t i_205343 = add64(x_205292,
                                                             i_207368);
                                    double defunc_0_add_arg_205344;
                                    
                                    defunc_0_add_arg_205344 =
                                        ((double *) mem_210914)[i_207375 *
                                                                n_203572 +
                                                                i_205343];
                                    defunc_0_f_res_205342 =
                                        defunc_0_add_arg_205344;
                                }
                                
                                double x_205345 = a0_205319 * tmp4_205341;
                                double defunc_9_fit_fun_res_205346 =
                                       defunc_0_f_res_205342 * x_205345;
                                double defunc_1_op_res_205323 =
                                       defunc_9_fit_fun_res_205346 +
                                       redout_207367;
                                double redout_tmp_213672 =
                                       defunc_1_op_res_205323;
                                
                                redout_207367 = redout_tmp_213672;
                            }
                            defunc_2_reduce_res_205320 = redout_207367;
                            ((double *) mem_210955.mem)[i_207375 *
                                                        l_n_m_203733 +
                                                        i_207371] =
                                defunc_2_reduce_res_205320;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_211196, &mem_210955,
                                     "mem_210955") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_211188, &mem_210951,
                                     "mem_210951") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_210955, "mem_210955") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_210951, "mem_210951") != 0)
                        return 1;
                } else {
                    bool match_lit_205349 = (int64_t) 1 == d_l_203580;
                    struct memblock ext_mem_211180;
                    
                    ext_mem_211180.references = NULL;
                    
                    struct memblock ext_mem_211172;
                    
                    ext_mem_211172.references = NULL;
                    if (match_lit_205349) {
                        struct memblock mem_210999;
                        
                        mem_210999.references = NULL;
                        if (memblock_alloc(ctx, &mem_210999, bytes_209015,
                                           "mem_210999")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_211003;
                        
                        mem_211003.references = NULL;
                        if (memblock_alloc(ctx, &mem_211003, bytes_209015,
                                           "mem_211003")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_207395 = 0; i_207395 <
                             partition_sizze_203667; i_207395++) {
                            for (int64_t i_207388 = 0; i_207388 < l_n_m_203733;
                                 i_207388++) {
                                int64_t x_205362;
                                
                                x_205362 = ((int64_t *) mem_209016)[i_207395 *
                                                                    l_n_m_203733 +
                                                                    i_207388];
                                
                                double x_205363;
                                
                                x_205363 = ((double *) mem_209020)[i_207395 *
                                                                   l_n_m_203733 +
                                                                   i_207388];
                                
                                int64_t min_arg_205364 = mul64(jump_t_203582,
                                                               i_207388);
                                int64_t min_res_205365 = smin64(i_203760,
                                                                min_arg_205364);
                                int64_t defunc_0_g_res_205366 =
                                        add64((int64_t) 1, min_res_205365);
                                double defunc_2_reduce_res_205367;
                                double defunc_2_reduce_res_205368;
                                double defunc_2_reduce_res_205369;
                                double redout_207377;
                                double redout_207378;
                                double redout_207379;
                                
                                redout_207377 = 0.0;
                                redout_207378 = 0.0;
                                redout_207379 = 0.0;
                                for (int64_t i_207380 = 0; i_207380 <
                                     q_l_203577; i_207380++) {
                                    bool cond_205380 = sle64(n_203572,
                                                             i_207380);
                                    int64_t defunc_0_f_res_205381;
                                    
                                    if (cond_205380) {
                                        defunc_0_f_res_205381 = (int64_t) 0;
                                    } else {
                                        int64_t i_205382 = add64(x_205362,
                                                                 i_207380);
                                        int64_t defunc_1_add_res_205383 =
                                                add64((int64_t) 1, i_205382);
                                        
                                        defunc_0_f_res_205381 =
                                            defunc_1_add_res_205383;
                                    }
                                    
                                    double defunc_0_f_res_205384;
                                    
                                    if (cond_205380) {
                                        defunc_0_f_res_205384 = 0.0;
                                    } else {
                                        int64_t i_205385 = add64(x_205362,
                                                                 i_207380);
                                        double defunc_0_add_arg_205386;
                                        
                                        defunc_0_add_arg_205386 =
                                            ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                              (i_207395 *
                                                                               ctx_param_ext_209246 +
                                                                               i_205385 *
                                                                               ctx_param_ext_209248)];
                                        defunc_0_f_res_205384 =
                                            defunc_0_add_arg_205386;
                                    }
                                    
                                    int64_t binop_p_205387 =
                                            sub64(defunc_0_f_res_205381,
                                                  defunc_0_g_res_205366);
                                    double defunc_0_f_res_205388 =
                                           sitofp_i64_f64(binop_p_205387);
                                    double abs_res_205389 =
                                           fabs(defunc_0_f_res_205388);
                                    double tmp1_205390 = abs_res_205389 /
                                           x_205363;
                                    double x_205391 = tmp1_205390 * tmp1_205390;
                                    double y_205392 = tmp1_205390 * x_205391;
                                    double tmp2_205393 = 1.0 - y_205392;
                                    double x_205394 = tmp2_205393 * tmp2_205393;
                                    double tmp3_205395 = tmp2_205393 * x_205394;
                                    double w_j_205396 = defunc_0_f_res_205384 *
                                           tmp3_205395;
                                    double xw_j_205397 = defunc_0_f_res_205388 *
                                           w_j_205396;
                                    double x2w_j_205398 =
                                           defunc_0_f_res_205388 * xw_j_205397;
                                    double defunc_1_op_res_205372 = w_j_205396 +
                                           redout_207377;
                                    double defunc_1_op_res_205375 =
                                           xw_j_205397 + redout_207378;
                                    double defunc_1_op_res_205378 =
                                           x2w_j_205398 + redout_207379;
                                    double redout_tmp_213677 =
                                           defunc_1_op_res_205372;
                                    double redout_tmp_213678 =
                                           defunc_1_op_res_205375;
                                    double redout_tmp_213679 =
                                           defunc_1_op_res_205378;
                                    
                                    redout_207377 = redout_tmp_213677;
                                    redout_207378 = redout_tmp_213678;
                                    redout_207379 = redout_tmp_213679;
                                }
                                defunc_2_reduce_res_205367 = redout_207377;
                                defunc_2_reduce_res_205368 = redout_207378;
                                defunc_2_reduce_res_205369 = redout_207379;
                                
                                double x_205399 = defunc_2_reduce_res_205367 *
                                       defunc_2_reduce_res_205369;
                                double y_205400 = defunc_2_reduce_res_205368 *
                                       defunc_2_reduce_res_205368;
                                double y_205401 = x_205399 - y_205400;
                                double det1_205402 = 1.0 / y_205401;
                                double a11_205403 = defunc_2_reduce_res_205369 *
                                       det1_205402;
                                double x_205404 = 0.0 -
                                       defunc_2_reduce_res_205368;
                                double b11_205405 = det1_205402 * x_205404;
                                double c11_205406 = defunc_2_reduce_res_205367 *
                                       det1_205402;
                                double defunc_2_reduce_res_205407;
                                double defunc_2_reduce_res_205408;
                                double redout_207381;
                                double redout_207382;
                                
                                redout_207381 = 0.0;
                                redout_207382 = 0.0;
                                for (int64_t i_207383 = 0; i_207383 <
                                     q_l_203577; i_207383++) {
                                    bool cond_205416 = sle64(n_203572,
                                                             i_207383);
                                    int64_t defunc_0_f_res_205417;
                                    
                                    if (cond_205416) {
                                        defunc_0_f_res_205417 = (int64_t) 0;
                                    } else {
                                        int64_t i_205418 = add64(x_205362,
                                                                 i_207383);
                                        int64_t defunc_1_add_res_205419 =
                                                add64((int64_t) 1, i_205418);
                                        
                                        defunc_0_f_res_205417 =
                                            defunc_1_add_res_205419;
                                    }
                                    
                                    double defunc_0_f_res_205420;
                                    
                                    if (cond_205416) {
                                        defunc_0_f_res_205420 = 0.0;
                                    } else {
                                        int64_t i_205421 = add64(x_205362,
                                                                 i_207383);
                                        double defunc_0_add_arg_205422;
                                        
                                        defunc_0_add_arg_205422 =
                                            ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                              (i_207395 *
                                                                               ctx_param_ext_209246 +
                                                                               i_205421 *
                                                                               ctx_param_ext_209248)];
                                        defunc_0_f_res_205420 =
                                            defunc_0_add_arg_205422;
                                    }
                                    
                                    int64_t binop_p_205423 =
                                            sub64(defunc_0_f_res_205417,
                                                  defunc_0_g_res_205366);
                                    double defunc_0_f_res_205424 =
                                           sitofp_i64_f64(binop_p_205423);
                                    double abs_res_205425 =
                                           fabs(defunc_0_f_res_205424);
                                    double tmp1_205426 = abs_res_205425 /
                                           x_205363;
                                    double x_205427 = tmp1_205426 * tmp1_205426;
                                    double y_205428 = tmp1_205426 * x_205427;
                                    double tmp2_205429 = 1.0 - y_205428;
                                    double x_205430 = tmp2_205429 * tmp2_205429;
                                    double tmp3_205431 = tmp2_205429 * x_205430;
                                    double tmp4_205432 = defunc_0_f_res_205420 *
                                           tmp3_205431;
                                    double defunc_1_f_res_205433 =
                                           defunc_0_f_res_205424 * tmp4_205432;
                                    double defunc_0_f_res_205434;
                                    
                                    if (cond_205416) {
                                        defunc_0_f_res_205434 = 0.0;
                                    } else {
                                        int64_t i_205435 = add64(x_205362,
                                                                 i_207383);
                                        double defunc_0_add_arg_205436;
                                        
                                        defunc_0_add_arg_205436 =
                                            ((double *) mem_210914)[i_207395 *
                                                                    n_203572 +
                                                                    i_205435];
                                        defunc_0_f_res_205434 =
                                            defunc_0_add_arg_205436;
                                    }
                                    
                                    double x_205437 = a11_205403 * tmp4_205432;
                                    double y_205438 = b11_205405 *
                                           defunc_1_f_res_205433;
                                    double x_205439 = x_205437 + y_205438;
                                    double defunc_9_fit_fun_res_205440 =
                                           defunc_0_f_res_205434 * x_205439;
                                    double x_205441 = b11_205405 * tmp4_205432;
                                    double y_205442 = c11_205406 *
                                           defunc_1_f_res_205433;
                                    double x_205443 = x_205441 + y_205442;
                                    double defunc_9_slope_fun_res_205444 =
                                           defunc_0_f_res_205434 * x_205443;
                                    double defunc_1_op_res_205411 =
                                           defunc_9_fit_fun_res_205440 +
                                           redout_207381;
                                    double defunc_1_op_res_205414 =
                                           defunc_9_slope_fun_res_205444 +
                                           redout_207382;
                                    double redout_tmp_213680 =
                                           defunc_1_op_res_205411;
                                    double redout_tmp_213681 =
                                           defunc_1_op_res_205414;
                                    
                                    redout_207381 = redout_tmp_213680;
                                    redout_207382 = redout_tmp_213681;
                                }
                                defunc_2_reduce_res_205407 = redout_207381;
                                defunc_2_reduce_res_205408 = redout_207382;
                                ((double *) mem_210999.mem)[i_207395 *
                                                            l_n_m_203733 +
                                                            i_207388] =
                                    defunc_2_reduce_res_205407;
                                ((double *) mem_211003.mem)[i_207395 *
                                                            l_n_m_203733 +
                                                            i_207388] =
                                    defunc_2_reduce_res_205408;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_211180, &mem_210999,
                                         "mem_210999") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_211172, &mem_211003,
                                         "mem_211003") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211003, "mem_211003") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_210999, "mem_210999") != 0)
                            return 1;
                    } else {
                        struct memblock mem_211087;
                        
                        mem_211087.references = NULL;
                        if (memblock_alloc(ctx, &mem_211087, bytes_209015,
                                           "mem_211087")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_211091;
                        
                        mem_211091.references = NULL;
                        if (memblock_alloc(ctx, &mem_211091, bytes_209015,
                                           "mem_211091")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_207418 = 0; i_207418 <
                             partition_sizze_203667; i_207418++) {
                            for (int64_t i_207411 = 0; i_207411 < l_n_m_203733;
                                 i_207411++) {
                                int64_t x_205457;
                                
                                x_205457 = ((int64_t *) mem_209016)[i_207418 *
                                                                    l_n_m_203733 +
                                                                    i_207411];
                                
                                double x_205458;
                                
                                x_205458 = ((double *) mem_209020)[i_207418 *
                                                                   l_n_m_203733 +
                                                                   i_207411];
                                
                                int64_t min_arg_205459 = mul64(jump_t_203582,
                                                               i_207411);
                                int64_t min_res_205460 = smin64(i_203760,
                                                                min_arg_205459);
                                int64_t defunc_0_g_res_205461 =
                                        add64((int64_t) 1, min_res_205460);
                                double defunc_2_reduce_res_205462;
                                double defunc_2_reduce_res_205463;
                                double defunc_2_reduce_res_205464;
                                double defunc_2_reduce_res_205465;
                                double defunc_2_reduce_res_205466;
                                double redout_207398;
                                double redout_207399;
                                double redout_207400;
                                double redout_207401;
                                double redout_207402;
                                
                                redout_207398 = 0.0;
                                redout_207399 = 0.0;
                                redout_207400 = 0.0;
                                redout_207401 = 0.0;
                                redout_207402 = 0.0;
                                for (int64_t i_207403 = 0; i_207403 <
                                     q_l_203577; i_207403++) {
                                    bool cond_205483 = sle64(n_203572,
                                                             i_207403);
                                    int64_t defunc_0_f_res_205484;
                                    
                                    if (cond_205483) {
                                        defunc_0_f_res_205484 = (int64_t) 0;
                                    } else {
                                        int64_t i_205485 = add64(x_205457,
                                                                 i_207403);
                                        int64_t defunc_1_add_res_205486 =
                                                add64((int64_t) 1, i_205485);
                                        
                                        defunc_0_f_res_205484 =
                                            defunc_1_add_res_205486;
                                    }
                                    
                                    double defunc_0_f_res_205487;
                                    
                                    if (cond_205483) {
                                        defunc_0_f_res_205487 = 0.0;
                                    } else {
                                        int64_t i_205488 = add64(x_205457,
                                                                 i_207403);
                                        double defunc_0_add_arg_205489;
                                        
                                        defunc_0_add_arg_205489 =
                                            ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                              (i_207418 *
                                                                               ctx_param_ext_209246 +
                                                                               i_205488 *
                                                                               ctx_param_ext_209248)];
                                        defunc_0_f_res_205487 =
                                            defunc_0_add_arg_205489;
                                    }
                                    
                                    int64_t binop_p_205490 =
                                            sub64(defunc_0_f_res_205484,
                                                  defunc_0_g_res_205461);
                                    double defunc_0_f_res_205491 =
                                           sitofp_i64_f64(binop_p_205490);
                                    double abs_res_205492 =
                                           fabs(defunc_0_f_res_205491);
                                    double tmp1_205493 = abs_res_205492 /
                                           x_205458;
                                    double x_205494 = tmp1_205493 * tmp1_205493;
                                    double y_205495 = tmp1_205493 * x_205494;
                                    double tmp2_205496 = 1.0 - y_205495;
                                    double x_205497 = tmp2_205496 * tmp2_205496;
                                    double tmp3_205498 = tmp2_205496 * x_205497;
                                    double w_j_205499 = defunc_0_f_res_205487 *
                                           tmp3_205498;
                                    double xw_j_205500 = defunc_0_f_res_205491 *
                                           w_j_205499;
                                    double x2w_j_205501 =
                                           defunc_0_f_res_205491 * xw_j_205500;
                                    double x3w_j_205502 =
                                           defunc_0_f_res_205491 * x2w_j_205501;
                                    double x4w_j_205503 =
                                           defunc_0_f_res_205491 * x3w_j_205502;
                                    double defunc_1_op_res_205469 = w_j_205499 +
                                           redout_207398;
                                    double defunc_1_op_res_205472 =
                                           xw_j_205500 + redout_207399;
                                    double defunc_1_op_res_205475 =
                                           x2w_j_205501 + redout_207400;
                                    double defunc_1_op_res_205478 =
                                           x3w_j_205502 + redout_207401;
                                    double defunc_1_op_res_205481 =
                                           x4w_j_205503 + redout_207402;
                                    double redout_tmp_213686 =
                                           defunc_1_op_res_205469;
                                    double redout_tmp_213687 =
                                           defunc_1_op_res_205472;
                                    double redout_tmp_213688 =
                                           defunc_1_op_res_205475;
                                    double redout_tmp_213689 =
                                           defunc_1_op_res_205478;
                                    double redout_tmp_213690 =
                                           defunc_1_op_res_205481;
                                    
                                    redout_207398 = redout_tmp_213686;
                                    redout_207399 = redout_tmp_213687;
                                    redout_207400 = redout_tmp_213688;
                                    redout_207401 = redout_tmp_213689;
                                    redout_207402 = redout_tmp_213690;
                                }
                                defunc_2_reduce_res_205462 = redout_207398;
                                defunc_2_reduce_res_205463 = redout_207399;
                                defunc_2_reduce_res_205464 = redout_207400;
                                defunc_2_reduce_res_205465 = redout_207401;
                                defunc_2_reduce_res_205466 = redout_207402;
                                
                                double x_205504 = defunc_2_reduce_res_205464 *
                                       defunc_2_reduce_res_205466;
                                double y_205505 = defunc_2_reduce_res_205465 *
                                       defunc_2_reduce_res_205465;
                                double a12_205506 = x_205504 - y_205505;
                                double x_205507 = defunc_2_reduce_res_205464 *
                                       defunc_2_reduce_res_205465;
                                double y_205508 = defunc_2_reduce_res_205463 *
                                       defunc_2_reduce_res_205466;
                                double b12_205509 = x_205507 - y_205508;
                                double x_205510 = defunc_2_reduce_res_205463 *
                                       defunc_2_reduce_res_205465;
                                double y_205511 = defunc_2_reduce_res_205464 *
                                       defunc_2_reduce_res_205464;
                                double c12_205512 = x_205510 - y_205511;
                                double x_205513 = defunc_2_reduce_res_205462 *
                                       defunc_2_reduce_res_205466;
                                double b2_205514 = x_205513 - y_205511;
                                double x_205515 = defunc_2_reduce_res_205463 *
                                       defunc_2_reduce_res_205464;
                                double y_205516 = defunc_2_reduce_res_205462 *
                                       defunc_2_reduce_res_205465;
                                double c2_205517 = x_205515 - y_205516;
                                double x_205518 = defunc_2_reduce_res_205462 *
                                       a12_205506;
                                double y_205519 = defunc_2_reduce_res_205463 *
                                       b12_205509;
                                double x_205520 = x_205518 + y_205519;
                                double y_205521 = defunc_2_reduce_res_205464 *
                                       c12_205512;
                                double y_205522 = x_205520 + y_205521;
                                double det_205523 = 1.0 / y_205522;
                                double a12_205524 = a12_205506 * det_205523;
                                double b12_205525 = b12_205509 * det_205523;
                                double c12_205526 = c12_205512 * det_205523;
                                double b2_205527 = b2_205514 * det_205523;
                                double c2_205528 = c2_205517 * det_205523;
                                double defunc_2_reduce_res_205529;
                                double defunc_2_reduce_res_205530;
                                double redout_207404;
                                double redout_207405;
                                
                                redout_207404 = 0.0;
                                redout_207405 = 0.0;
                                for (int64_t i_207406 = 0; i_207406 <
                                     q_l_203577; i_207406++) {
                                    bool cond_205538 = sle64(n_203572,
                                                             i_207406);
                                    int64_t defunc_0_f_res_205539;
                                    
                                    if (cond_205538) {
                                        defunc_0_f_res_205539 = (int64_t) 0;
                                    } else {
                                        int64_t i_205540 = add64(x_205457,
                                                                 i_207406);
                                        int64_t defunc_1_add_res_205541 =
                                                add64((int64_t) 1, i_205540);
                                        
                                        defunc_0_f_res_205539 =
                                            defunc_1_add_res_205541;
                                    }
                                    
                                    double defunc_0_f_res_205542;
                                    
                                    if (cond_205538) {
                                        defunc_0_f_res_205542 = 0.0;
                                    } else {
                                        int64_t i_205543 = add64(x_205457,
                                                                 i_207406);
                                        double defunc_0_add_arg_205544;
                                        
                                        defunc_0_add_arg_205544 =
                                            ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                              (i_207418 *
                                                                               ctx_param_ext_209246 +
                                                                               i_205543 *
                                                                               ctx_param_ext_209248)];
                                        defunc_0_f_res_205542 =
                                            defunc_0_add_arg_205544;
                                    }
                                    
                                    int64_t binop_p_205545 =
                                            sub64(defunc_0_f_res_205539,
                                                  defunc_0_g_res_205461);
                                    double defunc_0_f_res_205546 =
                                           sitofp_i64_f64(binop_p_205545);
                                    double abs_res_205547 =
                                           fabs(defunc_0_f_res_205546);
                                    double tmp1_205548 = abs_res_205547 /
                                           x_205458;
                                    double x_205549 = tmp1_205548 * tmp1_205548;
                                    double y_205550 = tmp1_205548 * x_205549;
                                    double tmp2_205551 = 1.0 - y_205550;
                                    double x_205552 = tmp2_205551 * tmp2_205551;
                                    double tmp3_205553 = tmp2_205551 * x_205552;
                                    double tmp4_205554 = defunc_0_f_res_205542 *
                                           tmp3_205553;
                                    double defunc_1_f_res_205555 =
                                           defunc_0_f_res_205546 * tmp4_205554;
                                    double defunc_1_f_res_205556 =
                                           defunc_0_f_res_205546 *
                                           defunc_1_f_res_205555;
                                    double defunc_0_f_res_205557;
                                    
                                    if (cond_205538) {
                                        defunc_0_f_res_205557 = 0.0;
                                    } else {
                                        int64_t i_205558 = add64(x_205457,
                                                                 i_207406);
                                        double defunc_0_add_arg_205559;
                                        
                                        defunc_0_add_arg_205559 =
                                            ((double *) mem_210914)[i_207418 *
                                                                    n_203572 +
                                                                    i_205558];
                                        defunc_0_f_res_205557 =
                                            defunc_0_add_arg_205559;
                                    }
                                    
                                    double x_205560 = a12_205524 * tmp4_205554;
                                    double y_205561 = b12_205525 *
                                           defunc_1_f_res_205555;
                                    double x_205562 = x_205560 + y_205561;
                                    double y_205563 = c12_205526 *
                                           defunc_1_f_res_205556;
                                    double x_205564 = x_205562 + y_205563;
                                    double defunc_9_fit_fun_res_205565 =
                                           defunc_0_f_res_205557 * x_205564;
                                    double x_205566 = b12_205525 * tmp4_205554;
                                    double y_205567 = b2_205527 *
                                           defunc_1_f_res_205555;
                                    double x_205568 = x_205566 + y_205567;
                                    double y_205569 = c2_205528 *
                                           defunc_1_f_res_205556;
                                    double x_205570 = x_205568 + y_205569;
                                    double defunc_9_slope_fun_res_205571 =
                                           defunc_0_f_res_205557 * x_205570;
                                    double defunc_1_op_res_205533 =
                                           defunc_9_fit_fun_res_205565 +
                                           redout_207404;
                                    double defunc_1_op_res_205536 =
                                           defunc_9_slope_fun_res_205571 +
                                           redout_207405;
                                    double redout_tmp_213691 =
                                           defunc_1_op_res_205533;
                                    double redout_tmp_213692 =
                                           defunc_1_op_res_205536;
                                    
                                    redout_207404 = redout_tmp_213691;
                                    redout_207405 = redout_tmp_213692;
                                }
                                defunc_2_reduce_res_205529 = redout_207404;
                                defunc_2_reduce_res_205530 = redout_207405;
                                ((double *) mem_211087.mem)[i_207418 *
                                                            l_n_m_203733 +
                                                            i_207411] =
                                    defunc_2_reduce_res_205529;
                                ((double *) mem_211091.mem)[i_207418 *
                                                            l_n_m_203733 +
                                                            i_207411] =
                                    defunc_2_reduce_res_205530;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_211180, &mem_211087,
                                         "mem_211087") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_211172, &mem_211091,
                                         "mem_211091") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211091, "mem_211091") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211087, "mem_211087") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_211196, &ext_mem_211180,
                                     "ext_mem_211180") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_211188, &ext_mem_211172,
                                     "ext_mem_211172") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211172,
                                       "ext_mem_211172") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211180,
                                       "ext_mem_211180") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_211573, &ext_mem_211196,
                                 "ext_mem_211196") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_211565, &ext_mem_211188,
                                 "ext_mem_211188") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_211188, "ext_mem_211188") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_211196, "ext_mem_211196") != 0)
                    return 1;
            } else {
                bool match_lit_205574 = (int64_t) 0 == d_l_203580;
                int64_t binop_y_211233 = (int64_t) 8 * q_l_203577;
                int64_t bytes_211234 = smax64((int64_t) 0, binop_y_211233);
                struct memblock ext_mem_211557;
                
                ext_mem_211557.references = NULL;
                
                struct memblock ext_mem_211549;
                
                ext_mem_211549.references = NULL;
                if (match_lit_205574) {
                    struct memblock mem_211207;
                    
                    mem_211207.references = NULL;
                    if (memblock_alloc(ctx, &mem_211207, bytes_209015,
                                       "mem_211207")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213693 = 0; i_213693 <
                         partition_sizze_203667; i_213693++) {
                        for (int64_t i_213694 = 0; i_213694 < l_n_m_203733;
                             i_213694++) {
                            ((double *) mem_211207.mem)[i_213693 *
                                                        l_n_m_203733 +
                                                        i_213694] = 0.0;
                        }
                    }
                    
                    struct memblock mem_211211;
                    
                    mem_211211.references = NULL;
                    if (memblock_alloc(ctx, &mem_211211, bytes_209015,
                                       "mem_211211")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_211235_cached_sizze_213888 <
                        (size_t) bytes_211234) {
                        mem_211235 = realloc(mem_211235, bytes_211234);
                        mem_211235_cached_sizze_213888 = bytes_211234;
                    }
                    for (int64_t i_207434 = 0; i_207434 <
                         partition_sizze_203667; i_207434++) {
                        for (int64_t i_207430 = 0; i_207430 < l_n_m_203733;
                             i_207430++) {
                            int64_t x_205586;
                            
                            x_205586 = ((int64_t *) mem_209016)[i_207434 *
                                                                l_n_m_203733 +
                                                                i_207430];
                            
                            double x_205587;
                            
                            x_205587 = ((double *) mem_209020)[i_207434 *
                                                               l_n_m_203733 +
                                                               i_207430];
                            
                            int64_t min_arg_205588 = mul64(jump_t_203582,
                                                           i_207430);
                            int64_t min_res_205589 = smin64(i_203760,
                                                            min_arg_205588);
                            int64_t defunc_0_g_res_205590 = add64((int64_t) 1,
                                                                  min_res_205589);
                            double defunc_2_reduce_res_205591;
                            double redout_207422 = 0.0;
                            
                            for (int64_t i_207424 = 0; i_207424 < q_l_203577;
                                 i_207424++) {
                                bool cond_205597 = sle64(n_203572, i_207424);
                                int64_t defunc_0_f_res_205598;
                                
                                if (cond_205597) {
                                    defunc_0_f_res_205598 = (int64_t) 0;
                                } else {
                                    int64_t i_205599 = add64(x_205586,
                                                             i_207424);
                                    int64_t defunc_1_add_res_205600 =
                                            add64((int64_t) 1, i_205599);
                                    
                                    defunc_0_f_res_205598 =
                                        defunc_1_add_res_205600;
                                }
                                
                                double defunc_0_f_res_205601;
                                
                                if (cond_205597) {
                                    defunc_0_f_res_205601 = 0.0;
                                } else {
                                    int64_t i_205602 = add64(x_205586,
                                                             i_207424);
                                    double defunc_0_add_arg_205603;
                                    
                                    defunc_0_add_arg_205603 =
                                        ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                          (i_207434 *
                                                                           ctx_param_ext_209246 +
                                                                           i_205602 *
                                                                           ctx_param_ext_209248)];
                                    defunc_0_f_res_205601 =
                                        defunc_0_add_arg_205603;
                                }
                                
                                int64_t binop_p_205604 =
                                        sub64(defunc_0_f_res_205598,
                                              defunc_0_g_res_205590);
                                double defunc_0_f_res_205605 =
                                       sitofp_i64_f64(binop_p_205604);
                                double abs_res_205606 =
                                       fabs(defunc_0_f_res_205605);
                                double tmp1_205607 = abs_res_205606 / x_205587;
                                double x_205608 = tmp1_205607 * tmp1_205607;
                                double y_205609 = tmp1_205607 * x_205608;
                                double tmp2_205610 = 1.0 - y_205609;
                                double x_205611 = tmp2_205610 * tmp2_205610;
                                double tmp3_205612 = tmp2_205610 * x_205611;
                                double tmp4_205613 = defunc_0_f_res_205601 *
                                       tmp3_205612;
                                double defunc_1_op_res_205595 = tmp4_205613 +
                                       redout_207422;
                                
                                ((double *) mem_211235)[i_207424] = tmp4_205613;
                                
                                double redout_tmp_213697 =
                                       defunc_1_op_res_205595;
                                
                                redout_207422 = redout_tmp_213697;
                            }
                            defunc_2_reduce_res_205591 = redout_207422;
                            
                            double a0_205614 = 1.0 / defunc_2_reduce_res_205591;
                            double defunc_2_reduce_res_205615;
                            double redout_207426 = 0.0;
                            
                            for (int64_t i_207427 = 0; i_207427 < q_l_203577;
                                 i_207427++) {
                                double x_205620;
                                
                                x_205620 = ((double *) mem_211235)[i_207427];
                                
                                bool cond_205621 = sle64(n_203572, i_207427);
                                double defunc_0_f_res_205622;
                                
                                if (cond_205621) {
                                    defunc_0_f_res_205622 = 0.0;
                                } else {
                                    int64_t i_205623 = add64(x_205586,
                                                             i_207427);
                                    double defunc_0_add_arg_205624;
                                    
                                    defunc_0_add_arg_205624 =
                                        ((double *) mem_210914)[i_207434 *
                                                                n_203572 +
                                                                i_205623];
                                    defunc_0_f_res_205622 =
                                        defunc_0_add_arg_205624;
                                }
                                
                                double x_205625 = a0_205614 * x_205620;
                                double defunc_9_fit_fun_res_205626 =
                                       defunc_0_f_res_205622 * x_205625;
                                double defunc_1_op_res_205618 =
                                       defunc_9_fit_fun_res_205626 +
                                       redout_207426;
                                double redout_tmp_213699 =
                                       defunc_1_op_res_205618;
                                
                                redout_207426 = redout_tmp_213699;
                            }
                            defunc_2_reduce_res_205615 = redout_207426;
                            ((double *) mem_211211.mem)[i_207434 *
                                                        l_n_m_203733 +
                                                        i_207430] =
                                defunc_2_reduce_res_205615;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_211557, &mem_211211,
                                     "mem_211211") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_211549, &mem_211207,
                                     "mem_211207") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211211, "mem_211211") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211207, "mem_211207") != 0)
                        return 1;
                } else {
                    bool match_lit_205629 = (int64_t) 1 == d_l_203580;
                    int64_t binop_y_211317 = (int64_t) 8 * q_l_203577;
                    int64_t bytes_211318 = smax64((int64_t) 0, binop_y_211317);
                    int64_t binop_y_211435 = (int64_t) 8 * q_l_203577;
                    int64_t bytes_211436 = smax64((int64_t) 0, binop_y_211435);
                    struct memblock ext_mem_211541;
                    
                    ext_mem_211541.references = NULL;
                    
                    struct memblock ext_mem_211533;
                    
                    ext_mem_211533.references = NULL;
                    if (match_lit_205629) {
                        struct memblock mem_211270;
                        
                        mem_211270.references = NULL;
                        if (memblock_alloc(ctx, &mem_211270, bytes_209015,
                                           "mem_211270")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_211274;
                        
                        mem_211274.references = NULL;
                        if (memblock_alloc(ctx, &mem_211274, bytes_209015,
                                           "mem_211274")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_211319_cached_sizze_213889 <
                            (size_t) bytes_211318) {
                            mem_211319 = realloc(mem_211319, bytes_211318);
                            mem_211319_cached_sizze_213889 = bytes_211318;
                        }
                        if (mem_211322_cached_sizze_213890 <
                            (size_t) bytes_211318) {
                            mem_211322 = realloc(mem_211322, bytes_211318);
                            mem_211322_cached_sizze_213890 = bytes_211318;
                        }
                        for (int64_t i_207460 = 0; i_207460 <
                             partition_sizze_203667; i_207460++) {
                            for (int64_t i_207453 = 0; i_207453 < l_n_m_203733;
                                 i_207453++) {
                                int64_t x_205642;
                                
                                x_205642 = ((int64_t *) mem_209016)[i_207460 *
                                                                    l_n_m_203733 +
                                                                    i_207453];
                                
                                double x_205643;
                                
                                x_205643 = ((double *) mem_209020)[i_207460 *
                                                                   l_n_m_203733 +
                                                                   i_207453];
                                
                                int64_t min_arg_205644 = mul64(jump_t_203582,
                                                               i_207453);
                                int64_t min_res_205645 = smin64(i_203760,
                                                                min_arg_205644);
                                int64_t defunc_0_g_res_205646 =
                                        add64((int64_t) 1, min_res_205645);
                                double defunc_2_reduce_res_205669;
                                double defunc_2_reduce_res_205670;
                                double defunc_2_reduce_res_205671;
                                double redout_207438;
                                double redout_207439;
                                double redout_207440;
                                
                                redout_207438 = 0.0;
                                redout_207439 = 0.0;
                                redout_207440 = 0.0;
                                for (int64_t i_207443 = 0; i_207443 <
                                     q_l_203577; i_207443++) {
                                    bool cond_205684 = sle64(n_203572,
                                                             i_207443);
                                    int64_t defunc_0_f_res_205685;
                                    
                                    if (cond_205684) {
                                        defunc_0_f_res_205685 = (int64_t) 0;
                                    } else {
                                        int64_t i_205686 = add64(x_205642,
                                                                 i_207443);
                                        int64_t defunc_1_add_res_205687 =
                                                add64((int64_t) 1, i_205686);
                                        
                                        defunc_0_f_res_205685 =
                                            defunc_1_add_res_205687;
                                    }
                                    
                                    double defunc_0_f_res_205688;
                                    
                                    if (cond_205684) {
                                        defunc_0_f_res_205688 = 0.0;
                                    } else {
                                        int64_t i_205689 = add64(x_205642,
                                                                 i_207443);
                                        double defunc_0_add_arg_205690;
                                        
                                        defunc_0_add_arg_205690 =
                                            ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                              (i_207460 *
                                                                               ctx_param_ext_209246 +
                                                                               i_205689 *
                                                                               ctx_param_ext_209248)];
                                        defunc_0_f_res_205688 =
                                            defunc_0_add_arg_205690;
                                    }
                                    
                                    int64_t binop_p_205691 =
                                            sub64(defunc_0_f_res_205685,
                                                  defunc_0_g_res_205646);
                                    double defunc_0_f_res_205692 =
                                           sitofp_i64_f64(binop_p_205691);
                                    double abs_res_205693 =
                                           fabs(defunc_0_f_res_205692);
                                    double tmp1_205694 = abs_res_205693 /
                                           x_205643;
                                    double x_205695 = tmp1_205694 * tmp1_205694;
                                    double y_205696 = tmp1_205694 * x_205695;
                                    double tmp2_205697 = 1.0 - y_205696;
                                    double x_205698 = tmp2_205697 * tmp2_205697;
                                    double tmp3_205699 = tmp2_205697 * x_205698;
                                    double tmp4_205700 = defunc_0_f_res_205688 *
                                           tmp3_205699;
                                    double defunc_1_f_res_205701 =
                                           defunc_0_f_res_205692 * tmp4_205700;
                                    double defunc_1_f_res_205702 =
                                           defunc_0_f_res_205692 *
                                           defunc_1_f_res_205701;
                                    double defunc_1_op_res_205676 =
                                           tmp4_205700 + redout_207438;
                                    double defunc_1_op_res_205679 =
                                           defunc_1_f_res_205701 +
                                           redout_207439;
                                    double defunc_1_op_res_205682 =
                                           defunc_1_f_res_205702 +
                                           redout_207440;
                                    
                                    ((double *) mem_211319)[i_207443] =
                                        defunc_1_f_res_205701;
                                    ((double *) mem_211322)[i_207443] =
                                        tmp4_205700;
                                    
                                    double redout_tmp_213704 =
                                           defunc_1_op_res_205676;
                                    double redout_tmp_213705 =
                                           defunc_1_op_res_205679;
                                    double redout_tmp_213706 =
                                           defunc_1_op_res_205682;
                                    
                                    redout_207438 = redout_tmp_213704;
                                    redout_207439 = redout_tmp_213705;
                                    redout_207440 = redout_tmp_213706;
                                }
                                defunc_2_reduce_res_205669 = redout_207438;
                                defunc_2_reduce_res_205670 = redout_207439;
                                defunc_2_reduce_res_205671 = redout_207440;
                                
                                double x_205708 = defunc_2_reduce_res_205669 *
                                       defunc_2_reduce_res_205671;
                                double y_205709 = defunc_2_reduce_res_205670 *
                                       defunc_2_reduce_res_205670;
                                double y_205710 = x_205708 - y_205709;
                                double det1_205711 = 1.0 / y_205710;
                                double a11_205712 = defunc_2_reduce_res_205671 *
                                       det1_205711;
                                double x_205713 = 0.0 -
                                       defunc_2_reduce_res_205670;
                                double b11_205714 = det1_205711 * x_205713;
                                double c11_205715 = defunc_2_reduce_res_205669 *
                                       det1_205711;
                                double defunc_2_reduce_res_205716;
                                double defunc_2_reduce_res_205717;
                                double redout_207446;
                                double redout_207447;
                                
                                redout_207446 = 0.0;
                                redout_207447 = 0.0;
                                for (int64_t i_207448 = 0; i_207448 <
                                     q_l_203577; i_207448++) {
                                    double x_205725;
                                    
                                    x_205725 =
                                        ((double *) mem_211322)[i_207448];
                                    
                                    double x_205726;
                                    
                                    x_205726 =
                                        ((double *) mem_211319)[i_207448];
                                    
                                    bool cond_205727 = sle64(n_203572,
                                                             i_207448);
                                    double defunc_0_f_res_205728;
                                    
                                    if (cond_205727) {
                                        defunc_0_f_res_205728 = 0.0;
                                    } else {
                                        int64_t i_205729 = add64(x_205642,
                                                                 i_207448);
                                        double defunc_0_add_arg_205730;
                                        
                                        defunc_0_add_arg_205730 =
                                            ((double *) mem_210914)[i_207460 *
                                                                    n_203572 +
                                                                    i_205729];
                                        defunc_0_f_res_205728 =
                                            defunc_0_add_arg_205730;
                                    }
                                    
                                    double x_205731 = a11_205712 * x_205725;
                                    double y_205732 = b11_205714 * x_205726;
                                    double x_205733 = x_205731 + y_205732;
                                    double defunc_9_fit_fun_res_205734 =
                                           defunc_0_f_res_205728 * x_205733;
                                    double x_205735 = b11_205714 * x_205725;
                                    double y_205736 = c11_205715 * x_205726;
                                    double x_205737 = x_205735 + y_205736;
                                    double defunc_9_slope_fun_res_205738 =
                                           defunc_0_f_res_205728 * x_205737;
                                    double defunc_1_op_res_205720 =
                                           defunc_9_fit_fun_res_205734 +
                                           redout_207446;
                                    double defunc_1_op_res_205723 =
                                           defunc_9_slope_fun_res_205738 +
                                           redout_207447;
                                    double redout_tmp_213709 =
                                           defunc_1_op_res_205720;
                                    double redout_tmp_213710 =
                                           defunc_1_op_res_205723;
                                    
                                    redout_207446 = redout_tmp_213709;
                                    redout_207447 = redout_tmp_213710;
                                }
                                defunc_2_reduce_res_205716 = redout_207446;
                                defunc_2_reduce_res_205717 = redout_207447;
                                ((double *) mem_211270.mem)[i_207460 *
                                                            l_n_m_203733 +
                                                            i_207453] =
                                    defunc_2_reduce_res_205716;
                                ((double *) mem_211274.mem)[i_207460 *
                                                            l_n_m_203733 +
                                                            i_207453] =
                                    defunc_2_reduce_res_205717;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_211541, &mem_211270,
                                         "mem_211270") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_211533, &mem_211274,
                                         "mem_211274") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211274, "mem_211274") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211270, "mem_211270") != 0)
                            return 1;
                    } else {
                        struct memblock mem_211388;
                        
                        mem_211388.references = NULL;
                        if (memblock_alloc(ctx, &mem_211388, bytes_209015,
                                           "mem_211388")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_211392;
                        
                        mem_211392.references = NULL;
                        if (memblock_alloc(ctx, &mem_211392, bytes_209015,
                                           "mem_211392")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_211437_cached_sizze_213891 <
                            (size_t) bytes_211436) {
                            mem_211437 = realloc(mem_211437, bytes_211436);
                            mem_211437_cached_sizze_213891 = bytes_211436;
                        }
                        if (mem_211440_cached_sizze_213892 <
                            (size_t) bytes_211436) {
                            mem_211440 = realloc(mem_211440, bytes_211436);
                            mem_211440_cached_sizze_213892 = bytes_211436;
                        }
                        if (mem_211467_cached_sizze_213893 <
                            (size_t) bytes_211436) {
                            mem_211467 = realloc(mem_211467, bytes_211436);
                            mem_211467_cached_sizze_213893 = bytes_211436;
                        }
                        if (mem_211470_cached_sizze_213894 <
                            (size_t) bytes_211436) {
                            mem_211470 = realloc(mem_211470, bytes_211436);
                            mem_211470_cached_sizze_213894 = bytes_211436;
                        }
                        for (int64_t i_207496 = 0; i_207496 <
                             partition_sizze_203667; i_207496++) {
                            for (int64_t i_207489 = 0; i_207489 < l_n_m_203733;
                                 i_207489++) {
                                int64_t x_205751;
                                
                                x_205751 = ((int64_t *) mem_209016)[i_207496 *
                                                                    l_n_m_203733 +
                                                                    i_207489];
                                
                                double x_205752;
                                
                                x_205752 = ((double *) mem_209020)[i_207496 *
                                                                   l_n_m_203733 +
                                                                   i_207489];
                                
                                int64_t min_arg_205753 = mul64(jump_t_203582,
                                                               i_207489);
                                int64_t min_res_205754 = smin64(i_203760,
                                                                min_arg_205753);
                                int64_t defunc_0_g_res_205755 =
                                        add64((int64_t) 1, min_res_205754);
                                
                                for (int64_t i_207467 = 0; i_207467 <
                                     q_l_203577; i_207467++) {
                                    bool cond_205759 = sle64(n_203572,
                                                             i_207467);
                                    int64_t defunc_0_f_res_205760;
                                    
                                    if (cond_205759) {
                                        defunc_0_f_res_205760 = (int64_t) 0;
                                    } else {
                                        int64_t i_205761 = add64(x_205751,
                                                                 i_207467);
                                        int64_t defunc_1_add_res_205762 =
                                                add64((int64_t) 1, i_205761);
                                        
                                        defunc_0_f_res_205760 =
                                            defunc_1_add_res_205762;
                                    }
                                    
                                    double defunc_0_f_res_205763;
                                    
                                    if (cond_205759) {
                                        defunc_0_f_res_205763 = 0.0;
                                    } else {
                                        int64_t i_205764 = add64(x_205751,
                                                                 i_207467);
                                        double defunc_0_add_arg_205765;
                                        
                                        defunc_0_add_arg_205765 =
                                            ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                              (i_207496 *
                                                                               ctx_param_ext_209246 +
                                                                               i_205764 *
                                                                               ctx_param_ext_209248)];
                                        defunc_0_f_res_205763 =
                                            defunc_0_add_arg_205765;
                                    }
                                    
                                    int64_t binop_p_205766 =
                                            sub64(defunc_0_f_res_205760,
                                                  defunc_0_g_res_205755);
                                    double defunc_0_f_res_205767 =
                                           sitofp_i64_f64(binop_p_205766);
                                    double abs_res_205768 =
                                           fabs(defunc_0_f_res_205767);
                                    double tmp1_205769 = abs_res_205768 /
                                           x_205752;
                                    double x_205770 = tmp1_205769 * tmp1_205769;
                                    double y_205771 = tmp1_205769 * x_205770;
                                    double tmp2_205772 = 1.0 - y_205771;
                                    double x_205773 = tmp2_205772 * tmp2_205772;
                                    double tmp3_205774 = tmp2_205772 * x_205773;
                                    double tmp4_205775 = defunc_0_f_res_205763 *
                                           tmp3_205774;
                                    
                                    ((double *) mem_211437)[i_207467] =
                                        defunc_0_f_res_205767;
                                    ((double *) mem_211440)[i_207467] =
                                        tmp4_205775;
                                }
                                
                                double defunc_2_reduce_res_205782;
                                double defunc_2_reduce_res_205783;
                                double defunc_2_reduce_res_205784;
                                double defunc_2_reduce_res_205785;
                                double defunc_2_reduce_res_205786;
                                double redout_207472;
                                double redout_207473;
                                double redout_207474;
                                double redout_207475;
                                double redout_207476;
                                
                                redout_207472 = 0.0;
                                redout_207473 = 0.0;
                                redout_207474 = 0.0;
                                redout_207475 = 0.0;
                                redout_207476 = 0.0;
                                for (int64_t i_207479 = 0; i_207479 <
                                     q_l_203577; i_207479++) {
                                    double x_205804;
                                    
                                    x_205804 =
                                        ((double *) mem_211437)[i_207479];
                                    
                                    double x_205805;
                                    
                                    x_205805 =
                                        ((double *) mem_211440)[i_207479];
                                    
                                    double defunc_1_f_res_205806 = x_205804 *
                                           x_205805;
                                    double defunc_1_f_res_205807 = x_205804 *
                                           defunc_1_f_res_205806;
                                    double defunc_1_f_res_205808 = x_205804 *
                                           defunc_1_f_res_205807;
                                    double defunc_1_f_res_205809 = x_205804 *
                                           defunc_1_f_res_205808;
                                    double defunc_1_op_res_205791 = x_205805 +
                                           redout_207472;
                                    double defunc_1_op_res_205794 =
                                           defunc_1_f_res_205806 +
                                           redout_207473;
                                    double defunc_1_op_res_205797 =
                                           defunc_1_f_res_205807 +
                                           redout_207474;
                                    double defunc_1_op_res_205800 =
                                           defunc_1_f_res_205808 +
                                           redout_207475;
                                    double defunc_1_op_res_205803 =
                                           defunc_1_f_res_205809 +
                                           redout_207476;
                                    
                                    ((double *) mem_211467)[i_207479] =
                                        defunc_1_f_res_205807;
                                    ((double *) mem_211470)[i_207479] =
                                        defunc_1_f_res_205806;
                                    
                                    double redout_tmp_213717 =
                                           defunc_1_op_res_205791;
                                    double redout_tmp_213718 =
                                           defunc_1_op_res_205794;
                                    double redout_tmp_213719 =
                                           defunc_1_op_res_205797;
                                    double redout_tmp_213720 =
                                           defunc_1_op_res_205800;
                                    double redout_tmp_213721 =
                                           defunc_1_op_res_205803;
                                    
                                    redout_207472 = redout_tmp_213717;
                                    redout_207473 = redout_tmp_213718;
                                    redout_207474 = redout_tmp_213719;
                                    redout_207475 = redout_tmp_213720;
                                    redout_207476 = redout_tmp_213721;
                                }
                                defunc_2_reduce_res_205782 = redout_207472;
                                defunc_2_reduce_res_205783 = redout_207473;
                                defunc_2_reduce_res_205784 = redout_207474;
                                defunc_2_reduce_res_205785 = redout_207475;
                                defunc_2_reduce_res_205786 = redout_207476;
                                
                                double x_205817 = defunc_2_reduce_res_205784 *
                                       defunc_2_reduce_res_205786;
                                double y_205818 = defunc_2_reduce_res_205785 *
                                       defunc_2_reduce_res_205785;
                                double a12_205819 = x_205817 - y_205818;
                                double x_205820 = defunc_2_reduce_res_205784 *
                                       defunc_2_reduce_res_205785;
                                double y_205821 = defunc_2_reduce_res_205783 *
                                       defunc_2_reduce_res_205786;
                                double b12_205822 = x_205820 - y_205821;
                                double x_205823 = defunc_2_reduce_res_205783 *
                                       defunc_2_reduce_res_205785;
                                double y_205824 = defunc_2_reduce_res_205784 *
                                       defunc_2_reduce_res_205784;
                                double c12_205825 = x_205823 - y_205824;
                                double x_205826 = defunc_2_reduce_res_205782 *
                                       defunc_2_reduce_res_205786;
                                double b2_205827 = x_205826 - y_205824;
                                double x_205828 = defunc_2_reduce_res_205783 *
                                       defunc_2_reduce_res_205784;
                                double y_205829 = defunc_2_reduce_res_205782 *
                                       defunc_2_reduce_res_205785;
                                double c2_205830 = x_205828 - y_205829;
                                double x_205831 = defunc_2_reduce_res_205782 *
                                       a12_205819;
                                double y_205832 = defunc_2_reduce_res_205783 *
                                       b12_205822;
                                double x_205833 = x_205831 + y_205832;
                                double y_205834 = defunc_2_reduce_res_205784 *
                                       c12_205825;
                                double y_205835 = x_205833 + y_205834;
                                double det_205836 = 1.0 / y_205835;
                                double a12_205837 = a12_205819 * det_205836;
                                double b12_205838 = b12_205822 * det_205836;
                                double c12_205839 = c12_205825 * det_205836;
                                double b2_205840 = b2_205827 * det_205836;
                                double c2_205841 = c2_205830 * det_205836;
                                double defunc_2_reduce_res_205842;
                                double defunc_2_reduce_res_205843;
                                double redout_207482;
                                double redout_207483;
                                
                                redout_207482 = 0.0;
                                redout_207483 = 0.0;
                                for (int64_t i_207484 = 0; i_207484 <
                                     q_l_203577; i_207484++) {
                                    double x_205851;
                                    
                                    x_205851 =
                                        ((double *) mem_211440)[i_207484];
                                    
                                    double x_205852;
                                    
                                    x_205852 =
                                        ((double *) mem_211470)[i_207484];
                                    
                                    double x_205853;
                                    
                                    x_205853 =
                                        ((double *) mem_211467)[i_207484];
                                    
                                    bool cond_205854 = sle64(n_203572,
                                                             i_207484);
                                    double defunc_0_f_res_205855;
                                    
                                    if (cond_205854) {
                                        defunc_0_f_res_205855 = 0.0;
                                    } else {
                                        int64_t i_205856 = add64(x_205751,
                                                                 i_207484);
                                        double defunc_0_add_arg_205857;
                                        
                                        defunc_0_add_arg_205857 =
                                            ((double *) mem_210914)[i_207496 *
                                                                    n_203572 +
                                                                    i_205856];
                                        defunc_0_f_res_205855 =
                                            defunc_0_add_arg_205857;
                                    }
                                    
                                    double x_205858 = a12_205837 * x_205851;
                                    double y_205859 = b12_205838 * x_205852;
                                    double x_205860 = x_205858 + y_205859;
                                    double y_205861 = c12_205839 * x_205853;
                                    double x_205862 = x_205860 + y_205861;
                                    double defunc_9_fit_fun_res_205863 =
                                           defunc_0_f_res_205855 * x_205862;
                                    double x_205864 = b12_205838 * x_205851;
                                    double y_205865 = b2_205840 * x_205852;
                                    double x_205866 = x_205864 + y_205865;
                                    double y_205867 = c2_205841 * x_205853;
                                    double x_205868 = x_205866 + y_205867;
                                    double defunc_9_slope_fun_res_205869 =
                                           defunc_0_f_res_205855 * x_205868;
                                    double defunc_1_op_res_205846 =
                                           defunc_9_fit_fun_res_205863 +
                                           redout_207482;
                                    double defunc_1_op_res_205849 =
                                           defunc_9_slope_fun_res_205869 +
                                           redout_207483;
                                    double redout_tmp_213724 =
                                           defunc_1_op_res_205846;
                                    double redout_tmp_213725 =
                                           defunc_1_op_res_205849;
                                    
                                    redout_207482 = redout_tmp_213724;
                                    redout_207483 = redout_tmp_213725;
                                }
                                defunc_2_reduce_res_205842 = redout_207482;
                                defunc_2_reduce_res_205843 = redout_207483;
                                ((double *) mem_211388.mem)[i_207496 *
                                                            l_n_m_203733 +
                                                            i_207489] =
                                    defunc_2_reduce_res_205842;
                                ((double *) mem_211392.mem)[i_207496 *
                                                            l_n_m_203733 +
                                                            i_207489] =
                                    defunc_2_reduce_res_205843;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_211541, &mem_211388,
                                         "mem_211388") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_211533, &mem_211392,
                                         "mem_211392") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211392, "mem_211392") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211388, "mem_211388") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_211557, &ext_mem_211541,
                                     "ext_mem_211541") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_211549, &ext_mem_211533,
                                     "ext_mem_211533") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211533,
                                       "ext_mem_211533") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211541,
                                       "ext_mem_211541") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_211573, &ext_mem_211557,
                                 "ext_mem_211557") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_211565, &ext_mem_211549,
                                 "ext_mem_211549") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_211549, "ext_mem_211549") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_211557, "ext_mem_211557") != 0)
                    return 1;
            }
            
            struct memblock ext_mem_211625;
            
            ext_mem_211625.references = NULL;
            if (cond_204197) {
                bool zzero_205873 = jump_l_203583 == (int64_t) 0;
                bool nonzzero_205874 = !zzero_205873;
                bool nonzzero_cert_205875;
                
                if (!nonzzero_205874) {
                    ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                           "division by zero",
                                           "-> #0  loess.fut:547:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:546:3-550:9\n   #5  stl.fut:252:23-75\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:250:15-253:43\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &ext_mem_211625,
                                       "ext_mem_211625") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211565,
                                       "ext_mem_211565") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211573,
                                       "ext_mem_211573") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210740,
                                       "ext_mem_210740") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210626,
                                       "ext_mem_210626") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210637,
                                       "ext_mem_210637") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209272,
                                       "mem_param_209272") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209264,
                                       "mem_param_209264") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212632,
                                       "ext_mem_212632") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212633,
                                       "ext_mem_212633") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209250,
                                       "mem_param_209250") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209242,
                                       "mem_param_209242") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209234,
                                       "mem_param_209234") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212961,
                                       "ext_mem_212961") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212962,
                                       "ext_mem_212962") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212963,
                                       "ext_mem_212963") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t y_205876 = sub64(l_n_m_203733, (int64_t) 1);
                struct memblock mem_211584;
                
                mem_211584.references = NULL;
                if (memblock_alloc(ctx, &mem_211584, bytes_208499,
                                   "mem_211584")) {
                    err = 1;
                    goto cleanup;
                }
                for (int64_t i_207505 = 0; i_207505 < partition_sizze_203667;
                     i_207505++) {
                    for (int64_t i_207501 = 0; i_207501 < n_203572;
                         i_207501++) {
                        int64_t m_v_205882 = sdiv64(i_207501, jump_l_203583);
                        bool cond_205883 = m_v_205882 == y_205876;
                        int64_t j_205884;
                        
                        if (cond_205883) {
                            int64_t j_t_res_205885 = sub64(m_v_205882,
                                                           (int64_t) 1);
                            
                            j_205884 = j_t_res_205885;
                        } else {
                            j_205884 = m_v_205882;
                        }
                        
                        int64_t min_arg_205886 = mul64(jump_l_203583, j_205884);
                        int64_t min_res_205887 = smin64(i_203760,
                                                        min_arg_205886);
                        int64_t defunc_0_m_fun_arg_205888 = add64((int64_t) 1,
                                                                  j_205884);
                        int64_t min_arg_205889 = mul64(jump_l_203583,
                                                       defunc_0_m_fun_arg_205888);
                        int64_t min_res_205890 = smin64(i_203760,
                                                        min_arg_205889);
                        int64_t i64_arg_205891 = sub64(min_res_205890,
                                                       min_res_205887);
                        double i64_res_205892 = sitofp_i64_f64(i64_arg_205891);
                        int64_t i64_arg_205893 = sub64(i_207501,
                                                       min_res_205887);
                        double i64_res_205894 = sitofp_i64_f64(i64_arg_205893);
                        double u_205895 = i64_res_205894 / i64_res_205892;
                        double u2_205896 = u_205895 * u_205895;
                        double u3_205897 = u_205895 * u2_205896;
                        double x_205898 = 2.0 * u3_205897;
                        double y_205899 = 3.0 * u2_205896;
                        double x_205900 = x_205898 - y_205899;
                        double x_205901 = 1.0 + x_205900;
                        bool x_205902 = sle64((int64_t) 0, j_205884);
                        bool y_205903 = slt64(j_205884, l_n_m_203733);
                        bool bounds_check_205904 = x_205902 && y_205903;
                        bool index_certs_205905;
                        
                        if (!bounds_check_205904) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) j_205884,
                                          "] out of bounds for array of shape [",
                                          (long long) l_n_m_203733, "].",
                                          "-> #0  loess.fut:536:27-33\n   #1  loess.fut:549:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:546:3-550:9\n   #6  stl.fut:252:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:250:15-253:43\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &mem_211584,
                                               "mem_211584") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211625,
                                               "ext_mem_211625") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211565,
                                               "ext_mem_211565") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211573,
                                               "ext_mem_211573") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210740,
                                               "ext_mem_210740") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210626,
                                               "ext_mem_210626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210637,
                                               "ext_mem_210637") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209272,
                                               "mem_param_209272") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209264,
                                               "mem_param_209264") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212632,
                                               "ext_mem_212632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212633,
                                               "ext_mem_212633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209250,
                                               "mem_param_209250") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209242,
                                               "mem_param_209242") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209234,
                                               "mem_param_209234") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212961,
                                               "ext_mem_212961") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212962,
                                               "ext_mem_212962") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212963,
                                               "ext_mem_212963") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209226,
                                               "mem_209226") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209222,
                                               "mem_209222") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213477,
                                               "mem_out_213477") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213476,
                                               "mem_out_213476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213475,
                                               "mem_out_213475") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_205906;
                        
                        y_205906 = ((double *) ext_mem_211573.mem)[i_207505 *
                                                                   l_n_m_203733 +
                                                                   j_205884];
                        
                        double x_205907 = x_205901 * y_205906;
                        double x_205908 = y_205899 - x_205898;
                        bool x_205909 = sle64((int64_t) 0,
                                              defunc_0_m_fun_arg_205888);
                        bool y_205910 = slt64(defunc_0_m_fun_arg_205888,
                                              l_n_m_203733);
                        bool bounds_check_205911 = x_205909 && y_205910;
                        bool index_certs_205912;
                        
                        if (!bounds_check_205911) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [",
                                          (long long) defunc_0_m_fun_arg_205888,
                                          "] out of bounds for array of shape [",
                                          (long long) l_n_m_203733, "].",
                                          "-> #0  loess.fut:537:27-37\n   #1  loess.fut:549:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:546:3-550:9\n   #6  stl.fut:252:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:250:15-253:43\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &mem_211584,
                                               "mem_211584") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211625,
                                               "ext_mem_211625") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211565,
                                               "ext_mem_211565") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211573,
                                               "ext_mem_211573") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210740,
                                               "ext_mem_210740") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210626,
                                               "ext_mem_210626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210637,
                                               "ext_mem_210637") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209272,
                                               "mem_param_209272") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209264,
                                               "mem_param_209264") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212632,
                                               "ext_mem_212632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212633,
                                               "ext_mem_212633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209250,
                                               "mem_param_209250") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209242,
                                               "mem_param_209242") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209234,
                                               "mem_param_209234") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212961,
                                               "ext_mem_212961") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212962,
                                               "ext_mem_212962") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212963,
                                               "ext_mem_212963") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209226,
                                               "mem_209226") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209222,
                                               "mem_209222") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213477,
                                               "mem_out_213477") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213476,
                                               "mem_out_213476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213475,
                                               "mem_out_213475") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_205913;
                        
                        y_205913 = ((double *) ext_mem_211573.mem)[i_207505 *
                                                                   l_n_m_203733 +
                                                                   defunc_0_m_fun_arg_205888];
                        
                        double y_205914 = x_205908 * y_205913;
                        double x_205915 = x_205907 + y_205914;
                        double y_205916 = 2.0 * u2_205896;
                        double x_205917 = u3_205897 - y_205916;
                        double x_205918 = u_205895 + x_205917;
                        double y_205919;
                        
                        y_205919 = ((double *) ext_mem_211565.mem)[i_207505 *
                                                                   l_n_m_203733 +
                                                                   j_205884];
                        
                        double x_205920 = x_205918 * y_205919;
                        double y_205921 = i64_res_205892 * x_205920;
                        double x_205922 = x_205915 + y_205921;
                        double x_205923 = u3_205897 - u2_205896;
                        double y_205924;
                        
                        y_205924 = ((double *) ext_mem_211565.mem)[i_207505 *
                                                                   l_n_m_203733 +
                                                                   defunc_0_m_fun_arg_205888];
                        
                        double x_205925 = x_205923 * y_205924;
                        double y_205926 = i64_res_205892 * x_205925;
                        double defunc_4_interpolate_proc_res_205927 = x_205922 +
                               y_205926;
                        
                        ((double *) mem_211584.mem)[i_207505 * n_203572 +
                                                    i_207501] =
                            defunc_4_interpolate_proc_res_205927;
                    }
                }
                if (memblock_set(ctx, &ext_mem_211625, &mem_211584,
                                 "mem_211584") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_211584, "mem_211584") != 0)
                    return 1;
            } else {
                bool dim_match_205928 = n_203572 == l_n_m_203733;
                bool empty_or_match_cert_205929;
                
                if (!dim_match_205928) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Value of (core language) shape (",
                                  (long long) partition_sizze_203667, ", ",
                                  (long long) l_n_m_203733,
                                  ") cannot match shape of type `[",
                                  (long long) partition_sizze_203667, "][",
                                  (long long) n_203572, "]t`.",
                                  "-> #0  stl.fut:255:15-36\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &ext_mem_211625,
                                       "ext_mem_211625") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211565,
                                       "ext_mem_211565") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211573,
                                       "ext_mem_211573") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210740,
                                       "ext_mem_210740") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210626,
                                       "ext_mem_210626") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210637,
                                       "ext_mem_210637") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209272,
                                       "mem_param_209272") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209264,
                                       "mem_param_209264") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212632,
                                       "ext_mem_212632") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212633,
                                       "ext_mem_212633") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209250,
                                       "mem_param_209250") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209242,
                                       "mem_param_209242") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209234,
                                       "mem_param_209234") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212961,
                                       "ext_mem_212961") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212962,
                                       "ext_mem_212962") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212963,
                                       "ext_mem_212963") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                if (memblock_set(ctx, &ext_mem_211625, &ext_mem_211573,
                                 "ext_mem_211573") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_211565, "ext_mem_211565") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_211573, "ext_mem_211573") != 0)
                return 1;
            
            struct memblock mem_211636;
            
            mem_211636.references = NULL;
            if (memblock_alloc(ctx, &mem_211636, bytes_208499, "mem_211636")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_207513 = 0; i_207513 < partition_sizze_203667;
                 i_207513++) {
                for (int64_t i_207509 = 0; i_207509 < n_203572; i_207509++) {
                    int64_t slice_207850 = n_p_203574 + i_207509;
                    double x_205936;
                    
                    x_205936 = ((double *) mem_210751)[i_207513 * C_len_203724 +
                                                       slice_207850];
                    
                    double x_205937;
                    
                    x_205937 = ((double *) ext_mem_211625.mem)[i_207513 *
                                                               ext_211628 +
                                                               i_207509];
                    
                    double defunc_1_f_res_205938 = x_205936 - x_205937;
                    
                    ((double *) mem_211636.mem)[i_207513 * n_203572 +
                                                i_207509] =
                        defunc_1_f_res_205938;
                }
            }
            if (memblock_unref(ctx, &ext_mem_211625, "ext_mem_211625") != 0)
                return 1;
            
            struct memblock ext_mem_212572;
            
            ext_mem_212572.references = NULL;
            
            struct memblock ext_mem_212564;
            
            ext_mem_212564.references = NULL;
            if (cond_204255) {
                bool match_lit_205941 = (int64_t) 0 == d_t_203579;
                int64_t binop_y_211695 = (int64_t) 8 * n_203572;
                int64_t bytes_211696 = smax64((int64_t) 0, binop_y_211695);
                struct memblock ext_mem_212060;
                
                ext_mem_212060.references = NULL;
                
                struct memblock ext_mem_212052;
                
                ext_mem_212052.references = NULL;
                if (match_lit_205941) {
                    struct memblock mem_211680;
                    
                    mem_211680.references = NULL;
                    if (memblock_alloc(ctx, &mem_211680, bytes_209118,
                                       "mem_211680")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213730 = 0; i_213730 <
                         partition_sizze_203667; i_213730++) {
                        for (int64_t i_213731 = 0; i_213731 < t_n_m_203740;
                             i_213731++) {
                            ((double *) mem_211680.mem)[i_213730 *
                                                        t_n_m_203740 +
                                                        i_213731] = 0.0;
                        }
                    }
                    
                    struct memblock mem_211684;
                    
                    mem_211684.references = NULL;
                    if (memblock_alloc(ctx, &mem_211684, bytes_209118,
                                       "mem_211684")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_211697_cached_sizze_213895 <
                        (size_t) bytes_211696) {
                        mem_211697 = realloc(mem_211697, bytes_211696);
                        mem_211697_cached_sizze_213895 = bytes_211696;
                    }
                    if (mem_211712_cached_sizze_213896 <
                        (size_t) bytes_211696) {
                        mem_211712 = realloc(mem_211712, bytes_211696);
                        mem_211712_cached_sizze_213896 = bytes_211696;
                    }
                    if (mem_211715_cached_sizze_213897 <
                        (size_t) bytes_211696) {
                        mem_211715 = realloc(mem_211715, bytes_211696);
                        mem_211715_cached_sizze_213897 = bytes_211696;
                    }
                    for (int64_t i_207536 = 0; i_207536 <
                         partition_sizze_203667; i_207536++) {
                        int64_t x_205951;
                        
                        x_205951 = ((int64_t *) mem_208503)[i_207536];
                        for (int64_t i_207517 = 0; i_207517 < n_203572;
                             i_207517++) {
                            double x_205955;
                            
                            x_205955 = ((double *) mem_208460)[i_207536 *
                                                               n_203572 +
                                                               i_207517];
                            
                            double x_205956;
                            
                            x_205956 = ((double *) mem_211636.mem)[i_207536 *
                                                                   n_203572 +
                                                                   i_207517];
                            
                            double defunc_1_f_res_205957 = x_205955 - x_205956;
                            
                            ((double *) mem_211697)[i_207517] =
                                defunc_1_f_res_205957;
                        }
                        for (int64_t i_207523 = 0; i_207523 < n_203572;
                             i_207523++) {
                            int64_t x_205960;
                            
                            x_205960 = ((int64_t *) mem_208500)[i_207536 *
                                                                n_203572 +
                                                                i_207523];
                            
                            bool cond_205961 = sle64((int64_t) 0, x_205960);
                            double defunc_0_f_res_205962;
                            
                            if (cond_205961) {
                                bool y_205963 = slt64(x_205960, n_203572);
                                bool bounds_check_205964 = cond_205961 &&
                                     y_205963;
                                bool index_certs_205965;
                                
                                if (!bounds_check_205964) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_205960,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_203572, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                    if (memblock_unref(ctx, &mem_211684,
                                                       "mem_211684") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211680,
                                                       "mem_211680") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212052,
                                                       "ext_mem_212052") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212060,
                                                       "ext_mem_212060") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212564,
                                                       "ext_mem_212564") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212572,
                                                       "ext_mem_212572") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211636,
                                                       "mem_211636") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211625,
                                                       "ext_mem_211625") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211565,
                                                       "ext_mem_211565") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211573,
                                                       "ext_mem_211573") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210740,
                                                       "ext_mem_210740") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210626,
                                                       "ext_mem_210626") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210637,
                                                       "ext_mem_210637") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209272,
                                                       "mem_param_209272") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209264,
                                                       "mem_param_209264") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212632,
                                                       "ext_mem_212632") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212633,
                                                       "ext_mem_212633") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209250,
                                                       "mem_param_209250") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209242,
                                                       "mem_param_209242") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209234,
                                                       "mem_param_209234") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212961,
                                                       "ext_mem_212961") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212962,
                                                       "ext_mem_212962") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212963,
                                                       "ext_mem_212963") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209226,
                                                       "mem_209226") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209222,
                                                       "mem_209222") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213477,
                                                       "mem_out_213477") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213476,
                                                       "mem_out_213476") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213475,
                                                       "mem_out_213475") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                double defunc_0_f_res_t_res_205966;
                                
                                defunc_0_f_res_t_res_205966 =
                                    ((double *) mem_211697)[x_205960];
                                defunc_0_f_res_205962 =
                                    defunc_0_f_res_t_res_205966;
                            } else {
                                defunc_0_f_res_205962 = 0.0;
                            }
                            
                            double defunc_0_f_res_205967;
                            
                            if (cond_205961) {
                                bool y_205968 = slt64(x_205960, n_203572);
                                bool bounds_check_205969 = cond_205961 &&
                                     y_205968;
                                bool index_certs_205970;
                                
                                if (!bounds_check_205969) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_205960,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_203572, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                    if (memblock_unref(ctx, &mem_211684,
                                                       "mem_211684") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211680,
                                                       "mem_211680") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212052,
                                                       "ext_mem_212052") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212060,
                                                       "ext_mem_212060") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212564,
                                                       "ext_mem_212564") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212572,
                                                       "ext_mem_212572") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211636,
                                                       "mem_211636") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211625,
                                                       "ext_mem_211625") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211565,
                                                       "ext_mem_211565") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211573,
                                                       "ext_mem_211573") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210740,
                                                       "ext_mem_210740") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210626,
                                                       "ext_mem_210626") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210637,
                                                       "ext_mem_210637") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209272,
                                                       "mem_param_209272") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209264,
                                                       "mem_param_209264") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212632,
                                                       "ext_mem_212632") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212633,
                                                       "ext_mem_212633") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209250,
                                                       "mem_param_209250") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209242,
                                                       "mem_param_209242") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209234,
                                                       "mem_param_209234") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212961,
                                                       "ext_mem_212961") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212962,
                                                       "ext_mem_212962") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212963,
                                                       "ext_mem_212963") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209226,
                                                       "mem_209226") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209222,
                                                       "mem_209222") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213477,
                                                       "mem_out_213477") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213476,
                                                       "mem_out_213476") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213475,
                                                       "mem_out_213475") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                double defunc_0_f_res_t_res_205971;
                                
                                defunc_0_f_res_t_res_205971 =
                                    ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                      (i_207536 *
                                                                       ctx_param_ext_209246 +
                                                                       x_205960 *
                                                                       ctx_param_ext_209248)];
                                defunc_0_f_res_205967 =
                                    defunc_0_f_res_t_res_205971;
                            } else {
                                defunc_0_f_res_205967 = 0.0;
                            }
                            ((double *) mem_211712)[i_207523] =
                                defunc_0_f_res_205967;
                            ((double *) mem_211715)[i_207523] =
                                defunc_0_f_res_205962;
                        }
                        for (int64_t i_207532 = 0; i_207532 < t_n_m_203740;
                             i_207532++) {
                            int64_t x_205974;
                            
                            x_205974 = ((int64_t *) mem_209119)[i_207536 *
                                                                t_n_m_203740 +
                                                                i_207532];
                            
                            double x_205975;
                            
                            x_205975 = ((double *) mem_209123)[i_207536 *
                                                               t_n_m_203740 +
                                                               i_207532];
                            
                            int64_t min_arg_205976 = mul64(jump_t_203582,
                                                           i_207532);
                            int64_t min_res_205977 = smin64(i_203760,
                                                            min_arg_205976);
                            int64_t defunc_0_g_res_205978 = add64((int64_t) 1,
                                                                  min_res_205977);
                            double defunc_2_reduce_res_205979;
                            double redout_207526 = 0.0;
                            
                            for (int64_t i_207527 = 0; i_207527 < q_t_203576;
                                 i_207527++) {
                                bool cond_205984 = sle64(x_205951, i_207527);
                                int64_t defunc_0_f_res_205985;
                                
                                if (cond_205984) {
                                    defunc_0_f_res_205985 = (int64_t) 0;
                                } else {
                                    int64_t i_205986 = add64(x_205974,
                                                             i_207527);
                                    int64_t defunc_0_add_arg_205987;
                                    
                                    defunc_0_add_arg_205987 =
                                        ((int64_t *) mem_208500)[i_207536 *
                                                                 n_203572 +
                                                                 i_205986];
                                    
                                    int64_t defunc_1_add_res_205988 =
                                            add64((int64_t) 1,
                                                  defunc_0_add_arg_205987);
                                    
                                    defunc_0_f_res_205985 =
                                        defunc_1_add_res_205988;
                                }
                                
                                double defunc_0_f_res_205989;
                                
                                if (cond_205984) {
                                    defunc_0_f_res_205989 = 0.0;
                                } else {
                                    int64_t i_205990 = add64(x_205974,
                                                             i_207527);
                                    double defunc_0_add_arg_205991;
                                    
                                    defunc_0_add_arg_205991 =
                                        ((double *) mem_211712)[i_205990];
                                    defunc_0_f_res_205989 =
                                        defunc_0_add_arg_205991;
                                }
                                
                                int64_t binop_p_205992 =
                                        sub64(defunc_0_f_res_205985,
                                              defunc_0_g_res_205978);
                                double defunc_0_f_res_205993 =
                                       sitofp_i64_f64(binop_p_205992);
                                double abs_res_205994 =
                                       fabs(defunc_0_f_res_205993);
                                double tmp1_205995 = abs_res_205994 / x_205975;
                                double x_205996 = tmp1_205995 * tmp1_205995;
                                double y_205997 = tmp1_205995 * x_205996;
                                double tmp2_205998 = 1.0 - y_205997;
                                double x_205999 = tmp2_205998 * tmp2_205998;
                                double tmp3_206000 = tmp2_205998 * x_205999;
                                double w_j_206001 = defunc_0_f_res_205989 *
                                       tmp3_206000;
                                double defunc_1_op_res_205982 = w_j_206001 +
                                       redout_207526;
                                double redout_tmp_213737 =
                                       defunc_1_op_res_205982;
                                
                                redout_207526 = redout_tmp_213737;
                            }
                            defunc_2_reduce_res_205979 = redout_207526;
                            
                            double a0_206002 = 1.0 / defunc_2_reduce_res_205979;
                            double defunc_2_reduce_res_206003;
                            double redout_207528 = 0.0;
                            
                            for (int64_t i_207529 = 0; i_207529 < q_t_203576;
                                 i_207529++) {
                                bool cond_206008 = sle64(x_205951, i_207529);
                                int64_t defunc_0_f_res_206009;
                                
                                if (cond_206008) {
                                    defunc_0_f_res_206009 = (int64_t) 0;
                                } else {
                                    int64_t i_206010 = add64(x_205974,
                                                             i_207529);
                                    int64_t defunc_0_add_arg_206011;
                                    
                                    defunc_0_add_arg_206011 =
                                        ((int64_t *) mem_208500)[i_207536 *
                                                                 n_203572 +
                                                                 i_206010];
                                    
                                    int64_t defunc_1_add_res_206012 =
                                            add64((int64_t) 1,
                                                  defunc_0_add_arg_206011);
                                    
                                    defunc_0_f_res_206009 =
                                        defunc_1_add_res_206012;
                                }
                                
                                double defunc_0_f_res_206013;
                                
                                if (cond_206008) {
                                    defunc_0_f_res_206013 = 0.0;
                                } else {
                                    int64_t i_206014 = add64(x_205974,
                                                             i_207529);
                                    double defunc_0_add_arg_206015;
                                    
                                    defunc_0_add_arg_206015 =
                                        ((double *) mem_211712)[i_206014];
                                    defunc_0_f_res_206013 =
                                        defunc_0_add_arg_206015;
                                }
                                
                                int64_t binop_p_206016 =
                                        sub64(defunc_0_f_res_206009,
                                              defunc_0_g_res_205978);
                                double defunc_0_f_res_206017 =
                                       sitofp_i64_f64(binop_p_206016);
                                double abs_res_206018 =
                                       fabs(defunc_0_f_res_206017);
                                double tmp1_206019 = abs_res_206018 / x_205975;
                                double x_206020 = tmp1_206019 * tmp1_206019;
                                double y_206021 = tmp1_206019 * x_206020;
                                double tmp2_206022 = 1.0 - y_206021;
                                double x_206023 = tmp2_206022 * tmp2_206022;
                                double tmp3_206024 = tmp2_206022 * x_206023;
                                double tmp4_206025 = defunc_0_f_res_206013 *
                                       tmp3_206024;
                                double defunc_0_f_res_206026;
                                
                                if (cond_206008) {
                                    defunc_0_f_res_206026 = 0.0;
                                } else {
                                    int64_t i_206027 = add64(x_205974,
                                                             i_207529);
                                    double defunc_0_add_arg_206028;
                                    
                                    defunc_0_add_arg_206028 =
                                        ((double *) mem_211715)[i_206027];
                                    defunc_0_f_res_206026 =
                                        defunc_0_add_arg_206028;
                                }
                                
                                double x_206029 = a0_206002 * tmp4_206025;
                                double defunc_9_fit_fun_res_206030 =
                                       defunc_0_f_res_206026 * x_206029;
                                double defunc_1_op_res_206006 =
                                       defunc_9_fit_fun_res_206030 +
                                       redout_207528;
                                double redout_tmp_213738 =
                                       defunc_1_op_res_206006;
                                
                                redout_207528 = redout_tmp_213738;
                            }
                            defunc_2_reduce_res_206003 = redout_207528;
                            ((double *) mem_211684.mem)[i_207536 *
                                                        t_n_m_203740 +
                                                        i_207532] =
                                defunc_2_reduce_res_206003;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_212060, &mem_211684,
                                     "mem_211684") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_212052, &mem_211680,
                                     "mem_211680") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211684, "mem_211684") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211680, "mem_211680") != 0)
                        return 1;
                } else {
                    bool match_lit_206033 = (int64_t) 1 == d_t_203579;
                    int64_t binop_y_211798 = (int64_t) 8 * n_203572;
                    int64_t bytes_211799 = smax64((int64_t) 0, binop_y_211798);
                    int64_t binop_y_211931 = (int64_t) 8 * n_203572;
                    int64_t bytes_211932 = smax64((int64_t) 0, binop_y_211931);
                    struct memblock ext_mem_212044;
                    
                    ext_mem_212044.references = NULL;
                    
                    struct memblock ext_mem_212036;
                    
                    ext_mem_212036.references = NULL;
                    if (match_lit_206033) {
                        struct memblock mem_211773;
                        
                        mem_211773.references = NULL;
                        if (memblock_alloc(ctx, &mem_211773, bytes_209118,
                                           "mem_211773")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_211777;
                        
                        mem_211777.references = NULL;
                        if (memblock_alloc(ctx, &mem_211777, bytes_209118,
                                           "mem_211777")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_211800_cached_sizze_213898 <
                            (size_t) bytes_211799) {
                            mem_211800 = realloc(mem_211800, bytes_211799);
                            mem_211800_cached_sizze_213898 = bytes_211799;
                        }
                        if (mem_211815_cached_sizze_213899 <
                            (size_t) bytes_211799) {
                            mem_211815 = realloc(mem_211815, bytes_211799);
                            mem_211815_cached_sizze_213899 = bytes_211799;
                        }
                        if (mem_211818_cached_sizze_213900 <
                            (size_t) bytes_211799) {
                            mem_211818 = realloc(mem_211818, bytes_211799);
                            mem_211818_cached_sizze_213900 = bytes_211799;
                        }
                        for (int64_t i_207567 = 0; i_207567 <
                             partition_sizze_203667; i_207567++) {
                            int64_t x_206043;
                            
                            x_206043 = ((int64_t *) mem_208503)[i_207567];
                            for (int64_t i_207540 = 0; i_207540 < n_203572;
                                 i_207540++) {
                                double x_206047;
                                
                                x_206047 = ((double *) mem_208460)[i_207567 *
                                                                   n_203572 +
                                                                   i_207540];
                                
                                double x_206048;
                                
                                x_206048 =
                                    ((double *) mem_211636.mem)[i_207567 *
                                                                n_203572 +
                                                                i_207540];
                                
                                double defunc_1_f_res_206049 = x_206047 -
                                       x_206048;
                                
                                ((double *) mem_211800)[i_207540] =
                                    defunc_1_f_res_206049;
                            }
                            for (int64_t i_207546 = 0; i_207546 < n_203572;
                                 i_207546++) {
                                int64_t x_206052;
                                
                                x_206052 = ((int64_t *) mem_208500)[i_207567 *
                                                                    n_203572 +
                                                                    i_207546];
                                
                                bool cond_206053 = sle64((int64_t) 0, x_206052);
                                double defunc_0_f_res_206054;
                                
                                if (cond_206053) {
                                    bool y_206055 = slt64(x_206052, n_203572);
                                    bool bounds_check_206056 = cond_206053 &&
                                         y_206055;
                                    bool index_certs_206057;
                                    
                                    if (!bounds_check_206056) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206052,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203572,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_211777,
                                                           "mem_211777") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211773,
                                                           "mem_211773") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212036,
                                                           "ext_mem_212036") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212044,
                                                           "ext_mem_212044") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212052,
                                                           "ext_mem_212052") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212060,
                                                           "ext_mem_212060") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212564,
                                                           "ext_mem_212564") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212572,
                                                           "ext_mem_212572") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211636,
                                                           "mem_211636") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211625,
                                                           "ext_mem_211625") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211565,
                                                           "ext_mem_211565") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211573,
                                                           "ext_mem_211573") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206058;
                                    
                                    defunc_0_f_res_t_res_206058 =
                                        ((double *) mem_211800)[x_206052];
                                    defunc_0_f_res_206054 =
                                        defunc_0_f_res_t_res_206058;
                                } else {
                                    defunc_0_f_res_206054 = 0.0;
                                }
                                
                                double defunc_0_f_res_206059;
                                
                                if (cond_206053) {
                                    bool y_206060 = slt64(x_206052, n_203572);
                                    bool bounds_check_206061 = cond_206053 &&
                                         y_206060;
                                    bool index_certs_206062;
                                    
                                    if (!bounds_check_206061) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206052,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203572,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_211777,
                                                           "mem_211777") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211773,
                                                           "mem_211773") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212036,
                                                           "ext_mem_212036") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212044,
                                                           "ext_mem_212044") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212052,
                                                           "ext_mem_212052") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212060,
                                                           "ext_mem_212060") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212564,
                                                           "ext_mem_212564") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212572,
                                                           "ext_mem_212572") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211636,
                                                           "mem_211636") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211625,
                                                           "ext_mem_211625") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211565,
                                                           "ext_mem_211565") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211573,
                                                           "ext_mem_211573") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206063;
                                    
                                    defunc_0_f_res_t_res_206063 =
                                        ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                          (i_207567 *
                                                                           ctx_param_ext_209246 +
                                                                           x_206052 *
                                                                           ctx_param_ext_209248)];
                                    defunc_0_f_res_206059 =
                                        defunc_0_f_res_t_res_206063;
                                } else {
                                    defunc_0_f_res_206059 = 0.0;
                                }
                                ((double *) mem_211815)[i_207546] =
                                    defunc_0_f_res_206059;
                                ((double *) mem_211818)[i_207546] =
                                    defunc_0_f_res_206054;
                            }
                            for (int64_t i_207560 = 0; i_207560 < t_n_m_203740;
                                 i_207560++) {
                                int64_t x_206067;
                                
                                x_206067 = ((int64_t *) mem_209119)[i_207567 *
                                                                    t_n_m_203740 +
                                                                    i_207560];
                                
                                double x_206068;
                                
                                x_206068 = ((double *) mem_209123)[i_207567 *
                                                                   t_n_m_203740 +
                                                                   i_207560];
                                
                                int64_t min_arg_206069 = mul64(jump_t_203582,
                                                               i_207560);
                                int64_t min_res_206070 = smin64(i_203760,
                                                                min_arg_206069);
                                int64_t defunc_0_g_res_206071 =
                                        add64((int64_t) 1, min_res_206070);
                                double defunc_2_reduce_res_206072;
                                double defunc_2_reduce_res_206073;
                                double defunc_2_reduce_res_206074;
                                double redout_207549;
                                double redout_207550;
                                double redout_207551;
                                
                                redout_207549 = 0.0;
                                redout_207550 = 0.0;
                                redout_207551 = 0.0;
                                for (int64_t i_207552 = 0; i_207552 <
                                     q_t_203576; i_207552++) {
                                    bool cond_206085 = sle64(x_206043,
                                                             i_207552);
                                    int64_t defunc_0_f_res_206086;
                                    
                                    if (cond_206085) {
                                        defunc_0_f_res_206086 = (int64_t) 0;
                                    } else {
                                        int64_t i_206087 = add64(x_206067,
                                                                 i_207552);
                                        int64_t defunc_0_add_arg_206088;
                                        
                                        defunc_0_add_arg_206088 =
                                            ((int64_t *) mem_208500)[i_207567 *
                                                                     n_203572 +
                                                                     i_206087];
                                        
                                        int64_t defunc_1_add_res_206089 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_206088);
                                        
                                        defunc_0_f_res_206086 =
                                            defunc_1_add_res_206089;
                                    }
                                    
                                    double defunc_0_f_res_206090;
                                    
                                    if (cond_206085) {
                                        defunc_0_f_res_206090 = 0.0;
                                    } else {
                                        int64_t i_206091 = add64(x_206067,
                                                                 i_207552);
                                        double defunc_0_add_arg_206092;
                                        
                                        defunc_0_add_arg_206092 =
                                            ((double *) mem_211815)[i_206091];
                                        defunc_0_f_res_206090 =
                                            defunc_0_add_arg_206092;
                                    }
                                    
                                    int64_t binop_p_206093 =
                                            sub64(defunc_0_f_res_206086,
                                                  defunc_0_g_res_206071);
                                    double defunc_0_f_res_206094 =
                                           sitofp_i64_f64(binop_p_206093);
                                    double abs_res_206095 =
                                           fabs(defunc_0_f_res_206094);
                                    double tmp1_206096 = abs_res_206095 /
                                           x_206068;
                                    double x_206097 = tmp1_206096 * tmp1_206096;
                                    double y_206098 = tmp1_206096 * x_206097;
                                    double tmp2_206099 = 1.0 - y_206098;
                                    double x_206100 = tmp2_206099 * tmp2_206099;
                                    double tmp3_206101 = tmp2_206099 * x_206100;
                                    double w_j_206102 = defunc_0_f_res_206090 *
                                           tmp3_206101;
                                    double xw_j_206103 = defunc_0_f_res_206094 *
                                           w_j_206102;
                                    double x2w_j_206104 =
                                           defunc_0_f_res_206094 * xw_j_206103;
                                    double defunc_1_op_res_206077 = w_j_206102 +
                                           redout_207549;
                                    double defunc_1_op_res_206080 =
                                           xw_j_206103 + redout_207550;
                                    double defunc_1_op_res_206083 =
                                           x2w_j_206104 + redout_207551;
                                    double redout_tmp_213746 =
                                           defunc_1_op_res_206077;
                                    double redout_tmp_213747 =
                                           defunc_1_op_res_206080;
                                    double redout_tmp_213748 =
                                           defunc_1_op_res_206083;
                                    
                                    redout_207549 = redout_tmp_213746;
                                    redout_207550 = redout_tmp_213747;
                                    redout_207551 = redout_tmp_213748;
                                }
                                defunc_2_reduce_res_206072 = redout_207549;
                                defunc_2_reduce_res_206073 = redout_207550;
                                defunc_2_reduce_res_206074 = redout_207551;
                                
                                double x_206105 = defunc_2_reduce_res_206072 *
                                       defunc_2_reduce_res_206074;
                                double y_206106 = defunc_2_reduce_res_206073 *
                                       defunc_2_reduce_res_206073;
                                double y_206107 = x_206105 - y_206106;
                                double det1_206108 = 1.0 / y_206107;
                                double a11_206109 = defunc_2_reduce_res_206074 *
                                       det1_206108;
                                double x_206110 = 0.0 -
                                       defunc_2_reduce_res_206073;
                                double b11_206111 = det1_206108 * x_206110;
                                double c11_206112 = defunc_2_reduce_res_206072 *
                                       det1_206108;
                                double defunc_2_reduce_res_206113;
                                double defunc_2_reduce_res_206114;
                                double redout_207553;
                                double redout_207554;
                                
                                redout_207553 = 0.0;
                                redout_207554 = 0.0;
                                for (int64_t i_207555 = 0; i_207555 <
                                     q_t_203576; i_207555++) {
                                    bool cond_206122 = sle64(x_206043,
                                                             i_207555);
                                    int64_t defunc_0_f_res_206123;
                                    
                                    if (cond_206122) {
                                        defunc_0_f_res_206123 = (int64_t) 0;
                                    } else {
                                        int64_t i_206124 = add64(x_206067,
                                                                 i_207555);
                                        int64_t defunc_0_add_arg_206125;
                                        
                                        defunc_0_add_arg_206125 =
                                            ((int64_t *) mem_208500)[i_207567 *
                                                                     n_203572 +
                                                                     i_206124];
                                        
                                        int64_t defunc_1_add_res_206126 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_206125);
                                        
                                        defunc_0_f_res_206123 =
                                            defunc_1_add_res_206126;
                                    }
                                    
                                    double defunc_0_f_res_206127;
                                    
                                    if (cond_206122) {
                                        defunc_0_f_res_206127 = 0.0;
                                    } else {
                                        int64_t i_206128 = add64(x_206067,
                                                                 i_207555);
                                        double defunc_0_add_arg_206129;
                                        
                                        defunc_0_add_arg_206129 =
                                            ((double *) mem_211815)[i_206128];
                                        defunc_0_f_res_206127 =
                                            defunc_0_add_arg_206129;
                                    }
                                    
                                    int64_t binop_p_206130 =
                                            sub64(defunc_0_f_res_206123,
                                                  defunc_0_g_res_206071);
                                    double defunc_0_f_res_206131 =
                                           sitofp_i64_f64(binop_p_206130);
                                    double abs_res_206132 =
                                           fabs(defunc_0_f_res_206131);
                                    double tmp1_206133 = abs_res_206132 /
                                           x_206068;
                                    double x_206134 = tmp1_206133 * tmp1_206133;
                                    double y_206135 = tmp1_206133 * x_206134;
                                    double tmp2_206136 = 1.0 - y_206135;
                                    double x_206137 = tmp2_206136 * tmp2_206136;
                                    double tmp3_206138 = tmp2_206136 * x_206137;
                                    double tmp4_206139 = defunc_0_f_res_206127 *
                                           tmp3_206138;
                                    double defunc_1_f_res_206140 =
                                           defunc_0_f_res_206131 * tmp4_206139;
                                    double defunc_0_f_res_206141;
                                    
                                    if (cond_206122) {
                                        defunc_0_f_res_206141 = 0.0;
                                    } else {
                                        int64_t i_206142 = add64(x_206067,
                                                                 i_207555);
                                        double defunc_0_add_arg_206143;
                                        
                                        defunc_0_add_arg_206143 =
                                            ((double *) mem_211818)[i_206142];
                                        defunc_0_f_res_206141 =
                                            defunc_0_add_arg_206143;
                                    }
                                    
                                    double x_206144 = a11_206109 * tmp4_206139;
                                    double y_206145 = b11_206111 *
                                           defunc_1_f_res_206140;
                                    double x_206146 = x_206144 + y_206145;
                                    double defunc_9_fit_fun_res_206147 =
                                           defunc_0_f_res_206141 * x_206146;
                                    double x_206148 = b11_206111 * tmp4_206139;
                                    double y_206149 = c11_206112 *
                                           defunc_1_f_res_206140;
                                    double x_206150 = x_206148 + y_206149;
                                    double defunc_9_slope_fun_res_206151 =
                                           defunc_0_f_res_206141 * x_206150;
                                    double defunc_1_op_res_206117 =
                                           defunc_9_fit_fun_res_206147 +
                                           redout_207553;
                                    double defunc_1_op_res_206120 =
                                           defunc_9_slope_fun_res_206151 +
                                           redout_207554;
                                    double redout_tmp_213749 =
                                           defunc_1_op_res_206117;
                                    double redout_tmp_213750 =
                                           defunc_1_op_res_206120;
                                    
                                    redout_207553 = redout_tmp_213749;
                                    redout_207554 = redout_tmp_213750;
                                }
                                defunc_2_reduce_res_206113 = redout_207553;
                                defunc_2_reduce_res_206114 = redout_207554;
                                ((double *) mem_211773.mem)[i_207567 *
                                                            t_n_m_203740 +
                                                            i_207560] =
                                    defunc_2_reduce_res_206113;
                                ((double *) mem_211777.mem)[i_207567 *
                                                            t_n_m_203740 +
                                                            i_207560] =
                                    defunc_2_reduce_res_206114;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_212044, &mem_211773,
                                         "mem_211773") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_212036, &mem_211777,
                                         "mem_211777") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211777, "mem_211777") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211773, "mem_211773") != 0)
                            return 1;
                    } else {
                        struct memblock mem_211906;
                        
                        mem_211906.references = NULL;
                        if (memblock_alloc(ctx, &mem_211906, bytes_209118,
                                           "mem_211906")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_211910;
                        
                        mem_211910.references = NULL;
                        if (memblock_alloc(ctx, &mem_211910, bytes_209118,
                                           "mem_211910")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_211933_cached_sizze_213901 <
                            (size_t) bytes_211932) {
                            mem_211933 = realloc(mem_211933, bytes_211932);
                            mem_211933_cached_sizze_213901 = bytes_211932;
                        }
                        if (mem_211948_cached_sizze_213902 <
                            (size_t) bytes_211932) {
                            mem_211948 = realloc(mem_211948, bytes_211932);
                            mem_211948_cached_sizze_213902 = bytes_211932;
                        }
                        if (mem_211951_cached_sizze_213903 <
                            (size_t) bytes_211932) {
                            mem_211951 = realloc(mem_211951, bytes_211932);
                            mem_211951_cached_sizze_213903 = bytes_211932;
                        }
                        for (int64_t i_207601 = 0; i_207601 <
                             partition_sizze_203667; i_207601++) {
                            int64_t x_206161;
                            
                            x_206161 = ((int64_t *) mem_208503)[i_207601];
                            for (int64_t i_207572 = 0; i_207572 < n_203572;
                                 i_207572++) {
                                double x_206165;
                                
                                x_206165 = ((double *) mem_208460)[i_207601 *
                                                                   n_203572 +
                                                                   i_207572];
                                
                                double x_206166;
                                
                                x_206166 =
                                    ((double *) mem_211636.mem)[i_207601 *
                                                                n_203572 +
                                                                i_207572];
                                
                                double defunc_1_f_res_206167 = x_206165 -
                                       x_206166;
                                
                                ((double *) mem_211933)[i_207572] =
                                    defunc_1_f_res_206167;
                            }
                            for (int64_t i_207578 = 0; i_207578 < n_203572;
                                 i_207578++) {
                                int64_t x_206170;
                                
                                x_206170 = ((int64_t *) mem_208500)[i_207601 *
                                                                    n_203572 +
                                                                    i_207578];
                                
                                bool cond_206171 = sle64((int64_t) 0, x_206170);
                                double defunc_0_f_res_206172;
                                
                                if (cond_206171) {
                                    bool y_206173 = slt64(x_206170, n_203572);
                                    bool bounds_check_206174 = cond_206171 &&
                                         y_206173;
                                    bool index_certs_206175;
                                    
                                    if (!bounds_check_206174) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206170,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203572,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_211910,
                                                           "mem_211910") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211906,
                                                           "mem_211906") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212036,
                                                           "ext_mem_212036") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212044,
                                                           "ext_mem_212044") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212052,
                                                           "ext_mem_212052") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212060,
                                                           "ext_mem_212060") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212564,
                                                           "ext_mem_212564") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212572,
                                                           "ext_mem_212572") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211636,
                                                           "mem_211636") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211625,
                                                           "ext_mem_211625") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211565,
                                                           "ext_mem_211565") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211573,
                                                           "ext_mem_211573") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206176;
                                    
                                    defunc_0_f_res_t_res_206176 =
                                        ((double *) mem_211933)[x_206170];
                                    defunc_0_f_res_206172 =
                                        defunc_0_f_res_t_res_206176;
                                } else {
                                    defunc_0_f_res_206172 = 0.0;
                                }
                                
                                double defunc_0_f_res_206177;
                                
                                if (cond_206171) {
                                    bool y_206178 = slt64(x_206170, n_203572);
                                    bool bounds_check_206179 = cond_206171 &&
                                         y_206178;
                                    bool index_certs_206180;
                                    
                                    if (!bounds_check_206179) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206170,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203572,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_211910,
                                                           "mem_211910") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211906,
                                                           "mem_211906") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212036,
                                                           "ext_mem_212036") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212044,
                                                           "ext_mem_212044") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212052,
                                                           "ext_mem_212052") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212060,
                                                           "ext_mem_212060") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212564,
                                                           "ext_mem_212564") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212572,
                                                           "ext_mem_212572") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211636,
                                                           "mem_211636") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211625,
                                                           "ext_mem_211625") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211565,
                                                           "ext_mem_211565") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211573,
                                                           "ext_mem_211573") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206181;
                                    
                                    defunc_0_f_res_t_res_206181 =
                                        ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                          (i_207601 *
                                                                           ctx_param_ext_209246 +
                                                                           x_206170 *
                                                                           ctx_param_ext_209248)];
                                    defunc_0_f_res_206177 =
                                        defunc_0_f_res_t_res_206181;
                                } else {
                                    defunc_0_f_res_206177 = 0.0;
                                }
                                ((double *) mem_211948)[i_207578] =
                                    defunc_0_f_res_206177;
                                ((double *) mem_211951)[i_207578] =
                                    defunc_0_f_res_206172;
                            }
                            for (int64_t i_207594 = 0; i_207594 < t_n_m_203740;
                                 i_207594++) {
                                int64_t x_206185;
                                
                                x_206185 = ((int64_t *) mem_209119)[i_207601 *
                                                                    t_n_m_203740 +
                                                                    i_207594];
                                
                                double x_206186;
                                
                                x_206186 = ((double *) mem_209123)[i_207601 *
                                                                   t_n_m_203740 +
                                                                   i_207594];
                                
                                int64_t min_arg_206187 = mul64(jump_t_203582,
                                                               i_207594);
                                int64_t min_res_206188 = smin64(i_203760,
                                                                min_arg_206187);
                                int64_t defunc_0_g_res_206189 =
                                        add64((int64_t) 1, min_res_206188);
                                double defunc_2_reduce_res_206190;
                                double defunc_2_reduce_res_206191;
                                double defunc_2_reduce_res_206192;
                                double defunc_2_reduce_res_206193;
                                double defunc_2_reduce_res_206194;
                                double redout_207581;
                                double redout_207582;
                                double redout_207583;
                                double redout_207584;
                                double redout_207585;
                                
                                redout_207581 = 0.0;
                                redout_207582 = 0.0;
                                redout_207583 = 0.0;
                                redout_207584 = 0.0;
                                redout_207585 = 0.0;
                                for (int64_t i_207586 = 0; i_207586 <
                                     q_t_203576; i_207586++) {
                                    bool cond_206211 = sle64(x_206161,
                                                             i_207586);
                                    int64_t defunc_0_f_res_206212;
                                    
                                    if (cond_206211) {
                                        defunc_0_f_res_206212 = (int64_t) 0;
                                    } else {
                                        int64_t i_206213 = add64(x_206185,
                                                                 i_207586);
                                        int64_t defunc_0_add_arg_206214;
                                        
                                        defunc_0_add_arg_206214 =
                                            ((int64_t *) mem_208500)[i_207601 *
                                                                     n_203572 +
                                                                     i_206213];
                                        
                                        int64_t defunc_1_add_res_206215 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_206214);
                                        
                                        defunc_0_f_res_206212 =
                                            defunc_1_add_res_206215;
                                    }
                                    
                                    double defunc_0_f_res_206216;
                                    
                                    if (cond_206211) {
                                        defunc_0_f_res_206216 = 0.0;
                                    } else {
                                        int64_t i_206217 = add64(x_206185,
                                                                 i_207586);
                                        double defunc_0_add_arg_206218;
                                        
                                        defunc_0_add_arg_206218 =
                                            ((double *) mem_211948)[i_206217];
                                        defunc_0_f_res_206216 =
                                            defunc_0_add_arg_206218;
                                    }
                                    
                                    int64_t binop_p_206219 =
                                            sub64(defunc_0_f_res_206212,
                                                  defunc_0_g_res_206189);
                                    double defunc_0_f_res_206220 =
                                           sitofp_i64_f64(binop_p_206219);
                                    double abs_res_206221 =
                                           fabs(defunc_0_f_res_206220);
                                    double tmp1_206222 = abs_res_206221 /
                                           x_206186;
                                    double x_206223 = tmp1_206222 * tmp1_206222;
                                    double y_206224 = tmp1_206222 * x_206223;
                                    double tmp2_206225 = 1.0 - y_206224;
                                    double x_206226 = tmp2_206225 * tmp2_206225;
                                    double tmp3_206227 = tmp2_206225 * x_206226;
                                    double w_j_206228 = defunc_0_f_res_206216 *
                                           tmp3_206227;
                                    double xw_j_206229 = defunc_0_f_res_206220 *
                                           w_j_206228;
                                    double x2w_j_206230 =
                                           defunc_0_f_res_206220 * xw_j_206229;
                                    double x3w_j_206231 =
                                           defunc_0_f_res_206220 * x2w_j_206230;
                                    double x4w_j_206232 =
                                           defunc_0_f_res_206220 * x3w_j_206231;
                                    double defunc_1_op_res_206197 = w_j_206228 +
                                           redout_207581;
                                    double defunc_1_op_res_206200 =
                                           xw_j_206229 + redout_207582;
                                    double defunc_1_op_res_206203 =
                                           x2w_j_206230 + redout_207583;
                                    double defunc_1_op_res_206206 =
                                           x3w_j_206231 + redout_207584;
                                    double defunc_1_op_res_206209 =
                                           x4w_j_206232 + redout_207585;
                                    double redout_tmp_213758 =
                                           defunc_1_op_res_206197;
                                    double redout_tmp_213759 =
                                           defunc_1_op_res_206200;
                                    double redout_tmp_213760 =
                                           defunc_1_op_res_206203;
                                    double redout_tmp_213761 =
                                           defunc_1_op_res_206206;
                                    double redout_tmp_213762 =
                                           defunc_1_op_res_206209;
                                    
                                    redout_207581 = redout_tmp_213758;
                                    redout_207582 = redout_tmp_213759;
                                    redout_207583 = redout_tmp_213760;
                                    redout_207584 = redout_tmp_213761;
                                    redout_207585 = redout_tmp_213762;
                                }
                                defunc_2_reduce_res_206190 = redout_207581;
                                defunc_2_reduce_res_206191 = redout_207582;
                                defunc_2_reduce_res_206192 = redout_207583;
                                defunc_2_reduce_res_206193 = redout_207584;
                                defunc_2_reduce_res_206194 = redout_207585;
                                
                                double x_206233 = defunc_2_reduce_res_206192 *
                                       defunc_2_reduce_res_206194;
                                double y_206234 = defunc_2_reduce_res_206193 *
                                       defunc_2_reduce_res_206193;
                                double a12_206235 = x_206233 - y_206234;
                                double x_206236 = defunc_2_reduce_res_206192 *
                                       defunc_2_reduce_res_206193;
                                double y_206237 = defunc_2_reduce_res_206191 *
                                       defunc_2_reduce_res_206194;
                                double b12_206238 = x_206236 - y_206237;
                                double x_206239 = defunc_2_reduce_res_206191 *
                                       defunc_2_reduce_res_206193;
                                double y_206240 = defunc_2_reduce_res_206192 *
                                       defunc_2_reduce_res_206192;
                                double c12_206241 = x_206239 - y_206240;
                                double x_206242 = defunc_2_reduce_res_206190 *
                                       defunc_2_reduce_res_206194;
                                double b2_206243 = x_206242 - y_206240;
                                double x_206244 = defunc_2_reduce_res_206191 *
                                       defunc_2_reduce_res_206192;
                                double y_206245 = defunc_2_reduce_res_206190 *
                                       defunc_2_reduce_res_206193;
                                double c2_206246 = x_206244 - y_206245;
                                double x_206247 = defunc_2_reduce_res_206190 *
                                       a12_206235;
                                double y_206248 = defunc_2_reduce_res_206191 *
                                       b12_206238;
                                double x_206249 = x_206247 + y_206248;
                                double y_206250 = defunc_2_reduce_res_206192 *
                                       c12_206241;
                                double y_206251 = x_206249 + y_206250;
                                double det_206252 = 1.0 / y_206251;
                                double a12_206253 = a12_206235 * det_206252;
                                double b12_206254 = b12_206238 * det_206252;
                                double c12_206255 = c12_206241 * det_206252;
                                double b2_206256 = b2_206243 * det_206252;
                                double c2_206257 = c2_206246 * det_206252;
                                double defunc_2_reduce_res_206258;
                                double defunc_2_reduce_res_206259;
                                double redout_207587;
                                double redout_207588;
                                
                                redout_207587 = 0.0;
                                redout_207588 = 0.0;
                                for (int64_t i_207589 = 0; i_207589 <
                                     q_t_203576; i_207589++) {
                                    bool cond_206267 = sle64(x_206161,
                                                             i_207589);
                                    int64_t defunc_0_f_res_206268;
                                    
                                    if (cond_206267) {
                                        defunc_0_f_res_206268 = (int64_t) 0;
                                    } else {
                                        int64_t i_206269 = add64(x_206185,
                                                                 i_207589);
                                        int64_t defunc_0_add_arg_206270;
                                        
                                        defunc_0_add_arg_206270 =
                                            ((int64_t *) mem_208500)[i_207601 *
                                                                     n_203572 +
                                                                     i_206269];
                                        
                                        int64_t defunc_1_add_res_206271 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_206270);
                                        
                                        defunc_0_f_res_206268 =
                                            defunc_1_add_res_206271;
                                    }
                                    
                                    double defunc_0_f_res_206272;
                                    
                                    if (cond_206267) {
                                        defunc_0_f_res_206272 = 0.0;
                                    } else {
                                        int64_t i_206273 = add64(x_206185,
                                                                 i_207589);
                                        double defunc_0_add_arg_206274;
                                        
                                        defunc_0_add_arg_206274 =
                                            ((double *) mem_211948)[i_206273];
                                        defunc_0_f_res_206272 =
                                            defunc_0_add_arg_206274;
                                    }
                                    
                                    int64_t binop_p_206275 =
                                            sub64(defunc_0_f_res_206268,
                                                  defunc_0_g_res_206189);
                                    double defunc_0_f_res_206276 =
                                           sitofp_i64_f64(binop_p_206275);
                                    double abs_res_206277 =
                                           fabs(defunc_0_f_res_206276);
                                    double tmp1_206278 = abs_res_206277 /
                                           x_206186;
                                    double x_206279 = tmp1_206278 * tmp1_206278;
                                    double y_206280 = tmp1_206278 * x_206279;
                                    double tmp2_206281 = 1.0 - y_206280;
                                    double x_206282 = tmp2_206281 * tmp2_206281;
                                    double tmp3_206283 = tmp2_206281 * x_206282;
                                    double tmp4_206284 = defunc_0_f_res_206272 *
                                           tmp3_206283;
                                    double defunc_1_f_res_206285 =
                                           defunc_0_f_res_206276 * tmp4_206284;
                                    double defunc_1_f_res_206286 =
                                           defunc_0_f_res_206276 *
                                           defunc_1_f_res_206285;
                                    double defunc_0_f_res_206287;
                                    
                                    if (cond_206267) {
                                        defunc_0_f_res_206287 = 0.0;
                                    } else {
                                        int64_t i_206288 = add64(x_206185,
                                                                 i_207589);
                                        double defunc_0_add_arg_206289;
                                        
                                        defunc_0_add_arg_206289 =
                                            ((double *) mem_211951)[i_206288];
                                        defunc_0_f_res_206287 =
                                            defunc_0_add_arg_206289;
                                    }
                                    
                                    double x_206290 = a12_206253 * tmp4_206284;
                                    double y_206291 = b12_206254 *
                                           defunc_1_f_res_206285;
                                    double x_206292 = x_206290 + y_206291;
                                    double y_206293 = c12_206255 *
                                           defunc_1_f_res_206286;
                                    double x_206294 = x_206292 + y_206293;
                                    double defunc_9_fit_fun_res_206295 =
                                           defunc_0_f_res_206287 * x_206294;
                                    double x_206296 = b12_206254 * tmp4_206284;
                                    double y_206297 = b2_206256 *
                                           defunc_1_f_res_206285;
                                    double x_206298 = x_206296 + y_206297;
                                    double y_206299 = c2_206257 *
                                           defunc_1_f_res_206286;
                                    double x_206300 = x_206298 + y_206299;
                                    double defunc_9_slope_fun_res_206301 =
                                           defunc_0_f_res_206287 * x_206300;
                                    double defunc_1_op_res_206262 =
                                           defunc_9_fit_fun_res_206295 +
                                           redout_207587;
                                    double defunc_1_op_res_206265 =
                                           defunc_9_slope_fun_res_206301 +
                                           redout_207588;
                                    double redout_tmp_213763 =
                                           defunc_1_op_res_206262;
                                    double redout_tmp_213764 =
                                           defunc_1_op_res_206265;
                                    
                                    redout_207587 = redout_tmp_213763;
                                    redout_207588 = redout_tmp_213764;
                                }
                                defunc_2_reduce_res_206258 = redout_207587;
                                defunc_2_reduce_res_206259 = redout_207588;
                                ((double *) mem_211906.mem)[i_207601 *
                                                            t_n_m_203740 +
                                                            i_207594] =
                                    defunc_2_reduce_res_206258;
                                ((double *) mem_211910.mem)[i_207601 *
                                                            t_n_m_203740 +
                                                            i_207594] =
                                    defunc_2_reduce_res_206259;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_212044, &mem_211906,
                                         "mem_211906") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_212036, &mem_211910,
                                         "mem_211910") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211910, "mem_211910") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_211906, "mem_211906") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_212060, &ext_mem_212044,
                                     "ext_mem_212044") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_212052, &ext_mem_212036,
                                     "ext_mem_212036") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212036,
                                       "ext_mem_212036") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212044,
                                       "ext_mem_212044") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_212572, &ext_mem_212060,
                                 "ext_mem_212060") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_212564, &ext_mem_212052,
                                 "ext_mem_212052") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212052, "ext_mem_212052") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212060, "ext_mem_212060") != 0)
                    return 1;
            } else {
                bool match_lit_206304 = (int64_t) 0 == d_t_203579;
                int64_t binop_y_212086 = (int64_t) 8 * n_203572;
                int64_t bytes_212087 = smax64((int64_t) 0, binop_y_212086);
                int64_t binop_y_212142 = (int64_t) 8 * q_t_203576;
                int64_t bytes_212143 = smax64((int64_t) 0, binop_y_212142);
                struct memblock ext_mem_212556;
                
                ext_mem_212556.references = NULL;
                
                struct memblock ext_mem_212548;
                
                ext_mem_212548.references = NULL;
                if (match_lit_206304) {
                    struct memblock mem_212071;
                    
                    mem_212071.references = NULL;
                    if (memblock_alloc(ctx, &mem_212071, bytes_209118,
                                       "mem_212071")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_213765 = 0; i_213765 <
                         partition_sizze_203667; i_213765++) {
                        for (int64_t i_213766 = 0; i_213766 < t_n_m_203740;
                             i_213766++) {
                            ((double *) mem_212071.mem)[i_213765 *
                                                        t_n_m_203740 +
                                                        i_213766] = 0.0;
                        }
                    }
                    
                    struct memblock mem_212075;
                    
                    mem_212075.references = NULL;
                    if (memblock_alloc(ctx, &mem_212075, bytes_209118,
                                       "mem_212075")) {
                        err = 1;
                        goto cleanup;
                    }
                    if (mem_212088_cached_sizze_213904 <
                        (size_t) bytes_212087) {
                        mem_212088 = realloc(mem_212088, bytes_212087);
                        mem_212088_cached_sizze_213904 = bytes_212087;
                    }
                    if (mem_212103_cached_sizze_213905 <
                        (size_t) bytes_212087) {
                        mem_212103 = realloc(mem_212103, bytes_212087);
                        mem_212103_cached_sizze_213905 = bytes_212087;
                    }
                    if (mem_212106_cached_sizze_213906 <
                        (size_t) bytes_212087) {
                        mem_212106 = realloc(mem_212106, bytes_212087);
                        mem_212106_cached_sizze_213906 = bytes_212087;
                    }
                    if (mem_212144_cached_sizze_213907 <
                        (size_t) bytes_212143) {
                        mem_212144 = realloc(mem_212144, bytes_212143);
                        mem_212144_cached_sizze_213907 = bytes_212143;
                    }
                    for (int64_t i_207628 = 0; i_207628 <
                         partition_sizze_203667; i_207628++) {
                        int64_t x_206314;
                        
                        x_206314 = ((int64_t *) mem_208503)[i_207628];
                        for (int64_t i_207606 = 0; i_207606 < n_203572;
                             i_207606++) {
                            double x_206318;
                            
                            x_206318 = ((double *) mem_208460)[i_207628 *
                                                               n_203572 +
                                                               i_207606];
                            
                            double x_206319;
                            
                            x_206319 = ((double *) mem_211636.mem)[i_207628 *
                                                                   n_203572 +
                                                                   i_207606];
                            
                            double defunc_1_f_res_206320 = x_206318 - x_206319;
                            
                            ((double *) mem_212088)[i_207606] =
                                defunc_1_f_res_206320;
                        }
                        for (int64_t i_207612 = 0; i_207612 < n_203572;
                             i_207612++) {
                            int64_t x_206323;
                            
                            x_206323 = ((int64_t *) mem_208500)[i_207628 *
                                                                n_203572 +
                                                                i_207612];
                            
                            bool cond_206324 = sle64((int64_t) 0, x_206323);
                            double defunc_0_f_res_206325;
                            
                            if (cond_206324) {
                                bool y_206326 = slt64(x_206323, n_203572);
                                bool bounds_check_206327 = cond_206324 &&
                                     y_206326;
                                bool index_certs_206328;
                                
                                if (!bounds_check_206327) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_206323,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_203572, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                    if (memblock_unref(ctx, &mem_212075,
                                                       "mem_212075") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_212071,
                                                       "mem_212071") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212548,
                                                       "ext_mem_212548") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212556,
                                                       "ext_mem_212556") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212564,
                                                       "ext_mem_212564") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212572,
                                                       "ext_mem_212572") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211636,
                                                       "mem_211636") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211625,
                                                       "ext_mem_211625") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211565,
                                                       "ext_mem_211565") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211573,
                                                       "ext_mem_211573") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210740,
                                                       "ext_mem_210740") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210626,
                                                       "ext_mem_210626") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210637,
                                                       "ext_mem_210637") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209272,
                                                       "mem_param_209272") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209264,
                                                       "mem_param_209264") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212632,
                                                       "ext_mem_212632") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212633,
                                                       "ext_mem_212633") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209250,
                                                       "mem_param_209250") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209242,
                                                       "mem_param_209242") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209234,
                                                       "mem_param_209234") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212961,
                                                       "ext_mem_212961") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212962,
                                                       "ext_mem_212962") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212963,
                                                       "ext_mem_212963") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209226,
                                                       "mem_209226") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209222,
                                                       "mem_209222") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213477,
                                                       "mem_out_213477") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213476,
                                                       "mem_out_213476") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213475,
                                                       "mem_out_213475") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                double defunc_0_f_res_t_res_206329;
                                
                                defunc_0_f_res_t_res_206329 =
                                    ((double *) mem_212088)[x_206323];
                                defunc_0_f_res_206325 =
                                    defunc_0_f_res_t_res_206329;
                            } else {
                                defunc_0_f_res_206325 = 0.0;
                            }
                            
                            double defunc_0_f_res_206330;
                            
                            if (cond_206324) {
                                bool y_206331 = slt64(x_206323, n_203572);
                                bool bounds_check_206332 = cond_206324 &&
                                     y_206331;
                                bool index_certs_206333;
                                
                                if (!bounds_check_206332) {
                                    ctx->error =
                                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                  "Index [",
                                                  (long long) x_206323,
                                                  "] out of bounds for array of shape [",
                                                  (long long) n_203572, "].",
                                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                    if (memblock_unref(ctx, &mem_212075,
                                                       "mem_212075") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_212071,
                                                       "mem_212071") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212548,
                                                       "ext_mem_212548") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212556,
                                                       "ext_mem_212556") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212564,
                                                       "ext_mem_212564") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212572,
                                                       "ext_mem_212572") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_211636,
                                                       "mem_211636") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211625,
                                                       "ext_mem_211625") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211565,
                                                       "ext_mem_211565") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_211573,
                                                       "ext_mem_211573") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210740,
                                                       "ext_mem_210740") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210626,
                                                       "ext_mem_210626") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_210637,
                                                       "ext_mem_210637") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209272,
                                                       "mem_param_209272") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209264,
                                                       "mem_param_209264") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212632,
                                                       "ext_mem_212632") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212633,
                                                       "ext_mem_212633") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209250,
                                                       "mem_param_209250") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209242,
                                                       "mem_param_209242") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_param_209234,
                                                       "mem_param_209234") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212961,
                                                       "ext_mem_212961") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212962,
                                                       "ext_mem_212962") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &ext_mem_212963,
                                                       "ext_mem_212963") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209226,
                                                       "mem_209226") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_209222,
                                                       "mem_209222") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213477,
                                                       "mem_out_213477") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213476,
                                                       "mem_out_213476") != 0)
                                        return 1;
                                    if (memblock_unref(ctx, &mem_out_213475,
                                                       "mem_out_213475") != 0)
                                        return 1;
                                    err = 1;
                                    goto cleanup;
                                }
                                
                                double defunc_0_f_res_t_res_206334;
                                
                                defunc_0_f_res_t_res_206334 =
                                    ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                      (i_207628 *
                                                                       ctx_param_ext_209246 +
                                                                       x_206323 *
                                                                       ctx_param_ext_209248)];
                                defunc_0_f_res_206330 =
                                    defunc_0_f_res_t_res_206334;
                            } else {
                                defunc_0_f_res_206330 = 0.0;
                            }
                            ((double *) mem_212103)[i_207612] =
                                defunc_0_f_res_206330;
                            ((double *) mem_212106)[i_207612] =
                                defunc_0_f_res_206325;
                        }
                        for (int64_t i_207624 = 0; i_207624 < t_n_m_203740;
                             i_207624++) {
                            int64_t x_206337;
                            
                            x_206337 = ((int64_t *) mem_209119)[i_207628 *
                                                                t_n_m_203740 +
                                                                i_207624];
                            
                            double x_206338;
                            
                            x_206338 = ((double *) mem_209123)[i_207628 *
                                                               t_n_m_203740 +
                                                               i_207624];
                            
                            int64_t min_arg_206339 = mul64(jump_t_203582,
                                                           i_207624);
                            int64_t min_res_206340 = smin64(i_203760,
                                                            min_arg_206339);
                            int64_t defunc_0_g_res_206341 = add64((int64_t) 1,
                                                                  min_res_206340);
                            double defunc_2_reduce_res_206342;
                            double redout_207616 = 0.0;
                            
                            for (int64_t i_207618 = 0; i_207618 < q_t_203576;
                                 i_207618++) {
                                bool cond_206348 = sle64(x_206314, i_207618);
                                int64_t defunc_0_f_res_206349;
                                
                                if (cond_206348) {
                                    defunc_0_f_res_206349 = (int64_t) 0;
                                } else {
                                    int64_t i_206350 = add64(x_206337,
                                                             i_207618);
                                    int64_t defunc_0_add_arg_206351;
                                    
                                    defunc_0_add_arg_206351 =
                                        ((int64_t *) mem_208500)[i_207628 *
                                                                 n_203572 +
                                                                 i_206350];
                                    
                                    int64_t defunc_1_add_res_206352 =
                                            add64((int64_t) 1,
                                                  defunc_0_add_arg_206351);
                                    
                                    defunc_0_f_res_206349 =
                                        defunc_1_add_res_206352;
                                }
                                
                                double defunc_0_f_res_206353;
                                
                                if (cond_206348) {
                                    defunc_0_f_res_206353 = 0.0;
                                } else {
                                    int64_t i_206354 = add64(x_206337,
                                                             i_207618);
                                    double defunc_0_add_arg_206355;
                                    
                                    defunc_0_add_arg_206355 =
                                        ((double *) mem_212103)[i_206354];
                                    defunc_0_f_res_206353 =
                                        defunc_0_add_arg_206355;
                                }
                                
                                int64_t binop_p_206356 =
                                        sub64(defunc_0_f_res_206349,
                                              defunc_0_g_res_206341);
                                double defunc_0_f_res_206357 =
                                       sitofp_i64_f64(binop_p_206356);
                                double abs_res_206358 =
                                       fabs(defunc_0_f_res_206357);
                                double tmp1_206359 = abs_res_206358 / x_206338;
                                double x_206360 = tmp1_206359 * tmp1_206359;
                                double y_206361 = tmp1_206359 * x_206360;
                                double tmp2_206362 = 1.0 - y_206361;
                                double x_206363 = tmp2_206362 * tmp2_206362;
                                double tmp3_206364 = tmp2_206362 * x_206363;
                                double tmp4_206365 = defunc_0_f_res_206353 *
                                       tmp3_206364;
                                double defunc_1_op_res_206346 = tmp4_206365 +
                                       redout_207616;
                                
                                ((double *) mem_212144)[i_207618] = tmp4_206365;
                                
                                double redout_tmp_213772 =
                                       defunc_1_op_res_206346;
                                
                                redout_207616 = redout_tmp_213772;
                            }
                            defunc_2_reduce_res_206342 = redout_207616;
                            
                            double a0_206366 = 1.0 / defunc_2_reduce_res_206342;
                            double defunc_2_reduce_res_206367;
                            double redout_207620 = 0.0;
                            
                            for (int64_t i_207621 = 0; i_207621 < q_t_203576;
                                 i_207621++) {
                                double x_206372;
                                
                                x_206372 = ((double *) mem_212144)[i_207621];
                                
                                bool cond_206373 = sle64(x_206314, i_207621);
                                double defunc_0_f_res_206374;
                                
                                if (cond_206373) {
                                    defunc_0_f_res_206374 = 0.0;
                                } else {
                                    int64_t i_206375 = add64(x_206337,
                                                             i_207621);
                                    double defunc_0_add_arg_206376;
                                    
                                    defunc_0_add_arg_206376 =
                                        ((double *) mem_212106)[i_206375];
                                    defunc_0_f_res_206374 =
                                        defunc_0_add_arg_206376;
                                }
                                
                                double x_206377 = a0_206366 * x_206372;
                                double defunc_9_fit_fun_res_206378 =
                                       defunc_0_f_res_206374 * x_206377;
                                double defunc_1_op_res_206370 =
                                       defunc_9_fit_fun_res_206378 +
                                       redout_207620;
                                double redout_tmp_213774 =
                                       defunc_1_op_res_206370;
                                
                                redout_207620 = redout_tmp_213774;
                            }
                            defunc_2_reduce_res_206367 = redout_207620;
                            ((double *) mem_212075.mem)[i_207628 *
                                                        t_n_m_203740 +
                                                        i_207624] =
                                defunc_2_reduce_res_206367;
                        }
                    }
                    if (memblock_set(ctx, &ext_mem_212556, &mem_212075,
                                     "mem_212075") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_212548, &mem_212071,
                                     "mem_212071") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_212075, "mem_212075") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_212071, "mem_212071") != 0)
                        return 1;
                } else {
                    bool match_lit_206381 = (int64_t) 1 == d_t_203579;
                    int64_t binop_y_212204 = (int64_t) 8 * n_203572;
                    int64_t bytes_212205 = smax64((int64_t) 0, binop_y_212204);
                    int64_t binop_y_212271 = (int64_t) 8 * q_t_203576;
                    int64_t bytes_212272 = smax64((int64_t) 0, binop_y_212271);
                    int64_t binop_y_212367 = (int64_t) 8 * n_203572;
                    int64_t bytes_212368 = smax64((int64_t) 0, binop_y_212367);
                    int64_t binop_y_212434 = (int64_t) 8 * q_t_203576;
                    int64_t bytes_212435 = smax64((int64_t) 0, binop_y_212434);
                    struct memblock ext_mem_212540;
                    
                    ext_mem_212540.references = NULL;
                    
                    struct memblock ext_mem_212532;
                    
                    ext_mem_212532.references = NULL;
                    if (match_lit_206381) {
                        struct memblock mem_212179;
                        
                        mem_212179.references = NULL;
                        if (memblock_alloc(ctx, &mem_212179, bytes_209118,
                                           "mem_212179")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_212183;
                        
                        mem_212183.references = NULL;
                        if (memblock_alloc(ctx, &mem_212183, bytes_209118,
                                           "mem_212183")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_212206_cached_sizze_213908 <
                            (size_t) bytes_212205) {
                            mem_212206 = realloc(mem_212206, bytes_212205);
                            mem_212206_cached_sizze_213908 = bytes_212205;
                        }
                        if (mem_212221_cached_sizze_213909 <
                            (size_t) bytes_212205) {
                            mem_212221 = realloc(mem_212221, bytes_212205);
                            mem_212221_cached_sizze_213909 = bytes_212205;
                        }
                        if (mem_212224_cached_sizze_213910 <
                            (size_t) bytes_212205) {
                            mem_212224 = realloc(mem_212224, bytes_212205);
                            mem_212224_cached_sizze_213910 = bytes_212205;
                        }
                        if (mem_212273_cached_sizze_213911 <
                            (size_t) bytes_212272) {
                            mem_212273 = realloc(mem_212273, bytes_212272);
                            mem_212273_cached_sizze_213911 = bytes_212272;
                        }
                        if (mem_212276_cached_sizze_213912 <
                            (size_t) bytes_212272) {
                            mem_212276 = realloc(mem_212276, bytes_212272);
                            mem_212276_cached_sizze_213912 = bytes_212272;
                        }
                        for (int64_t i_207665 = 0; i_207665 <
                             partition_sizze_203667; i_207665++) {
                            int64_t x_206391;
                            
                            x_206391 = ((int64_t *) mem_208503)[i_207665];
                            for (int64_t i_207632 = 0; i_207632 < n_203572;
                                 i_207632++) {
                                double x_206395;
                                
                                x_206395 = ((double *) mem_208460)[i_207665 *
                                                                   n_203572 +
                                                                   i_207632];
                                
                                double x_206396;
                                
                                x_206396 =
                                    ((double *) mem_211636.mem)[i_207665 *
                                                                n_203572 +
                                                                i_207632];
                                
                                double defunc_1_f_res_206397 = x_206395 -
                                       x_206396;
                                
                                ((double *) mem_212206)[i_207632] =
                                    defunc_1_f_res_206397;
                            }
                            for (int64_t i_207638 = 0; i_207638 < n_203572;
                                 i_207638++) {
                                int64_t x_206400;
                                
                                x_206400 = ((int64_t *) mem_208500)[i_207665 *
                                                                    n_203572 +
                                                                    i_207638];
                                
                                bool cond_206401 = sle64((int64_t) 0, x_206400);
                                double defunc_0_f_res_206402;
                                
                                if (cond_206401) {
                                    bool y_206403 = slt64(x_206400, n_203572);
                                    bool bounds_check_206404 = cond_206401 &&
                                         y_206403;
                                    bool index_certs_206405;
                                    
                                    if (!bounds_check_206404) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206400,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203572,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_212183,
                                                           "mem_212183") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_212179,
                                                           "mem_212179") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212532,
                                                           "ext_mem_212532") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212540,
                                                           "ext_mem_212540") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212548,
                                                           "ext_mem_212548") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212556,
                                                           "ext_mem_212556") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212564,
                                                           "ext_mem_212564") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212572,
                                                           "ext_mem_212572") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211636,
                                                           "mem_211636") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211625,
                                                           "ext_mem_211625") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211565,
                                                           "ext_mem_211565") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211573,
                                                           "ext_mem_211573") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206406;
                                    
                                    defunc_0_f_res_t_res_206406 =
                                        ((double *) mem_212206)[x_206400];
                                    defunc_0_f_res_206402 =
                                        defunc_0_f_res_t_res_206406;
                                } else {
                                    defunc_0_f_res_206402 = 0.0;
                                }
                                
                                double defunc_0_f_res_206407;
                                
                                if (cond_206401) {
                                    bool y_206408 = slt64(x_206400, n_203572);
                                    bool bounds_check_206409 = cond_206401 &&
                                         y_206408;
                                    bool index_certs_206410;
                                    
                                    if (!bounds_check_206409) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206400,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203572,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_212183,
                                                           "mem_212183") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_212179,
                                                           "mem_212179") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212532,
                                                           "ext_mem_212532") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212540,
                                                           "ext_mem_212540") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212548,
                                                           "ext_mem_212548") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212556,
                                                           "ext_mem_212556") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212564,
                                                           "ext_mem_212564") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212572,
                                                           "ext_mem_212572") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211636,
                                                           "mem_211636") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211625,
                                                           "ext_mem_211625") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211565,
                                                           "ext_mem_211565") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211573,
                                                           "ext_mem_211573") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206411;
                                    
                                    defunc_0_f_res_t_res_206411 =
                                        ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                          (i_207665 *
                                                                           ctx_param_ext_209246 +
                                                                           x_206400 *
                                                                           ctx_param_ext_209248)];
                                    defunc_0_f_res_206407 =
                                        defunc_0_f_res_t_res_206411;
                                } else {
                                    defunc_0_f_res_206407 = 0.0;
                                }
                                ((double *) mem_212221)[i_207638] =
                                    defunc_0_f_res_206407;
                                ((double *) mem_212224)[i_207638] =
                                    defunc_0_f_res_206402;
                            }
                            for (int64_t i_207658 = 0; i_207658 < t_n_m_203740;
                                 i_207658++) {
                                int64_t x_206415;
                                
                                x_206415 = ((int64_t *) mem_209119)[i_207665 *
                                                                    t_n_m_203740 +
                                                                    i_207658];
                                
                                double x_206416;
                                
                                x_206416 = ((double *) mem_209123)[i_207665 *
                                                                   t_n_m_203740 +
                                                                   i_207658];
                                
                                int64_t min_arg_206417 = mul64(jump_t_203582,
                                                               i_207658);
                                int64_t min_res_206418 = smin64(i_203760,
                                                                min_arg_206417);
                                int64_t defunc_0_g_res_206419 =
                                        add64((int64_t) 1, min_res_206418);
                                double defunc_2_reduce_res_206443;
                                double defunc_2_reduce_res_206444;
                                double defunc_2_reduce_res_206445;
                                double redout_207643;
                                double redout_207644;
                                double redout_207645;
                                
                                redout_207643 = 0.0;
                                redout_207644 = 0.0;
                                redout_207645 = 0.0;
                                for (int64_t i_207648 = 0; i_207648 <
                                     q_t_203576; i_207648++) {
                                    bool cond_206458 = sle64(x_206391,
                                                             i_207648);
                                    int64_t defunc_0_f_res_206459;
                                    
                                    if (cond_206458) {
                                        defunc_0_f_res_206459 = (int64_t) 0;
                                    } else {
                                        int64_t i_206460 = add64(x_206415,
                                                                 i_207648);
                                        int64_t defunc_0_add_arg_206461;
                                        
                                        defunc_0_add_arg_206461 =
                                            ((int64_t *) mem_208500)[i_207665 *
                                                                     n_203572 +
                                                                     i_206460];
                                        
                                        int64_t defunc_1_add_res_206462 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_206461);
                                        
                                        defunc_0_f_res_206459 =
                                            defunc_1_add_res_206462;
                                    }
                                    
                                    double defunc_0_f_res_206463;
                                    
                                    if (cond_206458) {
                                        defunc_0_f_res_206463 = 0.0;
                                    } else {
                                        int64_t i_206464 = add64(x_206415,
                                                                 i_207648);
                                        double defunc_0_add_arg_206465;
                                        
                                        defunc_0_add_arg_206465 =
                                            ((double *) mem_212221)[i_206464];
                                        defunc_0_f_res_206463 =
                                            defunc_0_add_arg_206465;
                                    }
                                    
                                    int64_t binop_p_206466 =
                                            sub64(defunc_0_f_res_206459,
                                                  defunc_0_g_res_206419);
                                    double defunc_0_f_res_206467 =
                                           sitofp_i64_f64(binop_p_206466);
                                    double abs_res_206468 =
                                           fabs(defunc_0_f_res_206467);
                                    double tmp1_206469 = abs_res_206468 /
                                           x_206416;
                                    double x_206470 = tmp1_206469 * tmp1_206469;
                                    double y_206471 = tmp1_206469 * x_206470;
                                    double tmp2_206472 = 1.0 - y_206471;
                                    double x_206473 = tmp2_206472 * tmp2_206472;
                                    double tmp3_206474 = tmp2_206472 * x_206473;
                                    double tmp4_206475 = defunc_0_f_res_206463 *
                                           tmp3_206474;
                                    double defunc_1_f_res_206476 =
                                           defunc_0_f_res_206467 * tmp4_206475;
                                    double defunc_1_f_res_206477 =
                                           defunc_0_f_res_206467 *
                                           defunc_1_f_res_206476;
                                    double defunc_1_op_res_206450 =
                                           tmp4_206475 + redout_207643;
                                    double defunc_1_op_res_206453 =
                                           defunc_1_f_res_206476 +
                                           redout_207644;
                                    double defunc_1_op_res_206456 =
                                           defunc_1_f_res_206477 +
                                           redout_207645;
                                    
                                    ((double *) mem_212273)[i_207648] =
                                        defunc_1_f_res_206476;
                                    ((double *) mem_212276)[i_207648] =
                                        tmp4_206475;
                                    
                                    double redout_tmp_213782 =
                                           defunc_1_op_res_206450;
                                    double redout_tmp_213783 =
                                           defunc_1_op_res_206453;
                                    double redout_tmp_213784 =
                                           defunc_1_op_res_206456;
                                    
                                    redout_207643 = redout_tmp_213782;
                                    redout_207644 = redout_tmp_213783;
                                    redout_207645 = redout_tmp_213784;
                                }
                                defunc_2_reduce_res_206443 = redout_207643;
                                defunc_2_reduce_res_206444 = redout_207644;
                                defunc_2_reduce_res_206445 = redout_207645;
                                
                                double x_206483 = defunc_2_reduce_res_206443 *
                                       defunc_2_reduce_res_206445;
                                double y_206484 = defunc_2_reduce_res_206444 *
                                       defunc_2_reduce_res_206444;
                                double y_206485 = x_206483 - y_206484;
                                double det1_206486 = 1.0 / y_206485;
                                double a11_206487 = defunc_2_reduce_res_206445 *
                                       det1_206486;
                                double x_206488 = 0.0 -
                                       defunc_2_reduce_res_206444;
                                double b11_206489 = det1_206486 * x_206488;
                                double c11_206490 = defunc_2_reduce_res_206443 *
                                       det1_206486;
                                double defunc_2_reduce_res_206491;
                                double defunc_2_reduce_res_206492;
                                double redout_207651;
                                double redout_207652;
                                
                                redout_207651 = 0.0;
                                redout_207652 = 0.0;
                                for (int64_t i_207653 = 0; i_207653 <
                                     q_t_203576; i_207653++) {
                                    double x_206500;
                                    
                                    x_206500 =
                                        ((double *) mem_212276)[i_207653];
                                    
                                    double x_206501;
                                    
                                    x_206501 =
                                        ((double *) mem_212273)[i_207653];
                                    
                                    bool cond_206502 = sle64(x_206391,
                                                             i_207653);
                                    double defunc_0_f_res_206503;
                                    
                                    if (cond_206502) {
                                        defunc_0_f_res_206503 = 0.0;
                                    } else {
                                        int64_t i_206504 = add64(x_206415,
                                                                 i_207653);
                                        double defunc_0_add_arg_206505;
                                        
                                        defunc_0_add_arg_206505 =
                                            ((double *) mem_212224)[i_206504];
                                        defunc_0_f_res_206503 =
                                            defunc_0_add_arg_206505;
                                    }
                                    
                                    double x_206506 = a11_206487 * x_206500;
                                    double y_206507 = b11_206489 * x_206501;
                                    double x_206508 = x_206506 + y_206507;
                                    double defunc_9_fit_fun_res_206509 =
                                           defunc_0_f_res_206503 * x_206508;
                                    double x_206510 = b11_206489 * x_206500;
                                    double y_206511 = c11_206490 * x_206501;
                                    double x_206512 = x_206510 + y_206511;
                                    double defunc_9_slope_fun_res_206513 =
                                           defunc_0_f_res_206503 * x_206512;
                                    double defunc_1_op_res_206495 =
                                           defunc_9_fit_fun_res_206509 +
                                           redout_207651;
                                    double defunc_1_op_res_206498 =
                                           defunc_9_slope_fun_res_206513 +
                                           redout_207652;
                                    double redout_tmp_213787 =
                                           defunc_1_op_res_206495;
                                    double redout_tmp_213788 =
                                           defunc_1_op_res_206498;
                                    
                                    redout_207651 = redout_tmp_213787;
                                    redout_207652 = redout_tmp_213788;
                                }
                                defunc_2_reduce_res_206491 = redout_207651;
                                defunc_2_reduce_res_206492 = redout_207652;
                                ((double *) mem_212179.mem)[i_207665 *
                                                            t_n_m_203740 +
                                                            i_207658] =
                                    defunc_2_reduce_res_206491;
                                ((double *) mem_212183.mem)[i_207665 *
                                                            t_n_m_203740 +
                                                            i_207658] =
                                    defunc_2_reduce_res_206492;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_212540, &mem_212179,
                                         "mem_212179") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_212532, &mem_212183,
                                         "mem_212183") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_212183, "mem_212183") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_212179, "mem_212179") != 0)
                            return 1;
                    } else {
                        struct memblock mem_212342;
                        
                        mem_212342.references = NULL;
                        if (memblock_alloc(ctx, &mem_212342, bytes_209118,
                                           "mem_212342")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_212346;
                        
                        mem_212346.references = NULL;
                        if (memblock_alloc(ctx, &mem_212346, bytes_209118,
                                           "mem_212346")) {
                            err = 1;
                            goto cleanup;
                        }
                        if (mem_212369_cached_sizze_213913 <
                            (size_t) bytes_212368) {
                            mem_212369 = realloc(mem_212369, bytes_212368);
                            mem_212369_cached_sizze_213913 = bytes_212368;
                        }
                        if (mem_212384_cached_sizze_213914 <
                            (size_t) bytes_212368) {
                            mem_212384 = realloc(mem_212384, bytes_212368);
                            mem_212384_cached_sizze_213914 = bytes_212368;
                        }
                        if (mem_212387_cached_sizze_213915 <
                            (size_t) bytes_212368) {
                            mem_212387 = realloc(mem_212387, bytes_212368);
                            mem_212387_cached_sizze_213915 = bytes_212368;
                        }
                        if (mem_212436_cached_sizze_213916 <
                            (size_t) bytes_212435) {
                            mem_212436 = realloc(mem_212436, bytes_212435);
                            mem_212436_cached_sizze_213916 = bytes_212435;
                        }
                        if (mem_212439_cached_sizze_213917 <
                            (size_t) bytes_212435) {
                            mem_212439 = realloc(mem_212439, bytes_212435);
                            mem_212439_cached_sizze_213917 = bytes_212435;
                        }
                        if (mem_212466_cached_sizze_213918 <
                            (size_t) bytes_212435) {
                            mem_212466 = realloc(mem_212466, bytes_212435);
                            mem_212466_cached_sizze_213918 = bytes_212435;
                        }
                        if (mem_212469_cached_sizze_213919 <
                            (size_t) bytes_212435) {
                            mem_212469 = realloc(mem_212469, bytes_212435);
                            mem_212469_cached_sizze_213919 = bytes_212435;
                        }
                        for (int64_t i_207712 = 0; i_207712 <
                             partition_sizze_203667; i_207712++) {
                            int64_t x_206523;
                            
                            x_206523 = ((int64_t *) mem_208503)[i_207712];
                            for (int64_t i_207670 = 0; i_207670 < n_203572;
                                 i_207670++) {
                                double x_206527;
                                
                                x_206527 = ((double *) mem_208460)[i_207712 *
                                                                   n_203572 +
                                                                   i_207670];
                                
                                double x_206528;
                                
                                x_206528 =
                                    ((double *) mem_211636.mem)[i_207712 *
                                                                n_203572 +
                                                                i_207670];
                                
                                double defunc_1_f_res_206529 = x_206527 -
                                       x_206528;
                                
                                ((double *) mem_212369)[i_207670] =
                                    defunc_1_f_res_206529;
                            }
                            for (int64_t i_207676 = 0; i_207676 < n_203572;
                                 i_207676++) {
                                int64_t x_206532;
                                
                                x_206532 = ((int64_t *) mem_208500)[i_207712 *
                                                                    n_203572 +
                                                                    i_207676];
                                
                                bool cond_206533 = sle64((int64_t) 0, x_206532);
                                double defunc_0_f_res_206534;
                                
                                if (cond_206533) {
                                    bool y_206535 = slt64(x_206532, n_203572);
                                    bool bounds_check_206536 = cond_206533 &&
                                         y_206535;
                                    bool index_certs_206537;
                                    
                                    if (!bounds_check_206536) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206532,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203572,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:281:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_212346,
                                                           "mem_212346") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_212342,
                                                           "mem_212342") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212532,
                                                           "ext_mem_212532") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212540,
                                                           "ext_mem_212540") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212548,
                                                           "ext_mem_212548") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212556,
                                                           "ext_mem_212556") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212564,
                                                           "ext_mem_212564") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212572,
                                                           "ext_mem_212572") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211636,
                                                           "mem_211636") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211625,
                                                           "ext_mem_211625") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211565,
                                                           "ext_mem_211565") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211573,
                                                           "ext_mem_211573") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206538;
                                    
                                    defunc_0_f_res_t_res_206538 =
                                        ((double *) mem_212369)[x_206532];
                                    defunc_0_f_res_206534 =
                                        defunc_0_f_res_t_res_206538;
                                } else {
                                    defunc_0_f_res_206534 = 0.0;
                                }
                                
                                double defunc_0_f_res_206539;
                                
                                if (cond_206533) {
                                    bool y_206540 = slt64(x_206532, n_203572);
                                    bool bounds_check_206541 = cond_206533 &&
                                         y_206540;
                                    bool index_certs_206542;
                                    
                                    if (!bounds_check_206541) {
                                        ctx->error =
                                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                                      "Index [",
                                                      (long long) x_206532,
                                                      "] out of bounds for array of shape [",
                                                      (long long) n_203572,
                                                      "].",
                                                      "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:42:43-70\n   #3  stl.fut:282:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:279:13-284:41\n   #7  stl.fut:415:61-429:75\n   #8  stl.fut:455:3-469:34\n   #9  stl.fut:439:1-469:34\n");
                                        if (memblock_unref(ctx, &mem_212346,
                                                           "mem_212346") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_212342,
                                                           "mem_212342") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212532,
                                                           "ext_mem_212532") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212540,
                                                           "ext_mem_212540") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212548,
                                                           "ext_mem_212548") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212556,
                                                           "ext_mem_212556") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212564,
                                                           "ext_mem_212564") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212572,
                                                           "ext_mem_212572") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_211636,
                                                           "mem_211636") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211625,
                                                           "ext_mem_211625") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211565,
                                                           "ext_mem_211565") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_211573,
                                                           "ext_mem_211573") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210740,
                                                           "ext_mem_210740") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210626,
                                                           "ext_mem_210626") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_210637,
                                                           "ext_mem_210637") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209272,
                                                           "mem_param_209272") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209264,
                                                           "mem_param_209264") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212632,
                                                           "ext_mem_212632") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212633,
                                                           "ext_mem_212633") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209250,
                                                           "mem_param_209250") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209242,
                                                           "mem_param_209242") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx,
                                                           &mem_param_209234,
                                                           "mem_param_209234") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212961,
                                                           "ext_mem_212961") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212962,
                                                           "ext_mem_212962") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &ext_mem_212963,
                                                           "ext_mem_212963") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209226,
                                                           "mem_209226") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_209222,
                                                           "mem_209222") != 0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213477,
                                                           "mem_out_213477") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213476,
                                                           "mem_out_213476") !=
                                            0)
                                            return 1;
                                        if (memblock_unref(ctx, &mem_out_213475,
                                                           "mem_out_213475") !=
                                            0)
                                            return 1;
                                        err = 1;
                                        goto cleanup;
                                    }
                                    
                                    double defunc_0_f_res_t_res_206543;
                                    
                                    defunc_0_f_res_t_res_206543 =
                                        ((double *) mem_param_209250.mem)[ctx_param_ext_209245 +
                                                                          (i_207712 *
                                                                           ctx_param_ext_209246 +
                                                                           x_206532 *
                                                                           ctx_param_ext_209248)];
                                    defunc_0_f_res_206539 =
                                        defunc_0_f_res_t_res_206543;
                                } else {
                                    defunc_0_f_res_206539 = 0.0;
                                }
                                ((double *) mem_212384)[i_207676] =
                                    defunc_0_f_res_206539;
                                ((double *) mem_212387)[i_207676] =
                                    defunc_0_f_res_206534;
                            }
                            for (int64_t i_207705 = 0; i_207705 < t_n_m_203740;
                                 i_207705++) {
                                int64_t x_206547;
                                
                                x_206547 = ((int64_t *) mem_209119)[i_207712 *
                                                                    t_n_m_203740 +
                                                                    i_207705];
                                
                                double x_206548;
                                
                                x_206548 = ((double *) mem_209123)[i_207712 *
                                                                   t_n_m_203740 +
                                                                   i_207705];
                                
                                int64_t min_arg_206549 = mul64(jump_t_203582,
                                                               i_207705);
                                int64_t min_res_206550 = smin64(i_203760,
                                                                min_arg_206549);
                                int64_t defunc_0_g_res_206551 =
                                        add64((int64_t) 1, min_res_206550);
                                
                                for (int64_t i_207683 = 0; i_207683 <
                                     q_t_203576; i_207683++) {
                                    bool cond_206555 = sle64(x_206523,
                                                             i_207683);
                                    int64_t defunc_0_f_res_206556;
                                    
                                    if (cond_206555) {
                                        defunc_0_f_res_206556 = (int64_t) 0;
                                    } else {
                                        int64_t i_206557 = add64(x_206547,
                                                                 i_207683);
                                        int64_t defunc_0_add_arg_206558;
                                        
                                        defunc_0_add_arg_206558 =
                                            ((int64_t *) mem_208500)[i_207712 *
                                                                     n_203572 +
                                                                     i_206557];
                                        
                                        int64_t defunc_1_add_res_206559 =
                                                add64((int64_t) 1,
                                                      defunc_0_add_arg_206558);
                                        
                                        defunc_0_f_res_206556 =
                                            defunc_1_add_res_206559;
                                    }
                                    
                                    double defunc_0_f_res_206560;
                                    
                                    if (cond_206555) {
                                        defunc_0_f_res_206560 = 0.0;
                                    } else {
                                        int64_t i_206561 = add64(x_206547,
                                                                 i_207683);
                                        double defunc_0_add_arg_206562;
                                        
                                        defunc_0_add_arg_206562 =
                                            ((double *) mem_212384)[i_206561];
                                        defunc_0_f_res_206560 =
                                            defunc_0_add_arg_206562;
                                    }
                                    
                                    int64_t binop_p_206563 =
                                            sub64(defunc_0_f_res_206556,
                                                  defunc_0_g_res_206551);
                                    double defunc_0_f_res_206564 =
                                           sitofp_i64_f64(binop_p_206563);
                                    double abs_res_206565 =
                                           fabs(defunc_0_f_res_206564);
                                    double tmp1_206566 = abs_res_206565 /
                                           x_206548;
                                    double x_206567 = tmp1_206566 * tmp1_206566;
                                    double y_206568 = tmp1_206566 * x_206567;
                                    double tmp2_206569 = 1.0 - y_206568;
                                    double x_206570 = tmp2_206569 * tmp2_206569;
                                    double tmp3_206571 = tmp2_206569 * x_206570;
                                    double tmp4_206572 = defunc_0_f_res_206560 *
                                           tmp3_206571;
                                    
                                    ((double *) mem_212436)[i_207683] =
                                        defunc_0_f_res_206564;
                                    ((double *) mem_212439)[i_207683] =
                                        tmp4_206572;
                                }
                                
                                double defunc_2_reduce_res_206579;
                                double defunc_2_reduce_res_206580;
                                double defunc_2_reduce_res_206581;
                                double defunc_2_reduce_res_206582;
                                double defunc_2_reduce_res_206583;
                                double redout_207688;
                                double redout_207689;
                                double redout_207690;
                                double redout_207691;
                                double redout_207692;
                                
                                redout_207688 = 0.0;
                                redout_207689 = 0.0;
                                redout_207690 = 0.0;
                                redout_207691 = 0.0;
                                redout_207692 = 0.0;
                                for (int64_t i_207695 = 0; i_207695 <
                                     q_t_203576; i_207695++) {
                                    double x_206601;
                                    
                                    x_206601 =
                                        ((double *) mem_212436)[i_207695];
                                    
                                    double x_206602;
                                    
                                    x_206602 =
                                        ((double *) mem_212439)[i_207695];
                                    
                                    double defunc_1_f_res_206603 = x_206601 *
                                           x_206602;
                                    double defunc_1_f_res_206604 = x_206601 *
                                           defunc_1_f_res_206603;
                                    double defunc_1_f_res_206605 = x_206601 *
                                           defunc_1_f_res_206604;
                                    double defunc_1_f_res_206606 = x_206601 *
                                           defunc_1_f_res_206605;
                                    double defunc_1_op_res_206588 = x_206602 +
                                           redout_207688;
                                    double defunc_1_op_res_206591 =
                                           defunc_1_f_res_206603 +
                                           redout_207689;
                                    double defunc_1_op_res_206594 =
                                           defunc_1_f_res_206604 +
                                           redout_207690;
                                    double defunc_1_op_res_206597 =
                                           defunc_1_f_res_206605 +
                                           redout_207691;
                                    double defunc_1_op_res_206600 =
                                           defunc_1_f_res_206606 +
                                           redout_207692;
                                    
                                    ((double *) mem_212466)[i_207695] =
                                        defunc_1_f_res_206604;
                                    ((double *) mem_212469)[i_207695] =
                                        defunc_1_f_res_206603;
                                    
                                    double redout_tmp_213798 =
                                           defunc_1_op_res_206588;
                                    double redout_tmp_213799 =
                                           defunc_1_op_res_206591;
                                    double redout_tmp_213800 =
                                           defunc_1_op_res_206594;
                                    double redout_tmp_213801 =
                                           defunc_1_op_res_206597;
                                    double redout_tmp_213802 =
                                           defunc_1_op_res_206600;
                                    
                                    redout_207688 = redout_tmp_213798;
                                    redout_207689 = redout_tmp_213799;
                                    redout_207690 = redout_tmp_213800;
                                    redout_207691 = redout_tmp_213801;
                                    redout_207692 = redout_tmp_213802;
                                }
                                defunc_2_reduce_res_206579 = redout_207688;
                                defunc_2_reduce_res_206580 = redout_207689;
                                defunc_2_reduce_res_206581 = redout_207690;
                                defunc_2_reduce_res_206582 = redout_207691;
                                defunc_2_reduce_res_206583 = redout_207692;
                                
                                double x_206614 = defunc_2_reduce_res_206581 *
                                       defunc_2_reduce_res_206583;
                                double y_206615 = defunc_2_reduce_res_206582 *
                                       defunc_2_reduce_res_206582;
                                double a12_206616 = x_206614 - y_206615;
                                double x_206617 = defunc_2_reduce_res_206581 *
                                       defunc_2_reduce_res_206582;
                                double y_206618 = defunc_2_reduce_res_206580 *
                                       defunc_2_reduce_res_206583;
                                double b12_206619 = x_206617 - y_206618;
                                double x_206620 = defunc_2_reduce_res_206580 *
                                       defunc_2_reduce_res_206582;
                                double y_206621 = defunc_2_reduce_res_206581 *
                                       defunc_2_reduce_res_206581;
                                double c12_206622 = x_206620 - y_206621;
                                double x_206623 = defunc_2_reduce_res_206579 *
                                       defunc_2_reduce_res_206583;
                                double b2_206624 = x_206623 - y_206621;
                                double x_206625 = defunc_2_reduce_res_206580 *
                                       defunc_2_reduce_res_206581;
                                double y_206626 = defunc_2_reduce_res_206579 *
                                       defunc_2_reduce_res_206582;
                                double c2_206627 = x_206625 - y_206626;
                                double x_206628 = defunc_2_reduce_res_206579 *
                                       a12_206616;
                                double y_206629 = defunc_2_reduce_res_206580 *
                                       b12_206619;
                                double x_206630 = x_206628 + y_206629;
                                double y_206631 = defunc_2_reduce_res_206581 *
                                       c12_206622;
                                double y_206632 = x_206630 + y_206631;
                                double det_206633 = 1.0 / y_206632;
                                double a12_206634 = a12_206616 * det_206633;
                                double b12_206635 = b12_206619 * det_206633;
                                double c12_206636 = c12_206622 * det_206633;
                                double b2_206637 = b2_206624 * det_206633;
                                double c2_206638 = c2_206627 * det_206633;
                                double defunc_2_reduce_res_206639;
                                double defunc_2_reduce_res_206640;
                                double redout_207698;
                                double redout_207699;
                                
                                redout_207698 = 0.0;
                                redout_207699 = 0.0;
                                for (int64_t i_207700 = 0; i_207700 <
                                     q_t_203576; i_207700++) {
                                    double x_206648;
                                    
                                    x_206648 =
                                        ((double *) mem_212439)[i_207700];
                                    
                                    double x_206649;
                                    
                                    x_206649 =
                                        ((double *) mem_212469)[i_207700];
                                    
                                    double x_206650;
                                    
                                    x_206650 =
                                        ((double *) mem_212466)[i_207700];
                                    
                                    bool cond_206651 = sle64(x_206523,
                                                             i_207700);
                                    double defunc_0_f_res_206652;
                                    
                                    if (cond_206651) {
                                        defunc_0_f_res_206652 = 0.0;
                                    } else {
                                        int64_t i_206653 = add64(x_206547,
                                                                 i_207700);
                                        double defunc_0_add_arg_206654;
                                        
                                        defunc_0_add_arg_206654 =
                                            ((double *) mem_212387)[i_206653];
                                        defunc_0_f_res_206652 =
                                            defunc_0_add_arg_206654;
                                    }
                                    
                                    double x_206655 = a12_206634 * x_206648;
                                    double y_206656 = b12_206635 * x_206649;
                                    double x_206657 = x_206655 + y_206656;
                                    double y_206658 = c12_206636 * x_206650;
                                    double x_206659 = x_206657 + y_206658;
                                    double defunc_9_fit_fun_res_206660 =
                                           defunc_0_f_res_206652 * x_206659;
                                    double x_206661 = b12_206635 * x_206648;
                                    double y_206662 = b2_206637 * x_206649;
                                    double x_206663 = x_206661 + y_206662;
                                    double y_206664 = c2_206638 * x_206650;
                                    double x_206665 = x_206663 + y_206664;
                                    double defunc_9_slope_fun_res_206666 =
                                           defunc_0_f_res_206652 * x_206665;
                                    double defunc_1_op_res_206643 =
                                           defunc_9_fit_fun_res_206660 +
                                           redout_207698;
                                    double defunc_1_op_res_206646 =
                                           defunc_9_slope_fun_res_206666 +
                                           redout_207699;
                                    double redout_tmp_213805 =
                                           defunc_1_op_res_206643;
                                    double redout_tmp_213806 =
                                           defunc_1_op_res_206646;
                                    
                                    redout_207698 = redout_tmp_213805;
                                    redout_207699 = redout_tmp_213806;
                                }
                                defunc_2_reduce_res_206639 = redout_207698;
                                defunc_2_reduce_res_206640 = redout_207699;
                                ((double *) mem_212342.mem)[i_207712 *
                                                            t_n_m_203740 +
                                                            i_207705] =
                                    defunc_2_reduce_res_206639;
                                ((double *) mem_212346.mem)[i_207712 *
                                                            t_n_m_203740 +
                                                            i_207705] =
                                    defunc_2_reduce_res_206640;
                            }
                        }
                        if (memblock_set(ctx, &ext_mem_212540, &mem_212342,
                                         "mem_212342") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_212532, &mem_212346,
                                         "mem_212346") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_212346, "mem_212346") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_212342, "mem_212342") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_212556, &ext_mem_212540,
                                     "ext_mem_212540") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_212548, &ext_mem_212532,
                                     "ext_mem_212532") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212532,
                                       "ext_mem_212532") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212540,
                                       "ext_mem_212540") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_212572, &ext_mem_212556,
                                 "ext_mem_212556") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_212564, &ext_mem_212548,
                                 "ext_mem_212548") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212548, "ext_mem_212548") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212556, "ext_mem_212556") != 0)
                    return 1;
            }
            
            struct memblock ext_mem_212624;
            
            ext_mem_212624.references = NULL;
            if (cond_204198) {
                bool zzero_206670 = jump_t_203582 == (int64_t) 0;
                bool nonzzero_206671 = !zzero_206670;
                bool nonzzero_cert_206672;
                
                if (!nonzzero_206671) {
                    ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                           "division by zero",
                                           "-> #0  loess.fut:547:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:546:3-550:9\n   #5  stl.fut:304:23-75\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:303:15-305:43\n   #9  stl.fut:415:61-429:75\n   #10 stl.fut:455:3-469:34\n   #11 stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &ext_mem_212624,
                                       "ext_mem_212624") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212564,
                                       "ext_mem_212564") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212572,
                                       "ext_mem_212572") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211636, "mem_211636") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211625,
                                       "ext_mem_211625") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211565,
                                       "ext_mem_211565") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211573,
                                       "ext_mem_211573") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210740,
                                       "ext_mem_210740") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210626,
                                       "ext_mem_210626") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210637,
                                       "ext_mem_210637") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209272,
                                       "mem_param_209272") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209264,
                                       "mem_param_209264") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212632,
                                       "ext_mem_212632") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212633,
                                       "ext_mem_212633") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209250,
                                       "mem_param_209250") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209242,
                                       "mem_param_209242") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209234,
                                       "mem_param_209234") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212961,
                                       "ext_mem_212961") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212962,
                                       "ext_mem_212962") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212963,
                                       "ext_mem_212963") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                
                int64_t y_206673 = sub64(t_n_m_203740, (int64_t) 1);
                struct memblock mem_212583;
                
                mem_212583.references = NULL;
                if (memblock_alloc(ctx, &mem_212583, bytes_208499,
                                   "mem_212583")) {
                    err = 1;
                    goto cleanup;
                }
                for (int64_t i_207721 = 0; i_207721 < partition_sizze_203667;
                     i_207721++) {
                    for (int64_t i_207717 = 0; i_207717 < n_203572;
                         i_207717++) {
                        int64_t m_v_206679 = sdiv64(i_207717, jump_t_203582);
                        bool cond_206680 = m_v_206679 == y_206673;
                        int64_t j_206681;
                        
                        if (cond_206680) {
                            int64_t j_t_res_206682 = sub64(m_v_206679,
                                                           (int64_t) 1);
                            
                            j_206681 = j_t_res_206682;
                        } else {
                            j_206681 = m_v_206679;
                        }
                        
                        int64_t min_arg_206683 = mul64(jump_t_203582, j_206681);
                        int64_t min_res_206684 = smin64(i_203760,
                                                        min_arg_206683);
                        int64_t defunc_0_m_fun_arg_206685 = add64((int64_t) 1,
                                                                  j_206681);
                        int64_t min_arg_206686 = mul64(jump_t_203582,
                                                       defunc_0_m_fun_arg_206685);
                        int64_t min_res_206687 = smin64(i_203760,
                                                        min_arg_206686);
                        int64_t i64_arg_206688 = sub64(min_res_206687,
                                                       min_res_206684);
                        double i64_res_206689 = sitofp_i64_f64(i64_arg_206688);
                        int64_t i64_arg_206690 = sub64(i_207717,
                                                       min_res_206684);
                        double i64_res_206691 = sitofp_i64_f64(i64_arg_206690);
                        double u_206692 = i64_res_206691 / i64_res_206689;
                        double u2_206693 = u_206692 * u_206692;
                        double u3_206694 = u_206692 * u2_206693;
                        double x_206695 = 2.0 * u3_206694;
                        double y_206696 = 3.0 * u2_206693;
                        double x_206697 = x_206695 - y_206696;
                        double x_206698 = 1.0 + x_206697;
                        bool x_206699 = sle64((int64_t) 0, j_206681);
                        bool y_206700 = slt64(j_206681, t_n_m_203740);
                        bool bounds_check_206701 = x_206699 && y_206700;
                        bool index_certs_206702;
                        
                        if (!bounds_check_206701) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) j_206681,
                                          "] out of bounds for array of shape [",
                                          (long long) t_n_m_203740, "].",
                                          "-> #0  loess.fut:536:27-33\n   #1  loess.fut:549:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:546:3-550:9\n   #6  stl.fut:304:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:303:15-305:43\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &mem_212583,
                                               "mem_212583") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212624,
                                               "ext_mem_212624") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212564,
                                               "ext_mem_212564") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212572,
                                               "ext_mem_212572") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_211636,
                                               "mem_211636") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211625,
                                               "ext_mem_211625") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211565,
                                               "ext_mem_211565") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211573,
                                               "ext_mem_211573") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210740,
                                               "ext_mem_210740") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210626,
                                               "ext_mem_210626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210637,
                                               "ext_mem_210637") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209272,
                                               "mem_param_209272") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209264,
                                               "mem_param_209264") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212632,
                                               "ext_mem_212632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212633,
                                               "ext_mem_212633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209250,
                                               "mem_param_209250") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209242,
                                               "mem_param_209242") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209234,
                                               "mem_param_209234") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212961,
                                               "ext_mem_212961") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212962,
                                               "ext_mem_212962") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212963,
                                               "ext_mem_212963") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209226,
                                               "mem_209226") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209222,
                                               "mem_209222") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213477,
                                               "mem_out_213477") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213476,
                                               "mem_out_213476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213475,
                                               "mem_out_213475") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_206703;
                        
                        y_206703 = ((double *) ext_mem_212572.mem)[i_207721 *
                                                                   t_n_m_203740 +
                                                                   j_206681];
                        
                        double x_206704 = x_206698 * y_206703;
                        double x_206705 = y_206696 - x_206695;
                        bool x_206706 = sle64((int64_t) 0,
                                              defunc_0_m_fun_arg_206685);
                        bool y_206707 = slt64(defunc_0_m_fun_arg_206685,
                                              t_n_m_203740);
                        bool bounds_check_206708 = x_206706 && y_206707;
                        bool index_certs_206709;
                        
                        if (!bounds_check_206708) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [",
                                          (long long) defunc_0_m_fun_arg_206685,
                                          "] out of bounds for array of shape [",
                                          (long long) t_n_m_203740, "].",
                                          "-> #0  loess.fut:537:27-37\n   #1  loess.fut:549:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:546:3-550:9\n   #6  stl.fut:304:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:303:15-305:43\n   #10 stl.fut:415:61-429:75\n   #11 stl.fut:455:3-469:34\n   #12 stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &mem_212583,
                                               "mem_212583") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212624,
                                               "ext_mem_212624") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212564,
                                               "ext_mem_212564") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212572,
                                               "ext_mem_212572") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_211636,
                                               "mem_211636") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211625,
                                               "ext_mem_211625") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211565,
                                               "ext_mem_211565") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_211573,
                                               "ext_mem_211573") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210740,
                                               "ext_mem_210740") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210626,
                                               "ext_mem_210626") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_210637,
                                               "ext_mem_210637") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209272,
                                               "mem_param_209272") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209264,
                                               "mem_param_209264") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212632,
                                               "ext_mem_212632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212633,
                                               "ext_mem_212633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209250,
                                               "mem_param_209250") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209242,
                                               "mem_param_209242") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209234,
                                               "mem_param_209234") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212961,
                                               "ext_mem_212961") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212962,
                                               "ext_mem_212962") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212963,
                                               "ext_mem_212963") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209226,
                                               "mem_209226") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209222,
                                               "mem_209222") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213477,
                                               "mem_out_213477") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213476,
                                               "mem_out_213476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213475,
                                               "mem_out_213475") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double y_206710;
                        
                        y_206710 = ((double *) ext_mem_212572.mem)[i_207721 *
                                                                   t_n_m_203740 +
                                                                   defunc_0_m_fun_arg_206685];
                        
                        double y_206711 = x_206705 * y_206710;
                        double x_206712 = x_206704 + y_206711;
                        double y_206713 = 2.0 * u2_206693;
                        double x_206714 = u3_206694 - y_206713;
                        double x_206715 = u_206692 + x_206714;
                        double y_206716;
                        
                        y_206716 = ((double *) ext_mem_212564.mem)[i_207721 *
                                                                   t_n_m_203740 +
                                                                   j_206681];
                        
                        double x_206717 = x_206715 * y_206716;
                        double y_206718 = i64_res_206689 * x_206717;
                        double x_206719 = x_206712 + y_206718;
                        double x_206720 = u3_206694 - u2_206693;
                        double y_206721;
                        
                        y_206721 = ((double *) ext_mem_212564.mem)[i_207721 *
                                                                   t_n_m_203740 +
                                                                   defunc_0_m_fun_arg_206685];
                        
                        double x_206722 = x_206720 * y_206721;
                        double y_206723 = i64_res_206689 * x_206722;
                        double defunc_4_interpolate_proc_res_206724 = x_206719 +
                               y_206723;
                        
                        ((double *) mem_212583.mem)[i_207721 * n_203572 +
                                                    i_207717] =
                            defunc_4_interpolate_proc_res_206724;
                    }
                }
                if (memblock_set(ctx, &ext_mem_212624, &mem_212583,
                                 "mem_212583") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_212583, "mem_212583") != 0)
                    return 1;
            } else {
                bool dim_match_206726 = n_203572 == t_n_m_203740;
                bool empty_or_match_cert_206727;
                
                if (!dim_match_206726) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Value of (core language) shape (",
                                  (long long) partition_sizze_203667, ", ",
                                  (long long) t_n_m_203740,
                                  ") cannot match shape of type `[",
                                  (long long) partition_sizze_203667, "][",
                                  (long long) n_203572, "]t`.",
                                  "-> #0  stl.fut:307:15-36\n   #1  stl.fut:415:61-429:75\n   #2  stl.fut:455:3-469:34\n   #3  stl.fut:439:1-469:34\n");
                    if (memblock_unref(ctx, &ext_mem_212624,
                                       "ext_mem_212624") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212564,
                                       "ext_mem_212564") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212572,
                                       "ext_mem_212572") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_211636, "mem_211636") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211625,
                                       "ext_mem_211625") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211565,
                                       "ext_mem_211565") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_211573,
                                       "ext_mem_211573") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210740,
                                       "ext_mem_210740") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210626,
                                       "ext_mem_210626") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_210637,
                                       "ext_mem_210637") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209272,
                                       "mem_param_209272") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209264,
                                       "mem_param_209264") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212632,
                                       "ext_mem_212632") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212633,
                                       "ext_mem_212633") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209250,
                                       "mem_param_209250") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209242,
                                       "mem_param_209242") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_209234,
                                       "mem_param_209234") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212961,
                                       "ext_mem_212961") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212962,
                                       "ext_mem_212962") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_212963,
                                       "ext_mem_212963") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213477,
                                       "mem_out_213477") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213476,
                                       "mem_out_213476") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_213475,
                                       "mem_out_213475") != 0)
                        return 1;
                    err = 1;
                    goto cleanup;
                }
                if (memblock_set(ctx, &ext_mem_212624, &ext_mem_212572,
                                 "ext_mem_212572") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_212564, "ext_mem_212564") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_212572, "ext_mem_212572") != 0)
                return 1;
            
            int64_t ctx_param_ext_tmp_213562 = ext_212628;
            int64_t ctx_param_ext_tmp_213563 = ext_212627;
            struct memblock mem_param_tmp_213564;
            
            mem_param_tmp_213564.references = NULL;
            if (memblock_set(ctx, &mem_param_tmp_213564, &mem_211636,
                             "mem_211636") != 0)
                return 1;
            
            struct memblock mem_param_tmp_213565;
            
            mem_param_tmp_213565.references = NULL;
            if (memblock_set(ctx, &mem_param_tmp_213565, &ext_mem_212624,
                             "ext_mem_212624") != 0)
                return 1;
            ctx_param_ext_209266 = ctx_param_ext_tmp_213562;
            ctx_param_ext_209268 = ctx_param_ext_tmp_213563;
            if (memblock_set(ctx, &mem_param_209264, &mem_param_tmp_213564,
                             "mem_param_tmp_213564") != 0)
                return 1;
            if (memblock_set(ctx, &mem_param_209272, &mem_param_tmp_213565,
                             "mem_param_tmp_213565") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_tmp_213565,
                               "mem_param_tmp_213565") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_tmp_213564,
                               "mem_param_tmp_213564") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_212624, "ext_mem_212624") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_212564, "ext_mem_212564") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_212572, "ext_mem_212572") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_211636, "mem_211636") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_211625, "ext_mem_211625") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_211565, "ext_mem_211565") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_211573, "ext_mem_211573") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_210740, "ext_mem_210740") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_210626, "ext_mem_210626") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_210637, "ext_mem_210637") != 0)
                return 1;
        }
        ext_212639 = ctx_param_ext_209266;
        ext_212637 = ctx_param_ext_209268;
        if (memblock_set(ctx, &ext_mem_212633, &mem_param_209264,
                         "mem_param_209264") != 0)
            return 1;
        if (memblock_set(ctx, &ext_mem_212632, &mem_param_209272,
                         "mem_param_209272") != 0)
            return 1;
        
        bool cond_206729 = slt64(i_outer_204282, y_204199);
        int64_t ext_212960;
        
        if (cond_206729) {
            ext_212960 = partition_sizze_203667;
        } else {
            ext_212960 = ctx_param_ext_209247;
        }
        
        int64_t ext_212959;
        
        if (cond_206729) {
            ext_212959 = n_203572;
        } else {
            ext_212959 = ctx_param_ext_209249;
        }
        
        int64_t ext_212958;
        
        if (cond_206729) {
            ext_212958 = partition_sizze_203667;
        } else {
            ext_212958 = ctx_param_ext_209243;
        }
        
        int64_t ext_212957;
        
        if (cond_206729) {
            ext_212957 = n_203572;
        } else {
            ext_212957 = ctx_param_ext_209244;
        }
        
        int64_t ext_212956;
        
        if (cond_206729) {
            ext_212956 = n_203572;
        } else {
            ext_212956 = ctx_param_ext_209246;
        }
        
        int64_t ext_212955;
        
        if (cond_206729) {
            ext_212955 = (int64_t) 1;
        } else {
            ext_212955 = ctx_param_ext_209248;
        }
        
        int64_t ext_212954;
        
        if (cond_206729) {
            ext_212954 = (int64_t) 0;
        } else {
            ext_212954 = ctx_param_ext_209245;
        }
        
        struct memblock ext_mem_212953;
        
        ext_mem_212953.references = NULL;
        if (cond_206729) {
            if (mem_212651_cached_sizze_213920 < (size_t) bytes_208499) {
                mem_212651 = realloc(mem_212651, bytes_208499);
                mem_212651_cached_sizze_213920 = bytes_208499;
            }
            if (mem_212655_cached_sizze_213921 < (size_t) bytes_208499) {
                mem_212655 = realloc(mem_212655, bytes_208499);
                mem_212655_cached_sizze_213921 = bytes_208499;
            }
            for (int64_t i_207735 = 0; i_207735 < partition_sizze_203667;
                 i_207735++) {
                for (int64_t i_207725 = 0; i_207725 < n_203572; i_207725++) {
                    double x_206738;
                    
                    x_206738 = ((double *) mem_208460)[i_207735 * n_203572 +
                                                       i_207725];
                    
                    double x_206739;
                    
                    x_206739 = ((double *) ext_mem_212633.mem)[i_207735 *
                                                               n_203572 +
                                                               i_207725];
                    
                    double x_206740;
                    
                    x_206740 = ((double *) ext_mem_212632.mem)[i_207735 *
                                                               ext_212637 +
                                                               i_207725];
                    
                    double x_206741 = x_206738 - x_206739;
                    double defunc_2_f_res_206742 = x_206741 - x_206740;
                    bool isnan_res_206743;
                    
                    isnan_res_206743 = futrts_isnan64(defunc_2_f_res_206742);
                    
                    double defunc_0_f_res_206744;
                    
                    if (isnan_res_206743) {
                        defunc_0_f_res_206744 = defunc_2_f_res_206742;
                    } else {
                        double abs_res_206745 = fabs(defunc_2_f_res_206742);
                        
                        defunc_0_f_res_206744 = abs_res_206745;
                    }
                    ((double *) mem_212655)[i_207735 * n_203572 + i_207725] =
                        defunc_0_f_res_206744;
                }
                for (int64_t i_207729 = 0; i_207729 < n_203572; i_207729++) {
                    int64_t x_206747;
                    
                    x_206747 = ((int64_t *) mem_208500)[i_207735 * n_203572 +
                                                        i_207729];
                    
                    bool cond_206748 = sle64((int64_t) 0, x_206747);
                    double defunc_0_f_res_206749;
                    
                    if (cond_206748) {
                        bool y_206750 = slt64(x_206747, n_203572);
                        bool bounds_check_206751 = cond_206748 && y_206750;
                        bool index_certs_206752;
                        
                        if (!bounds_check_206751) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) x_206747,
                                          "] out of bounds for array of shape [",
                                          (long long) n_203572, "].",
                                          "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:334:21-49\n   #3  /prelude/soacs.fut:67:19-23\n   #4  /prelude/soacs.fut:67:3-37\n   #5  stl.fut:332:13-335:35\n   #6  stl.fut:415:61-429:75\n   #7  stl.fut:455:3-469:34\n   #8  stl.fut:439:1-469:34\n");
                            if (memblock_unref(ctx, &ext_mem_212953,
                                               "ext_mem_212953") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209272,
                                               "mem_param_209272") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209264,
                                               "mem_param_209264") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212632,
                                               "ext_mem_212632") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212633,
                                               "ext_mem_212633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209250,
                                               "mem_param_209250") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209242,
                                               "mem_param_209242") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_209234,
                                               "mem_param_209234") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212961,
                                               "ext_mem_212961") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212962,
                                               "ext_mem_212962") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_212963,
                                               "ext_mem_212963") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209226,
                                               "mem_209226") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_209222,
                                               "mem_209222") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213477,
                                               "mem_out_213477") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213476,
                                               "mem_out_213476") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_213475,
                                               "mem_out_213475") != 0)
                                return 1;
                            err = 1;
                            goto cleanup;
                        }
                        
                        double defunc_0_f_res_t_res_206753;
                        
                        defunc_0_f_res_t_res_206753 =
                            ((double *) mem_212655)[i_207735 * n_203572 +
                                                    x_206747];
                        defunc_0_f_res_206749 = defunc_0_f_res_t_res_206753;
                    } else {
                        defunc_0_f_res_206749 = INFINITY;
                    }
                    ((double *) mem_212651)[i_207735 * n_203572 + i_207729] =
                        defunc_0_f_res_206749;
                }
            }
            
            bool loop_nonempty_206756 = slt32(0, iters_206755);
            bool loop_not_taken_206757 = !loop_nonempty_206756;
            bool protect_assert_disj_206758 = bounds_check_203763 ||
                 loop_not_taken_206757;
            bool index_certs_206759;
            
            if (!protect_assert_disj_206758) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) i_203760,
                              "] out of bounds for array of shape [",
                              (long long) n_203572, "].",
                              "-> #0  /prelude/array.fut:26:29-34\n   #1  lib/github.com/diku-dk/sorts/radix_sort.fut:25:24-35\n   #2  lib/github.com/diku-dk/sorts/radix_sort.fut:53:31-62\n   #3  lib/github.com/diku-dk/sorts/radix_sort.fut:104:6-36\n   #4  stl.fut:338:35-77\n   #5  stl.fut:337:28-339:40\n   #6  stl.fut:415:61-429:75\n   #7  stl.fut:455:3-469:34\n   #8  stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &ext_mem_212953, "ext_mem_212953") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209272,
                                   "mem_param_209272") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209264,
                                   "mem_param_209264") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212632, "ext_mem_212632") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212633, "ext_mem_212633") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209250,
                                   "mem_param_209250") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209242,
                                   "mem_param_209242") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209234,
                                   "mem_param_209234") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212961, "ext_mem_212961") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212962, "ext_mem_212962") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212963, "ext_mem_212963") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            if (mem_212739_cached_sizze_213922 < (size_t) bytes_208499) {
                mem_212739 = realloc(mem_212739, bytes_208499);
                mem_212739_cached_sizze_213922 = bytes_208499;
            }
            if (mem_212760_cached_sizze_213923 < (size_t) bytes_212759) {
                mem_212760 = realloc(mem_212760, bytes_212759);
                mem_212760_cached_sizze_213923 = bytes_212759;
            }
            if (mem_212763_cached_sizze_213924 < (size_t) bytes_212759) {
                mem_212763 = realloc(mem_212763, bytes_212759);
                mem_212763_cached_sizze_213924 = bytes_212759;
            }
            if (mem_212766_cached_sizze_213925 < (size_t) bytes_212759) {
                mem_212766 = realloc(mem_212766, bytes_212759);
                mem_212766_cached_sizze_213925 = bytes_212759;
            }
            if (mem_212769_cached_sizze_213926 < (size_t) bytes_212759) {
                mem_212769 = realloc(mem_212769, bytes_212759);
                mem_212769_cached_sizze_213926 = bytes_212759;
            }
            if (mem_212772_cached_sizze_213927 < (size_t) bytes_212771) {
                mem_212772 = realloc(mem_212772, bytes_212771);
                mem_212772_cached_sizze_213927 = bytes_212771;
            }
            if (mem_212835_cached_sizze_213928 < (size_t) bytes_212759) {
                mem_212835 = realloc(mem_212835, bytes_212759);
                mem_212835_cached_sizze_213928 = bytes_212759;
            }
            for (int64_t i_207773 = 0; i_207773 < partition_sizze_203667;
                 i_207773++) {
                if (n_203572 * (int64_t) 8 > 0)
                    memmove(mem_212739 + i_207773 * n_203572 * (int64_t) 8,
                            mem_212651 + ((int64_t) 0 + i_207773 * n_203572) *
                            (int64_t) 8, n_203572 * (int64_t) 8);
                for (int32_t i_206763 = 0; i_206763 < iters_206755;
                     i_206763++) {
                    int32_t defunc_2_radix_sort_step_arg_206765 = mul32(2,
                                                                        i_206763);
                    int32_t defunc_0_get_bit_arg_206766 = add32(1,
                                                                defunc_2_radix_sort_step_arg_206765);
                    bool cond_f_res_206767 = defunc_0_get_bit_arg_206766 == 63;
                    bool cond_f_res_206768 =
                         defunc_2_radix_sort_step_arg_206765 == 63;
                    int64_t unsign_arg_206769 =
                            zext_i32_i64(defunc_0_get_bit_arg_206766);
                    int64_t unsign_arg_206770 =
                            zext_i32_i64(defunc_2_radix_sort_step_arg_206765);
                    int64_t discard_207758;
                    int64_t discard_207759;
                    int64_t discard_207760;
                    int64_t discard_207761;
                    int64_t scanacc_207743;
                    int64_t scanacc_207744;
                    int64_t scanacc_207745;
                    int64_t scanacc_207746;
                    
                    scanacc_207743 = (int64_t) 0;
                    scanacc_207744 = (int64_t) 0;
                    scanacc_207745 = (int64_t) 0;
                    scanacc_207746 = (int64_t) 0;
                    for (int64_t i_207752 = 0; i_207752 < n_203572;
                         i_207752++) {
                        double x_206812;
                        
                        x_206812 = ((double *) mem_212739)[i_207773 * n_203572 +
                                                           i_207752];
                        
                        int64_t i64_arg_206813;
                        
                        i64_arg_206813 = futrts_to_bits64(x_206812);
                        
                        int64_t unsign_arg_206814 = ashr64(i64_arg_206813,
                                                           unsign_arg_206769);
                        int64_t unsign_arg_206815 = (int64_t) 1 &
                                unsign_arg_206814;
                        int32_t to_i32_res_206816 =
                                zext_i64_i32(unsign_arg_206815);
                        int64_t unsign_arg_206817 = ashr64(i64_arg_206813,
                                                           (int64_t) 63);
                        int64_t unsign_arg_206818 = (int64_t) 1 &
                                unsign_arg_206817;
                        int32_t to_i32_res_206819 =
                                zext_i64_i32(unsign_arg_206818);
                        bool cond_206820 = to_i32_res_206819 == 1;
                        bool x_206821 = !cond_206820;
                        bool y_206822 = cond_f_res_206767 && x_206821;
                        bool cond_206823 = cond_206820 || y_206822;
                        int32_t defunc_1_get_bit_res_206824;
                        
                        if (cond_206823) {
                            int32_t defunc_1_get_bit_res_t_res_206825 = 1 ^
                                    to_i32_res_206816;
                            
                            defunc_1_get_bit_res_206824 =
                                defunc_1_get_bit_res_t_res_206825;
                        } else {
                            defunc_1_get_bit_res_206824 = to_i32_res_206816;
                        }
                        
                        int32_t x_206826 = mul32(2,
                                                 defunc_1_get_bit_res_206824);
                        int64_t unsign_arg_206827 = ashr64(i64_arg_206813,
                                                           unsign_arg_206770);
                        int64_t unsign_arg_206828 = (int64_t) 1 &
                                unsign_arg_206827;
                        int32_t to_i32_res_206829 =
                                zext_i64_i32(unsign_arg_206828);
                        bool y_206830 = cond_f_res_206768 && x_206821;
                        bool cond_206831 = cond_206820 || y_206830;
                        int32_t defunc_1_get_bit_res_206832;
                        
                        if (cond_206831) {
                            int32_t defunc_1_get_bit_res_t_res_206833 = 1 ^
                                    to_i32_res_206829;
                            
                            defunc_1_get_bit_res_206832 =
                                defunc_1_get_bit_res_t_res_206833;
                        } else {
                            defunc_1_get_bit_res_206832 = to_i32_res_206829;
                        }
                        
                        int32_t defunc_0_f_res_206834 = add32(x_206826,
                                                              defunc_1_get_bit_res_206832);
                        bool cond_206835 = defunc_0_f_res_206834 == 0;
                        int64_t defunc_0_f_res_206836 =
                                btoi_bool_i64(cond_206835);
                        int64_t defunc_0_f_res_206837;
                        int64_t defunc_0_f_res_206838;
                        int64_t defunc_0_f_res_206839;
                        
                        if (cond_206835) {
                            defunc_0_f_res_206837 = (int64_t) 0;
                            defunc_0_f_res_206838 = (int64_t) 0;
                            defunc_0_f_res_206839 = (int64_t) 0;
                        } else {
                            bool cond_206840 = defunc_0_f_res_206834 == 1;
                            int64_t defunc_0_f_res_f_res_206841 =
                                    btoi_bool_i64(cond_206840);
                            int64_t defunc_0_f_res_f_res_206842;
                            int64_t defunc_0_f_res_f_res_206843;
                            
                            if (cond_206840) {
                                defunc_0_f_res_f_res_206842 = (int64_t) 0;
                                defunc_0_f_res_f_res_206843 = (int64_t) 0;
                            } else {
                                bool cond_206844 = defunc_0_f_res_206834 == 2;
                                int64_t defunc_0_f_res_f_res_f_res_206845 =
                                        btoi_bool_i64(cond_206844);
                                bool cond_neg_206846 = !cond_206844;
                                int64_t defunc_0_f_res_f_res_f_res_206847 =
                                        btoi_bool_i64(cond_neg_206846);
                                
                                defunc_0_f_res_f_res_206842 =
                                    defunc_0_f_res_f_res_f_res_206845;
                                defunc_0_f_res_f_res_206843 =
                                    defunc_0_f_res_f_res_f_res_206847;
                            }
                            defunc_0_f_res_206837 = defunc_0_f_res_f_res_206841;
                            defunc_0_f_res_206838 = defunc_0_f_res_f_res_206842;
                            defunc_0_f_res_206839 = defunc_0_f_res_f_res_206843;
                        }
                        
                        int64_t defunc_1_op_res_206808 =
                                add64(defunc_0_f_res_206836, scanacc_207743);
                        int64_t defunc_1_op_res_206809 =
                                add64(defunc_0_f_res_206837, scanacc_207744);
                        int64_t defunc_1_op_res_206810 =
                                add64(defunc_0_f_res_206838, scanacc_207745);
                        int64_t defunc_1_op_res_206811 =
                                add64(defunc_0_f_res_206839, scanacc_207746);
                        
                        ((int64_t *) mem_212760)[i_207752] =
                            defunc_1_op_res_206808;
                        ((int64_t *) mem_212763)[i_207752] =
                            defunc_1_op_res_206809;
                        ((int64_t *) mem_212766)[i_207752] =
                            defunc_1_op_res_206810;
                        ((int64_t *) mem_212769)[i_207752] =
                            defunc_1_op_res_206811;
                        ((int32_t *) mem_212772)[i_207752] =
                            defunc_0_f_res_206834;
                        
                        int64_t scanacc_tmp_213815 = defunc_1_op_res_206808;
                        int64_t scanacc_tmp_213816 = defunc_1_op_res_206809;
                        int64_t scanacc_tmp_213817 = defunc_1_op_res_206810;
                        int64_t scanacc_tmp_213818 = defunc_1_op_res_206811;
                        
                        scanacc_207743 = scanacc_tmp_213815;
                        scanacc_207744 = scanacc_tmp_213816;
                        scanacc_207745 = scanacc_tmp_213817;
                        scanacc_207746 = scanacc_tmp_213818;
                    }
                    discard_207758 = scanacc_207743;
                    discard_207759 = scanacc_207744;
                    discard_207760 = scanacc_207745;
                    discard_207761 = scanacc_207746;
                    
                    int64_t last_res_206853;
                    
                    last_res_206853 = ((int64_t *) mem_212760)[i_203760];
                    
                    int64_t last_res_206854;
                    
                    last_res_206854 = ((int64_t *) mem_212763)[i_203760];
                    
                    int64_t last_res_206855;
                    
                    last_res_206855 = ((int64_t *) mem_212766)[i_203760];
                    if (n_203572 * (int64_t) 8 > 0)
                        memmove(mem_212835 + (int64_t) 0, mem_212739 +
                                ((int64_t) 0 + i_207773 * n_203572) *
                                (int64_t) 8, n_203572 * (int64_t) 8);
                    for (int64_t write_iter_207762 = 0; write_iter_207762 <
                         n_203572; write_iter_207762++) {
                        int32_t write_iv_207764;
                        
                        write_iv_207764 =
                            ((int32_t *) mem_212772)[write_iter_207762];
                        
                        int64_t write_iv_207765;
                        
                        write_iv_207765 =
                            ((int64_t *) mem_212760)[write_iter_207762];
                        
                        int64_t write_iv_207766;
                        
                        write_iv_207766 =
                            ((int64_t *) mem_212763)[write_iter_207762];
                        
                        int64_t write_iv_207767;
                        
                        write_iv_207767 =
                            ((int64_t *) mem_212766)[write_iter_207762];
                        
                        int64_t write_iv_207768;
                        
                        write_iv_207768 =
                            ((int64_t *) mem_212769)[write_iter_207762];
                        
                        bool match_lit_206864 = 0 == write_iv_207764;
                        int64_t defunc_1_f_res_206865;
                        
                        if (match_lit_206864) {
                            int64_t case_res_206866 = sub64(write_iv_207765,
                                                            (int64_t) 1);
                            
                            defunc_1_f_res_206865 = case_res_206866;
                        } else {
                            bool match_lit_206867 = 1 == write_iv_207764;
                            int64_t x_206868;
                            
                            if (match_lit_206867) {
                                int64_t x_206869 = add64(last_res_206853,
                                                         write_iv_207766);
                                int64_t case_res_206870 = sub64(x_206869,
                                                                (int64_t) 1);
                                
                                x_206868 = case_res_206870;
                            } else {
                                bool match_lit_206871 = 2 == write_iv_207764;
                                int64_t x_206872;
                                
                                if (match_lit_206871) {
                                    int64_t x_206873 = add64(last_res_206853,
                                                             last_res_206854);
                                    int64_t x_206874 = add64(x_206873,
                                                             write_iv_207767);
                                    int64_t case_res_206875 = sub64(x_206874,
                                                                    (int64_t) 1);
                                    
                                    x_206872 = case_res_206875;
                                } else {
                                    int64_t x_206876 = add64(last_res_206853,
                                                             last_res_206854);
                                    int64_t x_206877 = add64(last_res_206855,
                                                             x_206876);
                                    int64_t x_206878 = add64(x_206877,
                                                             write_iv_207768);
                                    int64_t defunc_1_f_res_res_206879 =
                                            sub64(x_206878, (int64_t) 1);
                                    
                                    x_206872 = defunc_1_f_res_res_206879;
                                }
                                x_206868 = x_206872;
                            }
                            defunc_1_f_res_206865 = x_206868;
                        }
                        if (sle64((int64_t) 0, defunc_1_f_res_206865) &&
                            slt64(defunc_1_f_res_206865, n_203572)) {
                            if ((int64_t) 8 > 0)
                                memmove(mem_212835 + defunc_1_f_res_206865 *
                                        (int64_t) 8, mem_212739 + ((int64_t) 0 +
                                                                   i_207773 *
                                                                   n_203572 +
                                                                   (int64_t) 1 *
                                                                   write_iter_207762) *
                                        (int64_t) 8, (int64_t) 8);
                        }
                    }
                    if (n_203572 * (int64_t) 8 > 0)
                        memmove(mem_212739 + i_207773 * n_203572 * (int64_t) 8,
                                mem_212835 + (int64_t) 0, n_203572 *
                                (int64_t) 8);
                }
            }
            
            bool empty_slice_206881 = j_m_i_204223 == (int64_t) 0;
            int64_t m_206882 = sub64(j_m_i_204223, (int64_t) 1);
            int64_t i_p_m_t_s_206883 = add64(stl_res_203754, m_206882);
            bool zzero_leq_i_p_m_t_s_206884 = sle64((int64_t) 0,
                                                    i_p_m_t_s_206883);
            bool i_p_m_t_s_leq_w_206885 = slt64(i_p_m_t_s_206883, n_203572);
            bool zzero_lte_i_206886 = sle64((int64_t) 0, stl_res_203754);
            bool i_lte_j_206887 = sle64(stl_res_203754, stl_res_203755);
            bool y_206888 = i_p_m_t_s_leq_w_206885 && zzero_lte_i_206886;
            bool y_206889 = zzero_leq_i_p_m_t_s_206884 && y_206888;
            bool y_206890 = i_lte_j_206887 && y_206889;
            bool forwards_ok_206891 = zzero_lte_i_206886 && y_206890;
            bool ok_or_empty_206892 = empty_slice_206881 || forwards_ok_206891;
            bool index_certs_206893;
            
            if (!ok_or_empty_206892) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) stl_res_203754, ":",
                              (long long) stl_res_203755,
                              "] out of bounds for array of shape [",
                              (long long) n_203572, "].",
                              "-> #0  stl.fut:344:33-51\n   #1  stl.fut:342:13-349:28\n   #2  stl.fut:415:61-429:75\n   #3  stl.fut:455:3-469:34\n   #4  stl.fut:439:1-469:34\n");
                if (memblock_unref(ctx, &ext_mem_212953, "ext_mem_212953") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209272,
                                   "mem_param_209272") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209264,
                                   "mem_param_209264") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212632, "ext_mem_212632") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212633, "ext_mem_212633") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209250,
                                   "mem_param_209250") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209242,
                                   "mem_param_209242") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_209234,
                                   "mem_param_209234") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212961, "ext_mem_212961") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212962, "ext_mem_212962") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_212963, "ext_mem_212963") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
                    return 1;
                err = 1;
                goto cleanup;
            }
            if (mem_212866_cached_sizze_213929 < (size_t) bytes_208502) {
                mem_212866 = realloc(mem_212866, bytes_208502);
                mem_212866_cached_sizze_213929 = bytes_208502;
            }
            if (mem_212869_cached_sizze_213930 < (size_t) bytes_208502) {
                mem_212869 = realloc(mem_212869, bytes_208502);
                mem_212869_cached_sizze_213930 = bytes_208502;
            }
            if (mem_212872_cached_sizze_213931 < (size_t) bytes_208502) {
                mem_212872 = realloc(mem_212872, bytes_208502);
                mem_212872_cached_sizze_213931 = bytes_208502;
            }
            for (int64_t i_207783 = 0; i_207783 < partition_sizze_203667;
                 i_207783++) {
                double defunc_2_reduce_res_206899;
                double redout_207775 = 0.0;
                
                for (int64_t i_207776 = 0; i_207776 < j_m_i_204223;
                     i_207776++) {
                    int64_t slice_207810 = stl_res_203754 + i_207776;
                    double x_206903;
                    
                    x_206903 = ((double *) mem_212739)[i_207783 * n_203572 +
                                                       slice_207810];
                    
                    double defunc_1_op_res_206902 = x_206903 + redout_207775;
                    double redout_tmp_213828 = defunc_1_op_res_206902;
                    
                    redout_207775 = redout_tmp_213828;
                }
                defunc_2_reduce_res_206899 = redout_207775;
                
                double h_206904 = 3.0 * defunc_2_reduce_res_206899;
                double h9_206905 = 0.999 * h_206904;
                double h1_206906 = 1.0e-3 * h_206904;
                
                ((double *) mem_212866)[i_207783] = h_206904;
                ((double *) mem_212869)[i_207783] = h9_206905;
                ((double *) mem_212872)[i_207783] = h1_206906;
            }
            
            struct memblock mem_212912;
            
            mem_212912.references = NULL;
            if (memblock_alloc(ctx, &mem_212912, bytes_208499, "mem_212912")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_207793 = 0; i_207793 < partition_sizze_203667;
                 i_207793++) {
                double x_206912;
                
                x_206912 = ((double *) mem_212866)[i_207793];
                
                double x_206913;
                
                x_206913 = ((double *) mem_212869)[i_207793];
                
                double x_206914;
                
                x_206914 = ((double *) mem_212872)[i_207793];
                for (int64_t i_207789 = 0; i_207789 < n_203572; i_207789++) {
                    double x_206916;
                    
                    x_206916 = ((double *) mem_212655)[i_207793 * n_203572 +
                                                       i_207789];
                    
                    double x_206917 = x_206916 / x_206912;
                    double y_206918 = fpow64(x_206917, 2.0);
                    double x_206919 = 1.0 - y_206918;
                    double bicube_206920 = fpow64(x_206919, 2.0);
                    bool isnan_res_206921;
                    
                    isnan_res_206921 = futrts_isnan64(x_206916);
                    
                    bool cond_f_res_206922 = x_206916 <= x_206914;
                    bool x_206923 = !isnan_res_206921;
                    bool y_206924 = cond_f_res_206922 && x_206923;
                    bool cond_206925 = isnan_res_206921 || y_206924;
                    double defunc_0_f_res_206926;
                    
                    if (cond_206925) {
                        defunc_0_f_res_206926 = 1.0;
                    } else {
                        bool cond_206927 = x_206913 <= x_206916;
                        bool cond_f_res_206928 = x_206916 <= 1.0e-6;
                        bool x_206929 = !cond_206927;
                        bool y_206930 = cond_f_res_206928 && x_206929;
                        bool cond_206931 = cond_206927 || y_206930;
                        double defunc_0_f_res_f_res_206932;
                        
                        if (cond_206931) {
                            defunc_0_f_res_f_res_206932 = 1.0e-6;
                        } else {
                            defunc_0_f_res_f_res_206932 = bicube_206920;
                        }
                        defunc_0_f_res_206926 = defunc_0_f_res_f_res_206932;
                    }
                    ((double *) mem_212912.mem)[i_207793 * n_203572 +
                                                i_207789] =
                        defunc_0_f_res_206926;
                }
            }
            if (memblock_set(ctx, &ext_mem_212953, &mem_212912, "mem_212912") !=
                0)
                return 1;
            if (memblock_unref(ctx, &mem_212912, "mem_212912") != 0)
                return 1;
        } else {
            if (memblock_set(ctx, &ext_mem_212953, &mem_param_209250,
                             "mem_param_209250") != 0)
                return 1;
        }
        
        int64_t ctx_param_ext_tmp_213547 = ext_212639;
        int64_t ctx_param_ext_tmp_213548 = ext_212637;
        int64_t ctx_param_ext_tmp_213549 = ext_212958;
        int64_t ctx_param_ext_tmp_213550 = ext_212957;
        int64_t ctx_param_ext_tmp_213551 = ext_212954;
        int64_t ctx_param_ext_tmp_213552 = ext_212956;
        int64_t ctx_param_ext_tmp_213553 = ext_212960;
        int64_t ctx_param_ext_tmp_213554 = ext_212955;
        int64_t ctx_param_ext_tmp_213555 = ext_212959;
        struct memblock mem_param_tmp_213556;
        
        mem_param_tmp_213556.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_213556, &ext_mem_212633,
                         "ext_mem_212633") != 0)
            return 1;
        
        struct memblock mem_param_tmp_213557;
        
        mem_param_tmp_213557.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_213557, &ext_mem_212632,
                         "ext_mem_212632") != 0)
            return 1;
        
        struct memblock mem_param_tmp_213558;
        
        mem_param_tmp_213558.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_213558, &ext_mem_212953,
                         "ext_mem_212953") != 0)
            return 1;
        ctx_param_ext_209236 = ctx_param_ext_tmp_213547;
        ctx_param_ext_209238 = ctx_param_ext_tmp_213548;
        ctx_param_ext_209243 = ctx_param_ext_tmp_213549;
        ctx_param_ext_209244 = ctx_param_ext_tmp_213550;
        ctx_param_ext_209245 = ctx_param_ext_tmp_213551;
        ctx_param_ext_209246 = ctx_param_ext_tmp_213552;
        ctx_param_ext_209247 = ctx_param_ext_tmp_213553;
        ctx_param_ext_209248 = ctx_param_ext_tmp_213554;
        ctx_param_ext_209249 = ctx_param_ext_tmp_213555;
        if (memblock_set(ctx, &mem_param_209234, &mem_param_tmp_213556,
                         "mem_param_tmp_213556") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_209242, &mem_param_tmp_213557,
                         "mem_param_tmp_213557") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_209250, &mem_param_tmp_213558,
                         "mem_param_tmp_213558") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_213558,
                           "mem_param_tmp_213558") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_213557,
                           "mem_param_tmp_213557") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_213556,
                           "mem_param_tmp_213556") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_212953, "ext_mem_212953") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_209272, "mem_param_209272") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_209264, "mem_param_209264") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_212632, "ext_mem_212632") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_212633, "ext_mem_212633") != 0)
            return 1;
    }
    ext_212976 = ctx_param_ext_209236;
    ext_212974 = ctx_param_ext_209238;
    ext_212970 = ctx_param_ext_209243;
    ext_212969 = ctx_param_ext_209244;
    ext_212968 = ctx_param_ext_209245;
    ext_212967 = ctx_param_ext_209246;
    ext_212966 = ctx_param_ext_209247;
    ext_212965 = ctx_param_ext_209248;
    ext_212964 = ctx_param_ext_209249;
    if (memblock_set(ctx, &ext_mem_212963, &mem_param_209234,
                     "mem_param_209234") != 0)
        return 1;
    if (memblock_set(ctx, &ext_mem_212962, &mem_param_209242,
                     "mem_param_209242") != 0)
        return 1;
    if (memblock_set(ctx, &ext_mem_212961, &mem_param_209250,
                     "mem_param_209250") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
        return 1;
    if (mem_212988_cached_sizze_213932 < (size_t) bytes_208459) {
        mem_212988 = realloc(mem_212988, bytes_208459);
        mem_212988_cached_sizze_213932 = bytes_208459;
    }
    for (int64_t i_213831 = 0; i_213831 < m_203571; i_213831++) {
        for (int64_t i_213832 = 0; i_213832 < n_203572; i_213832++) {
            ((double *) mem_212988)[i_213831 * n_203572 + i_213832] = NAN;
        }
    }
    if (mem_212992_cached_sizze_213933 < (size_t) bytes_208459) {
        mem_212992 = realloc(mem_212992, bytes_208459);
        mem_212992_cached_sizze_213933 = bytes_208459;
    }
    for (int64_t i_213833 = 0; i_213833 < m_203571; i_213833++) {
        for (int64_t i_213834 = 0; i_213834 < n_203572; i_213834++) {
            ((double *) mem_212992)[i_213833 * n_203572 + i_213834] = NAN;
        }
    }
    if (mem_212996_cached_sizze_213934 < (size_t) bytes_208459) {
        mem_212996 = realloc(mem_212996, bytes_208459);
        mem_212996_cached_sizze_213934 = bytes_208459;
    }
    for (int64_t i_213835 = 0; i_213835 < m_203571; i_213835++) {
        for (int64_t i_213836 = 0; i_213836 < n_203572; i_213836++) {
            ((double *) mem_212996)[i_213835 * n_203572 + i_213836] = NAN;
        }
    }
    
    int64_t binop_y_213027 = (int64_t) 8 * n_203572;
    int64_t bytes_213028 = smax64((int64_t) 0, binop_y_213027);
    
    if (mem_213029_cached_sizze_213935 < (size_t) bytes_213028) {
        mem_213029 = realloc(mem_213029, bytes_213028);
        mem_213029_cached_sizze_213935 = bytes_213028;
    }
    if (mem_213032_cached_sizze_213936 < (size_t) bytes_213028) {
        mem_213032 = realloc(mem_213032, bytes_213028);
        mem_213032_cached_sizze_213936 = bytes_213028;
    }
    if (mem_213035_cached_sizze_213937 < (size_t) bytes_213028) {
        mem_213035 = realloc(mem_213035, bytes_213028);
        mem_213035_cached_sizze_213937 = bytes_213028;
    }
    for (int64_t write_iter_207799 = 0; write_iter_207799 <
         partition_sizze_203667; write_iter_207799++) {
        int64_t write_iv_207806;
        
        write_iv_207806 = ((int64_t *) mem_208463)[write_iter_207799];
        if (n_203572 * (int64_t) 8 > 0)
            memmove(mem_213029 + (int64_t) 0, ext_mem_212963.mem +
                    ((int64_t) 0 + write_iter_207799 * n_203572) * (int64_t) 8,
                    n_203572 * (int64_t) 8);
        if (n_203572 * (int64_t) 8 > 0)
            memmove(mem_213032 + (int64_t) 0, ext_mem_212962.mem +
                    ((int64_t) 0 + write_iter_207799 * ext_212974) *
                    (int64_t) 8, n_203572 * (int64_t) 8);
        for (int64_t i_207797 = 0; i_207797 < n_203572; i_207797++) {
            double x_206945;
            
            x_206945 = ((double *) mem_208460)[write_iter_207799 * n_203572 +
                                               i_207797];
            
            double x_206946;
            
            x_206946 = ((double *) ext_mem_212963.mem)[write_iter_207799 *
                                                       n_203572 + i_207797];
            
            double x_206947;
            
            x_206947 = ((double *) ext_mem_212962.mem)[write_iter_207799 *
                                                       ext_212974 + i_207797];
            
            double x_206948 = x_206945 - x_206946;
            double defunc_2_f_res_206949 = x_206948 - x_206947;
            
            ((double *) mem_213035)[i_207797] = defunc_2_f_res_206949;
        }
        if ((sle64((int64_t) 0, write_iv_207806) && slt64(write_iv_207806,
                                                          m_203571)) &&
            (sle64((int64_t) 0, (int64_t) 0) && slt64(n_203572 - (int64_t) 1,
                                                      n_203572))) {
            if (n_203572 * (int64_t) 8 > 0)
                memmove(mem_212996 + write_iv_207806 * n_203572 * (int64_t) 8,
                        mem_213035 + (int64_t) 0, n_203572 * (int64_t) 8);
        }
        if ((sle64((int64_t) 0, write_iv_207806) && slt64(write_iv_207806,
                                                          m_203571)) &&
            (sle64((int64_t) 0, (int64_t) 0) && slt64(n_203572 - (int64_t) 1,
                                                      n_203572))) {
            if (n_203572 * (int64_t) 8 > 0)
                memmove(mem_212992 + write_iv_207806 * n_203572 * (int64_t) 8,
                        mem_213032 + (int64_t) 0, n_203572 * (int64_t) 8);
        }
        if ((sle64((int64_t) 0, write_iv_207806) && slt64(write_iv_207806,
                                                          m_203571)) &&
            (sle64((int64_t) 0, (int64_t) 0) && slt64(n_203572 - (int64_t) 1,
                                                      n_203572))) {
            if (n_203572 * (int64_t) 8 > 0)
                memmove(mem_212988 + write_iv_207806 * n_203572 * (int64_t) 8,
                        mem_213029 + (int64_t) 0, n_203572 * (int64_t) 8);
        }
    }
    if (memblock_unref(ctx, &ext_mem_212962, "ext_mem_212962") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_212963, "ext_mem_212963") != 0)
        return 1;
    
    struct memblock mem_213075;
    
    mem_213075.references = NULL;
    if (memblock_alloc(ctx, &mem_213075, bytes_208459, "mem_213075")) {
        err = 1;
        goto cleanup;
    }
    if (m_203571 * n_203572 * (int64_t) 8 > 0)
        memmove(mem_213075.mem + (int64_t) 0, mem_212988 + (int64_t) 0,
                m_203571 * n_203572 * (int64_t) 8);
    
    struct memblock mem_213080;
    
    mem_213080.references = NULL;
    if (memblock_alloc(ctx, &mem_213080, bytes_208459, "mem_213080")) {
        err = 1;
        goto cleanup;
    }
    if (m_203571 * n_203572 * (int64_t) 8 > 0)
        memmove(mem_213080.mem + (int64_t) 0, mem_212992 + (int64_t) 0,
                m_203571 * n_203572 * (int64_t) 8);
    
    struct memblock mem_213085;
    
    mem_213085.references = NULL;
    if (memblock_alloc(ctx, &mem_213085, bytes_208459, "mem_213085")) {
        err = 1;
        goto cleanup;
    }
    if (m_203571 * n_203572 * (int64_t) 8 > 0)
        memmove(mem_213085.mem + (int64_t) 0, mem_212996 + (int64_t) 0,
                m_203571 * n_203572 * (int64_t) 8);
    if (memblock_set(ctx, &mem_out_213475, &mem_213075, "mem_213075") != 0)
        return 1;
    if (memblock_set(ctx, &mem_out_213476, &mem_213080, "mem_213080") != 0)
        return 1;
    if (memblock_set(ctx, &mem_out_213477, &mem_213085, "mem_213085") != 0)
        return 1;
    (*mem_out_p_213841).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_213841, &mem_out_213475,
                     "mem_out_213475") != 0)
        return 1;
    (*mem_out_p_213842).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_213842, &mem_out_213476,
                     "mem_out_213476") != 0)
        return 1;
    (*mem_out_p_213843).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_213843, &mem_out_213477,
                     "mem_out_213477") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_213085, "mem_213085") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_213080, "mem_213080") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_213075, "mem_213075") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_209250, "mem_param_209250") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_209242, "mem_param_209242") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_209234, "mem_param_209234") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_212961, "ext_mem_212961") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_212962, "ext_mem_212962") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_212963, "ext_mem_212963") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_209226, "mem_209226") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_209222, "mem_209222") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_213477, "mem_out_213477") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_213476, "mem_out_213476") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_213475, "mem_out_213475") != 0)
        return 1;
    
  cleanup:
    { }
    free(mem_208415);
    free(mem_208418);
    free(mem_208434);
    free(mem_208460);
    free(mem_208463);
    free(mem_208483);
    free(mem_208500);
    free(mem_208503);
    free(mem_208523);
    free(mem_208538);
    free(mem_208575);
    free(mem_208667);
    free(mem_208671);
    free(mem_208724);
    free(mem_208739);
    free(mem_208818);
    free(mem_208823);
    free(mem_208884);
    free(mem_209016);
    free(mem_209020);
    free(mem_209043);
    free(mem_209119);
    free(mem_209123);
    free(mem_209146);
    free(mem_209276);
    free(mem_209321);
    free(mem_209326);
    free(mem_210070);
    free(mem_210229);
    free(mem_210232);
    free(mem_210443);
    free(mem_210446);
    free(mem_210473);
    free(mem_210476);
    free(mem_210751);
    free(mem_210794);
    free(mem_210810);
    free(mem_210823);
    free(mem_210846);
    free(mem_210862);
    free(mem_210875);
    free(mem_210898);
    free(mem_210914);
    free(mem_210927);
    free(mem_211235);
    free(mem_211319);
    free(mem_211322);
    free(mem_211437);
    free(mem_211440);
    free(mem_211467);
    free(mem_211470);
    free(mem_211697);
    free(mem_211712);
    free(mem_211715);
    free(mem_211800);
    free(mem_211815);
    free(mem_211818);
    free(mem_211933);
    free(mem_211948);
    free(mem_211951);
    free(mem_212088);
    free(mem_212103);
    free(mem_212106);
    free(mem_212144);
    free(mem_212206);
    free(mem_212221);
    free(mem_212224);
    free(mem_212273);
    free(mem_212276);
    free(mem_212369);
    free(mem_212384);
    free(mem_212387);
    free(mem_212436);
    free(mem_212439);
    free(mem_212466);
    free(mem_212469);
    free(mem_212651);
    free(mem_212655);
    free(mem_212739);
    free(mem_212760);
    free(mem_212763);
    free(mem_212766);
    free(mem_212769);
    free(mem_212772);
    free(mem_212835);
    free(mem_212866);
    free(mem_212869);
    free(mem_212872);
    free(mem_212988);
    free(mem_212992);
    free(mem_212996);
    free(mem_213029);
    free(mem_213032);
    free(mem_213035);
    return err;
}

int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f64_2d **out0,
                       struct futhark_f64_2d **out1,
                       struct futhark_f64_2d **out2, const
                       struct futhark_f64_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5, const int64_t in6, const int64_t in7, const
                       int64_t in8, const int64_t in9, const int64_t in10, const
                       int64_t in11, const int64_t in12, const int64_t in13,
                       const int64_t in14)
{
    struct memblock Y_mem_208412;
    
    Y_mem_208412.references = NULL;
    
    int64_t m_203571;
    int64_t n_203572;
    int64_t n_p_203574;
    int64_t q_s_203575;
    int64_t q_t_203576;
    int64_t q_l_203577;
    int64_t d_s_203578;
    int64_t d_t_203579;
    int64_t d_l_203580;
    int64_t jump_s_203581;
    int64_t jump_t_203582;
    int64_t jump_l_203583;
    int64_t n_inner_203584;
    int64_t n_outer_203585;
    int64_t jump_threshold_203586;
    int64_t q_threshold_203587;
    struct memblock mem_out_213475;
    
    mem_out_213475.references = NULL;
    
    struct memblock mem_out_213476;
    
    mem_out_213476.references = NULL;
    
    struct memblock mem_out_213477;
    
    mem_out_213477.references = NULL;
    
    int ret = 0;
    
    lock_lock(&ctx->lock);
    Y_mem_208412 = in0->mem;
    m_203571 = in0->shape[0];
    n_203572 = in0->shape[1];
    n_p_203574 = in1;
    q_s_203575 = in2;
    q_t_203576 = in3;
    q_l_203577 = in4;
    d_s_203578 = in5;
    d_t_203579 = in6;
    d_l_203580 = in7;
    jump_s_203581 = in8;
    jump_t_203582 = in9;
    jump_l_203583 = in10;
    n_inner_203584 = in11;
    n_outer_203585 = in12;
    jump_threshold_203586 = in13;
    q_threshold_203587 = in14;
    if (!(m_203571 == in0->shape[0] && n_203572 == in0->shape[1])) {
        ret = 1;
        if (!ctx->error)
            ctx->error =
                msgprintf("Error: entry point arguments have invalid sizes.\n");
    }
    if (ret == 0) {
        ret = futrts_entry_main(ctx, &mem_out_213475, &mem_out_213476,
                                &mem_out_213477, Y_mem_208412, m_203571,
                                n_203572, n_p_203574, q_s_203575, q_t_203576,
                                q_l_203577, d_s_203578, d_t_203579, d_l_203580,
                                jump_s_203581, jump_t_203582, jump_l_203583,
                                n_inner_203584, n_outer_203585,
                                jump_threshold_203586, q_threshold_203587);
        if (ret == 0) {
            assert((*out0 =
                    (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d))) !=
                NULL);
            (*out0)->mem = mem_out_213475;
            (*out0)->shape[0] = m_203571;
            (*out0)->shape[1] = n_203572;
            assert((*out1 =
                    (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d))) !=
                NULL);
            (*out1)->mem = mem_out_213476;
            (*out1)->shape[0] = m_203571;
            (*out1)->shape[1] = n_203572;
            assert((*out2 =
                    (struct futhark_f64_2d *) malloc(sizeof(struct futhark_f64_2d))) !=
                NULL);
            (*out2)->mem = mem_out_213477;
            (*out2)->shape[0] = m_203571;
            (*out2)->shape[1] = n_203572;
        }
    }
    lock_unlock(&ctx->lock);
    return ret;
}
  
